SystemOrganization addCategory: #'ICal-Model'!
SystemOrganization addCategory: #'ICal-Abstract'!
SystemOrganization addCategory: #'ICal-Strategy'!
SystemOrganization addCategory: #'ICal-Parser'!
SystemOrganization addCategory: #'ICal-Tests'!
SystemOrganization addCategory: #'ICal-VCard-Model'!
SystemOrganization addCategory: #'ICal-VCard-Tests'!
SystemOrganization addCategory: #'ICal-VCard-Parser'!
SystemOrganization addCategory: #'ICal-VCard-IO'!
SystemOrganization addCategory: #'ICal-IO'!

!ByteArray class methodsFor: '*ICal' stamp: 'pmm 10/30/2005 21:08'!
fromICalString: aString
	^(Base64MimeConverter mimeDecodeToBytes: 
		(ReadStream on: aString))
			contents! !

!ByteArray class methodsFor: '*ICal' stamp: 'pmm 10/30/2005 21:05'!
iCalType
	^'BINARY'! !

!ByteArray methodsFor: '*ICal' stamp: 'pmm 10/30/2005 21:08'!
asICalString
	^(Base64MimeConverter mimeEncode:
		(ReadWriteStream on: self))
			contents! !

!ByteArray methodsFor: '*ICal' stamp: 'pmm 12/11/2005 11:39'!
exportICalParametersOn: anExpoter
	super exportICalParametersOn: anExpoter.
	anExpoter isVCard ifTrue: [
		anExpoter exportParameter: 'ENCODING' value: 'b' ]! !

!Time class methodsFor: '*iCal' stamp: 'pmm 10/4/2005 19:17'!
fromICalString: aString
	^self
		hour: (aString first: 2) asInteger
		minute: (aString copyFrom: 3 to: 4) asInteger
		second: (aString copyFrom: 5 to: 6) asInteger.! !

!Time class methodsFor: '*iCal' stamp: 'pmm 1/2/2006 11:33'!
fromVCardString: aString
	| time fraction nanos |
	time := self fromICalString: ((aString copyUpTo: $.) reject: [ :each | each = $: ]).
	^(aString includes: $.)
		ifFalse: [ time ]
		ifTrue: [
			fraction := (aString copyAfter: $.) copyUpTo: $Z.
			nanos := fraction asNumber * (10 raisedTo: 9 - fraction size).
			self hour: time hour minute: time minute second: time second nanoSecond: nanos ]! !

!Time class methodsFor: '*iCal' stamp: 'pmm 10/3/2005 17:07'!
iCalType
	^'TIME'! !

!Time methodsFor: '*ICal' stamp: 'pmm 10/2/2005 14:25'!
asICalString
	^self asICalTimeString! !

!Time methodsFor: '*ICal' stamp: 'avi 11/12/2005 00:19'!
asICalTimeString
	^String streamContents: [ :stream |
		stream
			nextPutAll: (self hour printPaddedWith: $0 to:  2);
			nextPutAll: (self minute printPaddedWith: $0 to:  2);
			nextPutAll: (self second asInteger printPaddedWith: $0 to:  2) ]! !

!Time methodsFor: '*ICal' stamp: 'pmm 10/10/2005 16:20'!
asICalUtcString
	^self asICalTimeString , 'Z'! !

!Time methodsFor: '*ICal' stamp: 'pmm 1/2/2006 11:59'!
asVCardString
	^self nanoSecond isZero
		ifTrue: [ self print24 ]
		ifFalse: [ self print24 , '.' , self fractionString ]! !

!Time methodsFor: '*ICal' stamp: 'pmm 1/2/2006 11:57'!
fractionString
	| string lastIndex |
	string := self nanoSecond asString.
	lastIndex := string size.
	[ (string at: lastIndex) = $0 ] whileTrue: [
		lastIndex := lastIndex - 1].
	^string first: lastIndex
	! !

SmaCCScanner subclass: #ICCalendarScanner2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Parser'!

!ICCalendarScanner2 commentStamp: '<historical>' prior: 0!
I'm the new Scanner, I contain lots of tokens specified in RFC 2445!

!ICCalendarScanner2 class methodsFor: 'generated-comments' stamp: 'pmm 10/15/2005 20:31'!
scannerDefinitionComment

	"<ALPHA> : [A-Za-z];

#0-9
<DIGIT> : \d;

#carriage return
<CR> : \r;

#Controls
<CTL> : [\x00-\x08] | [\x0A-\0x1F] | \x7F ;

#Quotation Mark
<DQUOTE> : \x22;

#line feed
<LF> : \f;

#Internet standard newline
<CRLF> : <CR> <LF>;

<HTAB> : \t;

<SPACE> : \x20;

<WSP> : <SPACE> | <HTAB>;

#Use restricted by charset parameter
#on outer MIME object (UTF-8 preferred)
<NONUSASCII> : [\x80-\xF8];

#Any textual character
<VALUECHAR> : <WSP> | [\x21-\x7E] | <NONUSASCII>;

#Any character except CTLs and DQUOTE
<QSAFECHAR> : <WSP> | [\x21] | [\x23-\x7E] | <NONUSASCII>; 

#Any character except CTLs, DQUOTE, "";"", "":"", "",""
<SAFECHAR> : <WSP> | [\x21] | [\x23-\x2B] | [\x2D-\x39] | [\x3C-\x7E] | <NONUSASCII>; 

<ianatoken> : (<ALPHA> | <DIGIT> | ""-"")+ ;

<xname> : (""X-"" | ""x-"") [<vendorid> ""-""]? (<ALPHA> | <DIGIT> | ""-"")+;

<paramtext> : <SAFECHAR>*;

<quotedstring> : <DQUOTE> <QSAFECHAR>* <DQUOTE>;

<value> : <VALUECHAR>*;

<xtoken> : (""X-"" | ""x-"") | (<ALPHA> | <DIGIT> | ""-"")+;

<vendorid> : (<ALPHA> | <DIGIT>) (<ALPHA> | <DIGIT>) (<ALPHA> | <DIGIT>)+;



"! !

!ICCalendarScanner2 methodsFor: 'generated-tokens' stamp: 'pmm 10/15/2005 20:31'!
emptySymbolTokenId
	^28! !

!ICCalendarScanner2 methodsFor: 'generated-tokens' stamp: 'pmm 10/15/2005 20:31'!
errorTokenId
	^29! !

!ICCalendarScanner2 methodsFor: 'generated-scanner' stamp: 'pmm 10/15/2005 20:31'!
scan1
	
	[self recordMatch: #(7 9).
	self step.
	currentCharacter == $	 or: 
			[(currentCharacter between: $  and: $!!) or: 
					[(currentCharacter between: $# and: $+) or: 
							[(currentCharacter between: $- and: $9) or: 
									[(currentCharacter between: $< and: $~) 
										or: [currentCharacter between: $ and: $]]]]]] 
			whileTrue.
	(currentCharacter == $" 
		or: [currentCharacter == $, or: [currentCharacter between: $: and: $;]]) 
			ifTrue: 
				[
				[self recordMatch: #(9).
				self step.
				currentCharacter == $	 or: 
						[(currentCharacter between: $  and: $~) 
							or: [currentCharacter between: $ and: $]]] 
						whileTrue.
				^self reportLastMatch].
	^self reportLastMatch! !

!ICCalendarScanner2 methodsFor: 'generated-scanner' stamp: 'pmm 10/15/2005 20:31'!
scan2
	
	[self recordMatch: #(9).
	self step.
	currentCharacter == $	 or: 
			[(currentCharacter between: $  and: $!!) or: 
					[(currentCharacter between: $# and: $~) 
						or: [currentCharacter between: $ and: $]]]] 
			whileTrue.
	currentCharacter == $" ifTrue: [^self scan3].
	^self reportLastMatch! !

!ICCalendarScanner2 methodsFor: 'generated-scanner' stamp: 'pmm 10/15/2005 20:31'!
scan3
	self recordMatch: #(8 9).
	self step.
	(currentCharacter == $	 or: 
			[(currentCharacter between: $  and: $~) 
				or: [currentCharacter between: $ and: $]]) 
		ifTrue: 
			[
			[self recordMatch: #(9).
			self step.
			currentCharacter == $	 or: 
					[(currentCharacter between: $  and: $~) 
						or: [currentCharacter between: $ and: $]]] 
					whileTrue.
			^self reportLastMatch].
	^self reportLastMatch! !

!ICCalendarScanner2 methodsFor: 'generated-scanner' stamp: 'pmm 10/15/2005 20:31'!
scan4
	
	[self recordMatch: #(5 9 10).
	self step.
	(currentCharacter == $	 or: 
			[(currentCharacter between: $  and: $!!) or: 
					[(currentCharacter between: $# and: $/) or: 
							[(currentCharacter between: $: and: $@) or: 
									[(currentCharacter between: $[ and: $`) or: 
											[(currentCharacter between: ${ and: $~) 
												or: [currentCharacter between: $ and: $]]]]]]) 
		ifTrue: 
			[
			[self recordMatch: #(9).
			self step.
			currentCharacter == $	 or: 
					[(currentCharacter between: $  and: $~) 
						or: [currentCharacter between: $ and: $]]] 
					whileTrue.
			^self reportLastMatch].
	currentCharacter isDigit or: 
			[(currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]]] 
			whileTrue.
	currentCharacter == $" ifTrue: [^self scan5].
	^self reportLastMatch! !

!ICCalendarScanner2 methodsFor: 'generated-scanner' stamp: 'pmm 10/15/2005 20:31'!
scan5
	self recordMatch: #(9).
	self step.
	(currentCharacter == $	 or: 
			[(currentCharacter between: $  and: $,) or: 
					[(currentCharacter between: $. and: $~) 
						or: [currentCharacter between: $ and: $]]]) 
		ifTrue: 
			[
			[self recordMatch: #(9).
			self step.
			currentCharacter == $	 or: 
					[(currentCharacter between: $  and: $~) 
						or: [currentCharacter between: $ and: $]]] 
					whileTrue.
			^self reportLastMatch].
	currentCharacter == $- 
		ifTrue: 
			[self recordMatch: #(9).
			self step.
			(currentCharacter == $	 or: 
					[(currentCharacter between: $  and: $!!) or: 
							[(currentCharacter between: $# and: $~) 
								or: [currentCharacter between: $ and: $]]]) 
				ifTrue: 
					[
					[self recordMatch: #(9).
					self step.
					currentCharacter == $	 or: 
							[(currentCharacter between: $  and: $~) 
								or: [currentCharacter between: $ and: $]]] 
							whileTrue.
					^self reportLastMatch].
			currentCharacter == $" ifTrue: [^self scan4].
			^self reportLastMatch].
	^self reportLastMatch! !

!ICCalendarScanner2 methodsFor: 'generated-scanner' stamp: 'pmm 10/15/2005 20:31'!
scan6
	
	[self recordMatch: #(6 9).
	self step.
	(currentCharacter == $	 or: 
			[(currentCharacter between: $  and: $!!) or: 
					[(currentCharacter between: $# and: $/) or: 
							[(currentCharacter between: $: and: $@) or: 
									[(currentCharacter between: $[ and: $`) or: 
											[(currentCharacter between: ${ and: $~) 
												or: [currentCharacter between: $ and: $]]]]]]) 
		ifTrue: 
			[
			[self recordMatch: #(9).
			self step.
			currentCharacter == $	 or: 
					[(currentCharacter between: $  and: $~) 
						or: [currentCharacter between: $ and: $]]] 
					whileTrue.
			^self reportLastMatch].
	currentCharacter isDigit or: 
			[(currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]]] 
			whileTrue.
	currentCharacter == $" ifTrue: [^self scan7].
	^self reportLastMatch! !

!ICCalendarScanner2 methodsFor: 'generated-scanner' stamp: 'pmm 10/15/2005 20:31'!
scan7
	self recordMatch: #(9).
	self step.
	(currentCharacter == $	 or: 
			[(currentCharacter between: $  and: $,) or: 
					[(currentCharacter between: $. and: $~) 
						or: [currentCharacter between: $ and: $]]]) 
		ifTrue: 
			[
			[self recordMatch: #(9).
			self step.
			currentCharacter == $	 or: 
					[(currentCharacter between: $  and: $~) 
						or: [currentCharacter between: $ and: $]]] 
					whileTrue.
			^self reportLastMatch].
	currentCharacter == $- ifTrue: [^self scan8].
	^self reportLastMatch! !

!ICCalendarScanner2 methodsFor: 'generated-scanner' stamp: 'pmm 10/15/2005 20:31'!
scan8
	self recordMatch: #(9).
	self step.
	(currentCharacter == $	 or: 
			[(currentCharacter between: $  and: $!!) or: 
					[(currentCharacter between: $# and: $~) 
						or: [currentCharacter between: $ and: $]]]) 
		ifTrue: 
			[
			[self recordMatch: #(9).
			self step.
			currentCharacter == $	 or: 
					[(currentCharacter between: $  and: $~) 
						or: [currentCharacter between: $ and: $]]] 
					whileTrue.
			^self reportLastMatch].
	currentCharacter == $" ifTrue: [^self scan6].
	^self reportLastMatch! !

!ICCalendarScanner2 methodsFor: 'generated-scanner' stamp: 'pmm 10/15/2005 20:31'!
scanForToken
	self recordMatch: #(7 9).
	self step.
	(currentCharacter == $	 or: 
			[(currentCharacter between: $  and: $!!) or: 
					[(currentCharacter between: $# and: $+) or: 
							[(currentCharacter between: $- and: $/) or: 
									[currentCharacter == $< or: 
											[(currentCharacter between: $> and: $@) or: 
													[(currentCharacter between: $[ and: $`) or: 
															[(currentCharacter between: ${ and: $~) 
																or: [currentCharacter between: $ and: $]]]]]]]]) 
		ifTrue: [^self scan1].
	(currentCharacter isDigit or: 
			[(currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]]) 
		ifTrue: 
			[
			[self recordMatch: #(5 7 9 10).
			self step.
			(currentCharacter == $	 or: 
					[(currentCharacter between: $  and: $!!) or: 
							[(currentCharacter between: $# and: $+) or: 
									[(currentCharacter between: $- and: $/) or: 
											[(currentCharacter between: $< and: $@) or: 
													[(currentCharacter between: $[ and: $`) or: 
															[(currentCharacter between: ${ and: $~) 
																or: [currentCharacter between: $ and: $]]]]]]]) 
				ifTrue: [^self scan1].
			currentCharacter isDigit or: 
					[(currentCharacter between: $A and: $Z) 
						or: [currentCharacter between: $a and: $z]]] 
					whileTrue.
			(currentCharacter == $, or: [currentCharacter between: $: and: $;]) 
				ifTrue: 
					[
					[self recordMatch: #(9).
					self step.
					currentCharacter == $	 or: 
							[(currentCharacter between: $  and: $~) 
								or: [currentCharacter between: $ and: $]]] 
							whileTrue.
					^self reportLastMatch].
			currentCharacter == $" ifTrue: [^self scan5].
			^self reportLastMatch].
	currentCharacter == $
 
		ifTrue: 
			[self step.
			currentCharacter == $ ifTrue: [^self recordAndReportMatch: #(4)].
			^self reportLastMatch].
	currentCharacter == $" 
		ifTrue: 
			[self recordMatch: #(9).
			self step.
			(currentCharacter == $	 or: 
					[(currentCharacter between: $  and: $!!) or: 
							[(currentCharacter between: $# and: $,) or: 
									[(currentCharacter between: $. and: $W) or: 
											[(currentCharacter between: $Y and: $w) or: 
													[(currentCharacter between: $y and: $~) 
														or: [currentCharacter between: $ and: $]]]]]]) 
				ifTrue: [^self scan2].
			(currentCharacter == $X or: [currentCharacter == $x]) 
				ifTrue: 
					[self recordMatch: #(9).
					self step.
					(currentCharacter == $	 or: 
							[(currentCharacter between: $  and: $!!) or: 
									[(currentCharacter between: $# and: $,) or: 
											[(currentCharacter between: $. and: $~) 
												or: [currentCharacter between: $ and: $]]]]) 
						ifTrue: [^self scan2].
					currentCharacter == $" ifTrue: [^self scan3].
					currentCharacter == $- 
						ifTrue: 
							[self recordMatch: #(9).
							self step.
							(currentCharacter == $	 or: 
									[(currentCharacter between: $  and: $!!) or: 
											[(currentCharacter between: $# and: $~) 
												or: [currentCharacter between: $ and: $]]]) 
								ifTrue: [^self scan2].
							currentCharacter == $" 
								ifTrue: 
									[self recordMatch: #(8 9 10).
									self step.
									(currentCharacter == $	 or: 
											[currentCharacter == $!! or: 
													[(currentCharacter between: $# and: $/) or: 
															[(currentCharacter between: $: and: $;) or: 
																	[currentCharacter == $= or: 
																			[(currentCharacter between: $? and: $@) or: 
																					[(currentCharacter between: $[ and: $`) or: 
																							[(currentCharacter between: ${ and: $~) 
																								or: [currentCharacter between: $ and: $]]]]]]]]) 
										ifTrue: 
											[
											[self recordMatch: #(9).
											self step.
											currentCharacter == $	 or: 
													[(currentCharacter between: $  and: $~) 
														or: [currentCharacter between: $ and: $]]] 
													whileTrue.
											^self reportLastMatch].
									(currentCharacter isDigit or: 
											[(currentCharacter between: $A and: $Z) 
												or: [currentCharacter between: $a and: $z]]) 
										ifTrue: [^self scan6].
									(currentCharacter == $  
										or: [currentCharacter == $< or: [currentCharacter == $>]]) 
											ifTrue: 
												[self recordMatch: #(9).
												self step.
												(currentCharacter == $	 or: 
														[(currentCharacter between: $  and: $!!) or: 
																[(currentCharacter between: $# and: $/) or: 
																		[(currentCharacter between: $: and: $@) or: 
																				[(currentCharacter between: $[ and: $`) or: 
																						[(currentCharacter between: ${ and: $~) 
																							or: [currentCharacter between: $ and: $]]]]]]) 
													ifTrue: 
														[
														[self recordMatch: #(9).
														self step.
														currentCharacter == $	 or: 
																[(currentCharacter between: $  and: $~) 
																	or: [currentCharacter between: $ and: $]]] 
																whileTrue.
														^self reportLastMatch].
												(currentCharacter isDigit or: 
														[(currentCharacter between: $A and: $Z) 
															or: [currentCharacter between: $a and: $z]]) 
													ifTrue: [^self scan6].
												currentCharacter == $" ifTrue: [^self scan7].
												^self reportLastMatch].
									currentCharacter == $" 
										ifTrue: 
											[self recordMatch: #(9).
											self step.
											(currentCharacter == $	 or: 
													[(currentCharacter between: $  and: $!!) or: 
															[(currentCharacter between: $# and: $,) or: 
																	[(currentCharacter between: $. and: $/) or: 
																			[(currentCharacter between: $: and: $@) or: 
																					[(currentCharacter between: $[ and: $`) or: 
																							[(currentCharacter between: ${ and: $~) 
																								or: [currentCharacter between: $ and: $]]]]]]]) 
												ifTrue: 
													[
													[self recordMatch: #(9).
													self step.
													currentCharacter == $	 or: 
															[(currentCharacter between: $  and: $~) 
																or: [currentCharacter between: $ and: $]]] 
															whileTrue.
													^self reportLastMatch].
											(currentCharacter isDigit or: 
													[(currentCharacter between: $A and: $Z) 
														or: [currentCharacter between: $a and: $z]]) 
												ifTrue: [^self scan6].
											currentCharacter == $" ifTrue: [^self scan7].
											currentCharacter == $- ifTrue: [^self scan8].
											^self reportLastMatch].
									^self reportLastMatch].
							^self reportLastMatch].
					^self reportLastMatch].
			currentCharacter == $" ifTrue: [^self scan3].
			currentCharacter == $- 
				ifTrue: 
					[self recordMatch: #(9).
					self step.
					(currentCharacter == $	 or: 
							[(currentCharacter between: $  and: $!!) or: 
									[(currentCharacter between: $# and: $~) 
										or: [currentCharacter between: $ and: $]]]) 
						ifTrue: [^self scan2].
					currentCharacter == $" 
						ifTrue: 
							[self recordMatch: #(5 8 9 10).
							self step.
							(currentCharacter == $	 or: 
									[(currentCharacter between: $  and: $!!) or: 
											[(currentCharacter between: $# and: $/) or: 
													[(currentCharacter between: $: and: $@) or: 
															[(currentCharacter between: $[ and: $`) or: 
																	[(currentCharacter between: ${ and: $~) 
																		or: [currentCharacter between: $ and: $]]]]]]) 
								ifTrue: 
									[
									[self recordMatch: #(9).
									self step.
									currentCharacter == $	 or: 
											[(currentCharacter between: $  and: $~) 
												or: [currentCharacter between: $ and: $]]] 
											whileTrue.
									^self reportLastMatch].
							(currentCharacter isDigit or: 
									[(currentCharacter between: $A and: $Z) 
										or: [currentCharacter between: $a and: $z]]) 
								ifTrue: [^self scan4].
							currentCharacter == $" ifTrue: [^self scan5].
							^self reportLastMatch].
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $, 
		ifTrue: 
			[
			[self recordMatch: #(9).
			self step.
			currentCharacter == $	 or: 
					[(currentCharacter between: $  and: $~) 
						or: [currentCharacter between: $ and: $]]] 
					whileTrue.
			^self reportLastMatch].
	currentCharacter == $: 
		ifTrue: 
			[self recordMatch: #(1 9).
			self step.
			(currentCharacter == $	 or: 
					[(currentCharacter between: $  and: $~) 
						or: [currentCharacter between: $ and: $]]) 
				ifTrue: 
					[
					[self recordMatch: #(9).
					self step.
					currentCharacter == $	 or: 
							[(currentCharacter between: $  and: $~) 
								or: [currentCharacter between: $ and: $]]] 
							whileTrue.
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $; 
		ifTrue: 
			[self recordMatch: #(2 9).
			self step.
			(currentCharacter == $	 or: 
					[(currentCharacter between: $  and: $~) 
						or: [currentCharacter between: $ and: $]]) 
				ifTrue: 
					[
					[self recordMatch: #(9).
					self step.
					currentCharacter == $	 or: 
							[(currentCharacter between: $  and: $~) 
								or: [currentCharacter between: $ and: $]]] 
							whileTrue.
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $= 
		ifTrue: 
			[self recordMatch: #(3 7 9).
			self step.
			(currentCharacter == $	 or: 
					[(currentCharacter between: $  and: $!!) or: 
							[(currentCharacter between: $# and: $+) or: 
									[(currentCharacter between: $- and: $9) or: 
											[(currentCharacter between: $< and: $~) 
												or: [currentCharacter between: $ and: $]]]]]) 
				ifTrue: [^self scan1].
			(currentCharacter == $" 
				or: [currentCharacter == $, or: [currentCharacter between: $: and: $;]]) 
					ifTrue: 
						[
						[self recordMatch: #(9).
						self step.
						currentCharacter == $	 or: 
								[(currentCharacter between: $  and: $~) 
									or: [currentCharacter between: $ and: $]]] 
								whileTrue.
						^self reportLastMatch].
			^self reportLastMatch].
	^self reportLastMatch! !

Object subclass: #ICCalendarHandParser
	instanceVariableNames: 'stream generator name parameters value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Parser'!

!ICCalendarHandParser commentStamp: 'pmm 10/15/2005 16:05' prior: 0!
This is a recursively descending parser written by hand because I couldn't get the smacc one working.!

!ICCalendarHandParser class methodsFor: 'instance creation' stamp: 'pmm 10/15/2005 16:02'!
on: aStream
	^self new
		stream: aStream;
		yourself! !

!ICCalendarHandParser class methodsFor: 'instance creation' stamp: 'pmm 11/12/2005 12:38'!
parseCalendarFile: aPath
	^self parseCalendarString: (FileStream readOnlyFileNamed: aPath) contentsOfEntireFile! !

!ICCalendarHandParser class methodsFor: 'instance creation' stamp: 'pmm 11/12/2005 12:18'!
parseCalendarStream: aStream
	"don't ask it's Squeak"
	| string |
	string := String streamContents: [ :stream |
			[ aStream atEnd ]
				whileFalse: [ stream nextPut: aStream next ] ].
	aStream close.
	^self parseCalendarString: string! !

!ICCalendarHandParser class methodsFor: 'instance creation' stamp: 'pmm 11/12/2005 12:17'!
parseCalendarString: aString
	| parser |
	parser := self on: (ReadStream on: aString).
	parser generator: ICCalendarGenerator new.
	parser parse.
	^parser product! !

!ICCalendarHandParser methodsFor: 'parsing' stamp: 'pmm 11/1/2005 07:42'!
addParameter: paramName value: paramValue
	self parameters add: paramName -> paramValue! !

!ICCalendarHandParser methodsFor: 'parsing' stamp: 'pmm 10/15/2005 15:59'!
contentline
	self generator
		contentline: self name
		parameters: self parameters
		value: self value! !

!ICCalendarHandParser methodsFor: 'accessing' stamp: 'pmm 10/15/2005 16:05'!
generator
	^generator! !

!ICCalendarHandParser methodsFor: 'accessing' stamp: 'pmm 10/15/2005 16:05'!
generator: anObject
	generator := anObject! !

!ICCalendarHandParser methodsFor: 'accessing' stamp: 'pmm 10/15/2005 15:45'!
name
	^name! !

!ICCalendarHandParser methodsFor: 'accessing' stamp: 'pmm 10/15/2005 15:45'!
name: anObject
	name := anObject! !

!ICCalendarHandParser methodsFor: 'accessing' stamp: 'pmm 10/15/2005 15:45'!
parameters
	^parameters! !

!ICCalendarHandParser methodsFor: 'accessing' stamp: 'pmm 10/15/2005 15:45'!
parameters: anObject
	parameters := anObject! !

!ICCalendarHandParser methodsFor: 'parsing' stamp: 'pmm 10/15/2005 16:31'!
parse	
	[ self stream atEnd ]
		whileFalse: [ self parseLine ]! !

!ICCalendarHandParser methodsFor: 'parsing' stamp: 'pmm 10/15/2005 16:39'!
parseLine
	self parseName.
	self parseParameters.
	self parseValue.
	
	self contentline! !

!ICCalendarHandParser methodsFor: 'parsing' stamp: 'pmm 10/18/2005 06:21'!
parseName
	self name: 
		(self unfold: 
			(self stream upToAny: #($; $:)) asUppercase).
	self stream position: self stream position - 1.! !

!ICCalendarHandParser methodsFor: 'parsing' stamp: 'pmm 11/1/2005 07:40'!
parseParameter
	"redefined for compatibility with ApplesAddress book"
	| paramName paramValue parameter |
	self stream next. "ignore $;"
	parameter := self stream upToAny: #($; $:).
	paramName := parameter copyUpTo: $=. 
	paramValue := parameter copyAfter: $=.
	paramName := (self unfold: paramName) asUppercase. "case insensitive"
	paramValue := (self unfold: paramValue) asUppercase. "case insensitive"
	self addParameter: paramName value: paramValue.
	self stream position: self stream position - 1.! !

!ICCalendarHandParser methodsFor: 'parsing' stamp: 'pmm 10/15/2005 15:57'!
parseParameters	
	self parameters: Dictionary new.
	[ self stream peek = $: ]
		whileFalse: [ 
			self parseParameter ].
	! !

!ICCalendarHandParser methodsFor: 'parsing' stamp: 'pmm 10/15/2005 20:28'!
parseValue
	| crlf |
	crlf := (Array with: Character cr with: Character lf).
	self stream next. "ignore $:"
		
	self value: (String streamContents: [ :strm |
		strm nextPutAll: (self stream upToAll: crlf). "no unfolding needed"
		[ self whitespaces includes: self stream peek ]
			whileTrue: [ 
				self stream next. "ignore whitespace"
				strm nextPutAll: (self stream upToAll: crlf) ] ]). "no unfolding needed"
	! !

!ICCalendarHandParser methodsFor: 'accessing' stamp: 'pmm 10/15/2005 16:03'!
product
	^self generator product! !

!ICCalendarHandParser methodsFor: 'accessing' stamp: 'pmm 10/15/2005 15:45'!
stream
	^stream! !

!ICCalendarHandParser methodsFor: 'accessing' stamp: 'pmm 10/15/2005 15:45'!
stream: anObject
	stream := anObject! !

!ICCalendarHandParser methodsFor: 'testing' stamp: 'pmm 11/19/2005 15:36'!
unfoldEquals
	^ICCalendarVersion value < 2.0! !

!ICCalendarHandParser methodsFor: 'utilities' stamp: 'pmm 11/19/2005 15:35'!
unfoldEquals: aString
	"remove any sequence of = CR LF WSP"
	| pattern whiteSpaces |
	whiteSpaces := Array
		with: Character space
		with: Character tab
		with: (Character value: 9)
		with: (Character value: 32).
	pattern := Array new: 4.
	pattern at: 1 put: $=.
	pattern at: 2 put: Character cr.
	pattern at: 3 put: Character lf.
	^whiteSpaces inject: aString into: [ :string :each |
		pattern at: 4 put: each.
		(string includesSubString: pattern)
			ifFalse: [ string ]
			ifTrue: [ string copyReplaceAll: pattern with: ''  ] ]! !

!ICCalendarHandParser methodsFor: 'utilities' stamp: 'pmm 11/19/2005 15:33'!
unfold: aString
	"remove any sequence of CR LF WSP"
	| pattern whiteSpaces |
	whiteSpaces := Array
		with: Character space
		with: Character tab
		with: (Character value: 9)
		with: (Character value: 32).
	pattern := Array new: 3.
	pattern at: 1 put: Character cr.
	pattern at: 2 put: Character lf.
	^whiteSpaces
		inject: (self unfoldEquals
			ifTrue: [ self unfoldEquals: aString ]
			ifFalse: [ aString ])
		into: [ :string :each |
			pattern at: 3 put: each.
			(string includesSubString: pattern)
				ifFalse: [ string ]
				ifTrue: [ string copyReplaceAll: pattern with: ''  ] ]! !

!ICCalendarHandParser methodsFor: 'accessing' stamp: 'pmm 10/15/2005 15:46'!
value
	^value! !

!ICCalendarHandParser methodsFor: 'accessing' stamp: 'pmm 10/15/2005 15:45'!
value: anObject
	value := anObject! !

!ICCalendarHandParser methodsFor: 'parsing' stamp: 'pmm 10/15/2005 12:18'!
whitespaces
	^Array
		with: Character space
		with: Character tab
		with: (Character value: 9)
		with: (Character value: 32).! !

ICCalendarHandParser subclass: #ICCardHandParser
	instanceVariableNames: 'group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-VCard-Parser'!

!ICCardHandParser class methodsFor: 'instance creation' stamp: 'pmm 11/12/2005 12:39'!
parseVCardFile: aPath
	^self parseVCardString: (FileStream readOnlyFileNamed: aPath) contentsOfEntireFile! !

!ICCardHandParser class methodsFor: 'instance creation' stamp: 'pmm 11/12/2005 12:06'!
parseVCardStream: aStream
	"don't ask it's Squeak"
	| string |
	string := String streamContents: [ :stream |
			[ aStream atEnd ]
				whileFalse: [ stream nextPut: aStream next ] ].
	aStream close.
	^self parseVCardString: string! !

!ICCardHandParser class methodsFor: 'instance creation' stamp: 'pmm 11/12/2005 12:04'!
parseVCardString: aString
	| parser |
	parser := self on: (ReadStream on: aString).
	parser generator: ICVCardGenerator new.
	parser parse.
	^parser product! !

!ICCardHandParser methodsFor: 'parsing' stamp: 'pmm 11/19/2005 15:12'!
addParameter: paramName value: paramValue
	| values |
	(self needsHackForOldFormat: paramName value: paramValue) ifTrue: [
		^self parseHackForOldFormat: paramName value: paramValue ].
	(self isMultivalued: paramName)
		ifFalse: [ super addParameter: paramName value: paramValue ]
		ifTrue: [
				values := self parameters at: paramName ifAbsentPut: [ OrderedCollection new ].
				(paramValue includes: $,)
					ifFalse: [ values add: paramValue ]
					ifTrue: [ values addAll: (paramValue subStrings: #($,)) ] ]! !

!ICCardHandParser methodsFor: 'accessing' stamp: 'pmm 10/18/2005 06:54'!
group
	^group! !

!ICCardHandParser methodsFor: 'accessing' stamp: 'pmm 10/18/2005 06:54'!
group: aString 
	group := aString! !

!ICCardHandParser methodsFor: 'testing' stamp: 'pmm 10/29/2005 22:26'!
isMultivalued: aParameterName
	^aParameterName = 'TYPE'! !

!ICCardHandParser methodsFor: 'accessing' stamp: 'pmm 10/18/2005 06:57'!
name: aString
	(aString includes: $.)
		ifFalse: [
			name := aString]
		ifTrue: [
			name := aString copyAfter: $. .
			self group: (aString upTo: $.) ]
	! !

!ICCardHandParser methodsFor: 'testing' stamp: 'pmm 11/19/2005 15:11'!
needsHackForOldFormat: aParameterName value: aParameterValue
	^aParameterValue isEmptyOrNil! !

!ICCardHandParser methodsFor: 'parsing' stamp: 'pmm 12/3/2005 00:03'!
parseHackForOldFormat: paramName value: paramValue	
	paramName = 'BASE64'
		ifTrue: [
			self parameters at: 'ENCODING'put: 'B'.
			self parameters at: 'VALUE' put: ByteArray iCalType ]
		ifFalse: [
			self addParameter: 'TYPE' value: paramName ]
	! !

!ICCardHandParser methodsFor: 'accessing' stamp: 'pmm 10/18/2005 06:57'!
parseName
	self group: nil.
	super parseName! !

!ICCardHandParser methodsFor: 'testing' stamp: 'pmm 11/19/2005 15:36'!
unfoldEquals
	^ICCalendarVersion value < 3.0! !

Object subclass: #ICCategory
	instanceVariableNames: 'summary textualDescription color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Model'!

!ICCategory commentStamp: '<historical>' prior: 0!
A Category has a title, a description and a color. Every category is associated with a calendar and every event can be assoicated with a category. 
Default categories have the title: 'private' or  'buissness' and are stored on the class side.!

!ICCategory class methodsFor: 'instance creation' stamp: 'pmm 10/14/2005 12:39'!
fromICalString: aString
	self flag: #todo. "look up in calendar or something like that"
	^self summary: (String fromICalString: aString)! !

!ICCategory class methodsFor: 'instance creation' stamp: 'pmm 10/6/2005 23:28'!
summary: aString
	^self new
		summary: aString;
		yourself! !

!ICCategory methodsFor: 'converting' stamp: 'pmm 10/6/2005 23:33'!
asICalString
	^self summary asICalString! !

!ICCategory methodsFor: 'accessing' stamp: 'pmm 10/6/2005 23:26'!
color
	^color! !

!ICCategory methodsFor: 'accessing' stamp: 'pmm 10/6/2005 23:27'!
color: aColor 
	color := aColor! !

!ICCategory methodsFor: 'testing' stamp: 'pmm 10/7/2005 00:00'!
hasColor
	^self color notNil! !

!ICCategory methodsFor: 'accessing' stamp: 'pmm 11/1/2005 22:31'!
hash
	^self summary hash! !

!ICCategory methodsFor: 'testing' stamp: 'pmm 10/7/2005 17:22'!
hasSummary
	^self summary notNil! !

!ICCategory methodsFor: 'printing' stamp: 'pmm 10/7/2005 17:22'!
printOn: aStream
	super printOn: aStream.
	self hasSummary ifTrue: [
		aStream
			nextPut: $(;
			nextPutAll: self summary;
			nextPut: $) ]! !

!ICCategory methodsFor: 'accessing' stamp: 'pmm 10/6/2005 23:26'!
summary
	^summary! !

!ICCategory methodsFor: 'accessing' stamp: 'pmm 10/6/2005 23:26'!
summary: anObject
	summary := anObject! !

!ICCategory methodsFor: 'accessing' stamp: 'pmm 10/6/2005 23:26'!
textualDescription
	^textualDescription! !

!ICCategory methodsFor: 'accessing' stamp: 'pmm 10/6/2005 23:27'!
textualDescription: aString 
	textualDescription := aString! !

!ICCategory methodsFor: 'comparing' stamp: 'pmm 10/6/2005 23:27'!
= aCategory
	^(aCategory isKindOf: ICCategory)
		and: [ self summary = aCategory summary ]! !

Object subclass: #ICComponent
	instanceVariableNames: 'unknownProperties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Abstract'!

ICComponent subclass: #ICAlarm
	instanceVariableNames: 'action attachments delay repetitions textualDescription trigger'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Model'!

!ICAlarm class methodsFor: 'accessing-actions' stamp: 'pmm 11/10/2005 22:40'!
actionAudio
	^'AUDIO'! !

!ICAlarm class methodsFor: 'accessing-actions' stamp: 'pmm 11/10/2005 22:41'!
actionDisplay
	^'DISPLAY'! !

!ICAlarm class methodsFor: 'accessing-actions' stamp: 'pmm 11/10/2005 22:40'!
actionEmail
	^'EMAIL'! !

!ICAlarm class methodsFor: 'accessing-actions' stamp: 'pmm 11/10/2005 22:42'!
actionProcedure
	^'PROCEDURE'! !

!ICAlarm class methodsFor: 'accessing' stamp: 'pmm 10/13/2005 09:56'!
iCalType
	^'VALARM'! !

!ICAlarm class methodsFor: 'accessing-actions' stamp: 'pmm 11/10/2005 22:43'!
possibleActions
	^Array
		with: self actionAudio
		with: self actionDisplay
		with: self actionEmail
		with: self actionProcedure! !

!ICAlarm methodsFor: 'actions' stamp: 'pmm 11/10/2005 22:38'!
action
	^action! !

!ICAlarm methodsFor: 'actions' stamp: 'pmm 11/10/2005 22:38'!
action: anObject
	action := anObject! !

!ICAlarm methodsFor: 'accessing' stamp: 'pmm 10/14/2005 12:13'!
addAttachment: anAttachment
	^self attachments add: anAttachment! !

!ICAlarm methodsFor: 'accessing' stamp: 'pmm 10/14/2005 12:11'!
attachments
	^attachments! !

!ICAlarm methodsFor: 'accessing' stamp: 'pmm 10/14/2005 12:12'!
attachments: aCollection 
	attachments := aCollection! !

!ICAlarm methodsFor: 'actions' stamp: 'pmm 11/10/2005 22:45'!
beAudio
	self action: self class actionAudio! !

!ICAlarm methodsFor: 'actions' stamp: 'pmm 11/10/2005 22:46'!
beDisplay
	self action: self class actionDisplay! !

!ICAlarm methodsFor: 'actions' stamp: 'pmm 11/10/2005 22:45'!
beEmail
	self action: self class actionEmail! !

!ICAlarm methodsFor: 'actions' stamp: 'pmm 11/10/2005 22:48'!
beProcedure
	self action: self class actionProcedure! !

!ICAlarm methodsFor: 'accessing' stamp: 'pmm 11/11/2005 20:09'!
delay
	^delay! !

!ICAlarm methodsFor: 'accessing' stamp: 'pmm 11/11/2005 20:09'!
delay: aDuration 
	delay := aDuration! !

!ICAlarm methodsFor: 'accessing' stamp: 'pmm 11/11/2005 23:03'!
duration
	^self delay! !

!ICAlarm methodsFor: 'accessing' stamp: 'pmm 11/11/2005 23:03'!
duration: aDuration 
	self delay: aDuration! !

!ICAlarm methodsFor: 'exporting' stamp: 'pmm 11/11/2005 22:17'!
exportOn: anExporter	
	anExporter exportAction: self action.
	anExporter exportTrigger: self trigger.
	anExporter exportDuration: self delay.
	anExporter exportRepetition: self repetitions.		
	anExporter exportAttachments: self attachments.
	anExporter exportDescription: self textualDescription.! !

!ICAlarm methodsFor: 'initialize-release' stamp: 'pmm 10/14/2005 12:13'!
initialize
	super initialize.
	self attachments: OrderedCollection new! !

!ICAlarm methodsFor: 'actions' stamp: 'pmm 11/10/2005 22:44'!
isAudio
	^self action = self class actionAudio! !

!ICAlarm methodsFor: 'actions' stamp: 'pmm 11/10/2005 22:44'!
isDisplay
	^self action = self class actionDisplay! !

!ICAlarm methodsFor: 'actions' stamp: 'pmm 11/10/2005 22:45'!
isEmail
	^self action = self class actionEmail! !

!ICAlarm methodsFor: 'actions' stamp: 'pmm 11/10/2005 22:45'!
isProcedure
	^self action = self class actionProcedure! !

!ICAlarm methodsFor: 'testing' stamp: 'pmm 11/10/2005 22:44'!
isValid
	self notYetImplemented! !

!ICAlarm methodsFor: 'accessing' stamp: 'pmm 11/11/2005 20:09'!
repetitions
	^repetitions! !

!ICAlarm methodsFor: 'accessing' stamp: 'pmm 11/11/2005 20:09'!
repetitions: anInteger 
	repetitions := anInteger! !

!ICAlarm methodsFor: 'accessing' stamp: 'pmm 10/7/2005 09:48'!
textualDescription
	^textualDescription! !

!ICAlarm methodsFor: 'accessing' stamp: 'pmm 10/7/2005 09:49'!
textualDescription: aString 
	textualDescription := aString! !

!ICAlarm methodsFor: 'accessing' stamp: 'pmm 11/11/2005 20:20'!
trigger
	^trigger! !

!ICAlarm methodsFor: 'accessing' stamp: 'pmm 11/11/2005 20:20'!
trigger: aTrigger 
	trigger := aTrigger! !

ICComponent subclass: #ICCalendar
	instanceVariableNames: 'categories charset events freeBusy journals method productId textualDescription timezones todos users version summary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Model'!

!ICCalendar commentStamp: '<historical>' prior: 0!
This is a SmallWiki 2 Calendar. It is the base Class of the Model. 
Mangages the adding, editing, removing of it parts.
Provides useful methods to get the elements we are looking for.

Holds:
-events: is an OrderedCollection of SWCEvents. An Event can be a SWCAppointment, SWCEventSerie or a SWCToDo

-places: is a Set of places which are stored as Strings. The calendar stores here the places the user used once by defining an Event.

-categories: is an OrderedCollection of SWCCategory Objects. !

!ICCalendar class methodsFor: 'accessing' stamp: 'pmm 10/9/2005 10:41'!
iCalType
	^'VCALENDAR'! !

!ICCalendar class methodsFor: 'constants' stamp: 'pmm 10/15/2005 18:17'!
methodAdd
	^'ADD'! !

!ICCalendar class methodsFor: 'constants' stamp: 'pmm 10/15/2005 18:18'!
methodCancel
	^'CANCEL'! !

!ICCalendar class methodsFor: 'constants' stamp: 'pmm 10/15/2005 18:18'!
methodCounter
	^'COUNTER'! !

!ICCalendar class methodsFor: 'constants' stamp: 'pmm 10/15/2005 18:19'!
methodDeclineCounter
	^'DECLINE-COUNTER'! !

!ICCalendar class methodsFor: 'constants' stamp: 'pmm 10/15/2005 18:17'!
methodPublish
	^'PUBLISH'! !

!ICCalendar class methodsFor: 'constants' stamp: 'pmm 10/15/2005 18:18'!
methodRefresh
	^'REFRESH'! !

!ICCalendar class methodsFor: 'constants' stamp: 'pmm 10/15/2005 18:17'!
methodReply
	^'REPLY'! !

!ICCalendar class methodsFor: 'constants' stamp: 'pmm 10/15/2005 18:17'!
methodRequest
	^'REQUEST'! !

!ICCalendar class methodsFor: 'accessing' stamp: 'pmm 10/7/2005 09:50'!
productId
	^'-//Squeak-iCalendar//-'! !

!ICCalendar class methodsFor: 'instance creation' stamp: 'pmm 10/7/2005 09:53'!
summary: aString
	^self new
		summary: aString;
		yourself! !

!ICCalendar methodsFor: 'categories' stamp: 'pmm 9/11/2005 16:43'!
addCategory: aCategory
	^self categories add: aCategory! !

!ICCalendar methodsFor: 'actions' stamp: 'pmm 10/13/2005 10:09'!
addComponent: aComponent
	aComponent addToCalendar: self! !

!ICCalendar methodsFor: 'events' stamp: 'pmm 10/7/2005 00:06'!
addEvent: anEvent 
	^self events add: anEvent! !

!ICCalendar methodsFor: 'freebusy' stamp: 'pmm 10/13/2005 10:07'!
addFreeBusy: aFreeBusy
	^self freeBusy add: aFreeBusy! !

!ICCalendar methodsFor: 'journals' stamp: 'pmm 10/7/2005 00:19'!
addJournal: aJournal
	^self journals add: aJournal! !

!ICCalendar methodsFor: 'timezones' stamp: 'pmm 10/7/2005 00:22'!
addTimezone: aTimezone
	^self timezones add: aTimezone! !

!ICCalendar methodsFor: 'todos' stamp: 'pmm 10/7/2005 00:14'!
addTodo: aTodo
	^self todos add: aTodo! !

!ICCalendar methodsFor: 'users' stamp: 'pmm 10/7/2005 00:23'!
addUser: aUser
	^self users add: aUser! !

!ICCalendar methodsFor: 'actions' stamp: 'pmm 10/6/2005 23:54'!
beICalendar
	self version: self iCalendarVersion ! !

!ICCalendar methodsFor: 'actions' stamp: 'pmm 10/6/2005 23:54'!
beVCalendar
	self version: self vCalendarVersion ! !

!ICCalendar methodsFor: 'categories' stamp: 'pmm 10/3/2005 16:48'!
categories
	^categories! !

!ICCalendar methodsFor: 'categories' stamp: 'dr 4/11/2005 10:17'!
categories: aCollection
	categories := aCollection! !

!ICCalendar methodsFor: 'categories' stamp: 'pmm 10/7/2005 10:10'!
categoryWithSummary: aString
	^self categories detect: [ :each | each summary = aString]! !

!ICCalendar methodsFor: 'accessing' stamp: 'pmm 12/13/2005 22:25'!
charset
	^charset! !

!ICCalendar methodsFor: 'accessing' stamp: 'pmm 12/13/2005 22:26'!
charset: aString 
	charset := aString! !

!ICCalendar methodsFor: 'accessing' stamp: 'pmm 10/15/2005 20:09'!
componentForDate: aDate
	^Array streamContents: [ :array |
		array
			nextPutAll: (self eventsForDate: aDate);
			nextPutAll: (self todosForDate: aDate) ]! !

!ICCalendar methodsFor: 'accessing' stamp: 'pmm 10/14/2005 16:00'!
components
	^Array streamContents: [ :stream |
		stream
			nextPutAll: self events;
			nextPutAll: self todos;
			nextPutAll: self journals;
			nextPutAll: self timezones;
			nextPutAll: self freeBusy ]! !

!ICCalendar methodsFor: 'accessing' stamp: 'pmm 10/14/2005 16:01'!
componentsDo: aBlock
	self eventsDo: aBlock.
	self todosDo: aBlock.
	self journalsDo: aBlock.
	self timezonesDo: aBlock.
	self freeBusyDo: aBlock! !

!ICCalendar methodsFor: 'events' stamp: 'dr 5/15/2005 15:07'!
events
	^events! !

!ICCalendar methodsFor: 'events' stamp: 'pmm 10/7/2005 00:17'!
eventsDo: aBlock
	self events do: aBlock! !

!ICCalendar methodsFor: 'events' stamp: 'pmm 10/7/2005 19:13'!
eventsForDateAndTime: aDateAndTime 
	^self events select: [ :each | each startsInHour: aDateAndTime]! !

!ICCalendar methodsFor: 'events' stamp: 'pmm 10/15/2005 20:07'!
eventsForDate: aDate 
	^self events select: [ :each | each isValidForDate: aDate]! !

!ICCalendar methodsFor: 'events' stamp: 'pmm 10/7/2005 17:01'!
events: aCollection
	events := aCollection! !

!ICCalendar methodsFor: 'events' stamp: 'pmm 10/7/2005 00:12'!
eventWithUid: anUid
	^self events detect: [ :each | each uid = anUid ]! !

!ICCalendar methodsFor: 'exporting' stamp: 'pmm 12/13/2005 22:28'!
exportOn: anExporter
	anExporter exportProductId: self productId.
	anExporter exportVersion: self version.
	anExporter exportMethod: self method.
	anExporter exportCharset: self charset.
	self componentsDo: [ :each |
		anExporter export: each ]! !

!ICCalendar methodsFor: 'freebusy' stamp: 'pmm 10/13/2005 10:06'!
freeBusy
	^freeBusy! !

!ICCalendar methodsFor: 'freebusy' stamp: 'pmm 10/14/2005 16:00'!
freeBusyDo: aBlock
	self freeBusy do: aBlock! !

!ICCalendar methodsFor: 'freebusy' stamp: 'pmm 10/13/2005 10:06'!
freeBusy: aCollection 
	freeBusy := aCollection! !

!ICCalendar methodsFor: 'accessing-constants' stamp: 'pmm 10/6/2005 23:53'!
iCalendarVersion
	^2.0! !

!ICCalendar methodsFor: 'testing' stamp: 'pmm 10/14/2005 16:00'!
includesComponentWithUid: aString 
	^(self includesEventWithUid: aString)
		or: [ self includesTodoWithUid: aString ]
		or: [ self includesJournalWithUid: aString ]
		or: [ self includesFreeBusyWithUid: aString ]
		or: [ self includesTimezoneWithUid: aString ]! !

!ICCalendar methodsFor: 'events' stamp: 'pmm 10/14/2005 15:22'!
includesEventWithUid: aString 
	^self events anySatisfy: [:each | each uid = aString]! !

!ICCalendar methodsFor: 'freebusy' stamp: 'pmm 10/14/2005 15:59'!
includesFreeBusyWithUid: aString 
	^self freeBusy anySatisfy: [:each | each uid = aString]! !

!ICCalendar methodsFor: 'journals' stamp: 'pmm 10/14/2005 15:22'!
includesJournalWithUid: aString 
	^self journals anySatisfy: [:each | each uid = aString]! !

!ICCalendar methodsFor: 'timezones' stamp: 'pmm 10/14/2005 15:25'!
includesTimezoneWithUid: aString
	^self timezones anySatisfy: [ :each | each uid = aString ]! !

!ICCalendar methodsFor: 'todos' stamp: 'pmm 10/14/2005 15:22'!
includesTodoWithUid: aString 
	^self todos anySatisfy: [:each | each uid = aString]! !

!ICCalendar methodsFor: 'initialize-release' stamp: 'pmm 10/15/2005 18:19'!
initialize
	super initialize.

	self beICalendar.
	self categories: OrderedCollection new.
	self journals: OrderedCollection new.
	self timezones: OrderedCollection new.
	self todos: OrderedCollection new.
	self events: OrderedCollection new.
	self users: OrderedCollection new.
	self freeBusy: OrderedCollection new.
	self productId: self class productId.
	self method: self class methodPublish! !

!ICCalendar methodsFor: 'journals' stamp: 'pmm 10/7/2005 00:19'!
journals
	^journals! !

!ICCalendar methodsFor: 'journals' stamp: 'pmm 10/7/2005 00:20'!
journalsDo: aBlock
	self journals do: aBlock! !

!ICCalendar methodsFor: 'journals' stamp: 'pmm 10/7/2005 00:20'!
journals: aCollection 
	journals := aCollection! !

!ICCalendar methodsFor: 'accessing' stamp: 'pmm 10/15/2005 18:16'!
method
	^method! !

!ICCalendar methodsFor: 'accessing' stamp: 'pmm 10/15/2005 18:16'!
method: aString 
	method := aString! !

!ICCalendar methodsFor: 'accessing' stamp: 'pmm 10/14/2005 14:50'!
productId
	^productId! !

!ICCalendar methodsFor: 'accessing' stamp: 'pmm 10/14/2005 14:50'!
productId: anObject
	productId := anObject! !

!ICCalendar methodsFor: 'categories' stamp: 'dr 4/11/2005 10:20'!
removeCategory: aCategory
	^self categories remove: aCategory! !

!ICCalendar methodsFor: 'testing' stamp: 'pmm 10/14/2005 16:00'!
removeComponentWithUid: aString
	(self includesEventWithUid: aString)
		ifTrue: [ ^self removeEventWithUid: aString ].
	(self includesTodoWithUid: aString)
		ifTrue: [ ^self removeTodoWithUid: aString ].
	(self includesJournalWithUid: aString)
		ifTrue: [ ^self removeJournalWithUid: aString  ].
	(self includesFreeBusyWithUid: aString)
		ifTrue: [ ^self removeJournalWithUid: aString ].
	(self includesTimezoneWithUid: aString)
		ifTrue: [ ^self removeTimezoneWithUid: aString ]! !

!ICCalendar methodsFor: 'events' stamp: 'pmm 10/7/2005 11:20'!
removeEventWithUid: aString
	| event |
	event := self events detect: [ :each | each uid = aString] ifNone: [^nil].
	^self removeEvent: event.
	! !

!ICCalendar methodsFor: 'events' stamp: 'dr 5/15/2005 15:07'!
removeEvent: anEvent 
	^self events remove: anEvent! !

!ICCalendar methodsFor: 'freebusy' stamp: 'pmm 11/12/2005 12:30'!
removeFreeBusyWithUid: aString
	| freebusy |
	freebusy := self freeBusy detect: [ :each | each uid = aString] ifNone: [^nil].
	^self removeFreeBusy: freebusy.
	! !

!ICCalendar methodsFor: 'freebusy' stamp: 'pmm 11/12/2005 12:29'!
removeFreeBusy: aFreebusy
	^self freeBusy remove: aFreebusy! !

!ICCalendar methodsFor: 'journals' stamp: 'pmm 10/14/2005 15:36'!
removeJournalWithUid: aString
	| journal |
	journal := self journals detect: [ :each | each uid = aString] ifNone: [^nil].
	^self removeEvent: journal.
	! !

!ICCalendar methodsFor: 'journals' stamp: 'pmm 10/14/2005 15:35'!
removeJournal: aJournal
	^self journals remove: aJournal! !

!ICCalendar methodsFor: 'timezones' stamp: 'pmm 10/14/2005 15:34'!
removeTimezoneWithUid: aString
	| timezone |
	timezone := self timezones detect: [ :each | each uid = aString] ifNone: [^nil].
	^self removeTimezone: timezone.
	! !

!ICCalendar methodsFor: 'timezones' stamp: 'pmm 10/14/2005 15:34'!
removeTimezone: aTimezone
	^self timezones remove: aTimezone! !

!ICCalendar methodsFor: 'todos' stamp: 'pmm 10/15/2005 16:42'!
removeTodoWithUid: aString
	| todo |
	todo := self todos detect: [ :each | each uid = aString] ifNone: [^nil].
	^self removeTodo: todo.! !

!ICCalendar methodsFor: 'todos' stamp: 'pmm 10/7/2005 18:59'!
removeTodo: aTodo
	^self todos remove: aTodo! !

!ICCalendar methodsFor: 'accessing' stamp: 'pmm 10/6/2005 23:51'!
summary
	^summary! !

!ICCalendar methodsFor: 'accessing' stamp: 'pmm 10/6/2005 23:52'!
summary: aString 
	summary := aString! !

!ICCalendar methodsFor: 'accessing' stamp: 'pmm 10/6/2005 23:51'!
textualDescription
	^textualDescription! !

!ICCalendar methodsFor: 'accessing' stamp: 'pmm 10/6/2005 23:52'!
textualDescription: aString 
	textualDescription := aString! !

!ICCalendar methodsFor: 'timezones' stamp: 'pmm 10/7/2005 00:20'!
timezones
	^timezones! !

!ICCalendar methodsFor: 'timezones' stamp: 'pmm 10/7/2005 00:23'!
timezonesDo: aBlock
	self timezones do: aBlock! !

!ICCalendar methodsFor: 'timezones' stamp: 'pmm 10/7/2005 00:22'!
timezones: aTimezone 
	timezones := aTimezone! !

!ICCalendar methodsFor: 'todos' stamp: 'pmm 10/7/2005 00:13'!
todos
	^todos! !

!ICCalendar methodsFor: 'todos' stamp: 'pmm 10/7/2005 00:18'!
todosDo: aBlock
	self todos do: aBlock! !

!ICCalendar methodsFor: 'todos' stamp: 'pmm 10/7/2005 19:26'!
todosForDateAndTime: aDateAndTime 
	^self todos select: [ :each | each startsInHour: aDateAndTime]! !

!ICCalendar methodsFor: 'todos' stamp: 'pmm 10/15/2005 20:07'!
todosForDate: aDate 
	^self todos select: [ :each | each isValidForDate: aDate]! !

!ICCalendar methodsFor: 'todos' stamp: 'pmm 10/7/2005 00:20'!
todos: aCollection 
	todos := aCollection! !

!ICCalendar methodsFor: 'users' stamp: 'pmm 10/7/2005 00:21'!
users
	^users! !

!ICCalendar methodsFor: 'users' stamp: 'pmm 10/7/2005 00:23'!
usersDo: aBlock
	self users do: aBlock! !

!ICCalendar methodsFor: 'users' stamp: 'pmm 10/7/2005 00:23'!
users: aCollection 
	users := aCollection! !

!ICCalendar methodsFor: 'accessing-constants' stamp: 'pmm 10/6/2005 23:53'!
vCalendarVersion
	^2.0! !

!ICCalendar methodsFor: 'accessing' stamp: 'pmm 10/6/2005 23:07'!
version
	^version! !

!ICCalendar methodsFor: 'accessing' stamp: 'pmm 10/6/2005 23:07'!
version: aFloat 
	version := aFloat! !

ICComponent subclass: #ICCalendarEntry
	instanceVariableNames: 'comments url uid stamp'
	classVariableNames: 'UidStrategy'
	poolDictionaries: ''
	category: 'ICal-Abstract'!

!ICCalendarEntry class methodsFor: 'class initialization' stamp: 'pmm 10/6/2005 18:28'!
initialize
	"self initialize"
	self uidStrategy: self selectStrategy! !

!ICCalendarEntry class methodsFor: 'class initialization' stamp: 'pmm 10/6/2005 18:30'!
selectStrategy
	^Utilities authorInitials = 'lr'
		ifFalse: [ ICRecommendedByStandardStrategy new  ]
		ifTrue: [ ICSqueakUUIDStrategy new ]! !

!ICCalendarEntry class methodsFor: 'accessing' stamp: 'pmm 10/6/2005 18:25'!
uidStrategy
	^UidStrategy! !

!ICCalendarEntry class methodsFor: 'accessing' stamp: 'pmm 10/6/2005 18:25'!
uidStrategy: aStrategy
	UidStrategy := aStrategy! !

!ICCalendarEntry methodsFor: 'accessing' stamp: 'pmm 10/14/2005 12:44'!
addComment: aString
	^self comments add: aString! !

!ICCalendarEntry methodsFor: 'accessing' stamp: 'pmm 10/8/2005 00:12'!
comments
	^comments! !

!ICCalendarEntry methodsFor: 'accessing' stamp: 'pmm 10/8/2005 00:12'!
comments: aCollection 
	comments := aCollection! !

!ICCalendarEntry methodsFor: 'exporting' stamp: 'pmm 10/9/2005 11:33'!
exportOn: anExporter
	anExporter exportUid: self uid.
	anExporter exportUrl: self url.
	anExporter exportComments: self comments.
	anExporter exportStamp: self stamp! !

!ICCalendarEntry methodsFor: 'private' stamp: 'pmm 10/6/2005 18:36'!
generateUid
	^self uidStrategy generateUid! !

!ICCalendarEntry methodsFor: 'initialize-release' stamp: 'pmm 10/8/2005 00:13'!
initialize
	super initialize.
	self uid: self generateUid.
	self comments: OrderedCollection new! !

!ICCalendarEntry methodsFor: 'accessing' stamp: 'pmm 10/7/2005 09:50'!
stamp
	^stamp! !

!ICCalendarEntry methodsFor: 'accessing' stamp: 'pmm 10/7/2005 09:50'!
stamp: aDateAndTime 
	stamp := aDateAndTime! !

!ICCalendarEntry methodsFor: 'accessing' stamp: 'pmm 10/6/2005 18:34'!
uid
	^uid! !

!ICCalendarEntry methodsFor: 'accessing' stamp: 'pmm 10/6/2005 18:24'!
uidStrategy
	^UidStrategy! !

!ICCalendarEntry methodsFor: 'accessing' stamp: 'pmm 10/6/2005 18:25'!
uidStrategy: aStrategy
	UidStrategy := aStrategy! !

!ICCalendarEntry methodsFor: 'accessing' stamp: 'pmm 10/6/2005 18:34'!
uid: aString 
	uid := aString! !

!ICCalendarEntry methodsFor: 'accessing' stamp: 'pmm 10/7/2005 09:50'!
url
	^url! !

!ICCalendarEntry methodsFor: 'accessing' stamp: 'pmm 10/7/2005 09:51'!
url: aUrl 
	url := aUrl! !

ICCalendarEntry subclass: #ICFreeBusy
	instanceVariableNames: 'end start duration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Model'!

!ICFreeBusy class methodsFor: 'accessing' stamp: 'pmm 10/3/2005 22:36'!
iCalType
	^'VFREEBUSY'! !

!ICFreeBusy methodsFor: 'double-dispatch' stamp: 'pmm 10/13/2005 10:07'!
addToCalendar: aCalendar
	aCalendar addFreeBusy: self! !

!ICFreeBusy methodsFor: 'accessing' stamp: 'pmm 10/7/2005 10:17'!
duration
	^duration! !

!ICFreeBusy methodsFor: 'accessing' stamp: 'pmm 10/7/2005 10:17'!
duration: aDuration 
	duration := aDuration! !

!ICFreeBusy methodsFor: 'accessing' stamp: 'pmm 10/3/2005 22:08'!
end
	^end! !

!ICFreeBusy methodsFor: 'accessing' stamp: 'pmm 10/3/2005 22:08'!
end: aDateAndTime 
	end := aDateAndTime! !

!ICFreeBusy methodsFor: 'exporting' stamp: 'pmm 10/9/2005 11:57'!
exportOn: anExporter
	super exportOn: anExporter.
	anExporter exportStart: self start.
	anExporter exportEnd: self end.	
	anExporter exportDuration: self duration! !

!ICFreeBusy methodsFor: 'accessing' stamp: 'pmm 10/7/2005 10:17'!
start
	^start! !

!ICFreeBusy methodsFor: 'accessing' stamp: 'pmm 10/7/2005 10:18'!
start: aDateAndTime 
	start := aDateAndTime! !

ICCalendarEntry subclass: #ICViewableCalendarEntry
	instanceVariableNames: 'attachments categories classification created exclusionDates exclusionRule status recurrenceDates recurrenceRule lastModified sequenceNumber summary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Abstract'!

ICViewableCalendarEntry subclass: #ICJob
	instanceVariableNames: 'alarms duration geo location priority resources start textualDescription'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Abstract'!

!ICJob commentStamp: '<historical>' prior: 0!
This is the abstract event main class and provides generic functionality used by all kind of events.
It is the superClass of classes like Appointment, Todo or EventSerie.
We used here the composite pattern: an event can be an simple event or a collection of events called EventSerie.
On the class side, all the possible priorities are stored as strings. The user can select one of these priorities for every kind of event.!

ICJob subclass: #ICEvent
	instanceVariableNames: 'end transparency'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Model'!

!ICEvent commentStamp: '<historical>' prior: 0!
An Appointment is a normal event which has a start- and an endtime.
It can also be a fulltime event which means that this event lasts the whole day.
On the class side, some static information about appointments is stored, for instance which stati an appointment can have. The two different types mentioned above, fullday or normal event, are also stored on the class side.!

!ICEvent class methodsFor: 'accessing' stamp: 'pmm 10/7/2005 10:13'!
iCalType
	^'VEVENT'! !

!ICEvent class methodsFor: 'accessing-stati' stamp: 'pmm 10/3/2005 18:56'!
possibleStati
	^super possibleStati
		add: self statusConfirmed;
		add: self statusTentative;
		yourself! !

!ICEvent class methodsFor: 'accessing-transparencies' stamp: 'pmm 10/3/2005 22:16'!
possibleTransparencies
	^Array
		with: self transparencyOpaque
		with: self transparencyTranparent ! !

!ICEvent class methodsFor: 'accessing-stati' stamp: 'pmm 10/3/2005 18:55'!
statusConfirmed
	^'CONFIRMED'! !

!ICEvent class methodsFor: 'accessing-stati' stamp: 'pmm 10/3/2005 18:55'!
statusTentative
	^'TENTATIVE'! !

!ICEvent class methodsFor: 'accessing-transparencies' stamp: 'pmm 10/3/2005 22:15'!
transparencyOpaque
	^'OPAQUE'! !

!ICEvent class methodsFor: 'accessing-transparencies' stamp: 'pmm 10/3/2005 22:15'!
transparencyTranparent
	^'TRANSPARENT'! !

!ICEvent methodsFor: 'double-dispatch' stamp: 'pmm 10/13/2005 10:03'!
addToCalendar: aCalendar
	aCalendar addEvent: self! !

!ICEvent methodsFor: 'status' stamp: 'pmm 10/3/2005 19:02'!
beConfirmed
	self status: self class statusConfirmed! !

!ICEvent methodsFor: 'actions' stamp: 'pmm 10/7/2005 14:17'!
beFullDay
	self start ifNotNil: [
		self start: self start asDate ].
	self end isNil
		ifTrue: [ self end: self start + 1 day ]
		ifFalse: [ self end: self end asDate ]	! !

!ICEvent methodsFor: 'transparency' stamp: 'pmm 10/9/2005 13:02'!
beOpaque
	self transparency: self class transparencyOpaque ! !

!ICEvent methodsFor: 'status' stamp: 'pmm 10/3/2005 19:02'!
beTentative
	self status: self class statusTentative! !

!ICEvent methodsFor: 'transparency' stamp: 'pmm 10/9/2005 13:02'!
beTransparent
	self transparency: self class transparencyTranparent! !

!ICEvent methodsFor: 'accessing' stamp: 'pmm 10/7/2005 13:19'!
end
	^end! !

!ICEvent methodsFor: 'accessing' stamp: 'pmm 10/7/2005 13:20'!
end: aDateAndTime 
	end := aDateAndTime! !

!ICEvent methodsFor: 'exporting' stamp: 'pmm 10/13/2005 11:49'!
exportOn: anExporter 
	super exportOn: anExporter.
	anExporter exportEnd: self end.
	anExporter exportTransparency: self transparency! !

!ICEvent methodsFor: 'accessing' stamp: 'pmm 11/12/2005 12:27'!
hours
	| diff |
	diff := self end - self start.
	^diff hours + (diff minutes / 60) asFloat.! !

!ICEvent methodsFor: 'status' stamp: 'pmm 10/7/2005 17:02'!
isConfirmed
	^self status = self class statusConfirmed! !

!ICEvent methodsFor: 'testing' stamp: 'pmm 10/7/2005 14:19'!
isFullDayEvent
	^(self start isDateOrNil)
		and: [ self end isDateOrNil ]! !

!ICEvent methodsFor: 'transparency' stamp: 'pmm 10/3/2005 22:18'!
isOpaque
	^self isTransparent not! !

!ICEvent methodsFor: 'status' stamp: 'pmm 10/7/2005 17:03'!
isTentative
	^self status = self class statusTentative! !

!ICEvent methodsFor: 'transparency' stamp: 'pmm 10/7/2005 14:20'!
isTransparent
	^self transparency = self class transparencyTranparent
		or: [ self end isNil ]! !

!ICEvent methodsFor: 'testing' stamp: 'pmm 10/7/2005 13:45'!
isValidForDate: aDate
	^self start asDate <= aDate and: [self end asDate >= aDate].! !

!ICEvent methodsFor: 'testing' stamp: 'pmm 10/7/2005 19:19'!
startsInHour: aDateAndTime 
	^aDateAndTime <= self start
		and: [(aDateAndTime + 3600 seconds) >= self start ]! !

!ICEvent methodsFor: 'transparency' stamp: 'pmm 10/3/2005 22:14'!
transparency
	^transparency! !

!ICEvent methodsFor: 'transparency' stamp: 'pmm 10/3/2005 22:14'!
transparency: aString 
	transparency := aString! !

!ICEvent methodsFor: 'actions' stamp: 'pmm 10/9/2005 11:53'!
updateEventWith: anEventOrCommand 
	super updateEventWith: anEventOrCommand.

	self start: anEventOrCommand start.
	self end: anEventOrCommand end.
	self location: anEventOrCommand location.! !

!ICJob class methodsFor: 'accessing-priorities' stamp: 'pmm 10/3/2005 17:58'!
highPriority
	^1! !

!ICJob class methodsFor: 'accessing-priorities' stamp: 'pmm 10/3/2005 17:58'!
lowPriority
	^9! !

!ICJob class methodsFor: 'accessing-priorities' stamp: 'pmm 10/3/2005 17:58'!
mediumPriority
	^5! !

!ICJob class methodsFor: 'accessing-priorities' stamp: 'pmm 10/7/2005 10:53'!
possiblePriorities
	"Description: The priority is specified as an integer in the range
   zero to nine. A value of zero (US-ASCII decimal 48) specifies an
   undefined priority. A value of one (US-ASCII decimal 49) is the
   highest priority. A value of two (US-ASCII decimal 50) is the second
   highest priority. Subsequent numbers specify a decreasing ordinal
   priority. A value of nine (US-ASCII decimal 58) is the lowest
   priority.

   A CUA with a three-level priority scheme of 'HIGH', 'MEDIUM' and
   'LOW' is mapped into this property such that a property value in the
   range of one (US-ASCII decimal 49) to four (US-ASCII decimal 52)
   specifies 'HIGH' priority. A value of five (US-ASCII decimal 53) is
   the normal or 'MEDIUM' priority. A value in the range of six (US-
   ASCII decimal 54) to nine (US-ASCII decimal 58) is 'LOW' priority.

   A CUA with a priority schema of 'A1', 'A2', 'A3', 'B1', 'B2', ...,
   'C3' is mapped into this property such that a property value of one
   (US-ASCII decimal 49) specifies 'A1', a property value of two (US-
   ASCII decimal 50) specifies 'A2', a property value of three (US-ASCII
   decimal 51) specifies 'A3', and so forth up to a property value of 9
   (US-ASCII decimal 58) specifies 'C3'."
	^0 to: 9! !

!ICJob class methodsFor: 'accessing-priorities' stamp: 'pmm 10/3/2005 17:59'!
undefinedPriority
	^0! !

!ICJob methodsFor: 'accessing' stamp: 'pmm 10/13/2005 11:48'!
addAlarm: anAlarm
	^self alarms add: anAlarm! !

!ICJob methodsFor: 'accessing' stamp: 'pmm 10/14/2005 12:50'!
addTextualDescription: aString
	"for polymorphism with ICJournal"
	self textualDescription: aString.
	^aString! !

!ICJob methodsFor: 'accessing' stamp: 'pmm 10/13/2005 11:47'!
alarms
	^alarms! !

!ICJob methodsFor: 'accessing' stamp: 'pmm 10/13/2005 11:47'!
alarms: aCollection 
	alarms := aCollection! !

!ICJob methodsFor: 'priority' stamp: 'pmm 10/7/2005 10:56'!
beHighPriority
	self priority: self class highPriority! !

!ICJob methodsFor: 'priority' stamp: 'pmm 10/7/2005 10:56'!
beLowPriority
	self priority: self class lowPriority! !

!ICJob methodsFor: 'priority' stamp: 'pmm 10/7/2005 10:54'!
beMediumPriority
	self priority: self class mediumPriority! !

!ICJob methodsFor: 'accessing' stamp: 'pmm 10/9/2005 12:17'!
duration
	^duration! !

!ICJob methodsFor: 'accessing' stamp: 'pmm 10/9/2005 12:17'!
duration: aDuration 
	duration := aDuration! !

!ICJob methodsFor: 'exporting' stamp: 'pmm 11/11/2005 22:16'!
exportOn: anExporter
	super exportOn: anExporter.
	anExporter exportPriority: self priority.
	anExporter exportDescription: self textualDescription.	
	anExporter exportGeo: (self geo ifNotNil: [ self geo asArray ]).
	anExporter exportLocation: self location.
	anExporter exportResources: self resources.
	anExporter exportStart: self start.
	anExporter exportDuration: self duration.
	self alarms do: [ :each |
		anExporter export: each ]! !

!ICJob methodsFor: 'accessing' stamp: 'pmm 10/3/2005 17:44'!
geo
	^geo! !

!ICJob methodsFor: 'accessing' stamp: 'pmm 10/3/2005 17:57'!
geo: aPoint
	"This property specifies information related to the global
   position for the activity specified by a calendar component."

 	"Description: The property value specifies latitude and longitude, in
   that order (i.e., 'LAT LON' ordering).

	aPoint is a point of floats"
	geo := aPoint! !

!ICJob methodsFor: 'calculation' stamp: 'pmm 10/7/2005 13:48'!
hours
	| diff |
	diff := self end - self start.
	^diff hours + (diff minutes / 60) asFloat.! !

!ICJob methodsFor: 'initialize-release' stamp: 'pmm 10/13/2005 11:48'!
initialize
	super initialize.
	self alarms: OrderedCollection new.	
	self resources: OrderedCollection new.
	self beMediumPriority.

	
	! !

!ICJob methodsFor: 'priority' stamp: 'pmm 10/7/2005 17:02'!
isHighPriority
	^self priority = self class highPriority! !

!ICJob methodsFor: 'priority' stamp: 'pmm 10/7/2005 17:01'!
isLowPriority
	^self priority = self class lowPriority! !

!ICJob methodsFor: 'priority' stamp: 'pmm 10/7/2005 17:01'!
isMediumPriority
	^self priority = self class mediumPriority! !

!ICJob methodsFor: 'testing' stamp: 'dr 4/18/2005 20:57'!
isValidForDate: aDate
	self subclassResponsibility! !

!ICJob methodsFor: 'accessing' stamp: 'pmm 10/9/2005 12:11'!
location
	^location! !

!ICJob methodsFor: 'accessing' stamp: 'pmm 10/9/2005 12:11'!
location: aString 
	location := aString! !

!ICJob methodsFor: 'priority' stamp: 'dr 4/19/2005 13:57'!
priority
	^priority! !

!ICJob methodsFor: 'priority' stamp: 'pmm 10/7/2005 10:54'!
priority: aString
	"see #possiblePriorites on class side"
	priority := aString! !

!ICJob methodsFor: 'accessing' stamp: 'pmm 10/3/2005 18:48'!
resources
	^resources! !

!ICJob methodsFor: 'accessing' stamp: 'pmm 10/3/2005 18:48'!
resources: aCollection 
	resources := aCollection! !

!ICJob methodsFor: 'accessing' stamp: 'pmm 10/7/2005 16:43'!
start
	^start! !

!ICJob methodsFor: 'testing' stamp: 'pmm 9/16/2005 16:29'!
startsInHour: aTimestamp 
	self subclassResponsibility ! !

!ICJob methodsFor: 'accessing' stamp: 'pmm 10/7/2005 16:43'!
start: aDateAndTime 
	start := aDateAndTime! !

!ICJob methodsFor: 'accessing' stamp: 'pmm 10/6/2005 23:14'!
textualDescription
	^textualDescription! !

!ICJob methodsFor: 'accessing' stamp: 'pmm 10/6/2005 23:14'!
textualDescription: aString 
	textualDescription := aString! !

!ICJob methodsFor: 'actions' stamp: 'pmm 10/7/2005 19:16'!
updateEventWith: anEventOrCommand 
	super updateEventWith: anEventOrCommand .
	
	self summary: anEventOrCommand summary.
	self categories: anEventOrCommand categories.
	self textualDescription: anEventOrCommand textualDescription.
	self status: anEventOrCommand status.
	self priority: anEventOrCommand priority.! !

!ICJob methodsFor: 'comparing' stamp: 'pmm 10/7/2005 13:19'!
<= aJob
	^self start <= aJob start! !

ICJob subclass: #ICTodo
	instanceVariableNames: 'completed due percentComplete'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Model'!

!ICTodo commentStamp: '<historical>' prior: 0!
An Event which represents a task which has to be done util the defined deadline.
A todo has as start- and endtime the deadline stored.!

!ICTodo class methodsFor: 'accessing' stamp: 'pmm 10/3/2005 22:34'!
iCalType
	^'VTODO'! !

!ICTodo class methodsFor: 'accessing' stamp: 'pmm 10/3/2005 19:00'!
possibleStati
	^super possibleStati
		add: self statusInProcess;
		add: self statusNeedsAction;
		add: self statusCompleted;
		yourself! !

!ICTodo class methodsFor: 'accessing' stamp: 'pmm 10/3/2005 18:58'!
statusCompleted
	^'COMPLETED'! !

!ICTodo class methodsFor: 'accessing' stamp: 'pmm 10/3/2005 18:59'!
statusInProcess
	^'IN-PROCESS'! !

!ICTodo class methodsFor: 'accessing' stamp: 'pmm 10/3/2005 18:58'!
statusNeedsAction
	^'NEEDS-ACTION'! !

!ICTodo methodsFor: 'double-dispatch' stamp: 'pmm 10/13/2005 10:09'!
addToCalendar: aCalendar
	aCalendar addTodo: self! !

!ICTodo methodsFor: 'status' stamp: 'pmm 10/3/2005 19:00'!
beCompleted
	self status: self class statusCompleted! !

!ICTodo methodsFor: 'status' stamp: 'pmm 10/7/2005 16:33'!
beInProcess
	self status: self class statusInProcess ! !

!ICTodo methodsFor: 'status' stamp: 'pmm 10/7/2005 16:34'!
beNeedsAction
	self status: self class statusNeedsAction! !

!ICTodo methodsFor: 'accessing' stamp: 'pmm 10/3/2005 22:03'!
completed
	^completed! !

!ICTodo methodsFor: 'accessing' stamp: 'pmm 10/7/2005 16:20'!
completed: aDateAndTime 
	completed := aDateAndTime.
	aDateAndTime ifNotNil: [
		self beCompleted ]! !

!ICTodo methodsFor: 'accessing' stamp: 'pmm 10/7/2005 16:17'!
due
	^due! !

!ICTodo methodsFor: 'accessing' stamp: 'pmm 10/7/2005 16:17'!
due: aDateAndTime 
	due := aDateAndTime! !

!ICTodo methodsFor: 'exporting' stamp: 'pmm 10/9/2005 12:05'!
exportOn: anExporter
	super exportOn: anExporter.
	anExporter exportCompleted: self completed.
	anExporter exportPercentComplete: self percentComplete.
	anExporter exportDue: self due	
	! !

!ICTodo methodsFor: 'status' stamp: 'pmm 10/3/2005 22:05'!
isCompleted
	^self status = self class statusCompleted.
	! !

!ICTodo methodsFor: 'status' stamp: 'pmm 10/7/2005 17:03'!
isInProcess
	^self status = self class statusInProcess ! !

!ICTodo methodsFor: 'status' stamp: 'pmm 10/7/2005 17:03'!
isNeedsAction
	^self status = self class statusNeedsAction! !

!ICTodo methodsFor: 'testing' stamp: 'pmm 10/7/2005 16:28'!
isValidForDate: aDate
	^self due asDate = aDate.! !

!ICTodo methodsFor: 'accessing' stamp: 'pmm 10/9/2005 12:04'!
percentComplete
	^percentComplete! !

!ICTodo methodsFor: 'accessing' stamp: 'pmm 10/9/2005 12:04'!
percentComplete: anInteger 
	"anInteger is an integer between 0 and 100
	e.g 70 means 70% complete"

	percentComplete := anInteger! !

!ICTodo methodsFor: 'testing' stamp: 'pmm 10/7/2005 17:31'!
startsInHour: aDateAndTime 
	^aDateAndTime <= self due
		and: [(aDateAndTime + 3600 seconds) >= self due]! !

!ICTodo methodsFor: 'actions' stamp: 'pmm 10/7/2005 19:11'!
updateEventWith: anEventOrCommand 
	super updateEventWith: anEventOrCommand.

	self due: anEventOrCommand due.

	anEventOrCommand isCompleted ifTrue: [
		self beCompleted.
		anEventOrCommand completed isNil ifTrue: [
			self completed: DateAndTime now.
		] ifFalse: [
			self completed: anEventOrCommand completed.
		].
	]! !

ICViewableCalendarEntry subclass: #ICJournal
	instanceVariableNames: 'textualDescriptions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Model'!

!ICJournal class methodsFor: 'accessing' stamp: 'pmm 10/3/2005 22:35'!
iCalType
	^'VJOURNAL'! !

!ICJournal class methodsFor: 'accessing' stamp: 'pmm 10/3/2005 19:05'!
possibleStati
	^super possibleStati
		add: self statusDraft;
		add: self statusFinal;
		yourself! !

!ICJournal class methodsFor: 'accessing' stamp: 'pmm 10/3/2005 19:04'!
statusDraft
	^'DRAFT'! !

!ICJournal class methodsFor: 'accessing' stamp: 'pmm 10/3/2005 19:04'!
statusFinal
	^'FINAL'! !

!ICJournal methodsFor: 'adding' stamp: 'pmm 10/12/2005 06:35'!
addTextualDescription: aString
	^self textualDescriptions add: aString! !

!ICJournal methodsFor: 'double-dispatch' stamp: 'pmm 10/13/2005 10:08'!
addToCalendar: aCalendar
	aCalendar addJournal: self! !

!ICJournal methodsFor: 'status' stamp: 'pmm 10/7/2005 16:35'!
beDraft
	self status: self class statusDraft! !

!ICJournal methodsFor: 'status' stamp: 'pmm 10/7/2005 16:35'!
beFinal
	self status: self class statusFinal! !

!ICJournal methodsFor: 'exporting' stamp: 'pmm 10/9/2005 11:58'!
exportOn: anExporter
	super exportOn: anExporter.
	anExporter exportDescription: self textualDescriptions! !

!ICJournal methodsFor: 'initialize-release' stamp: 'pmm 10/3/2005 17:43'!
initialize
	super initialize.
	self textualDescriptions: OrderedCollection new! !

!ICJournal methodsFor: 'status' stamp: 'pmm 10/7/2005 17:05'!
isDraft
	^self status = self class statusDraft! !

!ICJournal methodsFor: 'status' stamp: 'pmm 10/7/2005 17:05'!
isFinal
	^self status = self class statusFinal! !

!ICJournal methodsFor: 'accessing' stamp: 'pmm 10/3/2005 17:42'!
textualDescriptions
	^textualDescriptions! !

!ICJournal methodsFor: 'accessing' stamp: 'pmm 10/3/2005 17:42'!
textualDescriptions: aCollection 
	textualDescriptions := aCollection! !

!ICViewableCalendarEntry class methodsFor: 'accessing-classifications' stamp: 'pmm 10/7/2005 10:27'!
classificationConfidential
	^'CONFIDENTIAL'
	! !

!ICViewableCalendarEntry class methodsFor: 'accessing-classifications' stamp: 'pmm 10/7/2005 10:27'!
classificationPrivate
	^'PRIVATE'! !

!ICViewableCalendarEntry class methodsFor: 'accessing-classifications' stamp: 'pmm 10/7/2005 10:27'!
classificationPublic
	^'PUBLIC'
	! !

!ICViewableCalendarEntry class methodsFor: 'accessing-classifications' stamp: 'pmm 10/7/2005 10:28'!
possibleClassifications
	^Array
		with: self classificationPublic
		with: self classificationPrivate
		with: self classificationConfidential
	! !

!ICViewableCalendarEntry class methodsFor: 'accessing-stati' stamp: 'pmm 10/3/2005 18:54'!
possibleStati
	^OrderedCollection with: self statusCanceled
	! !

!ICViewableCalendarEntry class methodsFor: 'accessing-stati' stamp: 'pmm 10/3/2005 18:54'!
statusCanceled
	^'CANCELLED'
	! !

!ICViewableCalendarEntry class methodsFor: 'instance creation' stamp: 'pmm 10/6/2005 23:19'!
summary: aString
	^self new
		summary: aString;
		yourself! !

!ICViewableCalendarEntry methodsFor: 'accessing' stamp: 'pmm 10/7/2005 10:24'!
addCategory: aCategory
	^self categories add: aCategory! !

!ICViewableCalendarEntry methodsFor: 'accessing' stamp: 'pmm 10/14/2005 12:15'!
attachments
	^attachments! !

!ICViewableCalendarEntry methodsFor: 'accessing' stamp: 'pmm 10/14/2005 12:15'!
attachments: aCollection 
	attachments := aCollection! !

!ICViewableCalendarEntry methodsFor: 'status' stamp: 'pmm 10/7/2005 10:33'!
beCanceled
	self status: self class statusCanceled! !

!ICViewableCalendarEntry methodsFor: 'classification' stamp: 'pmm 10/7/2005 10:29'!
beConfidential
	self classification: self class classificationConfidential! !

!ICViewableCalendarEntry methodsFor: 'classification' stamp: 'pmm 10/7/2005 10:29'!
bePrivate
	self classification: self class classificationPrivate! !

!ICViewableCalendarEntry methodsFor: 'classification' stamp: 'pmm 10/7/2005 10:29'!
bePublic
	self classification: self class classificationPublic! !

!ICViewableCalendarEntry methodsFor: 'accessing' stamp: 'pmm 10/7/2005 10:24'!
categories
	^categories! !

!ICViewableCalendarEntry methodsFor: 'accessing' stamp: 'pmm 10/7/2005 10:24'!
categories: aCollection 
	categories := aCollection! !

!ICViewableCalendarEntry methodsFor: 'classification' stamp: 'pmm 10/7/2005 10:25'!
classification
	^classification! !

!ICViewableCalendarEntry methodsFor: 'classification' stamp: 'pmm 10/7/2005 10:26'!
classification: aString 
	"see #possibleClassification on class side"
	classification := aString! !

!ICViewableCalendarEntry methodsFor: 'accessing' stamp: 'pmm 10/6/2005 22:56'!
created
	^created! !

!ICViewableCalendarEntry methodsFor: 'accessing' stamp: 'pmm 10/6/2005 22:56'!
created: aDateAndTime 
	created := aDateAndTime! !

!ICViewableCalendarEntry methodsFor: 'accessing' stamp: 'pmm 10/6/2005 22:49'!
exclusionDates
	^exclusionDates! !

!ICViewableCalendarEntry methodsFor: 'accessing' stamp: 'pmm 10/6/2005 22:49'!
exclusionDates: aCollection 
	exclusionDates := aCollection! !

!ICViewableCalendarEntry methodsFor: 'accessing' stamp: 'pmm 10/6/2005 22:49'!
exclusionRule
	^exclusionRule! !

!ICViewableCalendarEntry methodsFor: 'accessing' stamp: 'pmm 10/6/2005 22:50'!
exclusionRule: aRecurrenceRule 
	exclusionRule := aRecurrenceRule! !

!ICViewableCalendarEntry methodsFor: 'exporting' stamp: 'pmm 10/14/2005 12:14'!
exportOn: anExporter
	super exportOn: anExporter.
	anExporter exportAttachments: self attachments.
	anExporter exportCategories: self categories.
	anExporter exportClassification: self classification.
	anExporter exportCreated: self created.
	anExporter exportExclusionDates: self exclusionDates.
	anExporter exportExclusionRule: self exclusionRule.
	anExporter exportStatus: self status.
	anExporter exportRecurrenceDates: self recurrenceDates.
	anExporter exportRecurrenceRule: self recurrenceRule.
	anExporter exportLastModified: self lastModified.
	anExporter exportSequenceNumber: self sequenceNumber.
	anExporter exportSummary: self summary! !

!ICViewableCalendarEntry methodsFor: 'testing' stamp: 'pmm 10/6/2005 22:51'!
hasRecurrenceRule
	^self recurrenceRule notNil! !

!ICViewableCalendarEntry methodsFor: 'testing' stamp: 'pmm 10/7/2005 17:10'!
hasSummary
	^self summary notNil! !

!ICViewableCalendarEntry methodsFor: 'initialize-release' stamp: 'pmm 10/14/2005 12:16'!
initialize
	super initialize.
	self created: DateAndTime now.
	self categories: OrderedCollection new.
	self recurrenceDates: OrderedCollection new.
	self exclusionDates: OrderedCollection new.
	self attachments: OrderedCollection new.
	self sequenceNumber: 0! !

!ICViewableCalendarEntry methodsFor: 'status' stamp: 'pmm 10/7/2005 10:34'!
isCanceled
	^self status = self class statusCanceled! !

!ICViewableCalendarEntry methodsFor: 'classification' stamp: 'pmm 11/1/2005 22:32'!
isConfidential
	^self classification = self class classificationConfidential! !

!ICViewableCalendarEntry methodsFor: 'classification' stamp: 'pmm 11/1/2005 22:32'!
isPrivate
	^self classification = self class classificationPrivate! !

!ICViewableCalendarEntry methodsFor: 'classification' stamp: 'pmm 11/1/2005 22:32'!
isPublic
	^self classification = self class classificationPublic! !

!ICViewableCalendarEntry methodsFor: 'testing' stamp: 'pmm 10/6/2005 22:51'!
isRecurrent
	^self hasRecurrenceRule
		or: [ self recurrenceDates notEmpty ]! !

!ICViewableCalendarEntry methodsFor: 'accessing' stamp: 'pmm 10/7/2005 17:32'!
lastModified
	^lastModified! !

!ICViewableCalendarEntry methodsFor: 'accessing' stamp: 'pmm 10/7/2005 17:32'!
lastModified: aDateAndTime 
	lastModified := aDateAndTime! !

!ICViewableCalendarEntry methodsFor: 'updating' stamp: 'pmm 10/6/2005 23:06'!
modified
	self lastModified: DateAndTime now.
	self sequenceNumber: self sequenceNumber + 1! !

!ICViewableCalendarEntry methodsFor: 'printing' stamp: 'pmm 10/7/2005 17:12'!
printOn: aStream
	super printOn: aStream.
	self hasSummary ifTrue: [
		aStream
			nextPut: $(;
			nextPutAll: self summary;
			nextPut: $) ]! !

!ICViewableCalendarEntry methodsFor: 'accessing' stamp: 'pmm 10/6/2005 22:49'!
recurrenceDates
	^recurrenceDates! !

!ICViewableCalendarEntry methodsFor: 'accessing' stamp: 'pmm 10/6/2005 22:50'!
recurrenceDates: aCollection 
	recurrenceDates := aCollection! !

!ICViewableCalendarEntry methodsFor: 'accessing' stamp: 'pmm 10/6/2005 22:49'!
recurrenceRule
	^recurrenceRule! !

!ICViewableCalendarEntry methodsFor: 'accessing' stamp: 'pmm 10/6/2005 22:50'!
recurrenceRule: aRecurrenceRule 
	recurrenceRule := aRecurrenceRule! !

!ICViewableCalendarEntry methodsFor: 'accessing' stamp: 'pmm 10/6/2005 23:04'!
sequenceNumber
	^sequenceNumber! !

!ICViewableCalendarEntry methodsFor: 'accessing' stamp: 'pmm 10/6/2005 23:04'!
sequenceNumber: anInteger 
	sequenceNumber := anInteger! !

!ICViewableCalendarEntry methodsFor: 'status' stamp: 'pmm 10/7/2005 10:32'!
status
	^status! !

!ICViewableCalendarEntry methodsFor: 'status' stamp: 'pmm 10/7/2005 10:32'!
status: anObject
	status := anObject! !

!ICViewableCalendarEntry methodsFor: 'accessing' stamp: 'pmm 10/6/2005 23:19'!
summary
	^summary! !

!ICViewableCalendarEntry methodsFor: 'accessing' stamp: 'pmm 10/6/2005 23:19'!
summary: aString 
	summary := aString! !

!ICViewableCalendarEntry methodsFor: 'updating' stamp: 'pmm 10/7/2005 19:16'!
updateEventWith: anEventOrCommand 
	self created: anEventOrCommand  created.
	self status: anEventOrCommand  status.
	self lastModified: anEventOrCommand lastModified! !

!ICComponent class methodsFor: 'accessing' stamp: 'pmm 10/3/2005 22:36'!
iCalType
	self subclassResponsibility ! !

!ICComponent methodsFor: 'accessing' stamp: 'pmm 10/14/2005 15:50'!
addUnknownProperty: anUnkownProperty
	^self unknownProperties add: anUnkownProperty! !

!ICComponent methodsFor: 'exporting' stamp: 'pmm 10/9/2005 10:56'!
exportOn: anExporter
	self subclassResponsibility ! !

!ICComponent methodsFor: 'initialize-release' stamp: 'pmm 10/14/2005 15:50'!
initialize
	super initialize.
	self unknownProperties: OrderedCollection new.! !

!ICComponent methodsFor: 'accessing' stamp: 'pmm 10/14/2005 15:49'!
unknownProperties
	^unknownProperties! !

!ICComponent methodsFor: 'accessing' stamp: 'pmm 10/14/2005 15:49'!
unknownProperties: aCollection 
	unknownProperties := aCollection! !

ICComponent subclass: #ICTimezone
	instanceVariableNames: 'comments start recurrenceRule recurrenceDates lastModified'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Model'!

!ICTimezone class methodsFor: 'accessing' stamp: 'pmm 10/3/2005 22:37'!
iCalType
	^'VTIMEZONE'! !

!ICTimezone methodsFor: 'double-dispatch' stamp: 'pmm 10/13/2005 10:08'!
addToCalendar: aCalendar
	aCalendar addTimezone: self! !

!ICTimezone methodsFor: 'accessing' stamp: 'pmm 10/9/2005 11:59'!
comments
	^comments! !

!ICTimezone methodsFor: 'accessing' stamp: 'pmm 10/9/2005 12:00'!
comments: aCollection 
	comments := aCollection! !

!ICTimezone methodsFor: 'exporting' stamp: 'pmm 10/9/2005 12:02'!
exportOn: anExporter
	anExporter exportStart: self start.
	anExporter exportRecurrenceRule: self recurrenceRule.
	anExporter exportRecurrenceDates: self recurrenceDates.
	anExporter exportLastModified: self lastModified ! !

!ICTimezone methodsFor: 'initialize-release' stamp: 'pmm 10/9/2005 11:59'!
initialize
	super initialize.
	self comments: OrderedCollection new! !

!ICTimezone methodsFor: 'accessing' stamp: 'pmm 10/6/2005 23:01'!
lastModified
	^lastModified! !

!ICTimezone methodsFor: 'accessing' stamp: 'pmm 10/6/2005 23:02'!
lastModified: aDateAndTime 
	lastModified := aDateAndTime! !

!ICTimezone methodsFor: 'accessing' stamp: 'pmm 10/6/2005 23:01'!
recurrenceDates
	^recurrenceDates! !

!ICTimezone methodsFor: 'accessing' stamp: 'pmm 10/6/2005 23:01'!
recurrenceDates: aCollection 
	recurrenceDates := aCollection! !

!ICTimezone methodsFor: 'accessing' stamp: 'pmm 10/6/2005 23:01'!
recurrenceRule
	^recurrenceRule! !

!ICTimezone methodsFor: 'accessing' stamp: 'pmm 10/6/2005 23:02'!
recurrenceRule: aRecurrenceRule 
	recurrenceRule := aRecurrenceRule! !

!ICTimezone methodsFor: 'accessing' stamp: 'pmm 10/7/2005 10:18'!
start
	^start! !

!ICTimezone methodsFor: 'accessing' stamp: 'pmm 10/7/2005 10:18'!
start: aDateAndTime 
	start := aDateAndTime! !

ICComponent subclass: #ICVCard
	instanceVariableNames: 'addresses categories birthday emailAddresses fullname name nickname notes organization phoneNumbers photo title url version aimids msnids icqids yahooids'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-VCard-Model'!

!ICVCard commentStamp: '<historical>' prior: 0!
I represent a VCard!

!ICVCard class methodsFor: 'accessing' stamp: 'avi 10/15/2005 17:35'!
iCalType
	^'VCARD'! !

!ICVCard methodsFor: 'adding' stamp: 'pmm 10/29/2005 21:17'!
addAddress: anAddress
	^self addresses add: anAddress! !

!ICVCard methodsFor: 'adding' stamp: 'pmm 11/14/2005 00:00'!
addAimid: anInstantMessageId
	^self aimids add: anInstantMessageId! !

!ICVCard methodsFor: 'adding' stamp: 'pmm 10/30/2005 19:32'!
addEmailAddress: anEmailAddress
	^self emailAddresses add: anEmailAddress! !

!ICVCard methodsFor: 'adding' stamp: 'pmm 11/14/2005 00:01'!
addIcqid: anInstantMessageId
	^self icqids add: anInstantMessageId! !

!ICVCard methodsFor: 'adding' stamp: 'pmm 11/14/2005 00:01'!
addMsnid: anInstantMessageId
	^self msnids add: anInstantMessageId! !

!ICVCard methodsFor: 'adding' stamp: 'pmm 12/11/2005 10:33'!
addNote: aString
	^self notes add: aString! !

!ICVCard methodsFor: 'adding' stamp: 'pmm 10/30/2005 16:42'!
addPhoneNumber: aPhoneNumber
	^self phoneNumbers add: aPhoneNumber! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 10/29/2005 21:16'!
addresses
	^addresses! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 10/29/2005 21:16'!
addresses: aCollection 
	addresses := aCollection! !

!ICVCard methodsFor: 'adding' stamp: 'pmm 11/14/2005 00:01'!
addYahooid: anInstantMessageId
	^self yahooids add: anInstantMessageId! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 11/13/2005 23:50'!
aimids
	^aimids! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 11/13/2005 23:51'!
aimids: aCollection 
	aimids := aCollection! !

!ICVCard methodsFor: 'private' stamp: 'pmm 12/12/2005 23:27'!
asJpeg: anArray
	| input proc |
	input := String streamContents: [ :stream |
		anArray do: [ :each |
			stream nextPut: (Character value: each) ] ].
	proc := OSProcess thisOSProcess
		command:  'convert -quality 0 - jpg:-'
		input: input.
	[ proc isComplete ] whileFalse: [ (Delay forSeconds: 1) wait ].
	^proc upToEnd asByteArray! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 1/2/2006 12:52'!
birthday
	^birthday! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 1/2/2006 12:52'!
birthday: aDate 
	birthday := aDate! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 11/14/2005 00:35'!
categories
	^categories! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 11/14/2005 00:36'!
categories: aString 
	categories := aString! !

!ICVCard methodsFor: 'public' stamp: 'pmm 12/13/2005 07:23'!
convertPhotoToJpeg
	(self photo notNil and: [ self photo isKindOf: ByteArray ])
		ifTrue: [ self photo: (self asJpeg: self photo) ]! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 10/30/2005 19:31'!
emailAddresses
	^emailAddresses! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 10/30/2005 19:31'!
emailAddresses: aCollection 
	emailAddresses := aCollection! !

!ICVCard methodsFor: 'exporting' stamp: 'pmm 1/2/2006 12:53'!
exportOn: anExporter
	anExporter exportVersion: self version.
	anExporter exportName: self name.
	anExporter exportFullname: self fullname.	
	anExporter exportNickname: self nickname.
	anExporter exportPhoto: self photo.
	anExporter exportBirthday: self birthday.
	anExporter exportAddresses: self addresses.
	anExporter exportTelephones: self phoneNumbers.
	anExporter exportEmails: self emailAddresses.
	anExporter exportTitle: self title.
	anExporter exportOrganization: self organization.
	anExporter exportCategories: self categories.
	anExporter exportNotes: self notes.
	anExporter exportUrl: self url.
	
	anExporter exportAim: self aimids.
	anExporter exportIcq: self icqids.
	anExporter exportMsn: self msnids.
	anExporter exportYahoo: self yahooids.! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 10/29/2005 00:56'!
fullname
	^fullname! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 10/29/2005 00:56'!
fullname: anObject
	fullname := anObject! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 11/13/2005 23:51'!
icqids
	^icqids! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 11/13/2005 23:52'!
icqids: aCollection 
	icqids := aCollection! !

!ICVCard methodsFor: 'initialize-release' stamp: 'pmm 12/3/2005 12:56'!
initialize
	super initialize.
	self addresses: OrderedCollection new.
	self phoneNumbers: OrderedCollection new.
	self emailAddresses: OrderedCollection new.
	self version: 3.0.
	self aimids: OrderedCollection new.
	self icqids: OrderedCollection new.
	self msnids: OrderedCollection new.
	self yahooids:OrderedCollection new.
	self categories: OrderedCollection new.
	self notes: OrderedCollection new! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 11/13/2005 23:51'!
msnids
	^msnids! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 11/13/2005 23:52'!
msnids: aCollection 
	msnids := aCollection! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 10/30/2005 08:30'!
name
	^name! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 10/30/2005 08:31'!
name: aName 
	name := aName! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 10/29/2005 00:56'!
nickname
	^nickname! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 10/29/2005 00:56'!
nickname: anObject
	nickname := anObject! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 12/3/2005 12:55'!
notes
	^notes! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 12/3/2005 12:56'!
notes: aCollection 
	notes := aCollection! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 11/1/2005 23:02'!
organization
	^organization! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 11/1/2005 23:02'!
organization: anOrganization 
	organization := anOrganization! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 10/30/2005 16:40'!
phoneNumbers
	^phoneNumbers! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 10/30/2005 16:40'!
phoneNumbers: aCollection 
	phoneNumbers := aCollection! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 10/30/2005 21:21'!
photo
	^photo! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 10/30/2005 21:21'!
photo: anObject
	photo := anObject! !

!ICVCard methodsFor: 'removing' stamp: 'pmm 10/29/2005 21:17'!
removeAddress: anAddress
	^self addresses remove: anAddress! !

!ICVCard methodsFor: 'removing' stamp: 'pmm 10/30/2005 19:32'!
removeEmailAddress: anEmailAddress
	^self emailAddresses remove: anEmailAddress! !

!ICVCard methodsFor: 'removing' stamp: 'pmm 10/30/2005 16:41'!
removePhoneNumber: aPhoneNumber
	^self phoneNumbers remove: aPhoneNumber! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 11/1/2005 22:01'!
title
	^title! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 11/1/2005 22:01'!
title: aString 
	title := aString! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 11/1/2005 22:06'!
url
	^url! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 11/1/2005 22:07'!
url: aUrl 
	url := aUrl! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 11/4/2005 23:01'!
version
	^version! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 11/4/2005 23:02'!
version: aFloat 
	version := aFloat! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 11/13/2005 23:51'!
yahooids
	^yahooids! !

!ICVCard methodsFor: 'accessing' stamp: 'pmm 11/13/2005 23:52'!
yahooids: aCollection 
	yahooids := aCollection! !

Object subclass: #ICConversion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-IO'!

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 11/11/2005 20:27'!
actionType
	^ICTypeInformation
		name: 'ACTION' 
		type: String iCalType 
		multivalued: false! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 10/9/2005 12:40'!
attachmentType
	^ICTypeInformation
		name: 'ATTACH' 
		type: Url iCalType 
		multivalued: false! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 10/9/2005 12:41'!
beginComponentType
	^ICTypeInformation 
		name: 'BEGIN' 
		type: String iCalType 
		multivalued: false! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 10/9/2005 12:41'!
categoriesType
	^ICTypeInformation 
		name: 'CATEGORIES' 
		type: String iCalType 
		multivalued: true! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 12/13/2005 22:26'!
charsetType
	^ICTypeInformation
		name: 'CHARSET' 
		type: String iCalType 
		multivalued: false! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 10/9/2005 12:41'!
classificationType
	^ICTypeInformation
		name: 'CLASS' 
		type: String iCalType 
		multivalued: false! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 10/9/2005 12:41'!
commentType
	^ICTypeInformation
		name: 'COMMENT' 
		type: String iCalType 
		multivalued: false! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 10/18/2005 06:30'!
completedType
	^ICTimeTypeInformation
		name: 'COMPLETED' 
		type: DateAndTime iCalType 
		multivalued: false
		utc: true! !

!ICConversion class methodsFor: 'accessing' stamp: 'pmm 11/12/2005 12:13'!
componentClassFor: anICalComponentName
	^self supportedComponents detect: [ :each |
		each iCalType sameAs: anICalComponentName ]! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 10/18/2005 06:30'!
createdType
	^ICTimeTypeInformation
		name: 'CREATED' 
		type: DateAndTime iCalType 
		multivalued: false
		utc: true! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 10/9/2005 12:42'!
descriptionType
	^ICTypeInformation
		name: 'DESCRIPTION' 
		type: String iCalType 
		multivalued: false! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 10/18/2005 06:30'!
dueType
	^ICTimeTypeInformation
		name: 'DUE' 
		type: DateAndTime iCalType 
		multivalued: false! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 10/18/2005 06:32'!
durationType
	^ICTimeTypeInformation
		name: 'DURATION' 
		type: Duration iCalType 
		multivalued: false! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 10/18/2005 06:32'!
endComponentType
	^ICTimeTypeInformation
		name: 'END' 
		type: String iCalType 
		multivalued: false! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 10/18/2005 06:32'!
endType
	^ICTimeTypeInformation 
		name: 'DTEND' 
		type: DateAndTime iCalType 
		multivalued: false! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 10/18/2005 06:32'!
exclusionDatesType
	^ICTimeTypeInformation
		name: 'EXDATE' 
		type: DateAndTime iCalType 
		multivalued: true! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 10/9/2005 12:43'!
exculsionRuleType
	^ICTypeInformation
		name: 'EXRULE' 
		type: ICRecurrenceRule iCalType 
		multivalued: false! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 10/9/2005 12:43'!
geoType
	^ICTypeInformation
		name: 'GEO'
		type: Float iCalType 
		multivalued: true! !

!ICConversion class methodsFor: 'accessing' stamp: 'pmm 12/11/2005 10:09'!
isSupportedComponent: anICalComponentName
	^self supportedComponents anySatisfy: [ :each |
		each iCalType sameAs: anICalComponentName ]! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 10/18/2005 06:30'!
lastModifiedType
	^ICTimeTypeInformation
		name: 'LAST-MODIFIED' 
		type: DateAndTime iCalType 
		multivalued: false
		utc: true! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 10/9/2005 12:43'!
locationType
	^ICTypeInformation 
		name: 'LOCATION' 
		type: String iCalType 
		multivalued: false! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 12/13/2005 22:27'!
methodType
	^ICTypeInformation
		name: 'METHOD' 
		type: String iCalType 
		multivalued: false! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 10/9/2005 12:44'!
percentCompleteType
	^ICTypeInformation
		name: 'PERCENT-COMPLETE' 
		type: Integer iCalType 
		multivalued: false! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 10/9/2005 12:44'!
priorityType
	^ICTypeInformation
		name: 'PRIORITY' 
		type: Integer iCalType 
		multivalued: false! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 10/9/2005 12:44'!
productIdType
	^ICTypeInformation
		name: 'PRODID' 
		type: String iCalType 
		multivalued: false! !

!ICConversion class methodsFor: 'accessing' stamp: 'pmm 10/14/2005 11:52'!
propertyClassFor: anICalType
	^self supportedClasses detect: [ :each |
		each iCalType = anICalType ]! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 10/18/2005 06:50'!
recurrenceDatesType
	^ICTimeTypeInformation
		name: 'RDATE' 
		type: DateAndTime iCalType 
		multivalued: true! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 10/9/2005 12:44'!
recurrenceRuleType
	^ICTypeInformation
		name: 'RRULE' 
		type: ICRecurrenceRule iCalType 
		multivalued: false! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 11/11/2005 20:20'!
repetitionType
	^ICTypeInformation
		name: 'REPEAT' 
		type: Integer iCalType 
		multivalued: false! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 10/9/2005 12:45'!
resourcesType
	^ICTypeInformation
		name: 'RESOURCES' 
		type: String iCalType 
		multivalued: true! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 10/9/2005 12:45'!
sequenceNumberType
	^ICTypeInformation
		name: 'SEQUENCE'
		type: Integer iCalType 
		multivalued: false! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 10/18/2005 06:30'!
stampType
	^ICTimeTypeInformation 
		name: 'DTSTAMP' 
		type: DateAndTime iCalType 
		multivalued: false
		utc: true! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 10/18/2005 06:50'!
startType
	^ICTimeTypeInformation 
		name: 'DTSTART' 
		type: DateAndTime iCalType 
		multivalued: false! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 10/9/2005 12:45'!
statusType
	^ICTypeInformation 
		name: 'STATUS' 
		type: String iCalType 
		multivalued: false! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 10/9/2005 12:46'!
summaryType
	^ICTypeInformation 
		name: 'SUMMARY' 
		type: String iCalType 
		multivalued: false! !

!ICConversion class methodsFor: 'accessing' stamp: 'pmm 10/30/2005 21:06'!
supportedClasses
	^OrderedCollection new
		add: Boolean;
		add: ByteArray;
		add: Date;
		add: DateAndTime;
		add: Duration;
		add: Float;
		add: ICRecurrenceRule;
		add: Integer;
		add: String;
		add: Time;
		add: Url;		
		yourself! !

!ICConversion class methodsFor: 'accessing' stamp: 'pmm 12/11/2005 10:16'!
supportedComponents
	^(OrderedCollection new)
		add: ICCalendar;
		add: ICEvent;
		add: ICTodo;
		add: ICAlarm;
		add: ICFreeBusy;
		add: ICTimezone;
		add: ICJournal;
		add: ICVCard;
		yourself! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 10/9/2005 13:04'!
transparencyType
	^ICTypeInformation 
		name: 'TRANSP' 
		type: String iCalType 
		multivalued: false! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 11/11/2005 20:23'!
triggerType
	^ICTypeInformation
		name: 'TRIGGER' 
		type: Duration iCalType 
		multivalued: false! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 10/9/2005 12:46'!
uidType
	^ICTypeInformation 
		name: 'UID' 
		type: String iCalType
		multivalued: false! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 10/9/2005 12:46'!
urlType
	^ICTypeInformation
		name: 'URL' 
		type: Url iCalType 
		multivalued: false! !

!ICConversion class methodsFor: 'accessing-types' stamp: 'pmm 10/9/2005 12:46'!
versionType
	^ICTypeInformation 
		name: 'VERSION'
		type: Float iCalType 
		multivalued: false! !

Object subclass: #ICExporter
	instanceVariableNames: 'dataStream lineStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-IO'!

!ICExporter commentStamp: '<historical>' prior: 0!
I'm the abstract superclass of calendar and card exporters!

ICExporter subclass: #ICCalendarExporter
	instanceVariableNames: 'calendar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-IO'!

!ICCalendarExporter commentStamp: '<historical>' prior: 0!
I can export a calendar and save it in an iCalendar file.!

!ICCalendarExporter class methodsFor: 'instance creation' stamp: 'dr 5/16/2005 13:27'!
calendar: aCalendar
	^(self new calendar: aCalendar)! !

!ICCalendarExporter class methodsFor: 'examples' stamp: 'pmm 10/9/2005 13:43'!
example1
	"self example1"
	| calendar event exporter |
	calendar := ICCalendar new.
	event :=( ICEvent summary: 'demo event')
		start: Date today;
		recurrenceRule: ICRecurrenceRule weekly; 
		yourself.
	calendar addEvent: event.
	
	exporter := self calendar: calendar.
	exporter dataStream: (FileStream forceNewFileNamed: 'demo.ics').
	exporter export.
	! !

!ICCalendarExporter methodsFor: 'accessing' stamp: 'pmm 12/11/2005 12:19'!
calendar
	^calendar! !

!ICCalendarExporter methodsFor: 'accessing' stamp: 'pmm 12/11/2005 12:19'!
calendar: aCalendar
	calendar := aCalendar! !

!ICCalendarExporter methodsFor: 'accessing' stamp: 'pmm 10/15/2005 23:45'!
contentType
	^'text/calendar'! !

!ICCalendarExporter methodsFor: 'exporting' stamp: 'pmm 12/11/2005 12:21'!
export
	self dataStream reset.
	self lineStream reset.
	self export: self calendar.
	self save! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 11/11/2005 20:28'!
exportAction: anObject 
	self exportProperty: anObject type: ICConversion actionType! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 11/6/2005 00:29'!
exportAttachments: anObject 
	self exportProperty: anObject type: ICConversion attachmentType! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 11/6/2005 00:29'!
exportCategories: anObject 
	self exportProperty: anObject type: ICConversion categoriesType! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 12/13/2005 22:28'!
exportCharset: anObject 
	self exportProperty: anObject type: ICConversion charsetType! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 11/6/2005 00:29'!
exportClassification: anObject 
	self exportProperty: anObject type: ICConversion classificationType! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 11/6/2005 00:29'!
exportComments: anObject 
	self exportProperty: anObject type: ICConversion commentType! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 11/6/2005 00:29'!
exportCompleted: anObject 
	self exportProperty: anObject type: ICConversion completedType! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 11/6/2005 00:29'!
exportCreated: anObject 
	self exportProperty: anObject type: ICConversion createdType! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 11/6/2005 00:29'!
exportDescription: anObject 
	self exportProperty: anObject type: ICConversion descriptionType! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 11/6/2005 00:29'!
exportDue: anObject 
	self exportProperty: anObject type: ICConversion dueType! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 11/6/2005 00:29'!
exportDuration: anObject 
	self exportProperty: anObject type: ICConversion durationType! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 11/6/2005 00:29'!
exportExclusionDates: anObject 
	self exportProperty: anObject type: ICConversion exclusionDatesType! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 11/6/2005 00:29'!
exportExclusionRule: anObject 
	self exportProperty: anObject type: ICConversion exculsionRuleType! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 11/6/2005 00:29'!
exportGeo: anObject 
	self exportProperty: anObject type: ICConversion geoType! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 11/6/2005 00:29'!
exportLastModified: anObject 
	self exportProperty: anObject type: ICConversion lastModifiedType! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 11/6/2005 00:29'!
exportLocation: anObject 
	self exportProperty: anObject type: ICConversion locationType! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 11/6/2005 00:29'!
exportMethod: anObject 
	self exportProperty: anObject type: ICConversion methodType! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 11/6/2005 00:29'!
exportPercentComplete: anObject 
	self exportProperty: anObject type: ICConversion percentCompleteType! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 11/6/2005 00:29'!
exportPriority: anObject 
	self exportProperty: anObject type: ICConversion priorityType! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 11/6/2005 00:29'!
exportProductId: anObject 
	self exportProperty: anObject type: ICConversion productIdType! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 11/6/2005 00:29'!
exportRecurrenceDates: anObject 
	self exportProperty: anObject type: ICConversion recurrenceDatesType! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 11/6/2005 00:29'!
exportRecurrenceRule: anObject 
	self exportProperty: anObject type: ICConversion recurrenceRuleType! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 11/11/2005 20:25'!
exportRepetition: anObject 
	self exportProperty: anObject type: ICConversion repetitionType! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 11/6/2005 00:29'!
exportResources: anObject 
	self exportProperty: anObject type: ICConversion resourcesType! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 11/6/2005 00:29'!
exportSequenceNumber: anObject 
	self exportProperty: anObject type: ICConversion sequenceNumberType! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 11/6/2005 00:29'!
exportStamp: anObject 
	self exportProperty: anObject type: ICConversion stampType! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 11/6/2005 00:29'!
exportStart: anObject 
	self exportProperty: anObject type: ICConversion startType! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 11/6/2005 00:29'!
exportStatus: anObject 
	self exportProperty: anObject type: ICConversion statusType! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 11/6/2005 00:29'!
exportSummary: anObject 
	self exportProperty: anObject type: ICConversion summaryType! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 11/6/2005 00:29'!
exportTransparency: anObject 
	self exportProperty: anObject type: ICConversion transparencyType! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 11/11/2005 20:24'!
exportTrigger: anObject 
	self exportProperty: anObject type: ICConversion triggerType! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 11/6/2005 00:29'!
exportUid: anObject 
	self exportProperty: anObject type: ICConversion uidType! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 11/6/2005 00:29'!
exportUrl: anObject 
	self exportProperty: anObject type: ICConversion urlType! !

!ICCalendarExporter methodsFor: 'exporting-values' stamp: 'pmm 11/6/2005 00:29'!
exportVersion: anObject 
	self exportProperty: anObject type: ICConversion versionType! !

!ICExporter methodsFor: 'converting' stamp: 'pmm 11/7/2005 10:04'!
asMIMEDocument
	^MIMEDocument
		contentType: self contentType 
		content: self dataStream contents! !

!ICExporter methodsFor: 'accessing' stamp: 'pmm 11/7/2005 10:05'!
contents
	^self dataStream contents! !

!ICExporter methodsFor: 'accessing' stamp: 'pmm 11/12/2005 12:31'!
contentType
	self subclassResponsibility ! !

!ICExporter methodsFor: 'accessing' stamp: 'pmm 11/7/2005 10:05'!
dataStream
	^dataStream! !

!ICExporter methodsFor: 'accessing' stamp: 'pmm 11/7/2005 10:05'!
dataStream: aWriteStream
	dataStream := aWriteStream! !

!ICExporter methodsFor: 'exporting' stamp: 'pmm 12/11/2005 12:21'!
export
	self subclassResponsability ! !

!ICExporter methodsFor: 'exporting' stamp: 'pmm 11/7/2005 10:10'!
exportAdditionalOf: anObject type: aTypeInformation
	anObject exportICalParametersOn: self
		! !

!ICExporter methodsFor: 'exporting-values' stamp: 'pmm 12/11/2005 13:40'!
exportBeginComponent: anObject 
	self exportProperty: anObject type: ICConversion beginComponentType! !

!ICExporter methodsFor: 'exporting-values' stamp: 'pmm 12/11/2005 13:41'!
exportEndComponent: anObject 
	self exportProperty: anObject type: ICConversion endComponentType! !

!ICExporter methodsFor: 'exporting-values' stamp: 'pmm 12/11/2005 13:40'!
exportEnd: anObject 
	self exportProperty: anObject type: ICConversion endType! !

!ICExporter methodsFor: 'exporting' stamp: 'pmm 12/13/2005 21:25'!
exportLine: aString
	self exportNewLine: aString

	! !

!ICExporter methodsFor: 'exporting' stamp: 'pmm 12/13/2005 21:57'!
exportNewLine: aString
	aString size <= 75
		ifTrue: [
			self dataStream
				nextPutAll: aString;
				nextPutAll: String crlf ]
		ifFalse: [
			self dataStream next: 75 putAll: aString.
			self dataStream nextPutAll: String crlf.
			(76 to: aString size by: 74) inject: 76 + 74 into: [ :end :start |
				self dataStream
					space;
					next: (end min: aString size + 1) - start putAll: aString startingAt: start;
					nextPutAll: String crlf.
				end + 74 ] ]
	! !

!ICExporter methodsFor: 'exporting-parameters' stamp: 'pmm 11/7/2005 10:06'!
exportParameter: aName value: aValue
	self lineStream
		nextPut: $; ;
		nextPutAll: aName;
		nextPut: $=;
		nextPutAll: aValue
		! !

!ICExporter methodsFor: 'exporting' stamp: 'pmm 11/7/2005 10:05'!
exportPropertyName: aTypeInformation
	self lineStream nextPutAll: aTypeInformation name! !

!ICExporter methodsFor: 'exporting' stamp: 'pmm 11/7/2005 10:05'!
exportProperty: anObject type: aTypeInformation 
	(self shouldExport: anObject) ifTrue: [
		(anObject isCollection
			and: [aTypeInformation multipleValuesPerLine not]
			and: [anObject isString not]) 
				ifTrue: [
					anObject do: [ :each |
						self exportSingleProperty: each type: aTypeInformation ] ]
				ifFalse: [
					self exportSingleProperty: anObject type: aTypeInformation ] ]! !

!ICExporter methodsFor: 'exporting' stamp: 'pmm 11/7/2005 10:05'!
exportSingleProperty: anObject type: aTypeInformation 
	self exportPropertyName: aTypeInformation.
	self exportType: aTypeInformation of: anObject.
	self exportAdditionalOf: anObject type: aTypeInformation.
	self exportValue: anObject type: aTypeInformation.
	self exportLine: self lineStream contents.
	self lineStream reset! !

!ICExporter methodsFor: 'exporting' stamp: 'pmm 11/7/2005 10:05'!
exportType: aTypeInformation of: anObject
	(anObject isCollection not or: [ anObject isString ]) ifTrue: [
		anObject iCalType = aTypeInformation defaultType ifFalse: [
			self
				exportParameter: 'VALUE'
				value: anObject iCalType ] ]
		! !

!ICExporter methodsFor: 'exporting' stamp: 'pmm 11/7/2005 10:12'!
exportValue: anObject type: aTypeInformation
	self lineStream nextPut: $:.
	(anObject isCollection not or: [ anObject isString ])
			ifTrue: [				
				self lineStream nextPutAll: (aTypeInformation convert: anObject) ]
			ifFalse: [
				anObject
					do: [ :each | self lineStream nextPutAll: (aTypeInformation convert: each) ]
					separatedBy: [ self lineStream nextPut: $, ] ]! !

!ICExporter methodsFor: 'exporting' stamp: 'pmm 11/7/2005 10:05'!
export: aComponent
	self exportBeginComponent: aComponent iCalType.
	aComponent exportOn: self.
	self exportEndComponent: aComponent iCalType! !

!ICExporter methodsFor: 'initialization' stamp: 'pmm 11/7/2005 10:06'!
initialize
	super initialize.
	self dataStream: (WriteStream on: String new).
	self lineStream: (WriteStream on: String new).! !

!ICExporter methodsFor: 'testing' stamp: 'pmm 12/11/2005 11:38'!
isVCard
	^false! !

!ICExporter methodsFor: 'accessing' stamp: 'pmm 11/7/2005 10:05'!
lineStream
	^lineStream! !

!ICExporter methodsFor: 'accessing' stamp: 'pmm 11/7/2005 10:05'!
lineStream: aStream 
	lineStream := aStream! !

!ICExporter methodsFor: 'exporting' stamp: 'pmm 11/7/2005 10:06'!
save
	self dataStream flush.
	self dataStream close.! !

!ICExporter methodsFor: 'testing' stamp: 'pmm 11/7/2005 10:06'!
shouldExport: anObject
	^(anObject isNil
		or: [ anObject isCollection
			and: [ anObject isEmpty ]
			and: [ anObject isString not ] ]) not! !

ICExporter subclass: #ICVCardExporter
	instanceVariableNames: 'cards'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-VCard-IO'!

!ICVCardExporter class methodsFor: 'instance creation' stamp: 'pmm 12/11/2005 12:23'!
cards: aCollection
	^self new
		cards: aCollection;
		yourself! !

!ICVCardExporter methodsFor: 'accessing' stamp: 'pmm 12/11/2005 12:22'!
cards
	^cards! !

!ICVCardExporter methodsFor: 'accessing' stamp: 'pmm 12/11/2005 12:22'!
cards: anObject
	cards := anObject! !

!ICVCardExporter methodsFor: 'accessing' stamp: 'pmm 1/1/2006 17:02'!
contentType
	^self contentType30! !

!ICVCardExporter methodsFor: 'accessing' stamp: 'pmm 1/1/2006 17:02'!
contentType21
	^'text/x-vcard'! !

!ICVCardExporter methodsFor: 'accessing' stamp: 'pmm 1/1/2006 17:01'!
contentType30
	^'text/directory'! !

!ICVCardExporter methodsFor: 'exporting' stamp: 'pmm 12/11/2005 14:04'!
export
	self dataStream reset.
	self lineStream reset.
	self cards do: [ :each |
		ICCardVersion
			use: each version
			during: [ self export: each ] ].
	self save! !

!ICVCardExporter methodsFor: 'exporting-values' stamp: 'pmm 12/11/2005 13:18'!
exportAddresses: anObject 
	self exportProperty: anObject type: ICVCardConversion addressType! !

!ICVCardExporter methodsFor: 'exporting-values' stamp: 'pmm 12/11/2005 13:18'!
exportAim: anObject 
	self exportProperty: anObject type: ICVCardConversion aimType! !

!ICVCardExporter methodsFor: 'exporting-values' stamp: 'pmm 1/2/2006 12:52'!
exportBirthday: anObject 
	self exportProperty: anObject type: ICVCardConversion birthdayType! !

!ICVCardExporter methodsFor: 'exporting-values' stamp: 'pmm 12/11/2005 13:18'!
exportCategories: anObject 
	self exportProperty: anObject type: ICVCardConversion categoriesType! !

!ICVCardExporter methodsFor: 'exporting-values' stamp: 'pmm 12/11/2005 13:28'!
exportEmails: anObject 
	self exportProperty: anObject type: ICVCardConversion emailType! !

!ICVCardExporter methodsFor: 'exporting-values' stamp: 'pmm 12/11/2005 13:19'!
exportFullname: anObject 
	self exportProperty: anObject type: ICVCardConversion fullnameType! !

!ICVCardExporter methodsFor: 'exporting-values' stamp: 'pmm 12/11/2005 13:19'!
exportIcq: anObject 
	self exportProperty: anObject type: ICVCardConversion icqType! !

!ICVCardExporter methodsFor: 'exporting' stamp: 'pmm 12/13/2005 21:31'!
exportLine: aString
	ICCardVersion value >= 3.0
		ifTrue: [ self exportNewLine: aString ]
		ifFalse: [ self exportOldLine: aString ]! !

!ICVCardExporter methodsFor: 'exporting-values' stamp: 'pmm 12/11/2005 13:20'!
exportMsn: anObject 
	self exportProperty: anObject type: ICVCardConversion msnType! !

!ICVCardExporter methodsFor: 'exporting-values' stamp: 'pmm 12/11/2005 13:20'!
exportName: anObject 
	self exportProperty: anObject type: ICVCardConversion nameType! !

!ICVCardExporter methodsFor: 'exporting-values' stamp: 'pmm 12/11/2005 13:20'!
exportNickname: anObject 
	self exportProperty: anObject type: ICVCardConversion nicknameType! !

!ICVCardExporter methodsFor: 'exporting-values' stamp: 'pmm 12/11/2005 13:33'!
exportNotes: anObject 
	self exportProperty: anObject type: ICVCardConversion noteType! !

!ICVCardExporter methodsFor: 'exporting' stamp: 'pmm 12/13/2005 22:14'!
exportOldLine: aString
	aString size <= 75
		ifTrue: [
			self dataStream
				nextPutAll: aString;
				nextPutAll: String crlf ]
		ifFalse: [
			| left stream first |
			left := aString size.
			stream := aString readStream.
			first := true.
			[ stream atEnd ] whileFalse: [				
				left > 74
					ifFalse: [
						self dataStream nextPutAll: (stream next: left).
						self dataStream nextPutAll: String crlf ]
					ifTrue: [ 
						self dataStream
							nextPutAll: (stream next: (first ifTrue: [ 74 ] ifFalse: [ 73 ]));							
							nextPut: $=;
							nextPutAll: String crlf;
							nextPut: Character space.
						left := left - (first ifTrue: [ 74 ] ifFalse: [ 73 ]).
						first := false ] ] ]! !

!ICVCardExporter methodsFor: 'exporting-values' stamp: 'pmm 12/11/2005 13:31'!
exportOrganization: anObject 
	self exportProperty: anObject type: ICVCardConversion organizationType! !

!ICVCardExporter methodsFor: 'exporting-values' stamp: 'pmm 12/11/2005 13:21'!
exportPhoto: anObject 
	self exportProperty: anObject type: ICVCardConversion photoType! !

!ICVCardExporter methodsFor: 'exporting-values' stamp: 'pmm 12/11/2005 13:27'!
exportTelephones: anObject 
	self exportProperty: anObject type: ICVCardConversion telephoneType! !

!ICVCardExporter methodsFor: 'exporting-values' stamp: 'pmm 12/11/2005 13:21'!
exportTitle: anObject 
	self exportProperty: anObject type: ICVCardConversion titleType! !

!ICVCardExporter methodsFor: 'exporting-values' stamp: 'pmm 12/11/2005 13:22'!
exportUrl: anObject 
	self exportProperty: anObject type: ICVCardConversion urlType! !

!ICVCardExporter methodsFor: 'exporting-values' stamp: 'pmm 12/11/2005 13:22'!
exportVersion: anObject 
	self exportProperty: anObject type: ICVCardConversion versionType! !

!ICVCardExporter methodsFor: 'exporting-values' stamp: 'pmm 12/11/2005 13:22'!
exportYahoo: anObject 
	self exportProperty: anObject type: ICVCardConversion yahooType! !

!ICVCardExporter methodsFor: 'initialize-release' stamp: 'pmm 12/11/2005 12:22'!
initialize
	super initialize.
	self cards: OrderedCollection new! !

!ICVCardExporter methodsFor: 'testing' stamp: 'pmm 12/11/2005 12:14'!
isVCard
	^true! !

Object subclass: #ICGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Parser'!

ICGenerator subclass: #ICCalendarGenerator
	instanceVariableNames: 'calendar tempComponent tempAlarm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Parser'!

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 11/11/2005 23:09'!
action: aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: String iCalType.
	self tempAlarm action: value! !

!ICCalendarGenerator methodsFor: 'accessing' stamp: 'pmm 10/14/2005 12:55'!
activeComponent
	^self tempAlarm isNil
		ifTrue: [ self tempComponent ]
		ifFalse: [ self tempAlarm ]! !

!ICCalendarGenerator methodsFor: 'accessing' stamp: 'pmm 10/14/2005 15:57'!
activeComponentOrCalendar
	^self activeComponent ifNil: [ self calendar ]! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'avi 10/15/2005 19:24'!
addUnknownProperty: aProperty
	self activeComponentOrCalendar addUnknownProperty: aProperty! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/14/2005 12:56'!
attach: aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: Url iCalType.
	self activeComponent addAttachment: value! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/14/2005 10:48'!
beginValarm
	self tempAlarm: ICAlarm new! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/14/2005 10:48'!
beginVcalendar
	^self calendar: ICCalendar new! !

!ICCalendarGenerator methodsFor: 'dispatching' stamp: 'pmm 10/15/2005 18:23'!
begin: aString
	(self specialBegins includes: aString)
		ifTrue: [
			self perform: ('begin' , aString asLowercase capitalized) asSymbol ]
		ifFalse: [
			self tempComponent: (ICConversion componentClassFor: aString) new ]! !

!ICCalendarGenerator methodsFor: 'accessing' stamp: 'pmm 10/14/2005 10:46'!
calendar
	^calendar! !

!ICCalendarGenerator methodsFor: 'accessing' stamp: 'pmm 10/14/2005 10:46'!
calendar: anObject
	calendar := anObject! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 12/3/2005 13:02'!
categories: aString parameters: aDictionary
	| categories |
	categories := self createMulitValue: aString parameters: aDictionary class: ICCategory.
	self tempComponent categories: categories.! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/14/2005 12:53'!
class: aString parameters: aDictionary 
	| value |
	value := self createValue: aString parameters: aDictionary default: String iCalType.
	self tempComponent classification: value! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/14/2005 12:53'!
comment: aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: String iCalType.
	self tempComponent addComment: value! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/14/2005 12:53'!
completed: aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: DateAndTime iCalType.
	self tempComponent completed: value! !

!ICCalendarGenerator methodsFor: 'productions' stamp: 'pmm 11/19/2005 15:27'!
contentline: aName parameters: aCollection value: aString
	self calendar isNil
		ifFalse: [
			ICCalendarVersion
				use: self calendar version
				during: [ super contentline: aName parameters: aCollection value: aString ] ]
		ifTrue: [ super contentline: aName parameters: aCollection value: aString ]! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/14/2005 12:53'!
created: aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: DateAndTime iCalType.
	self tempComponent created: value! !

!ICCalendarGenerator methodsFor: 'utilities' stamp: 'pmm 12/3/2005 13:02'!
createMulitValue: aString parameters: aDictionary class: aClass
	^ (self splitAtCommas: aString) collect: [ :each |
		aClass fromVCardString: each ]! !

!ICCalendarGenerator methodsFor: 'utilities' stamp: 'pmm 12/3/2005 13:03'!
createMulitValue: aString parameters: aDictionary type: aClass
	^ (self splitAtCommas: aString) collect: [ :each |
		self createValue: each parameters: aDictionary default: aClass ]! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/14/2005 12:53'!
description: aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: String iCalType.
	self tempComponent addTextualDescription: value! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/14/2005 13:02'!
dtend: aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: DateAndTime iCalType.
	self tempComponent end: value! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/14/2005 14:59'!
dtstamp: aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: DateAndTime iCalType.
	self tempComponent stamp: value! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/14/2005 15:00'!
dtstart: aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: DateAndTime iCalType.
	self tempComponent start: value! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/14/2005 12:52'!
due: aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: DateAndTime iCalType.
	self tempComponent due: value! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/14/2005 12:56'!
duration: aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: Duration iCalType.
	self activeComponent duration: value! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/14/2005 10:48'!
endValarm
	self tempComponent addAlarm: self tempAlarm.
	self tempAlarm: nil! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/14/2005 10:48'!
endVcalendar
	"nothing"! !

!ICCalendarGenerator methodsFor: 'dispatching' stamp: 'pmm 10/15/2005 18:24'!
end: aString
	(self specialEnds includes: aString)
		ifTrue: [
			self perform: ('end' , aString asLowercase capitalized) asSymbol ]
		ifFalse: [
			self calendar addComponent: self tempComponent.
			self tempComponent: nil ]! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 12/3/2005 13:06'!
exdate: aString parameters: aDictionary
	| dates |
	dates := self createMulitValue: aString parameters: aDictionary type: DateAndTime.
	self tempComponent exclusionDates: dates! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/14/2005 13:05'!
exrule: aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: ICRecurrenceRule iCalType.
	self tempComponent exclusionRule: value! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 12/3/2005 13:02'!
geo: aString parameters: aDictionary
	| coords |
	coords := self createMulitValue: aString parameters: aDictionary class: Float.
	self tempComponent geo: coords first @ coords second! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/14/2005 13:13'!
lastmodified: aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: DateAndTime iCalType.
	self tempComponent lastModified: value! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/14/2005 14:46'!
location: aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: String iCalType.
	self tempComponent location: value! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/15/2005 18:21'!
method: aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: String iCalType.
	self calendar method: value! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 11/12/2005 12:29'!
percentcomplete: aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: Integer iCalType.
	self tempComponent percentComplete: value! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/14/2005 14:49'!
priority: aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: Integer iCalType.
	self tempComponent priority: value! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/15/2005 18:10'!
prodid: aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: String iCalType.
	self calendar productId: value! !

!ICCalendarGenerator methodsFor: 'accessing' stamp: 'pmm 10/14/2005 14:53'!
product
	^self calendar! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 12/3/2005 13:04'!
rdate: aString parameters: aDictionary
	| dates |
	dates := self createMulitValue: aString parameters: aDictionary type: DateAndTime.
	self tempComponent recurrenceDates: dates! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 11/11/2005 23:10'!
repeat: aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: Integer iCalType.
	self tempAlarm repetitions: value! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 12/3/2005 13:04'!
resources: aString parameters: aDictionary
	| resources |
	resources := self createMulitValue: aString parameters: aDictionary type: String.
	self tempComponent resources: resources! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/14/2005 14:55'!
rrule: aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: ICRecurrenceRule iCalType.
	self tempComponent recurrenceRule: value! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/14/2005 14:58'!
sequence: aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: Integer iCalType.
	self tempComponent sequenceNumber: value! !

!ICCalendarGenerator methodsFor: 'accessing' stamp: 'pmm 10/14/2005 10:46'!
specialBegins
	^#(
		'VCALENDAR'
		'VALARM'
	)! !

!ICCalendarGenerator methodsFor: 'accessing' stamp: 'pmm 10/14/2005 10:47'!
specialEnds
	^self specialBegins! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/14/2005 15:00'!
status: aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: String iCalType.
	self tempComponent status: value! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/14/2005 15:02'!
summary: aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: String iCalType.
	self tempComponent summary: value! !

!ICCalendarGenerator methodsFor: 'accessing' stamp: 'pmm 10/14/2005 10:47'!
tempAlarm
	^tempAlarm! !

!ICCalendarGenerator methodsFor: 'accessing' stamp: 'pmm 10/14/2005 10:47'!
tempAlarm: anObject
	tempAlarm := anObject! !

!ICCalendarGenerator methodsFor: 'accessing' stamp: 'pmm 10/14/2005 10:47'!
tempComponent
	^tempComponent! !

!ICCalendarGenerator methodsFor: 'accessing' stamp: 'pmm 10/14/2005 10:47'!
tempComponent: anObject
	tempComponent := anObject! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/14/2005 15:02'!
transp: aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: String iCalType.
	self tempComponent transparency: value! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 11/11/2005 23:10'!
trigger: aString parameters: aDictionary
	| value |
	value := ICTrigger fromICalString: aString parameters: aDictionary.
	self tempAlarm trigger: value! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/14/2005 15:02'!
uid: aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: String iCalType.
	self tempComponent uid: value! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/14/2005 15:03'!
url: aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: Url iCalType.
	self tempComponent url: value! !

!ICCalendarGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/15/2005 18:11'!
version: aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: Float iCalType.
	self calendar version: value! !

!ICGenerator methodsFor: 'dispatching' stamp: 'pmm 11/1/2005 22:34'!
addUnknownProperty: aProperty
	self subclassResponsibility ! !

!ICGenerator methodsFor: 'utilities' stamp: 'avi 10/15/2005 19:16'!
asSelector: aString
	| parts |
	parts := aString subStrings: #($-).
	^String streamContents: [ :stream |
		parts do: [ :each |
			stream nextPutAll: each asLowercase ].
		stream nextPut: $: ]! !

!ICGenerator methodsFor: 'dispatching' stamp: 'avi 10/15/2005 19:27'!
begin: aString
	self subclassResponsibility! !

!ICGenerator methodsFor: 'productions' stamp: 'avi 10/15/2005 19:16'!
contentline: aName parameters: aCollection value: aString
	| selector |
	selector := self asSelector: aName.
	(self noParameterSelectors includes: selector)
		ifTrue: [
			self
				perform: selector asSymbol
				withArguments: (Array with: aString) ]
		ifFalse: [
			self
				perform: (selector , 'parameters:') asSymbol
				withArguments: (Array with: aString with: aCollection) ]! !

!ICGenerator methodsFor: 'utilities' stamp: 'pmm 12/3/2005 12:04'!
createValue: aString parameters: aDictionary default: aType
	| iCalType |
	iCalType := aDictionary at: 'VALUE' ifAbsent: [ aType ].
	^self createValue: aString parameters: aDictionary type: iCalType! !

!ICGenerator methodsFor: 'utilities' stamp: 'pmm 12/3/2005 12:03'!
createValue: aString parameters: aDictionary type: iCalType
	^(ICConversion propertyClassFor: iCalType)
		fromICalString: aString parameters: aDictionary! !

!ICGenerator methodsFor: 'dispatching' stamp: 'avi 10/15/2005 19:24'!
doesNotUnderstand: aMessage
	| property |
	^((aMessage selector endsWith: 'parameters:')
		and: [ aMessage arguments size = 2 ])
			ifFalse: [ super doesNotUnderstand: aMessage ]
			ifTrue: [ 
				property := ICUnknownProperty new
				 	name: (aMessage selector copyUpTo: $:);
					value: aMessage arguments first;
					parameters: aMessage arguments second;
					yourself.
				self addUnknownProperty: property ]! !

!ICGenerator methodsFor: 'dispatching' stamp: 'avi 10/15/2005 19:27'!
end: aString
	self subclassResponsibility ! !

!ICGenerator methodsFor: 'dispatching' stamp: 'avi 10/15/2005 19:27'!
noParameterSelectors
	^#(
		'begin:'
		'end:'
	)! !

!ICGenerator methodsFor: 'accessing' stamp: 'pmm 11/1/2005 22:36'!
product
	self subclassResponsibility ! !

!ICGenerator methodsFor: 'utilities' stamp: 'pmm 10/30/2005 08:23'!
splitAtCommas: aString
	^aString splitAtCommas! !

ICGenerator subclass: #ICVCardGenerator
	instanceVariableNames: 'currentCard cards'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-VCard-Parser'!

!ICVCardGenerator commentStamp: '<historical>' prior: 0!
THIS CLASS HAS NO COMMENT!!

!

!ICVCardGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/29/2005 21:39'!
addUnknownProperty: aProperty
	self currentCard addUnknownProperty: aProperty! !

!ICVCardGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/29/2005 21:48'!
adr:  aString parameters: aDictionary
	| value |
	value := self createAddress: aString parameters: aDictionary.
	self currentCard addAddress: value! !

!ICVCardGenerator methodsFor: 'processing-properties' stamp: 'pmm 1/2/2006 12:51'!
bday:  aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: Date iCalType.
	self currentCard birthday: value! !

!ICVCardGenerator methodsFor: 'processing-properties' stamp: 'pmm 11/12/2005 12:09'!
begin: aString
	(aString sameAs:  'VCARD')
		ifFalse: [self error: 'Only expecting VCARDS'].
	self currentCard: ICVCard new! !

!ICVCardGenerator methodsFor: 'accessing' stamp: 'pmm 10/29/2005 22:44'!
cards
	^cards! !

!ICVCardGenerator methodsFor: 'accessing' stamp: 'pmm 10/29/2005 21:38'!
cards: aCollection 
	cards := aCollection! !

!ICVCardGenerator methodsFor: 'processing-properties' stamp: 'pmm 12/3/2005 13:01'!
categories: aString parameters: aDictionary
	| categories |
	categories := self createMulitValue: aString parameters: aDictionary class: ICCategory.
	self currentCard categories: categories.! !

!ICVCardGenerator methodsFor: 'processing-properties' stamp: 'pmm 12/2/2005 23:15'!
category: aString parameters: aDictionary
	self categories: aString parameters: aDictionary! !

!ICVCardGenerator methodsFor: 'productions' stamp: 'pmm 11/19/2005 15:28'!
contentline: aName parameters: aCollection value: aString
	self currentCard isNil
		ifFalse: [
			ICCardVersion
				use: self currentCard version
				during: [ super contentline: aName parameters: aCollection value: aString ] ]
		ifTrue: [ super contentline: aName parameters: aCollection value: aString ]! !

!ICVCardGenerator methodsFor: 'private' stamp: 'pmm 12/2/2005 23:45'!
createAddress: aString parameters: aDictionary
	^ICAddress fromVCardString: aString parameters: aDictionary! !

!ICVCardGenerator methodsFor: 'private' stamp: 'pmm 3/24/2006 15:30'!
createAIMId: aString parameters: aDictionary
	^self createInstantMessageId: aString parameters: aDictionary class: ICAIMId! !

!ICVCardGenerator methodsFor: 'private' stamp: 'pmm 10/30/2005 19:56'!
createEmailAddress: aString parameters: aDictionary
	^ICEmailAddress fromICalString: aString parameters: aDictionary! !

!ICVCardGenerator methodsFor: 'private' stamp: 'pmm 3/24/2006 15:31'!
createICQId: aString parameters: aDictionary
	^self createInstantMessageId: aString parameters: aDictionary class: ICICQId! !

!ICVCardGenerator methodsFor: 'private' stamp: 'pmm 3/24/2006 15:29'!
createInstantMessageId: aString parameters: aDictionary class: anInstantMessageIdClass
	^anInstantMessageIdClass fromICalString: aString parameters: aDictionary! !

!ICVCardGenerator methodsFor: 'private' stamp: 'pmm 3/24/2006 15:31'!
createMSNId: aString parameters: aDictionary
	^self createInstantMessageId: aString parameters: aDictionary class: ICMSNId! !

!ICVCardGenerator methodsFor: 'utilities' stamp: 'pmm 12/3/2005 13:01'!
createMulitValue: aString parameters: aDictionary class: aClass
	^ (self splitAtCommas: aString) collect: [ :each |
		aClass fromVCardString: each ]! !

!ICVCardGenerator methodsFor: 'private' stamp: 'pmm 10/30/2005 08:35'!
createName: aString parameters: aDictionary
	^ICName fromICalString: aString parameters: aDictionary! !

!ICVCardGenerator methodsFor: 'private' stamp: 'pmm 11/1/2005 23:04'!
createOrganization: aString parameters: aDictionary
	^ICOrganization fromICalString: aString parameters: aDictionary! !

!ICVCardGenerator methodsFor: 'private' stamp: 'pmm 10/30/2005 16:43'!
createPhoneNumber: aString parameters: aDictionary
	^ICPhoneNumber fromICalString: aString parameters: aDictionary! !

!ICVCardGenerator methodsFor: 'utilities' stamp: 'pmm 12/3/2005 00:08'!
createValue: aString parameters: aDictionary default: aType
	^((aDictionary includesKey: 'ENCODING') and: 
			[ #('B' 'BASE64') includes: (aDictionary at: 'ENCODING') ]) 
			ifFalse: [
				super 
					createValue: aString
					parameters: aDictionary
					default: aType]
		ifTrue: [
			(ICConversion propertyClassFor: 'BINARY')
				fromICalString: aString
				parameters: aDictionary ]! !

!ICVCardGenerator methodsFor: 'utilities' stamp: 'pmm 12/3/2005 12:04'!
createValue: aString parameters: aDictionary type: iCalType
	^(ICConversion propertyClassFor: iCalType)
		fromVCardString: aString parameters: aDictionary! !

!ICVCardGenerator methodsFor: 'private' stamp: 'pmm 3/24/2006 15:31'!
createYahooId: aString parameters: aDictionary
	^self createInstantMessageId: aString parameters: aDictionary class: ICYahooId! !

!ICVCardGenerator methodsFor: 'accessing' stamp: 'pmm 10/29/2005 21:38'!
currentCard
	^currentCard! !

!ICVCardGenerator methodsFor: 'accessing' stamp: 'pmm 10/29/2005 21:38'!
currentCard: aCard 
	currentCard := aCard! !

!ICVCardGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/30/2005 19:57'!
email:  aString parameters: aDictionary
	| value |
	value := self createEmailAddress: aString parameters: aDictionary.
	self currentCard addEmailAddress: value! !

!ICVCardGenerator methodsFor: 'processing-properties' stamp: 'pmm 11/12/2005 12:11'!
end: aString
	(aString sameAs: 'VCARD') ifFalse: [
		self error: 'Only expecting VCARDS' ].
	self cards add: self currentCard.
	self currentCard: nil! !

!ICVCardGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/29/2005 21:46'!
fn:  aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: String iCalType.
	self currentCard fullname: value! !

!ICVCardGenerator methodsFor: 'initialize-release' stamp: 'pmm 10/29/2005 22:44'!
initialize
	super initialize.
	self cards: OrderedCollection new! !

!ICVCardGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/29/2005 21:46'!
nickname:  aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: String iCalType.
	self currentCard nickname: value! !

!ICVCardGenerator methodsFor: 'processing-properties' stamp: 'pmm 12/11/2005 10:32'!
note: aString parameters: aDictionary
	| notes |
	notes := self createValue: aString parameters: aDictionary default: String iCalType.
	self currentCard addNote: notes.! !

!ICVCardGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/30/2005 08:35'!
n:  aString parameters: aDictionary
	| value |
	value := self createName: aString parameters: aDictionary.
	self currentCard name: value! !

!ICVCardGenerator methodsFor: 'processing-properties' stamp: 'pmm 11/1/2005 23:05'!
org:  aString parameters: aDictionary
	| value |
	value := self createOrganization: aString parameters: aDictionary.
	self currentCard organization: value! !

!ICVCardGenerator methodsFor: 'processing-properties' stamp: 'pmm 12/2/2005 23:56'!
photo:  aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: Url iCalType.
	self currentCard photo: value! !

!ICVCardGenerator methodsFor: 'accessing' stamp: 'pmm 10/29/2005 21:43'!
product
	^self cards! !

!ICVCardGenerator methodsFor: 'processing-properties' stamp: 'pmm 10/30/2005 16:44'!
tel:  aString parameters: aDictionary
	| value |
	value := self createPhoneNumber: aString parameters: aDictionary.
	self currentCard addPhoneNumber: value! !

!ICVCardGenerator methodsFor: 'processing-properties' stamp: 'pmm 11/1/2005 22:02'!
title:  aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: String iCalType.
	self currentCard title: value! !

!ICVCardGenerator methodsFor: 'processing-properties' stamp: 'pmm 11/1/2005 22:07'!
url:  aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: Url iCalType.
	self currentCard url: value! !

!ICVCardGenerator methodsFor: 'processing-properties' stamp: 'pmm 11/4/2005 23:05'!
version:  aString parameters: aDictionary
	| value |
	value := self createValue: aString parameters: aDictionary default: Float iCalType.
	self currentCard version: value! !

!ICVCardGenerator methodsFor: 'processing-properties' stamp: 'pmm 3/24/2006 15:31'!
xaim:  aString parameters: aDictionary
	| value |
	value := self createAIMId: aString parameters: aDictionary.
	self currentCard addAimid: value! !

!ICVCardGenerator methodsFor: 'processing-properties' stamp: 'pmm 3/24/2006 15:32'!
xicq:  aString parameters: aDictionary
	| value |
	value := self createICQId: aString parameters: aDictionary.
	self currentCard addIcqid: value! !

!ICVCardGenerator methodsFor: 'processing-properties' stamp: 'pmm 3/24/2006 15:32'!
xmsn:  aString parameters: aDictionary
	| value |
	value := self createMSNId: aString parameters: aDictionary.
	self currentCard addMsnid: value! !

!ICVCardGenerator methodsFor: 'processing-properties' stamp: 'pmm 3/24/2006 15:32'!
xyahoo:  aString parameters: aDictionary
	| value |
	value := self createYahooId: aString parameters: aDictionary.
	self currentCard addYahooid: value! !

Object subclass: #ICImporter
	instanceVariableNames: 'fileContent components calendar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-IO'!

!ICImporter methodsFor: 'importing' stamp: 'pmm 10/14/2005 15:17'!
addComponentsToCalendar
	self components do: [ :each |
			self calendar addComponent: each ]! !

!ICImporter methodsFor: 'accessing' stamp: 'pmm 9/11/2005 17:58'!
calendar
	^calendar! !

!ICImporter methodsFor: 'accessing' stamp: 'pmm 9/11/2005 17:59'!
calendar: aCalendar 
	calendar := aCalendar! !

!ICImporter methodsFor: 'accessing' stamp: 'pmm 10/14/2005 15:15'!
components
	^components! !

!ICImporter methodsFor: 'accessing' stamp: 'pmm 10/14/2005 15:15'!
components: aCollection 
	components := aCollection! !

!ICImporter methodsFor: 'synchronizing' stamp: 'pmm 10/15/2005 18:26'!
deleteComponentsNotInFile: aCollection

	| uids |
	uids := (self calendar components collect: [ :each | each uid ]) asOrderedCollection.
	aCollection do: [ :each | uids remove: each uid ifAbsent: [nil]].
	
	uids do: [ :uid | self calendar removeComponentWithUid: uid ].! !

!ICImporter methodsFor: 'accessing' stamp: 'pmm 9/11/2005 17:57'!
fileContent
	^fileContent! !

!ICImporter methodsFor: 'accessing' stamp: 'pmm 9/11/2005 17:58'!
fileContent: aString 
	fileContent := aString! !

!ICImporter methodsFor: 'actions' stamp: 'pmm 10/14/2005 15:17'!
import
	self parseFile.
	self addComponentsToCalendar! !

!ICImporter methodsFor: 'actions' stamp: 'pmm 10/15/2005 18:25'!
parseFile
	| importedCalendar |
	importedCalendar := ICCalendarHandParser parseCalendarString: self fileContent.
	self components: importedCalendar components asOrderedCollection! !

!ICImporter methodsFor: 'actions' stamp: 'pmm 10/14/2005 15:42'!
synchronize
	self parseFile.

	"synchronize events with known ids"
	self synchronizeComponents: (self components select: [:item |
		item uid ~= 0 and: [ item uid notNil ]]).

	"add events with unknown ids"
	self components  do: [ :component |
		component uid = 0 ifTrue: [self calendar addComponent: component]].! !

!ICImporter methodsFor: 'synchronizing' stamp: 'pmm 10/14/2005 15:42'!
synchronizeComponents: aCollection
	
	self deleteComponentsNotInFile: aCollection.
	self updateOrAddComponentsInFile: aCollection.! !

!ICImporter methodsFor: 'synchronizing' stamp: 'pmm 10/14/2005 15:41'!
updateOrAddComponentsInFile: aCollection

	aCollection do: [ :each | 
		(self calendar includesComponentWithUid: each uid) 
			ifTrue: [ self calendar removeComponentWithUid: each uid ] .
		self calendar addComponent: each ]! !

Object subclass: #ICName
	instanceVariableNames: 'familyname givenname additionalnames honorificprefixes honorificsuffixes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-VCard-Model'!

!ICName class methodsFor: 'instance creation' stamp: 'pmm 11/12/2005 12:11'!
fromICalString: aString
	| instance parts |
	instance := self new.
	parts := aString  subStringsFull: #($;).
	instance familyName: (String fromICalString: parts first).
	instance givenName: (String fromICalString: parts second).
	
	"there should be no need to do these checks, but VB programmers are idiots"
	parts size >= 3 ifTrue: [
		instance additionalNames: (self unsplit: parts third) ].
	parts size >= 4 ifTrue: [
		instance honorificPrefixes: (self unsplit: parts fourth) ].
	parts size >= 5 ifTrue: [
		instance honorificSuffixes: (self unsplit: parts fifth) ].
	^instance! !

!ICName class methodsFor: 'accessing' stamp: 'pmm 12/11/2005 10:43'!
iCalType
	^String iCalType! !

!ICName class methodsFor: 'private' stamp: 'pmm 10/30/2005 08:38'!
unsplit: aString
	^aString splitAtCommas
		collect: [ :each | String fromICalString: each ]
		thenSelect: [ :each | each isEmptyOrNil not ]! !

!ICName methodsFor: 'adding' stamp: 'pmm 10/30/2005 08:10'!
addAdditionalName: aString
	^self additionalNames add: aString! !

!ICName methodsFor: 'adding' stamp: 'pmm 10/30/2005 08:11'!
addHonorificPrefix: aString
	^self honorificPrefixes add: aString! !

!ICName methodsFor: 'adding' stamp: 'pmm 10/30/2005 08:10'!
addHonorificSuffix: aString
	^self honorificSuffixes add: aString! !

!ICName methodsFor: 'accessing' stamp: 'pmm 10/30/2005 08:09'!
additionalNames
	^additionalnames! !

!ICName methodsFor: 'accessing' stamp: 'pmm 10/30/2005 08:09'!
additionalNames: aCollection 
	additionalnames := aCollection! !

!ICName methodsFor: 'converting' stamp: 'pmm 12/11/2005 14:02'!
asVCardString
	^String streamContents: [ :stream |
		self familyName isNil ifFalse: [
			stream nextPutAll: self familyName asVCardString ].
		stream nextPut: $; .

		self givenName isNil ifFalse: [
			stream nextPutAll: self givenName asVCardString ].
		stream nextPut: $; .

		self additionalNames
			do: [ :each | stream nextPutAll: each asVCardString ]
			separatedBy: [ stream nextPut: $, ].
		stream nextPut: $; .

		self honorificPrefixes
			do: [ :each | stream nextPutAll: each asVCardString ]
			separatedBy: [ stream nextPut: $, ].
		stream nextPut: $; .

		self honorificSuffixes
			do: [ :each | stream nextPutAll: each asVCardString ]
			separatedBy: [ stream nextPut: $, ] ]! !

!ICName methodsFor: 'converting' stamp: 'pmm 3/27/2006 12:49'!
displayString
	^String streamContents: [ :stream |
		| writeBlock |
		writeBlock := [ :each | stream nextPutAll: each; space ].
		self honorificPrefixes do: writeBlock.
		self givenName isNil ifFalse: [
			writeBlock value: self givenName ].
		self additionalNames do: writeBlock.
		self familyName isNil ifFalse: [
			writeBlock value: self familyName ].
		self honorificSuffixes do: writeBlock ]
	! !

!ICName methodsFor: 'accessing' stamp: 'pmm 3/27/2006 12:49'!
familyName
	^familyname! !

!ICName methodsFor: 'accessing' stamp: 'pmm 10/30/2005 08:08'!
familyName: aString 
	familyname := aString! !

!ICName methodsFor: 'accessing' stamp: 'pmm 10/30/2005 08:08'!
givenName
	^givenname! !

!ICName methodsFor: 'accessing' stamp: 'pmm 10/30/2005 08:08'!
givenName: aString 
	givenname := aString! !

!ICName methodsFor: 'accessing' stamp: 'pmm 10/30/2005 08:07'!
honorificPrefixes
	^honorificprefixes! !

!ICName methodsFor: 'accessing' stamp: 'pmm 10/30/2005 08:07'!
honorificPrefixes: aCollection 
	honorificprefixes := aCollection! !

!ICName methodsFor: 'accessing' stamp: 'pmm 10/30/2005 08:07'!
honorificSuffixes
	^honorificsuffixes! !

!ICName methodsFor: 'accessing' stamp: 'pmm 10/30/2005 08:07'!
honorificSuffixes: aCollection 
	honorificsuffixes := aCollection! !

!ICName methodsFor: 'initialize-release' stamp: 'pmm 10/30/2005 08:10'!
initialize
	super initialize.
	self additionalNames: OrderedCollection new.
	self honorificPrefixes: OrderedCollection new.
	self honorificSuffixes: OrderedCollection new.! !

Object subclass: #ICOrganization
	instanceVariableNames: 'name unitNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-VCard-Model'!

!ICOrganization class methodsFor: 'instance creation' stamp: 'pmm 11/1/2005 22:46'!
fromICalString: aString
	| instance parts |
	instance := self new.
	parts := aString subStringsFull: #($;).
	instance name: (parts isEmpty ifTrue: [ '' ] ifFalse: [ String fromICalString: parts first ]).
	instance unitNames: (
		parts allButFirst
			collect: [ :each | String fromICalString: each]
			thenSelect: [ :each | each notEmpty ]).
	^instance! !

!ICOrganization class methodsFor: 'accessing' stamp: 'pmm 11/1/2005 22:22'!
iCalType
	^String iCalType! !

!ICOrganization methodsFor: 'adding' stamp: 'pmm 11/1/2005 22:23'!
addUnitName: aString
	^self unitNames add: aString! !

!ICOrganization methodsFor: 'converting' stamp: 'pmm 12/11/2005 14:02'!
asVCardString
	^String streamContents: [ :stream |
		stream nextPutAll: self name asVCardString.
		self unitNames isEmpty ifFalse: [
			stream nextPut: $; ].
		self unitNames
			do: [ :each | stream nextPutAll: each asVCardString ]
			separatedBy: [ stream nextPut: $; ] ]! !

!ICOrganization methodsFor: 'initialize-release' stamp: 'pmm 11/1/2005 22:24'!
initialize
	super initialize.
	self unitNames: OrderedCollection new! !

!ICOrganization methodsFor: 'accessing' stamp: 'pmm 11/1/2005 22:22'!
name
	^name! !

!ICOrganization methodsFor: 'accessing' stamp: 'pmm 11/1/2005 22:23'!
name: aString 
	name := aString! !

!ICOrganization methodsFor: 'accessing' stamp: 'pmm 11/1/2005 22:23'!
unitNames
	^unitNames! !

!ICOrganization methodsFor: 'accessing' stamp: 'pmm 11/1/2005 22:23'!
unitNames: aCollection 
	unitNames := aCollection! !

Object subclass: #ICRecurrenceRule
	instanceVariableNames: 'frequency interval seconds minutes hours weekdays monthdays yeardays weeknumbers monthnumbers positions weekStartday repetition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Model'!

!ICRecurrenceRule commentStamp: '<historical>' prior: 0!
RFC 2445
4.3.10 Recurrence Rule

http://labix.org/python-dateutil!

!ICRecurrenceRule class methodsFor: 'parsing' stamp: 'pmm 10/4/2005 18:12'!
byday: aString on: aRule
	| firstLetterIndex day occurrence |
	firstLetterIndex := aString findFirst: [ :each | each isLetter ].
	firstLetterIndex = 1
		ifTrue: [ aRule addWeekday: aString asUppercase ]
		ifFalse: [
			day := (aString allButFirst: firstLetterIndex - 1) asUppercase.
			occurrence := Integer fromICalString: (aString first:  firstLetterIndex - 1).
			aRule addWeekday: day occurrence: occurrence ]! !

!ICRecurrenceRule class methodsFor: 'parsing' stamp: 'pmm 10/4/2005 17:58'!
byhour: aString on: aRule
	aRule addHour: (Integer fromICalString: aString)! !

!ICRecurrenceRule class methodsFor: 'parsing' stamp: 'pmm 10/4/2005 17:58'!
byminute: aString on: aRule
	aRule addMinute: (Integer fromICalString: aString)! !

!ICRecurrenceRule class methodsFor: 'parsing' stamp: 'pmm 10/4/2005 18:13'!
bymonthday: aString on: aRule
	aRule addMonthday: (Integer fromICalString: aString)! !

!ICRecurrenceRule class methodsFor: 'parsing' stamp: 'pmm 10/4/2005 17:57'!
bysecond: aString on: aRule
	aRule addSecond: (Integer fromICalString: aString)! !

!ICRecurrenceRule class methodsFor: 'parsing' stamp: 'pmm 10/4/2005 20:10'!
bysetpos: aString on: aRule
	aRule addPosition: (Integer fromICalString: aString)! !

!ICRecurrenceRule class methodsFor: 'parsing' stamp: 'pmm 10/4/2005 18:14'!
byyearday: aString on: aRule
	aRule addYearday: (Integer fromICalString: aString)! !

!ICRecurrenceRule class methodsFor: 'parsing' stamp: 'pmm 10/4/2005 07:19'!
count: aString on: aRule
	aRule count: (Integer fromICalString: aString)! !

!ICRecurrenceRule class methodsFor: 'instance creation' stamp: 'pmm 10/9/2005 13:38'!
daily
	^self frequency: self frequencyDaily ! !

!ICRecurrenceRule class methodsFor: 'accessing' stamp: 'pmm 10/9/2005 13:33'!
frequencyDaily
	^'DAILY'! !

!ICRecurrenceRule class methodsFor: 'accessing' stamp: 'pmm 10/9/2005 13:33'!
frequencyHourly
	^'HOURLY'! !

!ICRecurrenceRule class methodsFor: 'accessing' stamp: 'pmm 10/9/2005 13:33'!
frequencyMinutely
	^'MINUTELY'! !

!ICRecurrenceRule class methodsFor: 'accessing' stamp: 'pmm 10/9/2005 13:34'!
frequencyMonthly
	^'MONTHLY'! !

!ICRecurrenceRule class methodsFor: 'accessing' stamp: 'pmm 10/9/2005 13:33'!
frequencySecondly
	^'SECONDLY'! !

!ICRecurrenceRule class methodsFor: 'accessing' stamp: 'pmm 10/9/2005 13:36'!
frequencyWeekly
	^'WEEKLY'! !

!ICRecurrenceRule class methodsFor: 'accessing' stamp: 'pmm 10/9/2005 13:34'!
frequencyYearly
	^'YEARLY'! !

!ICRecurrenceRule class methodsFor: 'instance creation' stamp: 'pmm 10/2/2005 15:07'!
frequency: aString
	^self new
		frequency: aString;
		yourself! !

!ICRecurrenceRule class methodsFor: 'parsing' stamp: 'pmm 10/4/2005 20:00'!
freq: aString on: aRule
	aRule frequency: aString asUppercase! !

!ICRecurrenceRule class methodsFor: 'instance creation' stamp: 'pmm 10/4/2005 20:04'!
fromICalString: aString
	| inst parts key values |
	inst := self new.
	(aString  subStrings: #($;)) do: [ :property | 
		parts := property subStrings: #($=).
		key := parts first.
		values := parts second subStrings: #($,).
		values do: [ :each |
			self
				perform: (key asLowercase , ':on:') asSymbol
				withArguments: (Array with: each with: inst) ] ].
	^inst! !

!ICRecurrenceRule class methodsFor: 'instance creation' stamp: 'pmm 10/9/2005 13:38'!
hourly
	^self frequency: self frequencyHourly ! !

!ICRecurrenceRule class methodsFor: 'accessing' stamp: 'pmm 10/4/2005 07:17'!
iCalType
	^'RECUR'! !

!ICRecurrenceRule class methodsFor: 'parsing' stamp: 'pmm 10/4/2005 07:20'!
interval: aString on: aRule
	aRule interval: (Integer fromICalString: aString)! !

!ICRecurrenceRule class methodsFor: 'instance creation' stamp: 'pmm 10/9/2005 13:38'!
minutely
	^self frequency: self frequencyMinutely ! !

!ICRecurrenceRule class methodsFor: 'instance creation' stamp: 'pmm 10/9/2005 13:38'!
monthly
	^self frequency: self frequencyMonthly  ! !

!ICRecurrenceRule class methodsFor: 'accessing' stamp: 'pmm 10/9/2005 13:37'!
possibleFrequencies
	^OrderedCollection new
		add: self frequencySecondly;
		add: self frequencyMinutely;
		add: self frequencyHourly;
		add: self frequencyDaily;
		add: self frequencyWeekly;
		add: self frequencyMonthly; 
		add: self frequencyYearly;
		yourself! !

!ICRecurrenceRule class methodsFor: 'accessing' stamp: 'pmm 10/2/2005 13:15'!
possibleWeekdays
	^#(
		'SU'
		'MO'
		'TU'
		'WE'
		'TH'
		'FR'
		'SA'
	)! !

!ICRecurrenceRule class methodsFor: 'instance creation' stamp: 'pmm 10/9/2005 13:37'!
secondly
	^self frequency: self frequencySecondly! !

!ICRecurrenceRule class methodsFor: 'parsing' stamp: 'pmm 10/4/2005 07:20'!
until: aString on: aRule
	aRule until: (DateAndTime fromICalString: aString)! !

!ICRecurrenceRule class methodsFor: 'instance creation' stamp: 'pmm 10/9/2005 13:42'!
weekly
	^self frequency: self frequencyWeekly ! !

!ICRecurrenceRule class methodsFor: 'parsing' stamp: 'pmm 10/4/2005 18:18'!
wkst: aString on: aRule
	aRule weekStartday: aString asUppercase! !

!ICRecurrenceRule class methodsFor: 'instance creation' stamp: 'pmm 10/9/2005 13:39'!
yearly
	^self frequency: self frequencyYearly ! !

!ICRecurrenceRule methodsFor: 'adding' stamp: 'pmm 10/2/2005 13:09'!
addHour: anInteger
	^self hours add: anInteger! !

!ICRecurrenceRule methodsFor: 'adding' stamp: 'pmm 10/2/2005 13:09'!
addMinute: anInteger
	^self minutes add: anInteger! !

!ICRecurrenceRule methodsFor: 'adding' stamp: 'pmm 10/2/2005 13:11'!
addMonthday: anInteger
	^self monthdays add: anInteger! !

!ICRecurrenceRule methodsFor: 'adding' stamp: 'pmm 10/2/2005 13:33'!
addPosition: anInteger
	^self positions add: anInteger! !

!ICRecurrenceRule methodsFor: 'adding' stamp: 'pmm 10/2/2005 13:07'!
addSecond: anInteger
	^self seconds add: anInteger! !

!ICRecurrenceRule methodsFor: 'adding' stamp: 'pmm 10/2/2005 13:16'!
addWeekday: aString
	^self weekdays add: aString! !

!ICRecurrenceRule methodsFor: 'adding' stamp: 'pmm 10/4/2005 18:11'!
addWeekday: aString occurrence: anInteger
	^self weekdays add: aString -> anInteger! !

!ICRecurrenceRule methodsFor: 'adding' stamp: 'pmm 10/2/2005 13:28'!
addWeeknumber: anInteger
	^self weeknumbers add: anInteger! !

!ICRecurrenceRule methodsFor: 'adding' stamp: 'pmm 10/2/2005 13:26'!
addYearday: anInteger
	^self yeardays add: anInteger! !

!ICRecurrenceRule methodsFor: 'converting' stamp: 'pmm 10/4/2005 20:06'!
asICalString
	^String streamContents: [ :stream |
		self printFrequencyOn: stream.
		self hasRepetition
			ifTrue: [
				self printCommaOn: stream.
				self printRepetitonOn: stream ].
		self hasInterval
			ifTrue: [
				self printCommaOn: stream.
				self printIntervalOn: stream ].
		self hasSeconds
			ifTrue: [
				self printCommaOn: stream.
				self printSecondsOn: stream ].
		self hasMinutes
			ifTrue: [
				self printCommaOn: stream.
				self printMinutesOn: stream ].
		self hasHours
			ifTrue: [
				self printCommaOn: stream.
				self printHoursOn: stream ].
		self hasWeekdays
			ifTrue: [ 
				self printCommaOn: stream.
				self printWeekdaysOn: stream ].
		self hasMonthdays
			ifTrue: [ 
				self printCommaOn: stream.
				self printMonthdaysOn: stream ].
		self hasYeardays
			ifTrue: [ 
				self printCommaOn: stream.
				self printYeardaysOn: stream ].
		self hasWeeknumbers
			ifTrue: [ 
				self printCommaOn: stream.
				self printWeeknumbersOn: stream ].
		self hasMonthnumbers
			ifTrue: [ 
				self printCommaOn: stream.
				self printMonthnumbersOn: stream ].
		self hasPositions
			ifTrue: [ 
				self printCommaOn: stream.
				self printPositionsnumbersOn: stream. ].
		self hasWeekStartday
			ifTrue: [ 
				self printCommaOn: stream.
				self printWeekStartdayOn: stream ] ]! !

!ICRecurrenceRule methodsFor: 'accessing' stamp: 'pmm 10/2/2005 14:58'!
count: anInteger 
	repetition := anInteger! !

!ICRecurrenceRule methodsFor: 'accessing' stamp: 'pmm 10/2/2005 12:35'!
frequency
	^frequency! !

!ICRecurrenceRule methodsFor: 'accessing' stamp: 'pmm 10/2/2005 12:35'!
frequency: aString 
	frequency := aString! !

!ICRecurrenceRule methodsFor: 'testing' stamp: 'pmm 10/2/2005 13:42'!
hasHours
	^self hours notEmpty! !

!ICRecurrenceRule methodsFor: 'testing' stamp: 'pmm 10/2/2005 13:41'!
hasInterval
	^self interval notNil! !

!ICRecurrenceRule methodsFor: 'testing' stamp: 'pmm 10/2/2005 13:42'!
hasMinutes
	^self minutes notEmpty! !

!ICRecurrenceRule methodsFor: 'testing' stamp: 'pmm 10/2/2005 13:42'!
hasMonthdays
	^self monthdays notEmpty! !

!ICRecurrenceRule methodsFor: 'testing' stamp: 'pmm 10/2/2005 13:43'!
hasMonthnumbers
	^self monthnumbers notEmpty! !

!ICRecurrenceRule methodsFor: 'testing' stamp: 'pmm 10/2/2005 13:44'!
hasPositions
	^self positions notEmpty! !

!ICRecurrenceRule methodsFor: 'testing' stamp: 'pmm 10/2/2005 14:58'!
hasRepetition
	^self repetition notNil! !

!ICRecurrenceRule methodsFor: 'testing' stamp: 'pmm 10/2/2005 13:42'!
hasSeconds
	^self seconds notEmpty! !

!ICRecurrenceRule methodsFor: 'testing' stamp: 'pmm 10/2/2005 13:42'!
hasWeekdays
	^self weekdays notEmpty! !

!ICRecurrenceRule methodsFor: 'testing' stamp: 'pmm 10/2/2005 13:43'!
hasWeeknumbers
	^self weeknumbers notEmpty! !

!ICRecurrenceRule methodsFor: 'testing' stamp: 'pmm 10/2/2005 13:47'!
hasWeekStartday
	^self weekStartday notNil! !

!ICRecurrenceRule methodsFor: 'testing' stamp: 'pmm 10/2/2005 13:43'!
hasYeardays
	^self yeardays notEmpty! !

!ICRecurrenceRule methodsFor: 'accessing' stamp: 'pmm 10/2/2005 13:08'!
hours
	^hours! !

!ICRecurrenceRule methodsFor: 'accessing' stamp: 'pmm 10/2/2005 13:08'!
hours: aCollection 
	hours := aCollection! !

!ICRecurrenceRule methodsFor: 'initialize-release' stamp: 'pmm 10/29/2005 00:53'!
initialize
	super initialize.
	self seconds: Set new.
	self minutes: Set new.
	self hours: Set new.
	self weekdays: Set new.
	self monthdays: Set new.	
	self yeardays: Set new.
	self weeknumbers: Set new.
	self monthnumbers: Set new.
	self positions: Set new.! !

!ICRecurrenceRule methodsFor: 'accessing' stamp: 'pmm 10/2/2005 13:05'!
interval
	^interval! !

!ICRecurrenceRule methodsFor: 'accessing' stamp: 'pmm 10/2/2005 13:05'!
interval: anInteger 
	interval := anInteger! !

!ICRecurrenceRule methodsFor: 'testing' stamp: 'pmm 10/3/2005 16:58'!
isValid
	^self repetition notNil! !

!ICRecurrenceRule methodsFor: 'accessing' stamp: 'pmm 10/2/2005 13:08'!
minutes
	^minutes! !

!ICRecurrenceRule methodsFor: 'accessing' stamp: 'pmm 10/2/2005 13:08'!
minutes: aCollection 
	minutes := aCollection! !

!ICRecurrenceRule methodsFor: 'accessing' stamp: 'pmm 10/2/2005 13:10'!
monthdays
	^monthdays! !

!ICRecurrenceRule methodsFor: 'accessing' stamp: 'pmm 10/2/2005 13:10'!
monthdays: aCollection 
	monthdays := aCollection! !

!ICRecurrenceRule methodsFor: 'accessing' stamp: 'pmm 10/2/2005 13:30'!
monthnumbers
	^monthnumbers! !

!ICRecurrenceRule methodsFor: 'accessing' stamp: 'pmm 10/2/2005 13:30'!
monthnumbers: aCollection 
	monthnumbers := aCollection! !

!ICRecurrenceRule methodsFor: 'accessing' stamp: 'pmm 10/2/2005 13:32'!
positions
	^positions! !

!ICRecurrenceRule methodsFor: 'accessing' stamp: 'pmm 10/2/2005 13:32'!
positions: aCollection 
	positions := aCollection! !

!ICRecurrenceRule methodsFor: 'private' stamp: 'pmm 10/2/2005 15:03'!
printCommaOn: aStream
	aStream nextPut: $;! !

!ICRecurrenceRule methodsFor: 'private' stamp: 'pmm 10/2/2005 13:45'!
printFrequencyOn: aStream
	aStream
		nextPutAll: 'FREQ=';
		nextPutAll: self frequency! !

!ICRecurrenceRule methodsFor: 'private' stamp: 'pmm 10/2/2005 13:52'!
printHoursOn: aStream
	self
		printIntegers: self hours
		title: 'BYHOUR'
		on: aStream! !

!ICRecurrenceRule methodsFor: 'private' stamp: 'pmm 10/3/2005 17:47'!
printIntegers: aCollection title: aString on: aStream
	aStream
		nextPutAll: aString;
		nextPut: $=.
	aCollection
		do: [ :each | aStream nextPutAll: each asICalString ]
		separatedBy: [ aStream nextPut: $, ]! !

!ICRecurrenceRule methodsFor: 'private' stamp: 'pmm 10/3/2005 17:47'!
printIntervalOn: aStream
	aStream
		nextPutAll: 'INTERVAL=';
		nextPutAll: self interval asICalString! !

!ICRecurrenceRule methodsFor: 'private' stamp: 'pmm 10/2/2005 13:52'!
printMinutesOn: aStream
	self
		printIntegers: self minutes
		title: 'BYMINUTE'
		on: aStream! !

!ICRecurrenceRule methodsFor: 'private' stamp: 'pmm 10/2/2005 13:55'!
printMonthdaysOn: aStream
	self
		printIntegers: self monthdays
		title: 'BYMONTHDAY'
		on: aStream! !

!ICRecurrenceRule methodsFor: 'private' stamp: 'pmm 10/2/2005 13:57'!
printMonthnumbersOn: aStream
	self
		printIntegers: self monthnumbers
		title: 'BYMONTH'
		on: aStream! !

!ICRecurrenceRule methodsFor: 'private' stamp: 'pmm 10/2/2005 13:58'!
printPositionsnumbersOn: aStream
	self
		printIntegers: self positions
		title: 'BYSETPOS'
		on: aStream! !

!ICRecurrenceRule methodsFor: 'private' stamp: 'pmm 10/3/2005 17:49'!
printRepetitonOn: aStream	
	aStream
		nextPutAll: (self repetition isInteger
			ifTrue: [ 'COUNT=' ]
			ifFalse: [ 'UNTIL=' ]);
		nextPutAll: self repetition asICalString! !

!ICRecurrenceRule methodsFor: 'private' stamp: 'pmm 10/2/2005 13:52'!
printSecondsOn: aStream
	self
		printIntegers: self seconds
		title: 'BYSECOND'
		on: aStream! !

!ICRecurrenceRule methodsFor: 'private' stamp: 'pmm 10/4/2005 18:11'!
printWeekdaysOn: aStream
	aStream nextPutAll: 'BYDAY='.
	self weekdays
		do: [ :each |
			each isString
				ifTrue: [ aStream nextPutAll: each ]
				ifFalse: [
					aStream
						nextPutAll: each value asICalString; "occurrence"
						nextPutAll: each key asICalString "day" ] ]
		separatedBy: [ aStream nextPut: $, ]! !

!ICRecurrenceRule methodsFor: 'private' stamp: 'pmm 10/2/2005 13:56'!
printWeeknumbersOn: aStream
	self
		printIntegers: self weeknumbers
		title: 'BYWEEKNO'
		on: aStream! !

!ICRecurrenceRule methodsFor: 'private' stamp: 'pmm 10/2/2005 13:59'!
printWeekStartdayOn: aStream
	aStream
		nextPutAll: 'WKST=';
		nextPutAll: self weekStartday! !

!ICRecurrenceRule methodsFor: 'private' stamp: 'pmm 10/2/2005 13:54'!
printYeardaysOn: aStream
	self
		printIntegers: self yeardays
		title: 'BYYEARDAY'
		on: aStream! !

!ICRecurrenceRule methodsFor: 'accessing' stamp: 'pmm 10/2/2005 14:58'!
repetition
	^repetition! !

!ICRecurrenceRule methodsFor: 'accessing' stamp: 'pmm 10/2/2005 13:06'!
seconds
	^seconds! !

!ICRecurrenceRule methodsFor: 'accessing' stamp: 'pmm 10/2/2005 13:07'!
seconds: aCollection 
	seconds := aCollection! !

!ICRecurrenceRule methodsFor: 'accessing' stamp: 'pmm 10/2/2005 15:13'!
until: aDateOrDateAndTime 
	repetition := aDateOrDateAndTime! !

!ICRecurrenceRule methodsFor: 'accessing' stamp: 'pmm 10/2/2005 13:15'!
weekdays
	^weekdays! !

!ICRecurrenceRule methodsFor: 'accessing' stamp: 'pmm 10/2/2005 13:15'!
weekdays: aString 
	weekdays := aString! !

!ICRecurrenceRule methodsFor: 'accessing' stamp: 'pmm 10/2/2005 13:28'!
weeknumbers
	^weeknumbers! !

!ICRecurrenceRule methodsFor: 'accessing' stamp: 'pmm 10/2/2005 13:28'!
weeknumbers: aCollection 
	weeknumbers := aCollection! !

!ICRecurrenceRule methodsFor: 'accessing' stamp: 'pmm 10/2/2005 13:47'!
weekStartday
	^weekStartday! !

!ICRecurrenceRule methodsFor: 'accessing' stamp: 'pmm 10/2/2005 13:47'!
weekStartday: aString 
	weekStartday := aString! !

!ICRecurrenceRule methodsFor: 'accessing' stamp: 'pmm 10/2/2005 13:25'!
yeardays
	^yeardays! !

!ICRecurrenceRule methodsFor: 'accessing' stamp: 'pmm 10/2/2005 13:25'!
yeardays: aCollection 
	yeardays := aCollection! !

Object subclass: #ICStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Strategy'!

ICStrategy subclass: #ICRandombasedUUIDStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Strategy'!

!ICRandombasedUUIDStrategy methodsFor: 'generating' stamp: 'pmm 10/6/2005 18:35'!
generateUid
	^(PipeableOSProcess command: 'uuidgen -r') output! !

ICStrategy subclass: #ICRecommendedByStandardStrategy
	instanceVariableNames: 'uuidstragety'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Strategy'!

!ICRecommendedByStandardStrategy class methodsFor: 'accessing' stamp: 'pmm 10/5/2005 06:56'!
uuidstragetyClass
	^ICSqueakUUIDStrategy ! !

!ICRecommendedByStandardStrategy methodsFor: 'testing' stamp: 'pmm 10/6/2005 17:43'!
canUseCommandShell
	^self canUseOsProcess
		and: [ Smalltalk hasClassNamed: #PipeableOSProcess ]! !

!ICRecommendedByStandardStrategy methodsFor: 'testing' stamp: 'pmm 10/5/2005 06:58'!
canUseOsProcess
	^Smalltalk hasClassNamed: #OSProcess! !

!ICRecommendedByStandardStrategy methodsFor: 'generating' stamp: 'pmm 10/6/2005 18:35'!
generateUid
	^String streamContents: 
			[:stream | 
			stream
				nextPutAll: self now;
				nextPut: $-.
			self randomParts do: [:each | stream nextPutAll: each]
				separatedBy: [stream nextPut: $-].
			stream
				nextPut: $@;
				nextPutAll: self hostName]! !

!ICRecommendedByStandardStrategy methodsFor: 'accessing' stamp: 'pmm 11/19/2005 08:37'!
hostName
	| name isOSProcessFixed |
	self flag: #todo. "fix OS process"
	isOSProcessFixed := false.
	name := NetNameResolver localHostName.	
	isOSProcessFixed ifTrue: [
		(name = 'localhost' and: [ self canUseCommandShell ] and: [ self isUnix ])
			ifTrue: [
				"the vm screw up and returned localhost, this is a 'feature' of the Unix VM
				but fortunately we can use OSProcess and command shell to fix that"
				name := UnixProcess waitForCommandOutput: 'hostname'.			
				(UnixProcess waitForCommandOutput: 'dnsdomainname') output in: [ :domain |
					 domain isEmptyOrNil ifFalse: [ name := name , '.'  , domain ] ] ] ].
	^name! !

!ICRecommendedByStandardStrategy methodsFor: 'initialize-release' stamp: 'pmm 10/5/2005 06:57'!
initialize
	super initialize.
	uuidstragety := self class uuidstragetyClass new.! !

!ICRecommendedByStandardStrategy methodsFor: 'testing' stamp: 'pmm 11/19/2005 08:32'!
isUnix
	^OSProcess thisOSProcess isKindOf: UnixProcess! !

!ICRecommendedByStandardStrategy methodsFor: 'accessing' stamp: 'pmm 7/7/2006 10:51'!
memoryUsage
	| params  |
	params := SmalltalkImage current getVMParameters.
	^(params at: 2) printStringHex asLowercase
! !

!ICRecommendedByStandardStrategy methodsFor: 'accessing' stamp: 'pmm 10/5/2005 06:59'!
now
	^DateAndTime now asICalString! !

!ICRecommendedByStandardStrategy methodsFor: 'accessing' stamp: 'pmm 7/7/2006 11:01'!
processId
	^OSProcess thisOSProcess pid printStringHex asLowercase! !

!ICRecommendedByStandardStrategy methodsFor: 'accessing' stamp: 'pmm 10/6/2005 17:56'!
randomParts
	| parts |
	parts := OrderedCollection new.
	self canUseOsProcess ifTrue: [
		parts add: self processId ].
	parts add: self memoryUsage.
	parts add: self uptime.
	parts add: self uuid.
	^parts! !

!ICRecommendedByStandardStrategy methodsFor: 'accessing' stamp: 'pmm 7/7/2006 10:50'!
uptime
	^Time millisecondClockValue printStringHex asLowercase! !

!ICRecommendedByStandardStrategy methodsFor: 'accessing' stamp: 'pmm 10/6/2005 18:35'!
uuid
	^self uuidstragety generateUid! !

!ICRecommendedByStandardStrategy methodsFor: 'accessing' stamp: 'pmm 10/5/2005 06:56'!
uuidstragety
	^uuidstragety! !

ICStrategy subclass: #ICSqueakUUIDStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Strategy'!

!ICSqueakUUIDStrategy methodsFor: 'generating' stamp: 'pmm 10/6/2005 18:35'!
generateUid
	^UUID new printString! !

!ICStrategy methodsFor: 'generating' stamp: 'pmm 10/6/2005 18:35'!
generateUid
	self subclassResponsibility! !

ICStrategy subclass: #ICTimebasedUUIDStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Strategy'!

!ICTimebasedUUIDStrategy methodsFor: 'generating' stamp: 'pmm 10/6/2005 18:35'!
generateUid
	^(PipeableOSProcess command: 'uuidgen -t') output! !

Object subclass: #ICTrigger
	instanceVariableNames: 'related value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Model'!

!ICTrigger class methodsFor: 'instance creation' stamp: 'pmm 11/10/2005 23:20'!
fromICalString: aString parameters: aDictionary
	| related valueType value |
	related := aDictionary at: 'RELATED' ifAbsent: [ self relatedToStart ].
	valueType := aDictionary at: 'VALUE' ifAbsent: [ Duration iCalType ].
	value := (ICConversion propertyClassFor: valueType) fromICalString: aString.
	^self new
		related: related;
		value: value;
		yourself! !

!ICTrigger class methodsFor: 'accessing' stamp: 'pmm 11/10/2005 22:53'!
iCalType
	^Duration iCalType! !

!ICTrigger class methodsFor: 'accessing-related' stamp: 'pmm 11/10/2005 22:54'!
relatedToEnd
	^'END'! !

!ICTrigger class methodsFor: 'accessing-related' stamp: 'pmm 11/10/2005 22:53'!
relatedToStart
	^'START'! !

!ICTrigger methodsFor: 'converting' stamp: 'pmm 11/10/2005 23:23'!
asICalString
	^self value asICalString! !

!ICTrigger methodsFor: 'testing' stamp: 'pmm 11/10/2005 22:56'!
beRelatedToEnd
	self related: self class relatedToEnd! !

!ICTrigger methodsFor: 'testing' stamp: 'pmm 11/10/2005 22:56'!
beRelatedToStart
	self related: self class relatedToStart! !

!ICTrigger methodsFor: 'exporting' stamp: 'pmm 11/10/2005 23:11'!
exportICalParametersOn: anExpoter
	super exportICalParametersOn: anExpoter.
	self related isNil ifFalse: [
		anExpoter exportParameter: 'RELATED' value: self related ]! !

!ICTrigger methodsFor: 'accessing' stamp: 'pmm 11/10/2005 23:21'!
iCalType
	^self value isNil
		ifTrue: [ self class iCalType ]
		ifFalse: [ self value iCalType ]! !

!ICTrigger methodsFor: 'testing' stamp: 'pmm 11/10/2005 22:56'!
isRelatedToEnd
	^self related = self class relatedToEnd! !

!ICTrigger methodsFor: 'testing' stamp: 'pmm 11/10/2005 22:55'!
isRelatedToStart
	^self related = self class relatedToStart
		or: [ self related isNil ]! !

!ICTrigger methodsFor: 'accessing' stamp: 'pmm 11/10/2005 22:54'!
related
	^related! !

!ICTrigger methodsFor: 'accessing' stamp: 'pmm 11/10/2005 22:54'!
related: aString 
	related := aString! !

!ICTrigger methodsFor: 'accessing' stamp: 'pmm 11/10/2005 22:57'!
value
	^value! !

!ICTrigger methodsFor: 'accessing' stamp: 'pmm 11/10/2005 22:58'!
value: aDurationOrDateAndTime 
	value := aDurationOrDateAndTime! !

Object subclass: #ICTypedObject
	instanceVariableNames: 'types'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-VCard-Model'!

ICTypedObject subclass: #ICAddress
	instanceVariableNames: 'poBox extended street locality region postalcode country'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-VCard-Model'!

!ICAddress class methodsFor: 'accessing-types' stamp: 'pmm 10/29/2005 01:12'!
defaultTypes
	^Set
		with: self typeInternational 
		with: self typePostal 
		with: self typeParcel 
		with: self typeWork! !

!ICAddress class methodsFor: 'instance creation' stamp: 'pmm 12/3/2005 12:41'!
fromVCardString: aString parameters: aDictionary
	| instance parts |
	instance := self new.
	instance types: (self parseTypes: aDictionary).
	parts := aString  subStringsFull: #($;).
	instance poBox: (String fromVCardString: parts first).
	instance extended: (String fromVCardString: parts second).
	instance street: (String fromVCardString: parts third).
	
	parts size >= 4 ifTrue: [
		instance locality: (String fromVCardString: parts fourth) ].
	parts size >= 5 ifTrue: [
		instance region: (String fromVCardString: parts fifth) ].
	parts size >= 6 ifTrue: [
		instance postalcode: (String fromVCardString: parts sixth) ].
	parts size >= 7 ifTrue: [
		instance country: (String fromVCardString: parts seventh) ].
	^instance! !

!ICAddress class methodsFor: 'accessing-types' stamp: 'pmm 3/24/2006 15:03'!
possibleTypes
	^super possibleTypes
		add: self typeDomestic;
		add: self typeInternational;
		add: self typeParcel;
		add: self typePostal;
		yourself! !

!ICAddress class methodsFor: 'accessing-types' stamp: 'pmm 10/29/2005 01:05'!
typeDomestic
	^'dom'! !

!ICAddress class methodsFor: 'accessing-types' stamp: 'pmm 10/29/2005 01:05'!
typeInternational
	^'intl'! !

!ICAddress class methodsFor: 'accessing-types' stamp: 'pmm 10/29/2005 01:06'!
typeParcel
	^'parcel'! !

!ICAddress class methodsFor: 'accessing-types' stamp: 'pmm 10/29/2005 01:06'!
typePostal
	^'postal'! !

!ICAddress methodsFor: 'converting' stamp: 'pmm 12/11/2005 14:01'!
asVCardString
	^String streamContents: [ :stream |
		self poBox isNil ifFalse: [
			stream nextPutAll: self poBox asVCardString ].
		stream nextPut: $;.

		self extended isNil ifFalse: [
			stream nextPutAll: self extended asVCardString ].
		stream nextPut: $;.

		self street isNil ifFalse: [
			stream nextPutAll: self street asVCardString ].
		stream nextPut: $;.

		self locality isNil ifFalse: [
			stream nextPutAll: self locality asVCardString ].
		stream nextPut: $;.

		self region isNil ifFalse: [
			stream nextPutAll: self region asVCardString ].
		stream nextPut: $;.

		self postalcode isNil ifFalse: [
			stream nextPutAll: self postalcode asVCardString ].
		stream nextPut: $;.

		self country isNil ifFalse: [
			stream nextPutAll: self country asVCardString ] ]! !

!ICAddress methodsFor: 'accessing-types' stamp: 'pmm 10/29/2005 21:26'!
beDomestic
	self domestic: true! !

!ICAddress methodsFor: 'accessing-types' stamp: 'pmm 10/29/2005 21:26'!
beInternational
	self international: true! !

!ICAddress methodsFor: 'accessing-types' stamp: 'pmm 10/29/2005 21:27'!
beParcel
	self parcel: true! !

!ICAddress methodsFor: 'accessing-types' stamp: 'pmm 10/29/2005 21:27'!
bePostal
	self postal: true! !

!ICAddress methodsFor: 'accessing' stamp: 'pmm 10/29/2005 01:08'!
country
	^country! !

!ICAddress methodsFor: 'accessing' stamp: 'pmm 10/29/2005 01:08'!
country: aString 
	country := aString! !

!ICAddress methodsFor: 'accessing-types' stamp: 'pmm 10/29/2005 21:19'!
domestic
	^self types includes: self class typeDomestic! !

!ICAddress methodsFor: 'accessing-types' stamp: 'pmm 10/29/2005 21:23'!
domestic: aBoolean
	^self
		setType: self class typeDomestic
		toValue: aBoolean! !

!ICAddress methodsFor: 'accessing' stamp: 'pmm 10/29/2005 01:08'!
extended
	^extended! !

!ICAddress methodsFor: 'accessing' stamp: 'pmm 10/29/2005 01:09'!
extended: aString 
	extended := aString! !

!ICAddress methodsFor: 'accessing-types' stamp: 'pmm 10/29/2005 21:19'!
international
	^self types includes: self class typeInternational! !

!ICAddress methodsFor: 'accessing-types' stamp: 'pmm 10/29/2005 21:23'!
international: aBoolean
	^self
		setType: self class typeInternational
		toValue: aBoolean! !

!ICAddress methodsFor: 'accessing-types' stamp: 'pmm 10/29/2005 21:24'!
isDomestic
	^self domestic! !

!ICAddress methodsFor: 'accessing-types' stamp: 'pmm 10/29/2005 21:25'!
isInternational
	^self international! !

!ICAddress methodsFor: 'accessing-types' stamp: 'pmm 10/29/2005 21:25'!
isParcel
	^self parcel! !

!ICAddress methodsFor: 'accessing-types' stamp: 'pmm 10/29/2005 21:25'!
isPostal
	^self postal! !

!ICAddress methodsFor: 'accessing' stamp: 'pmm 10/29/2005 01:08'!
locality
	^locality! !

!ICAddress methodsFor: 'accessing' stamp: 'pmm 10/29/2005 01:09'!
locality: aString 
	locality := aString! !

!ICAddress methodsFor: 'accessing-types' stamp: 'pmm 10/29/2005 21:19'!
parcel
	^self types includes: self class typeParcel! !

!ICAddress methodsFor: 'accessing-types' stamp: 'pmm 10/29/2005 21:23'!
parcel: aBoolean
	^self
		setType: self class typeParcel
		toValue: aBoolean! !

!ICAddress methodsFor: 'accessing' stamp: 'pmm 10/29/2005 01:08'!
poBox
	^poBox! !

!ICAddress methodsFor: 'accessing' stamp: 'pmm 10/29/2005 01:09'!
poBox: aString 
	poBox := aString! !

!ICAddress methodsFor: 'accessing-types' stamp: 'pmm 10/29/2005 21:20'!
postal
	^self types includes: self class typePostal! !

!ICAddress methodsFor: 'accessing' stamp: 'pmm 10/29/2005 01:08'!
postalcode
	^postalcode! !

!ICAddress methodsFor: 'accessing' stamp: 'pmm 10/29/2005 01:09'!
postalcode: aString 
	postalcode := aString! !

!ICAddress methodsFor: 'accessing-types' stamp: 'pmm 10/29/2005 21:24'!
postal: aBoolean
	^self
		setType: self class typePostal
		toValue: aBoolean! !

!ICAddress methodsFor: 'accessing' stamp: 'pmm 10/29/2005 01:08'!
region
	^region! !

!ICAddress methodsFor: 'accessing' stamp: 'pmm 10/29/2005 01:09'!
region: aString 
	region := aString! !

!ICAddress methodsFor: 'accessing' stamp: 'pmm 10/29/2005 01:08'!
street
	^street! !

!ICAddress methodsFor: 'accessing' stamp: 'pmm 10/29/2005 01:09'!
street: aString 
	street := aString! !

ICTypedObject subclass: #ICEmailAddress
	instanceVariableNames: 'address'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-VCard-Model'!

!ICEmailAddress class methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 19:29'!
defaultTypes
	^Set with: self typeInternet! !

!ICEmailAddress class methodsFor: 'instance creation' stamp: 'pmm 10/30/2005 19:30'!
fromICalString: aString parameters: aDictionary
	| instance |
	instance := self new.
	instance types: (self parseTypes: aDictionary).
	instance address: (String fromICalString: aString).
	^instance! !

!ICEmailAddress class methodsFor: 'accessing-types' stamp: 'pmm 3/24/2006 15:03'!
possibleTypes
	^super possibleTypes
		add: self typeInternet;
		add: self typeX400;
		yourself! !

!ICEmailAddress class methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 19:28'!
typeInternet
	^'internet'! !

!ICEmailAddress class methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 19:28'!
typeX400
	^'x400'! !

!ICEmailAddress methodsFor: 'accessing' stamp: 'pmm 10/30/2005 19:26'!
address
	^address! !

!ICEmailAddress methodsFor: 'accessing' stamp: 'pmm 10/30/2005 19:26'!
address: aString 
	address := aString! !

!ICEmailAddress methodsFor: 'converting' stamp: 'pmm 12/11/2005 14:01'!
asVCardString
	^self address asVCardString! !

!ICEmailAddress methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 20:02'!
beInternet
	self internet: true! !

!ICEmailAddress methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 20:03'!
beX400
	self x400: true! !

!ICEmailAddress methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 20:00'!
internet
	^self types includes: self class typeInternet! !

!ICEmailAddress methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 20:02'!
internet: aBoolean
	^self
		setType: self class typeInternet
		toValue: aBoolean! !

!ICEmailAddress methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 20:01'!
isInternet
	^self internet! !

!ICEmailAddress methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 20:01'!
isX400
	^self x400! !

!ICEmailAddress methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 20:01'!
x400
	^self types includes: self class typeX400! !

!ICEmailAddress methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 20:02'!
x400: aBoolean
	^self
		setType: self class typeX400
		toValue: aBoolean! !

ICTypedObject subclass: #ICInstantMessageId
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-VCard-Model'!

ICInstantMessageId subclass: #ICAIMId
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-VCard-Model'!

ICInstantMessageId subclass: #ICICQId
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-VCard-Model'!

!ICInstantMessageId class methodsFor: 'accessing-types' stamp: 'pmm 11/14/2005 00:15'!
defaultTypes
	^#()! !

!ICInstantMessageId class methodsFor: 'instance creation' stamp: 'pmm 11/14/2005 00:08'!
fromICalString: aString parameters: aDictionary
	| instance |
	instance := self new.
	instance types: (self parseTypes: aDictionary).
	instance id: (String fromICalString: aString).
	^instance! !

!ICInstantMessageId methodsFor: 'converting' stamp: 'pmm 12/11/2005 14:01'!
asVCardString
	^self id asVCardString! !

!ICInstantMessageId methodsFor: 'accessing' stamp: 'pmm 11/13/2005 23:54'!
id
	^id! !

!ICInstantMessageId methodsFor: 'accessing' stamp: 'pmm 11/13/2005 23:55'!
id: aString 
	id := aString! !

ICInstantMessageId subclass: #ICMSNId
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-VCard-Model'!

ICInstantMessageId subclass: #ICYahooId
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-VCard-Model'!

ICTypedObject subclass: #ICPhoneNumber
	instanceVariableNames: 'number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-VCard-Model'!

!ICPhoneNumber class methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:12'!
defaultTypes
	^Set with: self typeVoice! !

!ICPhoneNumber class methodsFor: 'instance creation' stamp: 'pmm 10/30/2005 09:15'!
fromICalString: aString parameters: aDictionary
	| instance |
	instance := self new.
	instance types: (self parseTypes: aDictionary).
	instance number: (String fromICalString: aString).
	^instance! !

!ICPhoneNumber class methodsFor: 'accessing-types' stamp: 'pmm 3/24/2006 15:06'!
possibleTypes
	^super possibleTypes
		add: self typeBulletinBoard;
		add: self typeCar;
		add: self typeCellular;
		add: self typeFax;
		add: self typeISDN;
		add: self typeModem;
		add: self typePager;
		add: self typePersonalCommunication;
		add: self typeVideo;
		add: self typeVoice;
		add: self typeVoiceMessage;
		yourself! !

!ICPhoneNumber class methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:10'!
typeBulletinBoard
	^'bbs'! !

!ICPhoneNumber class methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:11'!
typeCar
	^'car'! !

!ICPhoneNumber class methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:09'!
typeCellular
	^'cell'! !

!ICPhoneNumber class methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:08'!
typeFax
	^'fax'! !

!ICPhoneNumber class methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:11'!
typeISDN
	^'isdn'! !

!ICPhoneNumber class methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:10'!
typeModem
	^'modem'! !

!ICPhoneNumber class methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:10'!
typePager
	^'pager'! !

!ICPhoneNumber class methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:11'!
typePersonalCommunication
	^'pcs'! !

!ICPhoneNumber class methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:09'!
typeVideo
	^'video'! !

!ICPhoneNumber class methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:08'!
typeVoice
	^'voice'! !

!ICPhoneNumber class methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:08'!
typeVoiceMessage
	^'msg'! !

!ICPhoneNumber methodsFor: 'converting' stamp: 'pmm 12/11/2005 14:02'!
asVCardString
	^self number asVCardString! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 19:23'!
beBulletinBoard
	self bulletinBoard: true! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 19:23'!
beCar
	self car: true! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 19:23'!
beCellular
	self cellular: true! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 19:23'!
beFax
	self fax: true! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 19:23'!
beISDN
	self isdn: true! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 19:23'!
beModem
	self modem: true! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 19:25'!
bePager
	self pager: true! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 19:25'!
bePersonalCommunication
	self personalCommunication: true! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 19:26'!
beVideo
	self video: true! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 19:25'!
beVoice
	self voice: true! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 19:26'!
beVoiceMessage
	self voiceMessage: true! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:16'!
bulletinBoard
	^self types includes: self class typeBulletinBoard! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 16:35'!
bulletinBoard: aBoolean
	^self
		setType: self class typeBulletinBoard
		toValue: aBoolean! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:16'!
car
	^self types includes: self class typeCar! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 16:36'!
car: aBoolean
	^self
		setType: self class typeCar
		toValue: aBoolean! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:17'!
cellular
	^self types includes: self class typeCellular! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 16:36'!
cellular: aBoolean
	^self
		setType: self class typeCellular
		toValue: aBoolean! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:17'!
fax
	^self types includes: self class typeFax! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 16:36'!
fax: aBoolean
	^self
		setType: self class typeFax
		toValue: aBoolean! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:19'!
isBulletinBoard
	^self bulletinBoard! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:19'!
isCar
	^self car! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:20'!
isCellular
	^self cellular! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:17'!
isdn
	^self types includes: self class typeISDN! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 16:36'!
isdn: aBoolean
	^self
		setType: self class typeISDN
		toValue: aBoolean! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 16:55'!
isFax
	^self fax! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:20'!
isISDN
	^self isdn! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:20'!
isModem
	^self modem! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:20'!
isPager
	^self pager! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 19:24'!
isPersonalCommunication
	^self personalCommunication! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 19:24'!
isVideo
	^self video! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:21'!
isVoice
	^self voice! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:19'!
isVoiceMessage
	^self voiceMessage! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:17'!
modem
	^self types includes: self class typeModem! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 16:36'!
modem: aBoolean
	^self
		setType: self class typeModem
		toValue: aBoolean! !

!ICPhoneNumber methodsFor: 'accessing' stamp: 'pmm 10/30/2005 09:01'!
number
	^number! !

!ICPhoneNumber methodsFor: 'accessing' stamp: 'pmm 10/30/2005 09:01'!
number: anObject
	number := anObject! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:17'!
pager
	^self types includes: self class typePager! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 16:36'!
pager: aBoolean
	^self
		setType: self class typePager
		toValue: aBoolean! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:18'!
personalCommunication
	^self types includes: self class typePersonalCommunication! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 16:37'!
personalCommunication: aBoolean
	^self
		setType: self class typePersonalCommunication
		toValue: aBoolean! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:18'!
video
	^self types includes: self class typeVideo! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 16:39'!
video: aBoolean
	^self
		setType: self class typeVideo
		toValue: aBoolean! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:18'!
voice
	^self types includes: self class typeVoice! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:18'!
voiceMessage
	^self types includes: self class typeVoiceMessage! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 16:39'!
voiceMessage: aBoolean
	^self
		setType: self class typeVoiceMessage
		toValue: aBoolean! !

!ICPhoneNumber methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 16:39'!
voice: aBoolean
	^self
		setType: self class typeVoice
		toValue: aBoolean! !

!ICTypedObject class methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:02'!
defaultTypes
	self subclassResponsibility ! !

!ICTypedObject class methodsFor: 'accessing' stamp: 'pmm 10/30/2005 19:27'!
iCalType
	^String iCalType! !

!ICTypedObject class methodsFor: 'private' stamp: 'pmm 10/30/2005 09:13'!
parseTypes: aDictionary
	^((aDictionary includesKey: 'TYPE')
		ifTrue: [ ((aDictionary at: 'TYPE') collect: [ :each | each asLowercase]) asSet ]
		ifFalse: [ self defaultTypes ]).! !

!ICTypedObject class methodsFor: 'accessing-types' stamp: 'pmm 3/24/2006 17:30'!
possibleTypes
	^OrderedCollection
		with: self typeHome
		with: self typePreferred
		with: self typeWork! !

!ICTypedObject class methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:04'!
typeHome
	^'home'! !

!ICTypedObject class methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:05'!
typePreferred
	^'pref'! !

!ICTypedObject class methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:04'!
typeWork
	^'work'! !

!ICTypedObject methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 08:59'!
addType: aString
	^self types add: aString! !

!ICTypedObject methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:05'!
beHome
	self home: true! !

!ICTypedObject methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:06'!
bePreferred
	self preferred: true! !

!ICTypedObject methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:05'!
beWork
	self work: true! !

!ICTypedObject methodsFor: 'exporting' stamp: 'pmm 12/11/2005 10:28'!
exportICalParametersOn: anExpoter
	super exportICalParametersOn: anExpoter.
	self types do: [ :each |
		anExpoter exportParameter: 'TYPE' value: each ]! !

!ICTypedObject methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:05'!
home
	^self types includes: self class typeHome! !

!ICTypedObject methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:05'!
home: aBoolean
	^self
		setType: self class typeHome
		toValue: aBoolean! !

!ICTypedObject methodsFor: 'initialize-release' stamp: 'pmm 10/30/2005 09:02'!
initialize
	super initialize.
	self types: self class defaultTypes! !

!ICTypedObject methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:06'!
isHome
	^self home! !

!ICTypedObject methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:07'!
isPreferred
	^self preferred! !

!ICTypedObject methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:06'!
isWork
	^self work! !

!ICTypedObject methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:06'!
preferred
	^self types includes: self class typePreferred! !

!ICTypedObject methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:06'!
preferred: aBoolean
	^self
		setType: self class typePreferred
		toValue: aBoolean! !

!ICTypedObject methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:05'!
removeType: aString
	^self types remove: aString ifAbsent: [ "ignore silentyl" ]! !

!ICTypedObject methodsFor: 'private' stamp: 'pmm 10/30/2005 09:05'!
setType: aString toValue: aBoolean
	^aBoolean
		ifTrue: [ self addType: aString ]
		ifFalse: [ self removeType: aString ]! !

!ICTypedObject methodsFor: 'accessing' stamp: 'pmm 10/30/2005 08:59'!
types
	^types! !

!ICTypedObject methodsFor: 'accessing' stamp: 'pmm 10/30/2005 08:59'!
types: aCollection 
	types := aCollection! !

!ICTypedObject methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:06'!
work
	^self types includes: self class typeWork! !

!ICTypedObject methodsFor: 'accessing-types' stamp: 'pmm 10/30/2005 09:06'!
work: aBoolean
	^self
		setType: self class typeWork
		toValue: aBoolean! !

Object subclass: #ICTypeInformation
	instanceVariableNames: 'name defaultType multipleValuesPerLine'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Model'!

ICTypeInformation subclass: #ICTimeTypeInformation
	instanceVariableNames: 'needsUtc'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Model'!

!ICTimeTypeInformation class methodsFor: 'instance creation' stamp: 'pmm 10/18/2005 06:49'!
name: aString type: aClass multivalued: aBoolean
	^self
		name: aString
		type: aClass
		multivalued: aBoolean
		utc: false! !

!ICTimeTypeInformation class methodsFor: 'instance creation' stamp: 'pmm 10/18/2005 06:48'!
name: aString type: aClass multivalued: aBoolean utc: anotherBoolean
	^(self new
		name: aString;
		defaultType: aClass;
		multipleValuesPerLine: aBoolean)
		needsUtc: anotherBoolean;
		yourself! !

!ICTimeTypeInformation methodsFor: 'accessing' stamp: 'pmm 11/7/2005 10:00'!
conversionSelector
	^self needsUtc
		ifFalse: [ super conversionSelector ]
		ifTrue: [ #asICalUtcString ]! !

!ICTimeTypeInformation methodsFor: 'accessing' stamp: 'pmm 10/18/2005 06:27'!
needsUtc
	^needsUtc! !

!ICTimeTypeInformation methodsFor: 'accessing' stamp: 'pmm 10/18/2005 06:27'!
needsUtc: anObject
	needsUtc := anObject! !

!ICTypeInformation class methodsFor: 'instance creation' stamp: 'pmm 10/18/2005 06:29'!
name: aString type: aClass multivalued: aBoolean
	^self new
		name: aString;
		defaultType: aClass;
		multipleValuesPerLine: aBoolean;
		yourself! !

!ICTypeInformation methodsFor: 'accessing' stamp: 'pmm 11/7/2005 10:00'!
conversionSelector
	^#asICalString! !

!ICTypeInformation methodsFor: 'converting' stamp: 'pmm 11/7/2005 10:01'!
convert: anObject
	^anObject perform: self conversionSelector! !

!ICTypeInformation methodsFor: 'accessing' stamp: 'pmm 10/8/2005 00:04'!
defaultType
	^defaultType! !

!ICTypeInformation methodsFor: 'accessing' stamp: 'pmm 10/8/2005 00:05'!
defaultType: aClass 
	defaultType := aClass! !

!ICTypeInformation methodsFor: 'accessing' stamp: 'pmm 10/8/2005 00:04'!
multipleValuesPerLine
	^multipleValuesPerLine! !

!ICTypeInformation methodsFor: 'accessing' stamp: 'pmm 10/8/2005 00:05'!
multipleValuesPerLine: aBoolean 
	multipleValuesPerLine := aBoolean! !

!ICTypeInformation methodsFor: 'accessing' stamp: 'pmm 10/8/2005 00:05'!
name
	^name! !

!ICTypeInformation methodsFor: 'accessing' stamp: 'pmm 10/8/2005 00:05'!
name: aString 
	name := aString! !

!ICTypeInformation methodsFor: 'accessing' stamp: 'pmm 10/18/2005 06:27'!
needsUtc
	^false! !

ICTypeInformation subclass: #ICVCardTypeInformation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-VCard-Model'!

!ICVCardTypeInformation methodsFor: 'as yet unclassified' stamp: 'pmm 12/11/2005 13:15'!
conversionSelector
	^#asVCardString! !

Object subclass: #ICUnknownProperty
	instanceVariableNames: 'name value parameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Model'!

!ICUnknownProperty methodsFor: 'initialize-release' stamp: 'pmm 10/13/2005 09:54'!
initialize
	super initialize.
	self parameters: Dictionary new! !

!ICUnknownProperty methodsFor: 'accessing' stamp: 'pmm 10/13/2005 09:53'!
name
	^name! !

!ICUnknownProperty methodsFor: 'accessing' stamp: 'pmm 10/13/2005 09:53'!
name: anObject
	name := anObject! !

!ICUnknownProperty methodsFor: 'accessing' stamp: 'pmm 10/13/2005 09:53'!
parameters
	^parameters! !

!ICUnknownProperty methodsFor: 'accessing' stamp: 'pmm 10/13/2005 09:53'!
parameters: aCollection 
	parameters := aCollection! !

!ICUnknownProperty methodsFor: 'printing' stamp: 'pmm 10/30/2005 21:25'!
printOn: aStream
	super printOn: aStream.
	self name ifNotNil: [
		aStream
			nextPut: $(;
			nextPutAll: self name;
			nextPut: $) ]! !

!ICUnknownProperty methodsFor: 'accessing' stamp: 'pmm 10/13/2005 09:53'!
value
	^value! !

!ICUnknownProperty methodsFor: 'accessing' stamp: 'pmm 10/13/2005 09:53'!
value: anObject
	value := anObject! !

Object subclass: #ICUser
	instanceVariableNames: 'emailAddress commonName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Model'!

!ICUser methodsFor: 'accessing' stamp: 'pmm 10/2/2005 12:21'!
commonName
	^commonName! !

!ICUser methodsFor: 'accessing' stamp: 'pmm 10/2/2005 12:21'!
commonName: aString 
	commonName := aString! !

!ICUser methodsFor: 'accessing' stamp: 'pmm 10/2/2005 12:21'!
emailAddress
	^emailAddress! !

!ICUser methodsFor: 'accessing' stamp: 'pmm 10/2/2005 12:21'!
emailAddress: aString 
	emailAddress := aString! !

Object subclass: #ICVCardConversion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-VCard-IO'!

!ICVCardConversion class methodsFor: 'accessing-types' stamp: 'pmm 12/11/2005 10:22'!
addressType
	^ICVCardTypeInformation
		name: 'ADR' 
		type: ICAddress iCalType 
		multivalued: false! !

!ICVCardConversion class methodsFor: 'accessing-types' stamp: 'pmm 3/24/2006 17:42'!
aimType
	^ICVCardTypeInformation
		name: 'X-AIM' 
		type: ICAIMId iCalType 
		multivalued: false! !

!ICVCardConversion class methodsFor: 'accessing-types' stamp: 'pmm 1/2/2006 12:52'!
birthdayType
	^ICVCardTypeInformation
		name: 'BDAY' 
		type: Date iCalType 
		multivalued: false! !

!ICVCardConversion class methodsFor: 'accessing-types' stamp: 'pmm 12/11/2005 10:24'!
categoriesType
	^ICVCardTypeInformation
		name: 'CATEGORIES' 
		type: String iCalType 
		multivalued: true! !

!ICVCardConversion class methodsFor: 'accessing-types' stamp: 'pmm 12/11/2005 10:25'!
emailType
	^ICVCardTypeInformation
		name: 'EMAIL' 
		type: ICEmailAddress iCalType 
		multivalued: false! !

!ICVCardConversion class methodsFor: 'accessing-types' stamp: 'pmm 12/11/2005 10:34'!
fullnameType
	^ICVCardTypeInformation
		name: 'FN' 
		type: String iCalType 
		multivalued: false! !

!ICVCardConversion class methodsFor: 'accessing-types' stamp: 'pmm 3/24/2006 17:42'!
icqType
	^ICVCardTypeInformation
		name: 'X-ICQ' 
		type: ICICQId iCalType 
		multivalued: false! !

!ICVCardConversion class methodsFor: 'accessing-types' stamp: 'pmm 3/24/2006 17:42'!
msnType
	^ICVCardTypeInformation
		name: 'X-MSN' 
		type: ICMSNId iCalType 
		multivalued: false! !

!ICVCardConversion class methodsFor: 'accessing-types' stamp: 'pmm 12/11/2005 13:47'!
nameType
	^ICVCardTypeInformation
		name: 'N' 
		type: String iCalType 
		multivalued: false! !

!ICVCardConversion class methodsFor: 'accessing-types' stamp: 'pmm 12/11/2005 10:33'!
nicknameType
	^ICVCardTypeInformation
		name: 'NICKNAME' 
		type: String iCalType 
		multivalued: false! !

!ICVCardConversion class methodsFor: 'accessing-types' stamp: 'pmm 12/11/2005 12:12'!
noteType
	^ICVCardTypeInformation
		name: 'NOTE' 
		type: String iCalType 
		multivalued: false! !

!ICVCardConversion class methodsFor: 'accessing-types' stamp: 'pmm 12/11/2005 13:30'!
organizationType
	^ICVCardTypeInformation
		name: 'ORG' 
		type: ICOrganization iCalType 
		multivalued: false! !

!ICVCardConversion class methodsFor: 'accessing-types' stamp: 'pmm 12/11/2005 11:40'!
photoType
	^ICVCardTypeInformation
		name: 'PHOTO' 
		type: Url iCalType 
		multivalued: false! !

!ICVCardConversion class methodsFor: 'accessing-types' stamp: 'pmm 12/11/2005 11:40'!
telephoneType
	^ICVCardTypeInformation
		name: 'TEL' 
		type: ICPhoneNumber iCalType 
		multivalued: false! !

!ICVCardConversion class methodsFor: 'accessing-types' stamp: 'pmm 12/11/2005 11:41'!
titleType
	^ICVCardTypeInformation
		name: 'TITLE' 
		type: String iCalType 
		multivalued: false! !

!ICVCardConversion class methodsFor: 'accessing-types' stamp: 'pmm 12/11/2005 11:41'!
urlType
	^ICVCardTypeInformation
		name: 'URL' 
		type: Url iCalType 
		multivalued: false! !

!ICVCardConversion class methodsFor: 'accessing-types' stamp: 'pmm 12/11/2005 11:42'!
versionType
	^ICVCardTypeInformation
		name: 'VERSION' 
		type: Float iCalType 
		multivalued: false! !

!ICVCardConversion class methodsFor: 'accessing-types' stamp: 'pmm 3/24/2006 17:42'!
yahooType
	^ICVCardTypeInformation
		name: 'X-YAHOO' 
		type: ICYahooId iCalType 
		multivalued: false! !

!Object methodsFor: '*ICal' stamp: 'pmm 12/8/2005 14:35'!
asVCardString
	^self asICalString! !

!Object methodsFor: '*ICal' stamp: 'pmm 11/6/2005 00:52'!
exportICalParametersOn: aExporter! !

!Object methodsFor: '*ICal' stamp: 'pmm 10/29/2005 00:56'!
iCalType
	^self class iCalType! !

!Object methodsFor: '*ICal' stamp: 'pmm 10/7/2005 14:19'!
isDateOrNil
	^false! !

!Date class methodsFor: '*ICal' stamp: 'pmm 10/4/2005 19:18'!
fromICalString: aString
	^self
		year: (aString first: 4) asInteger
	     month: (aString copyFrom: 5 to: 6) asInteger
	     day: (aString copyFrom: 7 to: 8) asInteger.! !

!Date class methodsFor: '*ICal' stamp: 'pmm 12/10/2005 10:56'!
fromVCardString: aString
	^(aString includesSubString: '-')
		ifFalse: [ self fromICalString: aString ]
		ifTrue:  [
			self
				year: (aString first: 4) asInteger
			     month: (aString copyFrom: 6 to: 7) asInteger
			     day: (aString copyFrom: 9 to: 10) asInteger ]! !

!Date class methodsFor: '*ICal' stamp: 'pmm 10/3/2005 17:08'!
iCalType
	^'DATE'! !

!Date methodsFor: '*ICal' stamp: 'pmm 10/2/2005 14:20'!
asICalDateString
	^String streamContents: [ :stream |
		stream
			nextPutAll: (self year printPaddedWith: $0 to:  4);
			nextPutAll: (self monthIndex printPaddedWith: $0 to:  2);
			nextPutAll: (self dayOfMonth printPaddedWith: $0 to:  2) ]
	! !

!Date methodsFor: '*ICal' stamp: 'pmm 10/2/2005 14:15'!
asICalString
	^self asICalDateString
	! !

!Date methodsFor: '*ICal' stamp: 'pmm 10/10/2005 17:11'!
asICalUtcString
	"shouldn't be sent to a date up they are Date and DateAndTime are somewhat 	polymorphic so a Date might end up somewhere where UTC time is needed"
	^self asICalDateString! !

!Date methodsFor: '*ICal' stamp: 'pmm 12/10/2005 11:00'!
asVCardString
	^self yyyymmdd! !

!Date methodsFor: '*ICal' stamp: 'pmm 10/7/2005 14:18'!
isDateOrNil
	^true! !

!Float class methodsFor: '*ICal' stamp: 'pmm 11/9/2005 07:09'!
fromICalString: aString
	| float |
	float := aString asNumber.
	^float asICalString ~= aString
		ifFalse: [ float ]
		ifTrue: [ ScaledDecimal fromICalString: aString ]! !

!Float class methodsFor: '*ICal' stamp: 'pmm 10/3/2005 17:02'!
iCalType
	^'FLOAT'! !

!Float methodsFor: '*ICal' stamp: 'pmm 10/3/2005 17:14'!
asICalString
	^self asString! !

TestCase subclass: #ICAddAppointmentTest
	instanceVariableNames: 'calendar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Tests'!

!ICAddAppointmentTest methodsFor: 'running' stamp: 'pmm 10/7/2005 09:53'!
setUp
	calendar := ICCalendar summary: 'the calendar'! !

!ICAddAppointmentTest methodsFor: 'testing' stamp: 'pmm 10/9/2005 11:53'!
testSave
	| savedEvent event |
	event := (ICEvent new)
				location: 'bern';
				start: (DateAndTime 
							year: 2005
							month: 4
							day: 18
							hour: 21
							minute: 1);
				end: (DateAndTime 
							year: 2005
							month: 4
							day: 18
							hour: 22
							minute: 1);
				addCategory: (ICCategory summary: 'first');
				summary: 'sleep';
				beMediumPriority;
				textualDescription: 'because I''m always tired';
				yourself.
	calendar addEvent: event.
	savedEvent := calendar events first.
	self assert: calendar events size = 1.
	self assert: savedEvent location = 'bern'.
	self assert: savedEvent categories anyOne = (ICCategory summary: 'first').
	self assert: savedEvent summary = 'sleep'.
	self assert: savedEvent isMediumPriority.
	self assert: savedEvent textualDescription = 'because I''m always tired'.! !

TestCase subclass: #ICAddCategoryTest
	instanceVariableNames: 'calendar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Tests'!

!ICAddCategoryTest methodsFor: 'running' stamp: 'pmm 10/6/2005 23:35'!
setUp
	calendar := ICCalendar new
! !

!ICAddCategoryTest methodsFor: 'testing' stamp: 'pmm 10/7/2005 17:06'!
testSave
	| savedCategory category |
	category := ICCategory new
				color: 'green';
				summary: 'greenpeace';
				textualDescription: 'this is a category for all greenpeace events';
				yourself.
	calendar addCategory: category.
	savedCategory := calendar categories anyOne .
	self assert: calendar categories size = 1.
	self assert: savedCategory summary = 'greenpeace'.
	self assert: savedCategory color = 'green'.
	self assert: savedCategory textualDescription  
				= 'this is a category for all greenpeace events'
! !

TestCase subclass: #ICAddToDoTest
	instanceVariableNames: 'calendar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Tests'!

!ICAddToDoTest methodsFor: 'running' stamp: 'pmm 10/7/2005 09:54'!
setUp
	calendar := ICCalendar summary: 'the calendar'! !

!ICAddToDoTest methodsFor: 'testing' stamp: 'pmm 10/7/2005 17:07'!
testSave
	| savedToDo deadLine todo |
	deadLine := DateAndTime now + 1 day.
	todo := (ICTodo new)
				addCategory: (ICCategory summary: 'second');
				summary: 'writing a letter';
				beLowPriority;
				textualDescription: 'this should be a real letter not an email';
				due: deadLine;
				yourself.
	calendar addTodo: todo.
	savedToDo := calendar todos first.
	self assert: calendar todos size = 1.
	self assert: savedToDo categories anyOne = (ICCategory summary: 'second').
	self assert: savedToDo summary = 'writing a letter'.
	self assert: savedToDo isLowPriority.
	self assert: savedToDo textualDescription 
				= 'this should be a real letter not an email'.
	self assert: savedToDo due = deadLine! !

TestCase subclass: #ICAppointmentTest
	instanceVariableNames: 'appointment serie calendar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Tests'!

!ICAppointmentTest methodsFor: 'running' stamp: 'pmm 10/9/2005 11:53'!
setUp
	calendar := ICCalendar summary: 'test'.
	appointment := ICEvent summary: 'aTitle'.
	appointment location: 'Bern'.
	appointment textualDescription: 'description'.
	appointment addCategory: (ICCategory summary: 'first').
	appointment start: (DateAndTime 
				year: 2005
				month: 4
				day: 18
				hour: 21
				minute: 1).
	appointment end: (DateAndTime 
				year: 2005
				month: 4
				day: 18
				hour: 23
				minute: 59).
! !

!ICAppointmentTest methodsFor: 'testing' stamp: 'pmm 10/9/2005 11:55'!
testBasicInformation
	self assert: appointment summary = 'aTitle'.
	appointment categories do: [ :each |
		self assert:  each class == ICCategory ].
	self assert: appointment location = 'Bern'.
	self assert: appointment textualDescription = 'description'.
	self assert: appointment start class = DateAndTime.
	self 
		assert: appointment start > (Date 
						year: 2005
						month: 4
						day: 18).
	self assert: appointment end class = DateAndTime.
	self 
		assert: appointment end > (Date 
						year: 2005
						month: 4
						day: 18)! !

TestCase subclass: #ICCalendarTest
	instanceVariableNames: 'calendar category1 event1 event2 todo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Tests'!

!ICCalendarTest methodsFor: 'testing-categories' stamp: 'pmm 10/7/2005 17:24'!
addCategory
	| cat1 cat2 categoryNumber |
	cat1 := ICCategory summary: 'cat1'.
	cat1
		color: 'blue';
		textualDescription: 'for ???'.
	cat2 := ICCategory summary: 'cat2'.
	cat2
		color: 'green';
		textualDescription: 'for ???'.
	categoryNumber := calendar categories size.
	calendar addCategory: cat1.
	self assert: calendar categories size = (categoryNumber + 1).
	calendar addCategory: cat2.
	self assert: calendar categories size = (categoryNumber + 2)
! !

!ICCalendarTest methodsFor: 'testing-categories' stamp: 'vf 6/15/2005 10:15'!
removeCategory
   | categoryNumber |
   categoryNumber := calendar categories size.
   self assert: (calendar categories includes: category1).
   calendar removeCategory: category1.
   self assert: (calendar categories size = (categoryNumber -1)).
   self deny: (calendar categories includes: category1).
   
! !

!ICCalendarTest methodsFor: 'running' stamp: 'pmm 10/9/2005 11:53'!
setUp
	| category2 |
	calendar := ICCalendar summary: 'Veriveris Calendar'.
	event1 := ICEvent summary: 'first date'.
	event1 location: 'swimmingpool'.
	event1 uid: 'app1'.
	event1 addCategory: (ICCategory summary: 'second').
	event1 start: (DateAndTime 
				year: 2005
				month: 5
				day: 20
				hour: 19
				minute: 1).
	event1 end: (DateAndTime 
				year: 2005
				month: 5
				day: 20
				hour: 23
				minute: 1).
	event2 := ICEvent summary: 'diner with...'.
	event2 location: 'Bellvue Bern'.
	event2 uid: 'app2'.
	event2 textualDescription: 'it is with ...'.
	event2 addCategory: (ICCategory summary: 'second').
	event2 start: (DateAndTime 
				year: 2005
				month: 5
				day: 24
				hour: 20
				minute: 1).
	event2 end: (DateAndTime 
				year: 2005
				month: 5
				day: 24
				hour: 22
				minute: 1).
	todo := ICTodo summary: 'repairing my bike'.
	todo uid: 'todo1'.
	todo
		beLowPriority;
		addCategory: (ICCategory summary: 'second');
		due: (DateAndTime 
					year: 2005
					month: 7
					day: 30
					hour: 22
					minute: 0);
		textualDescription: 'bla bla'.
	category1 := ICCategory summary: 'personal'.
	category2 := ICCategory summary: 'music school'.
	calendar
		addEvent: event1;
		addTodo: todo.
	calendar addCategory: category2! !

!ICCalendarTest methodsFor: 'testing-events' stamp: 'pmm 10/7/2005 19:18'!
testAddEvent
	"self debug: #testAddEvent"
	| newEvent newTodo todoNumber totalEvents totalComponents |
	newEvent := ICEvent summary: 'lunch'.
	newEvent
		beMediumPriority;
		start: (DateAndTime 
					year: 2005
					month: 10
					day: 22
					hour: 18
					minute: 30);
		end: (DateAndTime 
					year: 2005
					month: 10
					day: 22
					hour: 22
					minute: 1);
		addCategory: (ICCategory summary: 'first').
	"place: 'universitiy mensa';"
	newTodo := ICTodo summary: 'writing letters'.
	newTodo
		beLowPriority;
		addCategory: (ICCategory summary: 'second');
		due: (DateAndTime 
					year: 2005
					month: 6
					day: 30
					hour: 22
					minute: 0);
		textualDescription: 'bla bla'.
	todoNumber := calendar todos size.
	totalEvents := calendar events size.
	totalComponents := calendar components size.
	calendar
		addEvent: newEvent;
		addTodo: newTodo.
	self assert: calendar todos size = (todoNumber + 1).
	self assert: calendar events size = (totalEvents + 1).
	self assert: calendar components size = (totalComponents + 2)! !

!ICCalendarTest methodsFor: 'testing' stamp: 'pmm 10/7/2005 16:46'!
testAppointments
	"test add and remove methods for appointments"

	| size |
	size := 1.
	self assert: calendar events size = size.
	calendar addEvent: event2.
	self assert: calendar events size = (size + 1).
	calendar removeEvent: event1.
	self assert: calendar events size = size.
	calendar removeEvent: event2.
	self assert: calendar events isEmpty.
	calendar addEvent: event1.
	self assert: calendar events first == event1! !

!ICCalendarTest methodsFor: 'testing' stamp: 'pmm 10/7/2005 19:07'!
testCategories
	"test here methods to add and remove categories"

	| size collection c1 c2 c3 |
	size := 1.
	calendar addCategory: category1.
	self assert: calendar categories size = (size + 1).
	self assert: (calendar categoryWithSummary: 'personal') == category1.
	calendar removeCategory: category1.
	self assert: calendar categories size = size.
	c1 := ICCategory summary: 'school'.
	c2 := ICCategory summary: 'home'.
	c3 := ICCategory summary: 'friends'.
	collection := OrderedCollection 
				with: c1
				with: c2
				with: c3.
	calendar categories: collection.
	self assert: calendar categories size = 3.
	self assert: (calendar categories at: 2) == c2.
	self assert: calendar categories == collection.
	self assert: (calendar categoryWithSummary: 'friends') == c3
! !

!ICCalendarTest methodsFor: 'testing-categories' stamp: 'pmm 10/7/2005 09:56'!
testCategoryWithTitle
	| cat1 cat2 cat3 |
	cat1 := ICCategory summary: 'cat1'.
	cat2 := ICCategory summary: 'cat2'.
	cat3 := ICCategory summary: 'cat3'.
	calendar
		addCategory: cat1;
		addCategory: cat2;
		addCategory: cat3.
	self assert: (calendar categoryWithSummary: 'cat1') == cat1.
	self assert: (calendar categoryWithSummary: 'cat2') == cat2.
	self assert: (calendar categoryWithSummary: 'cat3') == cat3.
	calendar removeCategory: cat1.
	self should: [ calendar categoryWithSummary: 'cat1' ] raise: Error! !

!ICCalendarTest methodsFor: 'testing-events' stamp: 'pmm 10/7/2005 13:51'!
testEventsForDate
	| app1 app2 app3 |
	app1 := ICEvent summary: 'event1'.
	app1 start: (DateAndTime 
				year: 2006
				month: 4
				day: 22
				hour: 22
				minute: 12).
	app1 end: (DateAndTime 
				year: 2006
				month: 4
				day: 22
				hour: 23
				minute: 12).
	app2 := ICEvent summary: 'event1'.
	app2 start: (DateAndTime 
				year: 2006
				month: 4
				day: 22
				hour: 22
				minute: 45).
	app2 end: (DateAndTime 
				year: 2006
				month: 4
				day: 22
				hour: 23
				minute: 30).
	app3 := ICEvent summary: 'event1'.
	app3 start: (DateAndTime 
				year: 2006
				month: 4
				day: 22
				hour: 22
				minute: 55).
	app3 end: (DateAndTime 
				year: 2006
				month: 4
				day: 22
				hour: 23
				minute: 55).
	calendar
		addEvent: app1;
		addEvent: app2;
		addEvent: app3.
	self 
		assert: (calendar 
				eventsForDate: (DateAndTime 
						year: 2006
						month: 4
						day: 22
						hour: 22
						minute: 0) asDate) 
					size = 3.
	calendar removeEvent: app1.
	self 
		assert: (calendar 
				eventsForDate: (DateAndTime 
						year: 2006
						month: 4
						day: 22
						hour: 22
						minute: 0) asDate) 
					size = 2.
	calendar removeEvent: app2.
	self 
		assert: (calendar 
				eventsForDate: (DateAndTime 
						year: 2006
						month: 4
						day: 22
						hour: 22
						minute: 0) asDate) 
					size = 1! !

!ICCalendarTest methodsFor: 'testing-events' stamp: 'pmm 10/7/2005 19:27'!
testEventsForTimeStamp	
	"self debug: #testEventsForTimeStamp"
	self 
		assert: (calendar 
				eventsForDateAndTime: (DateAndTime 
						year: 2005
						month: 5
						day: 20
						hour: 19
						minute: 0)) 
					size = 1.
	calendar removeEvent: event1.
	self 
		assert: (calendar 
				eventsForDateAndTime: (DateAndTime 
						year: 2005
						month: 5
						day: 20
						hour: 19
						minute: 0)) 
					isEmpty.
	self 
		assert: (calendar 
				todosForDateAndTime: (DateAndTime 
						year: 2005
						month: 7
						day: 30
						hour: 22
						minute: 0)) 
					size = 1.
	calendar removeTodo: todo.
	self 
		assert: (calendar 
				todosForDateAndTime: (DateAndTime 
						year: 2005
						month: 7
						day: 30
						hour: 22
						minute: 0)) 
					isEmpty! !

!ICCalendarTest methodsFor: 'testing-events' stamp: 'pmm 10/7/2005 19:21'!
testIncludesEventWithUid
	"self debug: #testIncludesEventWithUid"
	self assert: (calendar includesEventWithUid: 'app1').
	self deny: (calendar includesTodoWithUid: 'app1').
	self assert: (calendar includesTodoWithUid: 'todo1').
	self deny: (calendar includesEventWithUid: 'todo1').
	self deny: (calendar includesEventWithUid: 'app2').
	calendar addEvent: event2.
	self assert: (calendar includesEventWithUid: 'app2').
	calendar removeTodo: todo.
	self deny: (calendar includesTodoWithUid: 'todo1')! !

!ICCalendarTest methodsFor: 'testing-events' stamp: 'pmm 10/7/2005 18:59'!
testRemoveEvent
	| eventNumber todoNumber totalNumber |
	eventNumber := calendar events size.
	todoNumber := calendar todos size.
	totalNumber := calendar components size.
	calendar removeTodo: todo.
	self assert: calendar todos size = (todoNumber - 1).
	self assert: calendar components size = (totalNumber - 1).
	self assert: calendar events size = eventNumber.
	calendar removeEvent: event1.
	self assert: calendar todos size = (todoNumber - 1).
	self assert: calendar events size = (eventNumber - 1).
	self assert: calendar components size = (totalNumber - 2)! !

!ICCalendarTest methodsFor: 'testing-events' stamp: 'pmm 10/7/2005 19:00'!
testRemoveEventWithUid
   self assert: (calendar includesEventWithUid: 'app1').
   calendar removeEventWithUid: 'app1'.
   self should: [ calendar eventWithUid: 'app1' ] raise: Error.
   calendar removeEventWithUid: 'todo1'.
  self should: [ calendar eventWithUid: 'todo1' ] raise: Error.! !

!ICCalendarTest methodsFor: 'testing' stamp: 'pmm 10/7/2005 00:24'!
testUser
	| user |
	user := ICUser new.
	self assert: calendar users isEmpty.
	calendar addUser: user.
	self deny: calendar users isEmpty.
	self assert: calendar users anyOne == user! !

TestCase subclass: #ICCategoryTest
	instanceVariableNames: 'calendar category1 category2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Tests'!

!ICCategoryTest methodsFor: 'running' stamp: 'pmm 10/7/2005 17:24'!
setUp
	| categories |
	calendar := ICCalendar summary: ' Test Calendar '.
	categories := OrderedCollection new.
	category1 := ICCategory summary: 'tennis club'.
	category1 textualDescription: 'this category is for tennis club events'.
	category1 color: 'red'.
	category2 := ICCategory summary: 'family'.
	category2 textualDescription: 'for family events'.
	category2 color: 'green'.
	categories := OrderedCollection with: category1 with: category2.
	calendar categories: categories! !

!ICCategoryTest methodsFor: 'testing' stamp: 'pmm 10/7/2005 00:00'!
testColor
  
   self assert: (calendar categoryWithSummary: 'family') hasColor.
   self assert: (calendar categoryWithSummary: 'tennis club') color = 'red'.
   
   category1 color: 'purple'.
   category2 color: 'yellow'.

   self assert: (calendar categoryWithSummary: 'family') hasColor.
   self deny: (calendar categoryWithSummary: 'tennis club') color = 'red'.! !

!ICCategoryTest methodsFor: 'testing' stamp: 'pmm 10/6/2005 23:45'!
testEqual
	self deny: category1 = category2.
	self assert: category1 = (ICCategory summary: 'tennis club').
	self assert: category2 = (ICCategory summary: 'family')! !

!ICCategoryTest methodsFor: 'testing' stamp: 'pmm 10/7/2005 00:01'!
testExplanation

    self assert: (calendar categoryWithSummary: 'family') textualDescription = 'for family events'.
    self assert: (calendar categoryWithSummary: 'tennis club') textualDescription = 'this category is for tennis club events'.
    self deny: category1 textualDescription = ''.! !

TestCase subclass: #ICConversionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Tests'!

!ICConversionTest methodsFor: 'testing' stamp: 'pmm 10/14/2005 12:04'!
testBoolean
	self assert: 'TRUE'  = true asICalString.
	self assert: 'FALSE'  = false asICalString.! !

!ICConversionTest methodsFor: 'testing' stamp: 'pmm 10/2/2005 22:22'!
testDate
	| date |
	date := Date newDay: 1 month: 1 year: 1901.
	self assert: '19010101'  = date asICalString.
	
	date := Date newDay: 1 month: 2 year: 1901.
	self assert: '19010201'  = date asICalString.
	
	date := Date newDay: 22 month: 11 year: 1901.
	self assert: '19011122'  = date asICalString.
	
	date := Date newDay: 14 month: 7 year: 1997.
	self assert: '19970714'  = date asICalString.! !

!ICConversionTest methodsFor: 'testing' stamp: 'pmm 10/2/2005 22:22'!
testDateAndTime
	| dateAndTime |
	dateAndTime := DateAndTime year: 1950 month: 11 day: 22 hour: 22 minute: 33 second: 44.
	self assert: '19501122T223344'  = dateAndTime asICalString.
	
	dateAndTime := DateAndTime year: 1950 month: 1 day: 2 hour: 3 minute: 4 second: 5.
	self assert: '19500102T030405'  = dateAndTime asICalString.
	
	dateAndTime := DateAndTime year: 1998 month: 1 day: 19 hour: 7 minute: 0 second: 0.
	self assert: '19980119T070000'  = dateAndTime asICalString.
	
	dateAndTime := DateAndTime year: 1998 month: 1 day: 18 hour: 23 minute: 0 second: 0.
	self assert: '19980118T230000'  = dateAndTime asICalString.! !

!ICConversionTest methodsFor: 'testing' stamp: 'pmm 10/10/2005 17:12'!
testDateAndTimeUtc
	| dateAndTime |
	dateAndTime := DateAndTime year: 1950 month: 11 day: 22 hour: 22 minute: 33 second: 44.
	self assert: '19501122T223344Z'  = dateAndTime asICalUtcString.
	
	dateAndTime := DateAndTime year: 1950 month: 1 day: 2 hour: 3 minute: 4 second: 5.
	self assert: '19500102T030405Z'  = dateAndTime asICalUtcString.
	
	dateAndTime := DateAndTime year: 1998 month: 1 day: 19 hour: 7 minute: 0 second: 0.
	self assert: '19980119T070000Z'  = dateAndTime asICalUtcString.
	
	dateAndTime := DateAndTime year: 1998 month: 1 day: 18 hour: 23 minute: 0 second: 0.
	self assert: '19980118T230000Z'  = dateAndTime asICalUtcString.! !

!ICConversionTest methodsFor: 'testing' stamp: 'pmm 10/10/2005 17:12'!
testDateUtc
	| date |
	date := Date newDay: 1 month: 1 year: 1901.
	self assert: '19010101'  = date asICalUtcString.
	
	date := Date newDay: 1 month: 2 year: 1901.
	self assert: '19010201'  = date asICalUtcString.
	
	date := Date newDay: 22 month: 11 year: 1901.
	self assert: '19011122'  = date asICalUtcString.
	
	date := Date newDay: 14 month: 7 year: 1997.
	self assert: '19970714'  = date asICalUtcString.! !

!ICConversionTest methodsFor: 'testing' stamp: 'pmm 10/2/2005 22:12'!
testDuration
	| duration |
	duration := Duration days: 15 hours: 5 minutes: 0 seconds: 20.
	self assert: 'P15DT5H0M20S'  = duration asICalString.
	
	duration := Duration weeks: 7.
	self assert: 'P7W'  = duration asICalString.! !

!ICConversionTest methodsFor: 'testing' stamp: 'pmm 10/4/2005 21:42'!
testFloatPrecision
	"it's ok when this test fails, floats are just not precise enough"
	| string float |
	string := '1000000.0000001'.
	float := Float fromICalString: string.
	self assert: string  = float asICalString.
	self assert: float = 1000000.0000001.! !

!ICConversionTest methodsFor: 'testing' stamp: 'pmm 10/14/2005 12:08'!
testParseBoolean
	| string boolean |
	string := 'TRUE'.
	boolean := Boolean fromICalString: string.	
	self assert: string = boolean asICalString.
	self assert: boolean.
	
	string := 'FALSE'.
	boolean := Boolean fromICalString: string.	
	self assert: string = boolean asICalString.
	self deny: boolean.! !

!ICConversionTest methodsFor: 'testing' stamp: 'pmm 10/4/2005 18:27'!
testParseDate
	| string date |
	string := '19970714'.
	date := Date fromICalString: string.
	
	self assert: string = date asICalString.
	self assert: date = (Date year: 1997 month: 7 day: 14)! !

!ICConversionTest methodsFor: 'testing' stamp: 'pmm 10/4/2005 20:14'!
testParseDateAndTime
	| string dateAndTime |
	string := '19980118T230000'.
	dateAndTime := DateAndTime fromICalString: string.
	
	self assert: string = dateAndTime asICalString.
	self assert: dateAndTime = (DateAndTime year: 1998 month: 1 day: 18 hour: 23 minute: 0 second: 0)! !

!ICConversionTest methodsFor: 'testing' stamp: 'pmm 10/10/2005 17:13'!
testParseDateAndTimeUtc
	| string dateAndTime |
	string := '19980118T230000Z'.
	dateAndTime := DateAndTime fromICalString: string.
	
	self assert: string = dateAndTime asICalUtcString.
	self assert: dateAndTime = (DateAndTime year: 1998 month: 1 day: 18 hour: 23 minute: 0 second: 0)! !

!ICConversionTest methodsFor: 'testing' stamp: 'pmm 11/11/2005 09:39'!
testParseDuration
	| duration string |
	string := 'P15DT5H0M20S'.
	duration := Duration fromICalString: string.
	self assert: string  = duration asICalString.
	self assert: duration = (Duration days: 15 hours: 5 minutes: 0 seconds: 20).
	
	string := '-P15DT5H0M20S'.
	duration := Duration fromICalString: string.
	self assert: string  = duration asICalString.
	self assert: duration = (Duration days: 15 hours: 5 minutes: 0 seconds: 20) negated.
	
	string := 'P7W'.
	duration := Duration fromICalString: string.
	self assert: string  = duration asICalString.
	self assert: duration = (Duration weeks: 7).
	
	string := '-P7W'.
	duration := Duration fromICalString: string.
	self assert: string  = duration asICalString.
	self assert: duration = (Duration weeks: 7 negated).
	self assert: duration = (Duration weeks: 7) negated.
	
	string := 'PT5M'.
	duration := Duration fromICalString: string.
	self assert: 'PT0H5M0S'  = duration asICalString.
	self assert: duration = 5 minutes.
	
	string := '-PT5M'.
	duration := Duration fromICalString: string.
	self assert: '-PT0H5M0S'  = duration asICalString.
	self assert: duration = 5 minutes negated.
	self assert: duration = 5 negated minutes.
	
	self assert: (Duration fromICalString: 'PT0H5M0S') = (Duration fromICalString: 'PT5M').! !

!ICConversionTest methodsFor: 'testing' stamp: 'pmm 10/4/2005 21:42'!
testParseFloat
	| float string |
	string := '-3.14'.
	float := Float fromICalString: string.
	self assert: string  = float asICalString.
	self assert: float = -3.14.
	
	string := '1.333'.
	float := Float fromICalString: string.
	self assert: string  = float asICalString.
	self assert: float = 1.333.! !

!ICConversionTest methodsFor: 'testing' stamp: 'pmm 10/4/2005 21:36'!
testParseInteger
	| integer string |
	string := '-1'.
	integer := Integer fromICalString: string.
	self assert: string  = integer asICalString.
	self assert: integer = -1.
	
	string := '1337'.
	integer := Integer fromICalString: string.
	self assert: string  = integer asICalString.
	self assert: integer = 1337.! !

!ICConversionTest methodsFor: 'testing' stamp: 'pmm 10/13/2005 00:11'!
testParseParameterString
	| string |
	string := 'TESTME'.
	self assert: 'TESTME' = string asICalParameterString.
	
	string := 'TEST;ME'.
	self assert: '"TEST;ME"' = string asICalParameterString.! !

!ICConversionTest methodsFor: 'testing' stamp: 'pmm 11/9/2005 07:17'!
testParseScaledDecimal
	| decimal string |
	string := '-3.14'.
	decimal := ScaledDecimal fromICalString: string.
	self assert: string  = decimal asICalString.
	self assert: decimal = -3.14.
	
	string := '1.333'.
	decimal := ScaledDecimal fromICalString: string.
	self assert: string  = decimal asICalString.
	self assert: decimal = 1.333.! !

!ICConversionTest methodsFor: 'testing' stamp: 'pmm 10/9/2005 10:26'!
testParseString
	| string value |
	string := 'test me!!'.
	value := String fromICalString: string.
	self assert: string = value asICalString.
	
	string := '":\\\,\;\n'.
	value := String fromICalString: string.
	self assert: value = '":\,;
'.
	self assert: string = value asICalString! !

!ICConversionTest methodsFor: 'testing' stamp: 'pmm 12/3/2005 12:50'!
testParseString2
	| string value |
	ICCalendarVersion
		use: 1.0
		during: [
			string := 'Bar Street 99=0AFootown 12345=0AFooland'.
			value := String fromICalString: string.
			self assert: value =
'Bar Street 99
Footown 12345
Fooland'.
			self assert: value asICalString = 'Bar Street 99=0D=0AFootown 12345=0D=0AFooland' ]! !

!ICConversionTest methodsFor: 'testing' stamp: 'pmm 12/3/2005 12:51'!
testParseString3
	| string value |
	ICCalendarVersion
		use: 1.0
		during: [
			string := '123 Winding Way=0D=0A=' , String crlf ,
' Any Town, CA 12345=0D=0A=' , String crlf ,
' USA'.
			value := String fromICalString: (ICCalendarHandParser new unfold: string).
			self assert: value =
'123 Winding Way
Any Town, CA 12345
USA'.
			self assert: value asICalString =  '123 Winding Way=0D=0AAny Town\\, CA 12345=0D=0AUSA' ]! !

!ICConversionTest methodsFor: 'testing' stamp: 'pmm 10/4/2005 19:58'!
testParseTime
	| string time |
	string := '123456'.
	time := Time fromICalString: string.
	
	self assert: string = time asICalString.
	self assert: time = (Time hour: 12 minute: 34 second: 56)! !

!ICConversionTest methodsFor: 'testing' stamp: 'pmm 10/10/2005 17:13'!
testParseTimeUtc
	| string time |
	string := '123456Z'.
	time := Time fromICalString: string.
	
	self assert: string = time asICalUtcString.
	self assert: time = (Time hour: 12 minute: 34 second: 56)! !

!ICConversionTest methodsFor: 'testing' stamp: 'pmm 10/6/2005 18:13'!
testParseUrl
	| url string |
	string := 'mailto:mouse@squeakfoundation.org'.
	url := Url fromICalString: string.
	self assert: string  = url asICalString.
		
	string := 'http://host1.com/my-report.txt'.
	url := Url fromICalString: string.
	self assert: string  = url asICalString.
	! !

!ICConversionTest methodsFor: 'testing' stamp: 'pmm 10/29/2005 00:59'!
testSelector
	ICConversion supportedClasses do: 
			[:each | 
			self assert: (each selectors includes: #asICalString).
			self assert: (each class selectors includes: #iCalType).
			self assert: (each class selectors includes: #fromICalString:)].
	ICConversion supportedComponents 
		do: [:each | self assert: (each class selectors includes: #iCalType)]! !

!ICConversionTest methodsFor: 'testing' stamp: 'pmm 10/30/2005 08:25'!
testSplitComma
	| parts |
	parts := 'a,b,c' splitAtCommas.
	self assert: parts = #('a' 'b' 'c') asOrderedCollection.
	
	parts := 'a\,b,c' splitAtCommas.
	self assert: parts = #('a\,b' 'c') asOrderedCollection.
	
	parts := 'a\,b\,c' splitAtCommas.
	self assert: parts = #('a\,b\,c') asOrderedCollection.
	
	"parts := splitter splitAtCommas: ',,'.
	self assert: parts = #('' '' '') asOrderedCollection.
	
	parts := splitter splitAtCommas: ',\,'.
	self assert: parts = #('' '\,') asOrderedCollection."! !

!ICConversionTest methodsFor: 'testing' stamp: 'pmm 10/2/2005 14:29'!
testTime
	| time |
	time := Time hour: 22 minute: 33 second: 44.
	self assert: '223344'  = time asICalString.
	
	time := Time hour: 0 minute: 0 second: 0.
	self assert: '000000'  = time asICalString.
	
	time := Time hour: 1 minute: 2 second: 3.
	self assert: '010203'  = time asICalString.! !

!ICConversionTest methodsFor: 'testing' stamp: 'pmm 10/10/2005 17:13'!
testTimeUtc
	| time |
	time := Time hour: 22 minute: 33 second: 44.
	self assert: '223344Z'  = time asICalUtcString.
	
	time := Time hour: 0 minute: 0 second: 0.
	self assert: '000000Z'  = time asICalUtcString.
	
	time := Time hour: 1 minute: 2 second: 3.
	self assert: '010203Z'  = time asICalUtcString.! !

!ICConversionTest methodsFor: 'testing' stamp: 'pmm 11/11/2005 09:34'!
testTrigger
	| trigger |
	trigger := ICTrigger fromICalString: 'PT5M ' parameters: (Dictionary with: 'RELATED' -> 'END').
	
	self assert: trigger isRelatedToEnd.
	self assert: trigger value = 5 minutes.
	self assert: trigger asICalString = 'PT0H5M0S'.
	
	self assert: ICTrigger new isRelatedToStart.
	
	trigger := ICTrigger
		fromICalString: '19501122T223344 '
		parameters: (Dictionary with: 'RELATED' -> 'END' with: 'VALUE' -> DateAndTime iCalType).
	self assert: trigger value = (DateAndTime year: 1950 month: 11 day: 22 hour: 22 minute: 33 second: 44).! !

!ICConversionTest methodsFor: 'testing' stamp: 'pmm 10/2/2005 20:19'!
testWeeks
	| duration |
	0 to: 10 do: [ :week |
		0 to: 6 do: [ :day |
			duration := Duration days: week * 7 + day.
			self assert: duration weeks = week ] ]! !

TestCase subclass: #ICCreateCalendarTest
	instanceVariableNames: 'calendars user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Tests'!

!ICCreateCalendarTest methodsFor: 'private' stamp: 'pmm 10/7/2005 09:58'!
addCalendarWithSummary: aString 
	calendars add: ((ICCalendar new)
				summary: aString;
				yourself)! !

!ICCreateCalendarTest methodsFor: 'private' stamp: 'pmm 10/7/2005 17:28'!
calendarTestWithSummary: aString 
	| newCalendar |
	newCalendar := calendars detect: [:each | each summary = aString]
				ifNone: [nil].
	self deny: newCalendar isNil.
	self assert: newCalendar class = ICCalendar.
	self assert: newCalendar categories isEmpty! !

!ICCreateCalendarTest methodsFor: 'running' stamp: 'pmm 10/7/2005 10:00'!
setUp
	| calendar |
	user := ICUser new.
	calendar := ICCalendar summary: 'veriveri''s Calendar'.
	calendar addUser: user.
	calendars := OrderedCollection with: calendar! !

!ICCreateCalendarTest methodsFor: 'testing' stamp: 'pmm 10/7/2005 09:59'!
testCalendar
	self calendarTestWithSummary: 'veriveri''s Calendar'.! !

!ICCreateCalendarTest methodsFor: 'testing' stamp: 'pmm 10/7/2005 17:29'!
testCategoryList
	| calendar |
		
	calendar := calendars detect: [ :each | each summary = 'veriveri''s Calendar' ] ifNone: [nil].
	self deny: calendar isNil.
	self deny: calendar categories isNil.
	self assert: calendar categories isEmpty.	
	
! !

!ICCreateCalendarTest methodsFor: 'testing' stamp: 'pmm 10/7/2005 09:58'!
testCreatingSeveralCalendars
	self addCalendarWithSummary: 'new Calendar 1'.
	self addCalendarWithSummary: 'new Calendar 2'.
	self addCalendarWithSummary: 'new Calendar 3'.
	
	self addCalendarWithSummary: 'new Calendar 1'.
     self addCalendarWithSummary: 'new Calendar 2'.
     self addCalendarWithSummary: 'new Calendar 3'.! !

!ICCreateCalendarTest methodsFor: 'testing' stamp: 'dr 6/19/2005 11:41'!
testRemove
	"| context calendar removeCommand root |
	self addCalendarWithTitle: 'testCalendar'.
	self calendarTestWithTitle: 'testCalendar'.
	calendar := calendars last.
	
	context := SW2Context kernel: SW2Kernel new structure: calendar.  
  	removeCommand := SWCRemoveCalendar context: context.
  	removeCommand execute.	
		
	root := SW2Kernel instances first root.	
	self assert: (root children children at: 'testCalendar' ifAbsent: [nil]) isNil."
	 
			
	! !

!ICCreateCalendarTest methodsFor: 'testing' stamp: 'pmm 10/7/2005 10:10'!
testToDoList
	| calendar |
		
	calendar := calendars detect: [ :each | each summary = 'veriveri''s Calendar' ] ifNone: [nil].
	self deny: calendar isNil.
	self deny: calendar todos size = 2.
	self deny: calendar todos isNil.
! !

!ICCreateCalendarTest methodsFor: 'testing' stamp: 'pmm 10/7/2005 17:29'!
testUser
	| newCalendar |
	newCalendar := calendars 
				detect: [:each | each summary = 'veriveri''s Calendar']
				ifNone: [nil].
	self deny: newCalendar isNil.
	self assert: newCalendar class = ICCalendar.
	self deny: newCalendar users isEmptyOrNil.
	self assert: newCalendar users anyOne = user! !

TestCase subclass: #ICEventTest
	instanceVariableNames: 'appointment1 appointment2 todo eventSerie calendar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Tests'!

!ICEventTest methodsFor: 'running' stamp: 'pmm 10/9/2005 11:53'!
setUp
	| category |
	calendar := ICCalendar new.
	appointment1 := ICEvent summary: 'diner'.
	category := ICCategory summary: 'friends'.
	appointment1 addCategory: category.
	appointment1 uid: 'app1'.
	appointment1
		start: (DateAndTime 
					year: 2005
					month: 5
					day: 18
					hour: 17
					minute: 0);
		end: (DateAndTime 
					year: 2005
					month: 5
					day: 18
					hour: 20
					minute: 0).
	appointment1 beLowPriority.
	appointment1 location: 'in nature'.
	appointment2 := ICEvent summary: 'running'.
	appointment2 uid: 'app2'.
	appointment2
		start: (DateAndTime 
					year: 2005
					month: 6
					day: 12
					hour: 8
					minute: 30);
		end: (DateAndTime 
					year: 2005
					month: 6
					day: 12
					hour: 9
					minute: 40).
	todo := ICTodo summary: 'clean the living-room'.
	todo uid: 'todo1'.
	todo due: (DateAndTime now + 4 days).
	calendar addEvent: appointment1.
	calendar addEvent: appointment2.
	calendar addEvent: todo! !

!ICEventTest methodsFor: 'testing' stamp: 'pmm 11/12/2005 12:34'!
testHours
  self assert: (appointment1 hours asInteger = 3).
  self assert: (appointment2 hours = (1 +(1/6)) asFloat).
   ! !

!ICEventTest methodsFor: 'testing' stamp: 'pmm 10/7/2005 19:31'!
testIDs
	| aTodo |
	self assert: appointment1 uid = 'app1'.
	self assert: appointment2 uid = 'app2'.
	self assert: todo uid = 'todo1'.
	calendar addEvent: (
		ICTodo new
			summary: 'cleaning';
			uid: 'todo2';
			yourself).
	aTodo := ICTodo summary: 'shopping'.
	aTodo uid: 'todo3'.
	calendar addEvent: aTodo.
	self assert: aTodo uid = 'todo3'.
	self assert: (calendar eventWithUid: 'app1') == appointment1.
	self assert: (calendar eventWithUid: 'todo2') summary = 'cleaning'! !

!ICEventTest methodsFor: 'testing' stamp: 'pmm 11/1/2005 22:38'!
testInitialize
	| anAppointment |
	anAppointment := ICEvent summary: 'physical test'.
	self assert: anAppointment summary = 'physical test'.
	self assert: anAppointment textualDescription isNil.
	self assert: anAppointment lastModified isNil.
	self assert: anAppointment isMediumPriority! !

!ICEventTest methodsFor: 'testing' stamp: 'dr 6/14/2005 13:45'!
testIsBefore
	self assert: appointment1 <= appointment2! !

!ICEventTest methodsFor: 'testing' stamp: 'pmm 10/7/2005 13:18'!
testStati
	| stati |
	stati := ICEvent possibleStati asSet.
	self assert: stati size = 3.
	self assert: (stati includes: ICEvent statusCanceled).
	self assert: (stati includes: ICEvent statusConfirmed).
	self assert: (stati includes: ICEvent statusTentative).
	stati := ICTodo possibleStati asSet.
	self assert: stati size = 4.
	self assert: (stati includes: ICTodo statusCanceled).
	self assert: (stati includes: ICTodo statusNeedsAction).
	self assert: (stati includes: ICTodo statusInProcess).
	self assert: (stati includes: ICTodo statusCompleted).
	stati := ICJournal possibleStati asSet.
	self assert: stati size = 3.
	self assert: (stati includes: ICJournal statusCanceled).
	self assert: (stati includes: ICJournal statusDraft).
	self assert: (stati includes: ICJournal statusFinal)! !

!ICEventTest methodsFor: 'testing' stamp: 'pmm 10/7/2005 16:25'!
testTesting

  self deny: (appointment1 isFullDayEvent).
  self deny: (appointment1 isRecurrent).

  self deny: (todo isRecurrent).

  self assert: (appointment1 isValidForDate: (Date 
							year: 2005
							month: 5
							day: 18)).
							
   self assert: (todo startsInHour: DateAndTime now + 4 days).! !

!ICEventTest methodsFor: 'testing' stamp: 'pmm 10/3/2005 22:19'!
testTransparency
	self assert: ICEvent new isTransparent! !

!ICEventTest methodsFor: 'testing' stamp: 'pmm 10/7/2005 16:58'!
testUpdateAppointment
	| appEvent |
	appEvent := ICEvent summary: 'meeting'.
	calendar addEvent: appEvent.
	appEvent updateEventWith: appointment1.
	self assert: appEvent summary = appointment1 summary.
	self assert: appEvent categories = appointment1 categories.
	self assert: appEvent textualDescription = appointment1 textualDescription.
	self assert: appEvent status = appointment1 status.
	self assert: appEvent priority = appointment1 priority.
	self assert: appEvent created = appointment1 created.
	self assert: appEvent lastModified = appointment1 lastModified.
	self assert: appEvent sequenceNumber = appointment1 sequenceNumber.
	self assert: appEvent start = appointment1 start.
	self assert: appEvent end = appointment1 end.! !

!ICEventTest methodsFor: 'testing' stamp: 'pmm 10/7/2005 19:15'!
testUpdateToDo
	| todoEvent |
	todoEvent := ICTodo summary: 'todo'.
	todoEvent updateEventWith: todo.
	self assert: todoEvent summary = todo summary.
	self assert: todoEvent categories = todo categories.
	self assert: todoEvent textualDescription = todo textualDescription.
	self assert: todoEvent status = todo status.
	self assert: todoEvent priority = todo priority.
	self assert: todoEvent created = todo created.
	self assert: todoEvent lastModified = todo lastModified.
	self assert: todoEvent sequenceNumber = todo sequenceNumber.
	self assert: todoEvent due = todo due! !

TestCase subclass: #ICExportTest
	instanceVariableNames: 'iCalExporter calendar event todo dateEvent journal alarm1 alarm2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Tests'!

!ICExportTest methodsFor: 'running' stamp: 'pmm 11/11/2005 22:45'!
setUp
	calendar := ICCalendar summary: 'test'.
	event := (ICEvent summary: 'aTitle')
				location: 'Bern';
				uid: 'a short but globally unique id';
				textualDescription: 'a long long long text, very long... really!!';
				start: (DateAndTime 
							year: 2005
							month: 4
							day: 25
							hour: 10
							minute: 45);
				end: (DateAndTime 
							year: 2005
							month: 4
							day: 25
							hour: 12
							minute: 9);
				lastModified: (DateAndTime 
							year: 2005
							month: 5
							day: 1
							hour: 11
							minute: 2
							second: 31);
				created: (DateAndTime 
							year: 2005
							month: 5
							day: 1
							hour: 11
							minute: 2
							second: 31);
				beHighPriority;
				beTentative;
				beOpaque;
				yourself.
	todo := (ICTodo summary: 'aTitle')
				textualDescription: 'a long long long text, very long... really!!';
				uid: 'a very special value';
				due: (DateAndTime 
							year: 2005
							month: 4
							day: 25
							hour: 12
							minute: 9);
				lastModified: (DateAndTime 
							year: 2005
							month: 5
							day: 1
							hour: 11
							minute: 2
							second: 31);
				created: (DateAndTime 
							year: 2005
							month: 5
							day: 1
							hour: 11
							minute: 2
							second: 31);
				completed: (DateAndTime 
							year: 2005
							month: 5
							day: 1
							hour: 11
							minute: 2
							second: 31);
				beHighPriority;
				beCompleted;
				yourself.	
	dateEvent := (ICEvent summary: 'aTitle')
				uid: 'an event with a start date and not date and time';
				start: (Date
							year: 2005
							month: 4
							day: 25);
				created: (DateAndTime 
							year: 2005
							month: 5
							day: 1
							hour: 11
							minute: 2
							second: 31);
				addCategory: 'category1';
				addCategory: (ICCategory fromICalString: 'category2');
				yourself.
	journal := (ICJournal summary: 'aTitle')
				uid: 'jornal1';
				created: (DateAndTime 
							year: 2005
							month: 5
							day: 1
							hour: 11
							minute: 2
							second: 31);
				addTextualDescription: 'description1';
				addTextualDescription: 'description2';
				yourself.
	alarm1 := ICAlarm new
		trigger: (ICTrigger new
			value: (DateAndTime year: 1997 month: 3 day: 17 hour: 13 minute: 30);
			yourself);
		repetitions: 4;
		delay: 15 minutes;
		beAudio;
		addAttachment: (Url fromICalString: 'ftp://host.com/pub/sounds/bell-01.aud');
		yourself.
	alarm2 := ICAlarm  new
		trigger: (ICTrigger new
			value: 30 negated minutes;
			yourself);
		delay: 15 minutes;
		repetitions: 2;
		beDisplay;
		yourself.		
	iCalExporter := ICCalendarExporter calendar: calendar! !

!ICExportTest methodsFor: 'testing' stamp: 'pmm 11/11/2005 22:35'!
testExportAlarm1
	| export str alarmEvent created |
	alarmEvent := ICEvent summary: 'an alarming event'.
	alarmEvent addAlarm: alarm1.
	created := alarmEvent created.
	alarmEvent uid: 'xxx'.
	calendar addEvent: alarmEvent.
	export := iCalExporter export.
	str := 'BEGIN:VCALENDAR' , String crlf 
				, 'PRODID:' , calendar productId , String crlf 
				, 'VERSION:2.0' , String crlf 
				, 'METHOD:PUBLISH' , String crlf
				, 'BEGIN:VEVENT' , String crlf 				
				, 'UID:' , alarmEvent uid , String crlf 
				, 'CREATED:' , created asICalUtcString , String crlf 
				, 'SEQUENCE:0' , String crlf
				, 'SUMMARY:an alarming event' , String crlf 
				, 'PRIORITY:5' , String crlf
				, 'BEGIN:VALARM' , String crlf 
				, 'ACTION:AUDIO' , String crlf 
				, 'TRIGGER;VALUE=DATE-TIME:19970317T133000' , String crlf 
				, 'DURATION:PT0H15M0S' , String crlf 
				, 'REPEAT:4' , String crlf 
				, 'ATTACH:ftp://host.com/pub/sounds/bell-01.aud' , String crlf 
				, 'END:VALARM' , String crlf 
				, 'END:VEVENT' , String crlf 
				, 'END:VCALENDAR' , String crlf.
	export dataStream contents 
		keysAndValuesDo: [:index :value |
			self assert: value = (str at: index) ].
	self assert: export dataStream contents = str! !

!ICExportTest methodsFor: 'testing' stamp: 'pmm 11/11/2005 22:49'!
testExportAlarm2
	| export str alarmTodo created |
	alarmTodo := ICTodo summary: 'an alarming todo'.
	alarmTodo addAlarm: alarm2.
	created := alarmTodo created.
	alarmTodo uid: '(cons car cdr)'.
	calendar addEvent: alarmTodo.
	export := iCalExporter export.
	str := 'BEGIN:VCALENDAR' , String crlf 
				, 'PRODID:' , calendar productId , String crlf 
				, 'VERSION:2.0' , String crlf 
				, 'METHOD:PUBLISH' , String crlf
				, 'BEGIN:VTODO' , String crlf 				
				, 'UID:' , alarmTodo uid , String crlf 
				, 'CREATED:' , created asICalUtcString , String crlf 
				, 'SEQUENCE:0' , String crlf
				, 'SUMMARY:an alarming todo' , String crlf 
				, 'PRIORITY:5' , String crlf 
				, 'BEGIN:VALARM' , String crlf 
				, 'ACTION:DISPLAY' , String crlf 
				, 'TRIGGER:-PT0H30M0S' , String crlf 
				, 'DURATION:PT0H15M0S' , String crlf 
				, 'REPEAT:2' , String crlf 
				, 'END:VALARM' , String crlf 
				, 'END:VTODO' , String crlf 
				, 'END:VCALENDAR' , String crlf.
	export dataStream contents 
		keysAndValuesDo: [:index :value |
			self assert: value = (str at: index) ].
	self assert: export dataStream contents = str! !

!ICExportTest methodsFor: 'testing' stamp: 'pmm 10/15/2005 20:34'!
testExportDateEvent
	| export str |
	calendar addEvent: dateEvent.
	export := iCalExporter export.
	str := 'BEGIN:VCALENDAR' , String crlf 
				, 'PRODID:' , calendar productId , String crlf 
				, 'VERSION:2.0' , String crlf 
				, 'METHOD:PUBLISH' , String crlf
				, 'BEGIN:VEVENT' , String crlf 				
				, 'UID:' , dateEvent uid , String crlf 
				, 'CATEGORIES:category1,category2' , String crlf
				, 'CREATED:20050501T110231Z' , String crlf 
				, 'SEQUENCE:0' , String crlf
				, 'SUMMARY:aTitle' , String crlf 
				, 'PRIORITY:5' , String crlf 				
				, 'DTSTART;VALUE=DATE:20050425' , String crlf 
				, 'END:VEVENT' , String crlf 
				, 'END:VCALENDAR' , String crlf.
	export dataStream contents 
		keysAndValuesDo: [:index :value | self assert: value = (str at: index)].
	self assert: export dataStream contents = str! !

!ICExportTest methodsFor: 'testing' stamp: 'pmm 10/15/2005 20:34'!
testExportEvent
	| export str |
	calendar addEvent: event.
	export := iCalExporter export.
	str := 'BEGIN:VCALENDAR' , String crlf 
				, 'PRODID:' , calendar productId , String crlf 
				, 'VERSION:2.0' , String crlf 
				, 'METHOD:PUBLISH' , String crlf
				, 'BEGIN:VEVENT' , String crlf 				
				, 'UID:' , event uid , String crlf 
				, 'CREATED:20050501T110231Z' , String crlf 
				, 'STATUS:TENTATIVE' , String crlf 
				, 'LAST-MODIFIED:20050501T110231Z' , String crlf 
				, 'SEQUENCE:0' , String crlf
				, 'SUMMARY:aTitle' , String crlf 
				, 'PRIORITY:1' , String crlf 
				, 'DESCRIPTION:a long long long text\, very long... really!!' , String crlf 
				, 'LOCATION:Bern' , String crlf 				
				, 'DTSTART:20050425T104500' , String crlf 
				, 'DTEND:20050425T120900' , String crlf 				
				, 'TRANSP:OPAQUE' , String crlf 
				, 'END:VEVENT' , String crlf 
				, 'END:VCALENDAR' , String crlf.
	export dataStream contents 
		keysAndValuesDo: [:index :value |
			self assert: value = (str at: index) ].
	self assert: export dataStream contents = str! !

!ICExportTest methodsFor: 'testing' stamp: 'pmm 10/15/2005 20:33'!
testExportJournal
	| export str |
	calendar addJournal: journal.
	export := iCalExporter export.
	str := 'BEGIN:VCALENDAR' , String crlf 
				, 'PRODID:' , calendar productId , String crlf 
				, 'VERSION:2.0' , String crlf 
				, 'METHOD:PUBLISH' , String crlf
				, 'BEGIN:VJOURNAL' , String crlf 				
				, 'UID:' , journal uid , String crlf 
				, 'CREATED:20050501T110231Z' , String crlf 
				, 'SEQUENCE:0' , String crlf
				, 'SUMMARY:aTitle'  , String crlf 
				, 'DESCRIPTION:description1' , String crlf  				
				, 'DESCRIPTION:description2' , String crlf 
				, 'END:VJOURNAL' , String crlf 
				, 'END:VCALENDAR' , String crlf.
	export dataStream contents 
		keysAndValuesDo: [:index :value | self assert: value = (str at: index)].
	self assert: export dataStream contents = str! !

!ICExportTest methodsFor: 'testing' stamp: 'pmm 11/9/2005 21:17'!
testExportLine

	self assert: (iCalExporter exportLine: 'aaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx ttttt fff ggg hhh') dataStream contents = ('aaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx ttttt', String crlf,'  fff ggg hhh', String crlf).! !

!ICExportTest methodsFor: 'testing' stamp: 'pmm 11/9/2005 21:39'!
testExportLine2

	self assert: (iCalExporter exportLine: 'aaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx tttttaaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx tttt fff ggg hhh') dataStream contents = ('aaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx ttttt', String crlf,' aaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx tttt', String crlf,'  fff ggg hhh', String crlf).! !

!ICExportTest methodsFor: 'testing' stamp: 'pmm 11/9/2005 21:50'!
testExportLine2a

	self assert: (iCalExporter exportLine: 'aaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx tttttaaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx ttttaaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx tttt fff ggg hhh') dataStream contents = ('aaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx ttttt', String crlf,' aaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx tttt' , String crlf,' aaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx tttt' , String crlf,'  fff ggg hhh', String crlf).! !

!ICExportTest methodsFor: 'testing' stamp: 'pmm 11/9/2005 21:48'!
testExportLine3

	self assert: (iCalExporter exportLine: 'aaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx tttttaaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx tttt') dataStream contents = ('aaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx ttttt', String crlf,' aaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx tttt', String crlf).! !

!ICExportTest methodsFor: 'testing' stamp: 'pmm 11/9/2005 21:49'!
testExportLine3a

	self assert: (iCalExporter exportLine: 'aaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx tttttaaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx ttttaaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx tttt') dataStream contents = ('aaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx ttttt', String crlf,' aaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx tttt', String crlf,' aaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx tttt' , String crlf).! !

!ICExportTest methodsFor: 'testing' stamp: 'pmm 10/15/2005 20:33'!
testExportTodo
	| export str |
	calendar addTodo: todo.
	export := iCalExporter export.
	str := 'BEGIN:VCALENDAR' , String crlf 
				, 'PRODID:' , calendar productId , String crlf 
				, 'VERSION:2.0' , String crlf 
				, 'METHOD:PUBLISH' , String crlf
				, 'BEGIN:VTODO' , String crlf 
				, 'UID:' , todo uid , String crlf 
				, 'CREATED:20050501T110231Z' , String crlf 
				, 'STATUS:COMPLETED' , String crlf 
				, 'LAST-MODIFIED:20050501T110231Z' , String crlf 
				, 'SEQUENCE:0' , String crlf 
				, 'SUMMARY:aTitle' , String crlf 
				, 'PRIORITY:1' , String crlf 
				, 'DESCRIPTION:a long long long text\, very long... really!!' , String crlf 
				, 'COMPLETED:20050501T110231Z' , String crlf 
				, 'DUE:20050425T120900' , String crlf 
				, 'END:VTODO' , String crlf 
				, 'END:VCALENDAR' , String crlf.
	export dataStream contents 
		keysAndValuesDo: [:index :value | self assert: value = (str at: index)].
	self assert: export dataStream contents = str! !

!ICExportTest methodsFor: 'testing' stamp: 'pmm 10/9/2005 12:12'!
testICalDate
	self assert: event start asDate asICalString = '20050425'.
	self assert: event end asDate asICalString = '20050425'! !

!ICExportTest methodsFor: 'testing' stamp: 'pmm 10/9/2005 12:10'!
testICalDateAndTime
	self 
		assert: event start asICalString = '20050425T104500'.
	self 
		assert: event end asICalString = '20050425T120900'! !

TestCase subclass: #ICImportTest
	instanceVariableNames: 'calendar importCommand todo otherTodo event'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Tests'!

!ICImportTest methodsFor: 'private' stamp: 'pmm 10/14/2005 16:11'!
createTodo
	^(ICTodo summary: 'aTitle')
				textualDescription: 'a long long long text, very long... really!!';
				due: (DateAndTime 
							year: 2005
							month: 4
							day: 25
							hour: 12
							minute: 9);
				lastModified: (DateAndTime 
							year: 2005
							month: 5
							day: 1
							hour: 11
							minute: 2
							second: 31);
				created: (DateAndTime 
							year: 2005
							month: 5
							day: 1
							hour: 11
							minute: 2
							second: 31);
				completed: (DateAndTime 
							year: 2005
							month: 5
							day: 1
							hour: 11
							minute: 2
							second: 31);
				beHighPriority;
				beCompleted;
				yourself.! !

!ICImportTest methodsFor: 'running' stamp: 'pmm 11/11/2005 23:14'!
setUp
	| importString |
	calendar := ICCalendar summary: 'test'.
	event := (ICEvent summary: 'aTitle')
				location: 'Bern';
				textualDescription: 'a long long long text, very long... really!!';
				uid: 'http://localhost:8080/seaside/smallwiki/Calendar/app1';
				start: (DateAndTime 
							year: 2005
							month: 4
							day: 25
							hour: 10
							minute: 45);
				end: (DateAndTime 
							year: 2005
							month: 4
							day: 25
							hour: 12
							minute: 9);
				lastModified: (DateAndTime 
							year: 2005
							month: 4
							day: 25
							hour: 10
							minute: 45);
				created: (DateAndTime 
							year: 2005
							month: 4
							day: 25
							hour: 12
							minute: 9);
				beHighPriority;
				beTentative;
				yourself.
	todo := self createTodo.
	todo uid: 'http://localhost:8080/seaside/smallwiki/Calendar/todo1'.
	otherTodo := self createTodo.
	otherTodo summary: 'anotherToDo'.
	calendar addComponent: event.
	calendar addComponent: todo.
	calendar addComponent: otherTodo.
	importString := 'BEGIN:VCALENDAR' , String crlf ,
'PRODID:-//SMALLWIKI2-Calendar v1.0//-' , String crlf ,
'VERSION:2.0' , String crlf ,
'METHOD:PUBLISH' , String crlf ,
'BEGIN:VEVENT' , String crlf ,
'DTSTART:20050614T110000Z' , String crlf ,
'DTEND:20050614T130000Z' , String crlf ,
'DTSTAMP:20050614T110853Z' , String crlf ,
'CREATED:20050614T110853Z' , String crlf ,
'LAST-MODIFIED:20050614T110853Z' , String crlf ,
'UID:http://localhost:8080/seaside/smallwiki/Calendar/app1' , String crlf ,
'SUMMARY:test1' , String crlf ,
'DESCRIPTION:blabla' , String crlf ,
'CATEGORIES:business' , String crlf ,
'PRIORITY:1' , String crlf ,
'STATUS:CONFIRMED' , String crlf ,
'LOCATION:Bern' , String crlf ,
'TRANSP:OPAQUE' , String crlf ,
'BEGIN:VALARM' , String crlf ,
'TRIGGER;VALUE=DATE-TIME:19970317T133000Z' , String crlf ,
'REPEAT:4' , String crlf ,
'DURATION:PT15M' , String crlf ,
'ACTION:AUDIO' , String crlf ,
'ATTACH;FMTTYPE=audio/basic:ftp://host.com/pub/sounds/bell-01.aud' , String crlf ,
'END:VALARM' , String crlf ,
'BEGIN:VALARM' , String crlf ,
'TRIGGER:-PT30M' , String crlf ,
'REPEAT:2' , String crlf ,
'DURATION:PT15M' , String crlf ,
'ACTION:DISPLAY' , String crlf ,
'END:VALARM' , String crlf ,
'END:VEVENT' , String crlf ,
'BEGIN:VEVENT' , String crlf ,
'DTSTART:20050614T160000Z' , String crlf ,
'DTEND:20050614T190000Z' , String crlf ,
'DTSTAMP:20050614T110951Z' , String crlf ,
'CREATED:20050614T110951Z' , String crlf ,
'LAST-MODIFIED:20050614T110951Z' , String crlf ,
'UID:http://localhost:8080/seaside/smallwiki/Calendar/app2' , String crlf ,
'SUMMARY:test2' , String crlf ,
'DESCRIPTION:erzttz' , String crlf ,
'CATEGORIES:business' , String crlf ,
'PRIORITY:9' , String crlf ,
'STATUS:CANCELLED' , String crlf ,
'LOCATION:Bern' , String crlf ,
'TRANSP:OPAQUE' , String crlf ,
'END:VEVENT' , String crlf ,
'BEGIN:VTODO' , String crlf ,
'DUE;VALUE=DATE-TIME:20050614T150000Z' , String crlf ,
'STATUS:COMPLETED' , String crlf ,
'COMPLETED:20050614T110915Z' , String crlf ,
'DTSTAMP:20050614T110915Z' , String crlf ,
'CREATED:20050614T110915Z' , String crlf ,
'LAST-MODIFIED:20050614T110915Z' , String crlf ,
'UID:http://localhost:8080/seaside/smallwiki/Calendar/todo1' , String crlf ,
'SUMMARY:todo1' , String crlf ,
'DESCRIPTION:testest' , String crlf ,
'CATEGORIES:business' , String crlf ,
'PRIORITY:1' , String crlf ,
'END:VTODO' , String crlf ,
'END:VCALENDAR' , String crlf.
	importCommand := (ICImporter new)
				calendar: calendar;
				fileContent: importString;
				yourself! !

!ICImportTest methodsFor: 'testing' stamp: 'pmm 11/11/2005 23:17'!
testImport
	| events eventAtDate date tempAlarm |
	date := Date 
				year: 2005
				month: 6
				day: 14.
	self assert: calendar components size = 3.
	self assert: calendar events size = 1.
	self assert: calendar todos size = 2.
	importCommand import.
	self assert: calendar components size = 6.
	self assert: calendar todos size = 3.
	self assert: calendar events size = 3.
	self assert: (calendar events includes: event).
	self assert: (calendar todos includes: todo).
	self assert: (calendar components includes: event).
	self assert: (calendar components includes: todo).
	events := calendar componentForDate: date.
	self assert: events size = 3.
	eventAtDate := events detect: [:each | each summary = 'test1'].
	self assert: eventAtDate isHighPriority.
	self assert: eventAtDate location = 'Bern'.
	self assert: eventAtDate isConfirmed.
	self assert: eventAtDate textualDescription = 'blabla'.
	"self assert: eventAtDate categories anyOne 
				= (calendar categoryWithSummary: 'business')."
	self 
		assert: eventAtDate start = (DateAndTime date: date
						time: (Time 
								hour: 11
								minute: 0
								second: 0)).
	self 
		assert: eventAtDate end = (DateAndTime date: date
						time: (Time 
								hour: 13
								minute: 0
								second: 0)).
	self assert: eventAtDate alarms size = 2.
	tempAlarm := eventAtDate alarms first.
	self assert: tempAlarm trigger value = (DateAndTime year: 1997 month: 3 day: 17 hour: 13 minute: 30).
	self assert: tempAlarm repetitions = 4.
	self assert: tempAlarm delay = 15 minutes.
	self assert: tempAlarm isAudio.
	self assert: tempAlarm attachments size = 1.
	self assert: tempAlarm attachments first asICalString = (Url fromICalString: 'ftp://host.com/pub/sounds/bell-01.aud') asICalString.
	tempAlarm := eventAtDate alarms second.
	self assert: tempAlarm trigger value = 30 negated minutes.
	self assert: tempAlarm trigger isRelatedToStart.
	self assert: tempAlarm delay = 15 minutes.
	self assert: tempAlarm isDisplay.
								
	eventAtDate := events detect: [:each | each summary = 'todo1'].
	self assert: eventAtDate isHighPriority.
	self assert: eventAtDate isCompleted.
	self assert: eventAtDate textualDescription = 'testest'.
	"self assert: eventAtDate categories anyOne 
				= (calendar categoryWithSummary: 'business')."
	self 
		assert: eventAtDate due = (DateAndTime date: date
						time: (Time 
								hour: 15
								minute: 0
								second: 0)).
	self 
		assert: eventAtDate completed = (DateAndTime date: date
						time: (Time 
								hour: 11
								minute: 9
								second: 15))! !

!ICImportTest methodsFor: 'testing' stamp: 'pmm 11/11/2005 23:05'!
testSynchronize
	| events tempEvent date |
	date := Date 
				year: 2005
				month: 6
				day: 14.
	self assert: calendar components size = 3.
	self assert: calendar todos size = 2.
	self assert: calendar events size = 1.
	importCommand synchronize.
	self assert: calendar components size = 3.
	self assert: calendar todos size = 1.
	self assert: calendar events size = 2.
	self assert: (calendar includesEventWithUid: event uid).
	self assert: (calendar includesTodoWithUid: todo uid).
	self assert: (calendar includesComponentWithUid: event uid).
	self assert: (calendar includesComponentWithUid: todo uid).
	self deny: (calendar includesTodoWithUid: otherTodo uid).
	events := calendar componentForDate: date.
	self assert: events size = 3.
	tempEvent := events detect: [:each | each summary = 'test1'].
	self assert: tempEvent isHighPriority.
	self assert: tempEvent location = 'Bern'.
	self assert: tempEvent isConfirmed.
	self assert: tempEvent textualDescription = 'blabla'.
	"self assert: tempEvent categories anyOne 
				= (calendar categoryWithSummary: 'business')."
	self 
		assert: tempEvent start = (DateAndTime date: date
						time: (Time 
								hour: 11
								minute: 0
								second: 0)).
	self 
		assert: tempEvent end = (DateAndTime date: date
						time: (Time 
								hour: 13
								minute: 0
								second: 0)).
	
	tempEvent := events detect: [:each | each summary = 'todo1'].
	self assert: tempEvent isHighPriority.
	self assert: tempEvent isCompleted.
	self assert: tempEvent textualDescription = 'testest'.
	"self assert: tempEvent categories anyOne 
				= (calendar categoryWithSummary: 'business')."
	self 
		assert: tempEvent due = (DateAndTime date: date
						time: (Time 
								hour: 15
								minute: 0
								second: 0)).
	self 
		assert: tempEvent completed = (DateAndTime date: date
						time: (Time 
								hour: 11
								minute: 9
								second: 15))! !

!ICImportTest methodsFor: 'testing' stamp: 'pmm 10/18/2005 07:15'!
testUnfolding
	| importString |
	importString := 'BEGIN:VCALENDAR' , String crlf ,
'PRODID:-//SMALLWIKI2-Calendar v1.0//-' , String crlf ,
'VERSION:2.0' , String crlf ,
'METHOD:PUBLISH' , String crlf ,
'BEGIN:VEVENT' , String crlf ,
'DT' , String crlf ,
' START' , String crlf ,
' ;' , String crlf ,
'	val' , String crlf ,
'	ue' , String crlf ,
'	=' , String crlf ,
' DA' , String crlf ,
' Te' , String crlf ,
'	:' , String crlf ,
' 20050' , String crlf ,
' 614' , String crlf ,
'DTEND:20050614T130000Z' , String crlf ,
'DTSTAMP:20050614T110853Z' , String crlf ,
'CREATED:20050614T110853Z' , String crlf ,
'LAST-MODIFIED:20050614T110853Z' , String crlf ,
'UID:http://localhost:8080/seaside/smallwiki/Calendar/app1' , String crlf ,
'SUMMARY:te' , String crlf ,
' s' , String crlf ,
' t' , String crlf ,
'DESCRIPTION:blabla' , String crlf ,
'CATEGORIES:' , String crlf ,
' business' , String crlf ,
'PRIORITY:1' , String crlf ,
'STATUS:CONFIRMED' , String crlf ,
'LOCATION:Be' , String crlf ,
'	rn' , String crlf ,
'TRANSP:OPAQUE' , String crlf ,
'END:VEVENT' , String crlf ,
'END:VCALENDAR' , String crlf.
	calendar := ICCalendarHandParser parseCalendarString: importString.
	event := calendar events first.
	self assert: event start = (Date year: 2005 month: 6 day: 14).
	self assert: event summary = 'test'.
	self assert: event location = 'Bern'.
	self assert: event isOpaque.
	self assert: event textualDescription = 'blabla'.
	self assert: event categories size = 1.
	self assert: event categories first summary = 'business'.! !

TestCase subclass: #ICOrganizationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-VCard-Tests'!

!ICOrganizationTest methodsFor: 'testing' stamp: 'pmm 12/11/2005 11:30'!
testABCInc
	| organization string |
	string := 'ABC\, Inc.;North American Division;Marketing'.
	organization := ICOrganization fromICalString: string.
	self assert: organization name = 'ABC, Inc.'.
	self assert: organization unitNames size = 2.
	self assert: organization unitNames first = 'North American Division'.
	self assert: organization unitNames second = 'Marketing'.
	self assert: organization asVCardString = string! !

!ICOrganizationTest methodsFor: 'testing' stamp: 'pmm 12/11/2005 11:30'!
testUnibe
	| organization string |
	string := 'University of Bern'.
	organization := ICOrganization fromICalString: string.
	self assert: organization name = 'University of Bern'.
	self assert: organization unitNames isEmpty.
	self assert: organization asVCardString = string! !

TestCase subclass: #ICRecurrenceRuleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Tests'!

!ICRecurrenceRuleTest methodsFor: 'testing' stamp: 'pmm 10/29/2005 00:54'!
testHours
	| rule expected |
	rule := ICRecurrenceRule frequency: 'MONTHLY'.
	
	rule addHour: 5.	
	expected := 'FREQ=MONTHLY;BYHOUR=5'.
	self assert: expected = rule asICalString.
	
	rule addHour: 15.	
	expected := 'FREQ=MONTHLY;BYHOUR=15,5'.
	self assert: expected = rule asICalString.
	! !

!ICRecurrenceRuleTest methodsFor: 'testing' stamp: 'pmm 10/29/2005 00:55'!
testParsing
	| string rule |
	string := 'FREQ=MONTHLY;BYDAY=TU,MO,TH,WE,FR;BYSETPOS=-1'.
	rule := ICRecurrenceRule fromICalString: string.
	self assert: string = rule asICalString! !

!ICRecurrenceRuleTest methodsFor: 'testing' stamp: 'pmm 10/2/2005 15:14'!
testRepetition
	| rule expected |
	rule := ICRecurrenceRule frequency: 'MONTHLY'.
	
	rule count: 4.	
	expected := 'FREQ=MONTHLY;COUNT=4'.
	self assert: expected = rule asICalString.
	
	rule until: (Date year: 1997 month: 3 day: 10).
	expected := 'FREQ=MONTHLY;UNTIL=19970310'.
	self assert: expected = rule asICalString.
	
	rule count: 2.
	expected := 'FREQ=MONTHLY;COUNT=2'.
	self assert: expected = rule asICalString.! !

!ICRecurrenceRuleTest methodsFor: 'testing' stamp: 'pmm 10/2/2005 15:10'!
testSimple
	| rule |
	rule := ICRecurrenceRule frequency: 'MONTHLY'.
	self assert: 'FREQ=MONTHLY' = rule asICalString! !

!ICRecurrenceRuleTest methodsFor: 'testing' stamp: 'pmm 10/4/2005 20:02'!
testWeekdays
	| rule expected |
	rule := ICRecurrenceRule frequency: 'MONTHLY'.
	
	rule addWeekday: 'MO'.	
	expected := 'FREQ=MONTHLY;BYDAY=MO'.
	self assert: expected = rule asICalString.
	
	rule addWeekday: 'TU' occurrence: 2.	
	expected := 'FREQ=MONTHLY;BYDAY=MO,2TU'.
	self assert: expected = rule asICalString.
	
	rule addWeekday: 'WE' occurrence: -5.	
	expected := 'FREQ=MONTHLY;BYDAY=MO,2TU,-5WE'.
	self assert: expected = rule asICalString.
	! !

TestCase subclass: #ICRemoveCategoryTest
	instanceVariableNames: 'calendar category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Tests'!

!ICRemoveCategoryTest methodsFor: 'testing' stamp: 'pmm 10/7/2005 11:33'!
remove: aString
	| eventsForCategory |
	category := calendar categoryWithSummary: aString.
	calendar removeCategory: category.
	eventsForCategory := calendar events select: [:event | event categories anyOne = category ].
	eventsForCategory do: [:event | event categories: OrderedCollection new ].! !

!ICRemoveCategoryTest methodsFor: 'running' stamp: 'pmm 10/7/2005 18:47'!
setUp
	calendar := ICCalendar new.
	category := ICCategory summary: 'irishdance'.
	category
		color: 'SpringGreen';
		textualDescription: 'for irishdace events like trainings or dancing shows'.
	calendar addCategory: category.! !

!ICRemoveCategoryTest methodsFor: 'testing' stamp: 'pmm 10/7/2005 18:46'!
testRemove
	| numCats |
	numCats := calendar categories size.
	
	self assert: (calendar categories includes: category).
  	self remove: 'irishdance'.
  	self assert: (calendar categories size = (numCats - 1)).
	self deny: (calendar categories includes: category).
  	self should: [ calendar categoryWithSummary: 'irishdance' ] raise: Error
  ! !

TestCase subclass: #ICRemoveEventTest
	instanceVariableNames: 'calendar event'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Tests'!

!ICRemoveEventTest methodsFor: 'private' stamp: 'pmm 9/11/2005 15:50'!
removeTesting: anEvent
"Helper method for testing methods. Test removing the current event"
  | eventSizeBeforeRemove |
  eventSizeBeforeRemove := calendar events size.
  calendar removeEvent: anEvent.
  self deny: (calendar events size = eventSizeBeforeRemove).
  self assert: (calendar events size = (eventSizeBeforeRemove - 1)).
! !

!ICRemoveEventTest methodsFor: 'running' stamp: 'pmm 10/7/2005 10:05'!
setUp
	calendar := ICCalendar summary: 'the calendar'! !

!ICRemoveEventTest methodsFor: 'testing' stamp: 'pmm 10/9/2005 11:54'!
testRemoveAppointment
	"self debug: #testRemoveAppointment"
	event := ICEvent summary: 'simple appointment'.
	calendar addEvent: event.
	event
		location: 'room one';
		addCategory: (ICCategory summary: 'second');
		start: (DateAndTime 
					year: 2005
					month: 5
					day: 18
					hour: 17
					minute: 0);
		end: (DateAndTime 
					year: 2005
					month: 5
					day: 18
					hour: 20
					minute: 0);
		beLowPriority.
	self removeTesting: event! !

!ICRemoveEventTest methodsFor: 'testing' stamp: 'pmm 10/7/2005 16:21'!
testRemoveToDo
	event := ICTodo summary: 'working'.
	event
		addCategory: (ICCategory summary: 'second');
		due: (DateAndTime 
					year: 2005
					month: 6
					day: 24
					hour: 12
					minute: 1);
		beLowPriority.
	calendar addEvent: event.
	self removeTesting: event! !

TestCase subclass: #ICVCardConversionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-VCard-Tests'!

!ICVCardConversionTest methodsFor: 'testing' stamp: 'pmm 12/11/2005 11:27'!
testAddress
	| address string |
	string := ';;123 Main Street;Any Town;CA;91921-1234;'.
	address := ICAddress fromVCardString: string parameters: Dictionary new.
	self assert: address poBox isEmptyOrNil.
	self assert: address extended isEmptyOrNil.
	self assert: address street = '123 Main Street'.
	self assert: address locality = 'Any Town'.
	self assert: address postalcode = '91921-1234'.
	self assert: address region = 'CA'.
	self assert: address country isEmptyOrNil.
	self assert: address asVCardString = string.	

	string := ';;501 E. Middlefield Rd.;Mountain View;CA;94043;U.S.A.'.
	address := ICAddress fromVCardString: string parameters: Dictionary new.
	self assert: address poBox isEmptyOrNil.
	self assert: address extended isEmptyOrNil.
	self assert: address street = '501 E. Middlefield Rd.'.
	self assert: address locality = 'Mountain View'.
	self assert: address postalcode = '94043'.
	self assert: address region = 'CA'.
	self assert: address country = 'U.S.A.'.
	self assert: address asVCardString = string.

	string := ';;6544 Battleford Drive;Raleigh;NC;27613-3502;U.S.A.'.
	address := ICAddress fromVCardString: string parameters: Dictionary new.
	self assert: address poBox isEmptyOrNil.
	self assert: address extended isEmptyOrNil.
	self assert: address street = '6544 Battleford Drive'.
	self assert: address locality = 'Raleigh'.
	self assert: address postalcode = '27613-3502'.
	self assert: address region = 'NC'.
	self assert: address country = 'U.S.A.'.
	self assert: address asVCardString = string.! !

!ICVCardConversionTest methodsFor: 'testing' stamp: 'pmm 1/2/2006 12:09'!
testDate
	| date |
	date := Date newDay: 12 month: 04 year: 1985.
	self assert: date asVCardString = '1985-04-12'.

	date := Date newDay: 05 month: 08 year: 1996.
	self assert: date asVCardString = '1996-08-05'.

	date := Date newDay: 11 month: 11 year: 1996.
	self assert: date asVCardString = '1996-11-11'.! !

!ICVCardConversionTest methodsFor: 'testing' stamp: 'pmm 1/2/2006 12:13'!
testDateAndTime
	| dateAndTime |
	dateAndTime := DateAndTime year: 1996 month: 10 day: 22 hour: 14 minute: 00 second: 00.
	self assert: '1996-10-22T14:00:00'  = dateAndTime asVCardString.
	
	dateAndTime := DateAndTime year: 1996 month: 08 day: 11 hour: 12 minute: 34 second: 56.
	self assert: '1996-08-11T12:34:56'  = dateAndTime asVCardString.! !

!ICVCardConversionTest methodsFor: 'testing' stamp: 'pmm 12/11/2005 10:57'!
testName
	| name string |
	string := 'Public;John;Quinlan;Mr.;Esq.'.
	name := ICName fromICalString: string.
	self assert: name familyName = 'Public'.
	self assert: name givenName = 'John'.
	self assert: name additionalNames asArray = #('Quinlan').
	self assert: name honorificPrefixes asArray = #('Mr.').
	self assert: name honorificSuffixes asArray = #('Esq.').	
	self assert: name asVCardString = string.

	string := 'Stevenson;John;Philip,Paul;Dr.;Jr.,M.D.,A.C.P.'.
	name := ICName fromICalString: string.
	self assert: name familyName = 'Stevenson'.
	self assert: name givenName = 'John'.
	self assert: name additionalNames asArray = #('Philip' 'Paul').
	self assert: name honorificPrefixes asArray = #('Dr.').
	self assert: name honorificSuffixes asArray = #('Jr.' 'M.D.' 'A.C.P.').
	self assert: name asVCardString = string.! !

!ICVCardConversionTest methodsFor: 'testing' stamp: 'pmm 1/2/2006 12:09'!
testParseDate
	| string date |
	string := '1985-04-12'.
	date := Date fromVCardString: string.
	self assert: date = (Date year: 1985 month: 04 day: 12).

	string := '1996-08-05'.
	date := Date fromVCardString: string.
	self assert: date = (Date year: 1996 month: 08 day: 05).

	string := '1996-11-11'.
	date := Date fromVCardString: string.
	self assert: date = (Date year: 1996 month: 11 day: 11).

	string := '19850412'.
	date := Date fromVCardString: string.
	self assert: date = (Date year: 1985 month: 04 day: 12).! !

!ICVCardConversionTest methodsFor: 'testing' stamp: 'pmm 1/2/2006 12:15'!
testParseDateAndTime
	| string dateAndTime |
	string := '1996-10-22T14:00:00Z'.
	dateAndTime := DateAndTime fromVCardString: string.
	self assert: dateAndTime = (DateAndTime year: 1996 month: 10 day: 22 hour: 14 minute: 00 second: 00).

	string := '1996-08-11T12:34:56Z'.
	dateAndTime := DateAndTime fromVCardString: string.
	self assert: dateAndTime = (DateAndTime year: 1996 month: 08 day: 11 hour: 12 minute: 34 second: 56).

	string := '19960811T123456Z'.
	dateAndTime := DateAndTime fromVCardString: string.
	self assert: dateAndTime = (DateAndTime year: 1996 month: 08 day: 11 hour: 12 minute: 34 second: 56).! !

!ICVCardConversionTest methodsFor: 'testing' stamp: 'pmm 1/2/2006 12:09'!
testParseTime
	| string time |
	string := '10:22:00'.
	time := Time fromVCardString: string.
	self assert: time = (Time hour: 10 minute: 22 second: 00).

	string := '102200'.
	time := Time fromVCardString: string.
	self assert: time = (Time hour: 10 minute: 22 second: 00).

	string := '10:22:00.33'.
	time := Time fromVCardString: string.
	self assert: time = (Time hour: 10 minute: 22 second: 00 nanoSecond: 330000000).

	string := '10:22:00.33Z'.
	time := Time fromVCardString: string.
	self assert: time = (Time hour: 10 minute: 22 second: 00 nanoSecond: 330000000).

	string := '10:22:33'.
	time := Time fromVCardString: string.
	self assert: time = (Time hour: 10 minute: 22 second: 33).

	string := '10:22:00-08:00'.
	time := Time fromVCardString: string.
	self assert: time = (Time hour: 10 minute: 22 second: 00).! !

!ICVCardConversionTest methodsFor: 'testing' stamp: 'pmm 1/2/2006 12:09'!
testTime
	| time |
	time := Time hour: 10 minute: 22 second: 00.
	self assert: time asVCardString = '10:22:00'.

	time := Time hour: 10 minute: 22 second: 00 nanoSecond: 330000000.
	self assert: time asVCardString = '10:22:00.33'.

	time :=Time hour: 10 minute: 22 second: 33.
	self assert: time asVCardString = '10:22:33'.
! !

TestCase subclass: #ICVCardExportLineTest
	instanceVariableNames: 'vCardExporter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-VCard-Tests'!

!ICVCardExportLineTest methodsFor: 'running' stamp: 'pmm 12/13/2005 21:29'!
performTest
	ICCardVersion 
		use: 2.1
		during: [ super performTest ].
	! !

!ICVCardExportLineTest methodsFor: 'running' stamp: 'pmm 12/13/2005 21:27'!
setUp
	vCardExporter := ICVCardExporter new
	! !

!ICVCardExportLineTest methodsFor: 'testing' stamp: 'pmm 12/13/2005 21:32'!
testExportLine

	self assert: (vCardExporter exportLine: 'aaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx tttt fff ggg hhh') dataStream contents = ('aaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx tttt=', String crlf,'  fff ggg hhh', String crlf).! !

!ICVCardExportLineTest methodsFor: 'testing' stamp: 'pmm 12/13/2005 21:38'!
testExportLine2

	self assert: (vCardExporter exportLine: 'aaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx ttttaaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx ttt fff ggg hhh')
	dataStream contents = (
'aaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx tttt=', String crlf,
' aaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx ttt=', String crlf,
'  fff ggg hhh', String crlf).! !

!ICVCardExportLineTest methodsFor: 'testing' stamp: 'pmm 12/13/2005 21:35'!
testExportLine2a

	self assert: (vCardExporter exportLine: 'aaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx ttttaaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx tttaaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx ttt fff ggg hhh')
dataStream contents = (
'aaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx tttt=', String crlf,
' aaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx ttt=' , String crlf,
' aaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx ttt=' , String crlf,
'  fff ggg hhh', String crlf).! !

!ICVCardExportLineTest methodsFor: 'testing' stamp: 'pmm 12/13/2005 21:36'!
testExportLine3

	self assert: (vCardExporter exportLine: 'aaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx ttttaaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx tttt')
	dataStream contents = (
'aaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx tttt=', String crlf,
' aaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx tttt', String crlf).! !

!ICVCardExportLineTest methodsFor: 'testing' stamp: 'pmm 12/13/2005 21:36'!
testExportLine3a

	self assert: (vCardExporter exportLine: 'aaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx ttttaaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx tttaaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx tttt')
	dataStream contents = (
'aaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx tttt=', String crlf,
' aaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx ttt=', String crlf,
' aaabbbcccddd dddcccbbbaaa zzz yyy xxx xxx yyy zzz bla foo bar xyz zyx tttt' , String crlf).! !

TestCase subclass: #ICVCardTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-VCard-Tests'!

!ICVCardTest methodsFor: 'accessing-parsing' stamp: 'avi 11/12/2005 13:15'!
aviCardString
^
'BEGIN:VCARD' , String crlf ,
'VERSION:3.0' , String crlf ,
'N:Bryant;Avi;;;' , String crlf ,
'FN:Avi Bryant' , String crlf ,
'EMAIL;type=INTERNET;type=WORK;type=pref:avi@smallthought.com' , String crlf ,
'EMAIL;type=INTERNET;type=HOME:avi.bryant@gmail.com' , String crlf ,
'TEL;type=HOME;type=pref:(778) xxx-xxxx' , String crlf ,
'item1.ADR;type=HOME;type=pref:;;xxx E. xx Ave;Vancouver;BC;V5V 1E3;Canada' , String crlf ,
'item1.X-ABADR:ca' , String crlf ,
'item2.X-AIM;type=pref:avbry' , String crlf ,
'item2.X-ABLabel:_$!!<Other>!!$_' , String crlf ,
'item3.X-MSN;type=pref:avi666@hotmail.com' , String crlf ,
'item3.X-ABLabel:_$!!<Other>!!$_' , String crlf ,
'PHOTO;BASE64:' , String crlf ,
'  TU0AKgAAHVRMUWlAR142PVQoL0QcIjIZGycXGB8aGBsYFBceExUuHBw6IR9IJiVVLi9ZLzNaLzZa' , String crlf ,
'  MjVVLjFRKS9HJCg+HyU2HCAuFx8mExkgEBohFR8kHScnIy8lIzEdHSoWFykWFykaGSkaGSkZGi4Z' , String crlf ,
'  GiwXGisXGycYGiYXGSMYHCcUGCQUGioVGy0RFioQFigUFygTFiUXFyQYGCUlKj4vNEgoL0IbITMX' , String crlf ,
'  GCgTERwVEBYYDxIcERMwIiJKNDRgREF0UE+EXFyLY2aSaGyTaWuPZ2iKYmOBWlt2VFVrS05fQENQ' , String crlf ,
'  NjlAKi06JSoxICgoGyQjFyEcFR8cFCMbFSMaFiQZFyUXGCoXGisVGysYGyoZGygXGSUYGiYYGicX' , String crlf ,
'  GisWGSwVGCsXGi0ZGioWGCUWFiMXFyQnLTswNkQjJjUQEh8TDRkXDRUiERcsGBpAKixlTE2FZ2WW' , String crlf ,
'  dXCpg362j4q9lZXAmJjEmJfClpO9kY60iIOtgXyofHefc26SaWWIYVx9V1RtS0pbPT1KLTE8IiYu' , String crlf ,
'  Fx8hDhYcEBkYExwUFiMUGigTGywTGywYGSsaGSkaFiUbFyYZGCgWFykXGCoaGysbGygZFyUWFiMU' , String crlf ,
'  FiM8Q0s8QEkqLDgVER0cEBkvHiQ4HyJLLjB9XmGlg4K4lZHBm5bRqKLbtK3euLXfubbjt7ThtK/b' , String crlf ,
'  r6jUpZ/NnpbKmZLEk4y8i4SygXqsfXeleHOabmuKYGF7VFVoREZSMzYyHB8lFhsZFBsWFiIUFyYR' , String crlf ,
'  FycWFykaFygaFScaFiUYFSYYFycYGSkaGicYFiMYFiMUFiMUFiM3PD82OT0rLDEeFx4yIyhSPD9P' , String crlf ,
'  MDN2UlK6k5TTq6vYr6vZsKrnvrjux8DsycXoxcHrwr7rv7rovLfluLPesqvaq6XUo57NnJfKmZTF' , String crlf ,
'  lI/BkIu6iIWwgHypeXebbmuJYF5yTk1TNzY0HyQjFh8bFSEXFSMXFiYYFycaFygaFygYFycZGCgZ' , String crlf ,
'  GygXGSYXFyMUFiIVFyQTFiUmLCwmKisjIiclHyNNPEBsUlVnRUaogYLetrbrwsDmurfcsKvkvLTy' , String crlf ,
'  y8Tyz8nuy8Xux8Dsw73swLvrv7rpvLfkt7LgsKzbqqXZpqLUoZ3Om5fIlZHBjoi8iYO0gXupeHGb' , String crlf ,
'  b2iJYFxxTU1TNjozICYdEBoXDxwZFSMWFCIWFiMWFSUWFSUWFycYGicXGycVGSUUFyYTFiUeIiMg' , String crlf ,
'  IiMeHSIqJChVREhuVVh9Xl7Npqfuxsbyy8jpwLzSqaPMoZrVrKbgurXkwbvowbrpw7rsw73txL7s' , String crlf ,
'  wL3qvbrpubfltbHgrqvcq6bYpaHToJrQm5PKlY3AjIG5hXqyfHKqdW2cameGXVttS0xRNzozIiYc' , String crlf ,
'  EhoZFB0UEh8TEyAUEyMTFCQVGCcVGykSGicUFyYUFyYaHh8fISIeHSIiHCBCMTVhSEuSc3PgvLv2' , String crlf ,
'  z8/0zcrwx8PWrae2i4SkfHSngXy3kYzGoJnSq6ThuLLov7nrv7rtwLvuvrrrubbms6/ir6vdqKLZ' , String crlf ,
'  pJzWopfQnJHJlYrHkYXEi4C/hnuzfHWjcmuVaWSEXltmSklINDUoGR4cEhsYEh4YFiQVFCQRFCMR' , String crlf ,
'  GSYRGSYVGCcVGCcbHR4YGhsZGB0fGR0zJCdWQEKoiojsysj+19f2z8zqwb3Xrqi4jYaccWqHYFuH' , String crlf ,
'  YVySbGelf3jCm5TWqqXhta7su7bvvLbwu7Xsta7pr6nfqKHcppzbpZvVoZbNmY7JlYrJk4fGkIS+' , String crlf ,
'  in20gnWpeG+ccGeNZF54VFNdPkE6ICcjEhobERwXEyEUFiMQFiQRFyUVGCcWGCUdHR8YGBoYFhkf' , String crlf ,
'  Fhk1JChhS0u9n53z0s371dL50s3ov7nMoZq4jIOyhn2ddG6BWlVzTUh2UEuMZV6vg37On5nerabl' , String crlf ,
'  sKrpsqvts63psKfjqaPdpJvaoJrUnZbOmZHMl4/Nl43LlYnEkIO+in23g3avfXKmdW6WamOCWVdn' , String crlf ,
'  Q0NFKy4pFhwcEBkZFSEWFiMSEyMVFyQWGCQVExQSEBEWEhMfFBY8Kit7YmDevLr/2db/19X6zsvq' , String crlf ,
'  vrfOn5e3iIC9jobBlZCnfniGYFtxS0ZnQDt1TEaXamW5ioTOm5fapZ/cpaDhp6HgpqLdopzan5vV' , String crlf ,
'  m5fRl5PPlY/RmpPPmY/LlYvGkofCjoO+in+2g3urenGaa2ONYVxyTElOMC4vGx0aDhQRDBUVEyAX' , String crlf ,
'  FSIYGCIZFRQaFhUfGRsqHiBHMzSafn3wzMv+19T/1tL7z8rzxL7YqaG+jYbCk4vTpqG+ko2sg32W' , String crlf ,
'  bWd7UkxnOzZkNzJ2R0GYZ2K5hoDJlI7RmpXXnZnWm5XVmJPUl5LUl5LTmJLWnJbXnZfUmpTTmpHO' , String crlf ,
'  mI7JlYrCkIW5iH+se3KecmePZF16VE9ZOzk0ICEaDxUUDxYUERoWFR0nISErIiMuIyc6Ky5XQUO5' , String crlf ,
'  m5v609P+1dP/1dL90cz1xsDgsanFlI24iYHGmZTKnpm3i4SoeXGWZ2GFVlBwQTtiMSprOjOGU02o' , String crlf ,
'  c225gnvJj4nOkorPkInQkYrUk4vWl5DWm5XZnpjZnJfZnpjXnZfQm5PIl47AlIm5jYKugneldmyW' , String crlf ,
'  a2J9V1JbPzw2JCQXDBATDhQTEBcwJScxJigyJipALzNuVVjRs7P91tb/2tf/2df/1dL1yMPsvbfS' , String crlf ,
'  o52md3Gfcm+6jYrCk420g3yfbmeMW1SAT0h3Rj1xQDd4RT2IVEmgamC6gXjFi4DHi4HKi4LPkIfS' , String crlf ,
'  lozVmpTZnpjanZjcopnboZvUn5fNnpbInJPClo29kYi2h32menGQaGB3Vk9TOjYpGRkXDhEQDhE0' , String crlf ,
'  KCoyJig0JSpFNDqLcnbgwcT41tX+19f/2Nj/2tf80M/3ysfmtrS5iYeNX2GEV1aebmygcGyXZmGC' , String crlf ,
'  UUp2QztzQTZ0QjV9STyFUkOZZlesd2m0fnK2gHS7gnfBiH3EjoTGj4jLlI3Ql4zWnZLXoZfUn5fQ' , String crlf ,
'  nZnQnpvLm5fFmJO8jYevg3yienKPaWJvTklHLysiFxkSDg83KCs0JSg5KC5PPECljI/qzMz41tX8' , String crlf ,
'  1dX/19f91NL90M/9zcvywL/aqKeoeHh/T09tPT1qODdlMzBiMSxfLiddKyBnMyZ6RziOW0yaZ1al' , String crlf ,
'  cmOqdWeqdGipdWiodGmmdGmlcmqtenK0gne+jIHFlIvGlY7Gl5HImJTGmZbIm5i9kIuzhoGsgXqb' , String crlf ,
'  c2uCW1RkRUI3JyceFRY3Jiw0Iyc5JyhmUlPBp6jszsz20tH709P/0tH+zs7/y83/ysr2wL7kr6vE' , String crlf ,
'  kI6daWd8SEpsODphMTFdLSlgMStnNi9uPDGBTUCPXk+kcWKueWmqcmWhaF2cZlqPW1CBUUV1Rjx1' , String crlf ,
'  SUCBVk2MZFqXcWideG+ngXqwiYK3joi7koy6jYi6joe2ioOne3SRZF9wSUZNNDIvHRs1JCoxICRB' , String crlf ,
'  LzB/aWnPtrTszcvyy8v5z9D+zs7/y83+yMj+xsf3v77rtLHVnpu2gX2ja2yOWFp9S0x1RUN6SkaC' , String crlf ,
'  UUqJVEyUYFWfa163hHW9iHqze26jal+QWk55RzxnOC5dMShVLSNSLCNVMCdhPjZlRDttTEN+W1OK' , String crlf ,
'  ZF2YcmueeG+je3OpgXmrgHmYbGd4UUxXOTY+JSEzJCcxIiVNOzyVf3/Xu7rmx8XsxcX2zcv8zMz/' , String crlf ,
'  y83/x8r/xMb7wMDzubfjrKnQmZbDiIq5foCseHihb2ydbGedamSfaGGmcGa7hXvSnJDVnJHCiX6n' , String crlf ,
'  bmODT0RpOjBZLSJUKSBVLSVYLylVLidVLilMJiFKJB9RLihdPDNjQjlkRztpTEB2WU2BYVZ7W1Bu' , String crlf ,
'  TURaPTVILSQmGhwuICBUQkKijIzVubjfwL3mwL3sw8HywsL4xMb7w8b+wsT+wsT5vb3utLLkqqjf' , String crlf ,
'  oaLYnJzQmJfLlZPJlJDKk5DLkY3QlpDcpZ7rtavnsafQmpCqdGp8SUFqPjNgNSxPJx9NJB5ZMCph' , String crlf ,
'  ODJlPDhjOjZhOjVeODNbODBXOS9VOCxUOCxZPTFfQzdgQzdjRjpgQzdSNSkrICIvJCNYRkaqlZLQ' , String crlf ,
'  tLHVs7HctrPhuLTpubnwvL74vcH7vcD9v8L6vL3zuLbxtrTsr67mqajfpaPZop/coaHdoqLip6Xo' , String crlf ,
'  rqz2v7z8xcD2v7rcp5+ueXGBUEl1SUBqPzZcMCtQJCFYLClpPTp6Tk19VFJ8U093UEt0TkdzUEhy' , String crlf ,
'  UEZsTD9tTUByUkV0UkZ0UkZpSTxaOi00KywxJyZXR0eympjOsK7Ip6LQqqXXrqrfr63ksLDus7fx' , String crlf ,
'  s7b1tLb2trbztrX3urf0t7TxtLHrsK7mrKrmqqrpra3ytrb7wMD/ycj/zcn6xcHeq6Wyf3mSYVqJ' , String crlf ,
'  WlJ3S0RnOjVcMC1ZLSpgNzN7UlCMY2GMZWCHYFuHYFmBW1J4UkdzTkN7VUqHYVaMZluFYFV0UkZf' , String crlf ,
'  PTEhGxspHx5XR0e0nJrLraq/nJjEnpnHnpjNoJvTn53fpKbjpabmpafoqKjrq6vws7D4u7j3vLjz' , String crlf ,
'  uLbyt7X0uLj2urz6v8H+w8X/y8v/y8n1wr7ap6O1gnykcWuhbmiWZWCAUExrPjtVLCpRKidoQj+A' , String crlf ,
'  XVmOaGOOaGOJYluEXFSCV06JXlOTZ1ybcGWec2iRaV9+XFJfPzQXEREqIB9dTU2zm5nEpqO4lY++' , String crlf ,
'  mJG8k422iYS5iIPGi4vJjIvIiIjIhoXJiYfOkYzTmJLkqaXyuLb6v7/7wML5wcL7w8b7xcf/zM7+' , String crlf ,
'  ysrvu7nToJy2gXuvenSzfHe0f3mlcW+FVVNuQT5aMS9NJyROKCNYMi1fODFsRDx/U0qYaV+vfnWy' , String crlf ,
'  g3mxgnisgHWXb2V/XFRYOjIRCw0kGRtUREStlZO8npu4lY/AmpOzi4OjeHGebWaga2eeY1+XWleZ' , String crlf ,
'  WVWaWlaeYVy5fnjboZ3ut7T2wL74xMT9y8z5xsr/zc7/zM79ycnmrq3LlJHAhoK4fni6f3nCh4HA' , String crlf ,
'  hoSweniWYmB6SkhqPjtjNzReMi9mOjV8UEmgb2i8iYHGk4vEk4q9joSwhHmbdWx4WlRGLSkUDhAp' , String crlf ,
'  ICFURESfioe3mZa2lY68lo+vh3+ab2aKXlWDUEqGUUuUWVOeYVymaWSwc27KkIz3wL3/zMr7x8f7' , String crlf ,
'  y8v8z87/09X/0NP/zc/2vr/doqLLkIzEiYPBhX3GioLKjYjKj43JjY28hIOrdXOcaGiQXluSYF2h' , String crlf ,
'  bmqwfXnDjojOmZPOm5PHlo27j4awhXyWcGliSUUzIBwcGBswJypNPz+KdnWwlJC1lI25k4yviYCi' , String crlf ,
'  enCab2aRZVySY1ulcGq1fnfBhoDHjIbjqaf/zMv/0tL/z8/+0tH/2Nn/2dr/0dT/yszusrLYmJjN' , String crlf ,
'  jYvLi4fJjYXPk4vTl4/WmZbZnJvUl5bNkpDKjo7FiYnGiorMkY/Wm5naoJzYoZzSn5nJmpK7kImv' , String crlf ,
'  h3+LamNKNTIkFhMeGh0sJig+MzJxX12jioavkYm0kYmzjYSxi4KadGuIYlmDW1OccGm7ioXMlZDO' , String crlf ,
'  l5Tjq6r/zs7/1Nb/2Nj/2Nn/2tr/1df/09P/xsjxsLLenJ3UkI/OjorNkYnSlo7fo5vfpJ7ip6Pe' , String crlf ,
'  oaDeoaDho6TeoKHfoqHeoaDhpKPfpaPapaHRoJvHmpW3kImmg311WlM0JCIbEQ8eGR8uKCw9MjRd' , String crlf ,
'  T0yMd3Keg3ypiIGviYKhe3R4VU1tTEN1UkqRamOvg37AjovCjozHk5Psurv/zc7/09b/1Nb+0dP/' , String crlf ,
'  0ND/zM7/w8XzsLPno6TZlZTUlJDQlIzIjITUmpHepJ7iqKLhp6Pnranssa/oravlqanipqbfpKTd' , String crlf ,
'  paTVo6DJnJe/mJOwj4iWeXNZRD8lGhYXEg8dGB4tKSw8MzRIPTtnVE59ZV2TdW2ee3OCYVhaPDRX' , String crlf ,
'  OjJkR0F6WVSTbGmpfHuxf4Ccb26tgH/qt7v/z9P/0dX/z9P+ysz9xcb8u73wrq/ppaTfnZzgo57U' , String crlf ,
'  mZO0enGudGvGi4XVm5Xhp6PnranqsK7rsa/nrKzfpKTbo6LYoqLPn53Al5W3lJCmiIV9ZWFBMCsd' , String crlf ,
'  FRIcGRUbGB4oJCc2MjE5MS5JOjVlTUiCZV+ObWZpS0NNMCpELSVQODNkSER3VVORZGaPYWN6UU95' , String crlf ,
'  TUy9io76w8j/zNL/xs36vsL8vsH3tLfsqqvlpaPjpqPkqaPQlpCtcmybXlmoZmPBgX3Ym5jeo5/d' , String crlf ,
'  pqPiq6jhqajdpabYoqLRnZ/ImJi5j5Cti4qUeHViTUouIB0kHxwsKikZFhwcGh0pJygsJyQ0KSVO' , String crlf ,
'  OzVoT0pwU01iRT9OMyxBKSFHLilVNzRfOzt6TVB4SkxzTUpoQj95TEvOmpz0uL/xs7jvrLPxrrPu' , String crlf ,
'  q67np6ffoqHdop7Umpa+h4Ctc2+hZmCVVVGjY1+7fnvLkY3TnJnUoJ7RnZ3Snp7MmpvDk5O5jI6r' , String crlf ,
'  hIScfXuBaGZOPDonHBs1MTJCQkQZGB4dHCElIyYnIyQpHx42KCVPPDZgSENbQztRNi1UNy9rSkV0' , String crlf ,
'  TUprPT9yP0NwP0JqR0NXOTFMKSODV1S+honOjZHTjJLfmJzenZ/NkpC7gX+pcm+qcG6veHOyfXmr' , String crlf ,
'  dnCbYV2NU0+bYVuzfHe9iITAjovCkpC6jYy1iYipgn+feXaTdHGMcG1nUk8xISErICJKR01XWF0W' , String crlf ,
'  FxwYGR4eHSIiHiEkGxwtIiBAMSxOOzRWPjZdQDhwTUeNZGChcXGOWlx3PkR9SUtsRUJTNS1HJh9Q' , String crlf ,
'  KSRvPTyOU1WeXV+pa2ybZWN7S0dkNDBuPzmQXFqodXGwgHymd3GWZWCFVE+CT0mTYFqicWqneHKl' , String crlf ,
'  eXageXSUbmmKaWR+YFqBZWF4Y15KOjgiGBc4NDdeXWNoa3IQExoVFhscGyAfHSAhGx0rISBBMS9V' , String crlf ,
'  QDtbPztoR0KDXFekd3S8iIi6f4OUVV2CR0uNXV10TUhpQz5hOzZZMCxSJiNSJiNOJyI+IBg8HxdA' , String crlf ,
'  IhpbODCCVlOYa2ahdHGRZWJ7VE90TUZySkJ8UUiIXVSQZVyMZl2FX1h1UkprTUVvVE15ZF9ZSUcq' , String crlf ,
'  IiAkIiVQUVZtcHdzeH4VGB8VFhsVFhocGh0lHyExJyZCNDFUPzpeQj50UU2VaWa0goHEjI3Pk5W+' , String crlf ,
'  fYOXWV6CR0mPXVySZmN8VVBuR0JaNC9LKCI9IBg4IRk7JxxDLCRUNy9wSkeAWVR8VlNjQDxSNC5X' , String crlf ,
'  OTFsSUFzUUd2UUZ/Wk95V01mSD5eQTdjS0FsV1FjUk08MjE8OjtVWF9udX2Gi5GJjpQeHyQaGyAZ' , String crlf ,
'  Gh4dHR8lISIuJiQ+MC1PPDZeQD19V1Sfcm+5hYPLkJLWmJvYl52/fIOfWF6MS0+VX1+OXlyHW1p6' , String crlf ,
'  U1BiPztPMStDKiU/KCBFLCdJLCZVMzFZOzVPMy8/JiE6Ih1BKiJlSkFzV0t0V0t2Wk5qUENdRTli' , String crlf ,
'  S0FmVEpfUElMQT1IQkJkZWltdH5xeoOJjZaTlp0iIygiIygfICQeHiAeHB0kHxw2KydLOjNdQT14' , String crlf ,
'  VVGbb2ywfHrDi4zTl5nbnaLVkpnJfISuY2qSUVWCR0mOWFqJV1h1REdmPD1aNjVLKSdHJSNCIB5I' , String crlf ,
'  JiRKLCk9JB8wGxUqFxAzHxZYQTdvWExvV0tlTkJaRjteTkNfUEhOQTk6MCktJSIuKi01Njs4P0lL' , String crlf ,
'  VF1scHmGiZAuLTMrKjAlJioiJCUkJCQnJiIzKyhCMy5XPjp0U06cc2+vf32zf32+hoXHj5DPkZTU' , String crlf ,
'  h4/Ofoe5bnekW2ScU1yNRE2DO0Z2ND1pMDZeKy9dLzFZLzBdNTVZNzVIKic0HBctGRA1IRZVQTZq' , String crlf ,
'  VktdS0FKOTFIOzNNQz8+NjMoIB0aEhAYEhIZFRgUExkSFB4WGiMlKjBGS1EgHyUiISYhIiYhIyQi' , String crlf ,
'  JCMiIx4pJCA3KiROOTRxVE6Zcm+zhoOygH2rd3Wtd3e5foDEfYPCd37Ge4S/dH2+bnm8bHeyYW+l' , String crlf ,
'  WWWXU12MT1aJUleIV1qGWVt1Tk5aOzg/Jx83IBg7JxxUQDVgTkRBMisrIRoxKSYoJCMaGBkWFBUY' , String crlf ,
'  FBUaFhcaFhkWExkZGiESFRwUGR8wOD0RDhQREBUPEBQPERIcHh0eHxojHhozKCRNOjRrUEmRa2ix' , String crlf ,
'  hYK4iISufHmfa2mcZmaeYmSlZ2yvcXazcHe7dHy8c3y8cXq5cHmua3Kna2+kbG+da2yPY2KAWldl' , String crlf ,
'  R0FILSY+Jx9LNy5TQTdBMismGxcaEhAVExQTFBgXGBwYFxwaGBscGBkcGBsZFxoZFhwXGB0aHSQ6' , String crlf ,
'  P0UMCQ8NCw4MDA4LDQwUFhMdHhkmIR40KSVKNzFrT0uLaGSthIC+joy5hYOqdnSaZGSHUVOEUFKM' , String crlf ,
'  VliQWlyZXmKlZ2yxcHaycXevcXarcHSjbW+ZZ2iOZWN+W1dgRT5ELSU/LCVGNS08LSYpHBYZEQ4P' , String crlf ,
'  CwoNDhIVGB0XGh8XGh4bGx0bGRwbGRobGRwaFx0ZGB4fIik/REoRDxIQDg8ODg4MDAwPDw0aGRUj' , String crlf ,
'  HhssIR1NOjZtUU2EYV2nfnq8jIq9iYm6goOlb2+SYGF7TU9vQ0J1SUh3S0iBUU+OXFuVX1+TXV2W' , String crlf ,
'  YGCUYmOUZ2aPaGhzV1NOOzQ5LCM2LCUzKCQiGBQUDAkPCgcLCQoLDxAWGx4XHB8YGx8aHB0aGhoa' , String crlf ,
'  GhoaGhwYGR0YGR4ZGiEoKzIZFxgZFxgVExQSEhIRDw4XFhIbFhMkGRVDMi1fRkJ5V1WgeXa2hoS2' , String crlf ,
'  goKzfX2ha2uOYGJ4Tk9vRkR8VVJ9VFB6Tkt6TUp8TEqIVlWUYmGYa2qUbGyCY2BeSUQ9MCgvKCAk' , String crlf ,
'  HxsZFBESDQoOCwcJBwYNDQ0TFxgVGh0XHB8XGxwZGxoYGhkaGhoZGxwXGh8WGR4WGR4YGR4cGBcf' , String crlf ,
'  GxocGBcYFhUYFBMZFhIZFBEkGhZGNzJXPztrTUqLaGSfc3CoeHaseHindXSPYmSDWVp+UlGGWViL' , String crlf ,
'  W1mPXVyTX12aZmSfbWymeXaheneGZGJiSUVFNC8wJSElHRoUEw8ICAYJBwYLCQgGBgQQEBAZHR4X' , String crlf ,
'  GxwZHR4YHB0ZGxoaGhoaHBsbHR4XHCAWGx8VGB0RFBgdGRggHBsgHBseGhkcGBcaFRIZFBAoHho2' , String crlf ,
'  KCVHNC5gR0J5W1WHYV6Ua2efb22gc3CFXlt+V1SBVVSKXVqVY2KdaWmkcG6xf3ywg4Cke3mMamho' , String crlf ,
'  T0tFNC8yJCElGxkYExAMDAoHCQgICAYJCQcKCgoTExMbHR4YHB0ZHR4aHB0aGhoaGhocHB4ZHCAX' , String crlf ,
'  HCAWGx8UFxsUFxsjHhsgGxghHBkgGxgeGRYbFhMbFhIiGhUnHRk2KSFPPDVlTkZxU01/XFiJYFyM' , String crlf ,
'  ZWB2U09rSkV5U1CHXlqUZ2Scb2qjdnGyhoGkfXiKZ2NpTUlMOTU0KSUlHRsYFBMPDQwICAgICgkJ' , String crlf ,
'  CQcLCQgREREYGBgaHB0ZGh4bHCAZGxwZGRkaGhobGx0aGx8WGR4TGBwVFhoWGBkkHh4bFxYdGhYd' , String crlf ,
'  GhYfGhceGRYdGBUaFREiGhUmHRY3KiJOPTVbQz5pTEZtT0lsTkhhQ0BbPTpwUkx6V1N/WFOFXlmL' , String crlf ,
'  ZF+Sb2mDYl1sUExLODIwJSEhGRcXExIQDg8NDQ0ICAgGBgYICAgMDAwTExMZGxwcHSEYGR0bHCAZ' , String crlf ,
'  Gh4ZGRsZGRkaGhwZGh4UFxwSFRoUFRkXFxkfGx4WFBUWFBMbGhYcGRUbFhMdFRMZFBEZFhIdGBQo' , String crlf ,
'  IBs6MClGNS5HNC5OOTRPNzNGMSxKMi5dREBjR0NlR0FtT0loSkdhSERYQDtHNi8wJiQgGxgVERAN' , String crlf ,
'  CwoJCQkJCQkIBgUIBgcLCwsTFRYWGhsXGh4aGx8ZGh4ZGh4WFxsYGhsZGxwYGR0UFxsSExcTFBgW' , String crlf ,
'  GBkUFhceGyEVExYSEhIXFhIZFhIZFBAcExQYEhIXFBAWFRAcFxMoIRkuIRsvIBk4JyI5KCM7KCQ8' , String crlf ,
'  KSVONjRSOTVXOzdeQj5QODRFMi48KSMuIRsdGBUSEA8ODAsMCgkKCgoKCgoNCQgMCgkPDxEVGRoY' , String crlf ,
'  Gx8WGx4ZGh4XGBwYGR0WFxsWGhsXGxwWGR0UFxsTFBgTFBgVFxgTFRYADAEAAAMAAAABADIAAAEB' , String crlf ,
'  AAMAAAABADIAAAECAAMAAAADAAAd6gEDAAMAAAABAAEAAAEGAAMAAAABAAIAAAERAAQAAAABAAAA' , String crlf ,
'  CAESAAMAAAABAAEAAAEVAAMAAAABAAMAAAEXAAQAAAABAAAdTAEcAAMAAAABAAEAAAFTAAMAAAAD' , String crlf ,
'  AAAd8IdzAAcAAA3oAAAd9gAAAAAACAAIAAgAAQABAAEAAA3oYXBwbAIAAABtbnRyUkdCIFhZWiAH' , String crlf ,
'  1QAGAAcADwAGADBhY3NwQVBQTAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA9tYAAQAAAADTLWFw' , String crlf ,
'  cGw+yfSajeQseR3F2zzMGI+PAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA5yWFlaAAAB' , String crlf ,
'  LAAAABRnWFlaAAABQAAAABRiWFlaAAABVAAAABR3dHB0AAABaAAAABRjaGFkAAABfAAAACxyVFJD' , String crlf ,
'  AAABqAAAAA5nVFJDAAABuAAAAA5iVFJDAAAByAAAAA52Y2d0AAAB2AAAAxJuZGluAAAE7AAABj5k' , String crlf ,
'  ZXNjAAALLAAAAGRkc2NtAAALkAAAAf5tbW9kAAANkAAAAChjcHJ0AAANuAAAAC1YWVogAAAAAAAA' , String crlf ,
'  ZC4AADctAAADGVhZWiAAAAAAAABrfwAAsIgAAB8SWFlaIAAAAAAAACcoAAAYZgAAsPlYWVogAAAA' , String crlf ,
'  AAAA81IAAQAAAAEWz3NmMzIAAAAAAAEMQgAABd7///MmAAAHkgAA/ZH///ui///9owAAA9wAAMBs' , String crlf ,
'  Y3VydgAAAAAAAAABAc0AAGN1cnYAAAAAAAAAAQHNAABjdXJ2AAAAAAAAAAEBzQAAdmNndAAAAAAA' , String crlf ,
'  AAAAAAMBAAABAAYJDA8RExUXGBocHR8gISMkJScoKSorLC0uLzAxMjMzNDU3ODg5Ojs9Pj9AQUJC' , String crlf ,
'  Q0RERUZHR0hJSktLTE1OT1BQUVJTU1RVVldXWFlaW1tcXF1eX2BhYmJjZGVmZ2hoaWprbG1ub3Bx' , String crlf ,
'  cnN0dXZ3eHl7fH1+f4CCgoOEhYaGh4iJioqLjI2Ojo+QkJGSk5OUlZaXl5iZmpqbnJ2dnp+goKGi' , String crlf ,
'  o6Skpaamp6ipqqqrrK2urq+wsbGys7S0tba3uLm5uru8vb6+v8DBwsPExcXGx8jJysvMzc3Oz9DR' , String crlf ,
'  0tPU1dbX2Nna2tvc3d7e3+Di4uPk5ebn6Onq6+3u8PHz9ff6/wAFCAsNDxETFRYYGRscHh8hIiMk' , String crlf ,
'  JicoKSorLC0uLzAxMTIzNTY2Nzk6Ozw9Pj9AQEFCQ0RERUZHSElKSktMTU5OT1BRUVJTVFVVVldY' , String crlf ,
'  WVlaW1tcXV1eX2BhYWJjZGVmZ2hpaWprbG1ub3BxcnN0dXZ3eHl6fH1+gIGCg4OEhYaHh4iJiouL' , String crlf ,
'  jI2Oj4+QkZKSk5SVlpeXmJmZmpucnZ2en5+goaKjpKSlpqanqKmqqqusra6ur7CxsrKztLW2t7e4' , String crlf ,
'  ubq7vLy9vr/AwcLDxMTFxsfIycrLy8zNzs/Q0dPT1NXW19jZ2tvb3N3e3+Dh4uPk5ebn6Onq6+3u' , String crlf ,
'  7/Hy9Pb4+v8ABgkMDhARExQWFxgaGxwdHh8gISIjJCUlJiYnKCkpKiorLC4vLzAxMjM0NTY3ODg5' , String crlf ,
'  Ojs8PD0+P0BBQkJDQ0RFRkdHSElJSktLTE1OTk9QUFFRUlNTVFVWV1hYWVlaW1tcXV5eX2BhYmJj' , String crlf ,
'  ZGVlZmdoaWlqa2xtbnBxcnN0dXZ3eHl6e3x9fn+AgYKDhISFhoeIiYqLi4yNjo6PkJGSkpOUlZWW' , String crlf ,
'  l5iZmpqbnJ2enp+goaKjo6SlpqenqKmqq6ytra6vsLGysrO0tra3uLm6u7y9vr/AwcLDxMXGx8jJ' , String crlf ,
'  ysvMzc7P0NLT1dXW19jZ2tzd3t/g4eLk5efp6uzu8PL09/r/AABuZGluAAAAAAAABjYAAJ++AABZ' , String crlf ,
'  FgAAUakAAI6XAAAnjQAAFqgAAFANAABUOQAB1woAAdHrAAGMzAADAQAAAgAAAAAAAAABAAEAAgAD' , String crlf ,
'  AAUACAALAA4AEgAWABsAIAAlAC4ANwBCAE0AWQBlAHMAgQCfALAAwQDSAOUBCwEgATUBYQGQAagB' , String crlf ,
'  wQH1AisCRwJkAp8C3AMcA18DgQPqBDQEfwTNBR0FcAXEBnQGzwb+By0HjAhSCLgJIAlUCYoJ9gpk' , String crlf ,
'  CtULRwu8DKsNJg4hDqEPJBAvELgRQxHPEu4TgBQVFKsVQxZ5FxcXthj8GaEaSBrxHEkc+B2oHlsf' , String crlf ,
'  xSE3IfIisCNvJDAk8yZ+J0YoECjcKakqeSwcLPEtxy6gL3kwVTEzMhIy8zPVNLk1oDaHN3E4XDlJ' , String crlf ,
'  Ojg6sDsoPBo9Dj4DPvs/9EBxQO5C6EPoROlF7Ef3SP9KCUsUTTBOQE9SUGZSklOrVeFW/1geWmFb' , String crlf ,
'  hVyrXdJgJWFSYn9k4GYSZ0dptGrtbChuom/hcSJyZXTvdjZ4yXoVe2N8sn9VgKmB/4NWhgmHZYjC' , String crlf ,
'  i4GM445HkRKSe5PklVCWvJmbmwycf530n2qiWqMXpVGmz6hOqc6rUa5ar+CxabLytH62C7eZuSm8' , String crlf ,
'  Tb3hv3fBDsHaxEHF3cd7yRnKusxbzf/Po9Lx1JvWRdfx207c/93Y3rHiGePQ5YjnQej86rnsdu42' , String crlf ,
'  7/fw1/G583z0X/VC9wj37PjQ+bX6mvt//GX8/v2X/jH+jf7q/0b/o///AAAAAAABAAEAAgADAAUA' , String crlf ,
'  CAALAA4AEgAWAB0AJQAuADcAQgBNAFkAZQBzAIEAnwCwAMEA5QD4AQsBNQFLAWEBkAGoAcEB9QIr' , String crlf ,
'  AmQCgQKfAtwDHANfA4ED6gQ0BH8EzQUdBXAFxAZ0Bs8G/gctB4wIUgiECLgJIAmKCfYKZArVC0cL' , String crlf ,
'  vAyrDSYNog4hDyQPqRAvELgRQxHPEu4TgBQVFKsV3RZ5FxcYWBj8GaEaSBucHEkc+B2oHw8fxSE3' , String crlf ,
'  IfIjbyQwJPMltydGKBAo3CmpKnkrSiwcLPEuoC95MFUxMzISMvMz1TS5NaA2hzdxOFw5STo4Oyg8' , String crlf ,
'  Gj0OPYg+Az77P/RAcUDuQepC6EPoRexG8Uf3SP9LFEwhTTBOQFBmUXtSklOrVeFW/1geWmFbhVyr' , String crlf ,
'  XdJe+2FSYn9k4GYSZ0dofGrtbChuom/hcSJyZXOpdjZ3f3oVe2N8sn4DgKmB/4NWhK+HZYjCiiGL' , String crlf ,
'  gY5Hj6yREpJ7k+SWvJgrmZubDJx/n2qg4aJao9WlUabPqE6pzqzUrlqv4LFpsvK0frYLuSm6urxN' , String crlf ,
'  veG/d8EOwdrCp8Xdx3vJGcq6zFvN/8+j0UrUm9ZF1/HZn9tO3P/eseBk4hnj0OWI50Ho/Oq57Hbu' , String crlf ,
'  Nu8W7/fxufN89F/1QvcI9+z40Pm1+pr7f/xl/Uv+Mf6N/ur/Rv+j//8AAAAAAAAAAQABAAIAAwAF' , String crlf ,
'  AAgACwAOABIAFgAdACUALgA3AE0AWQBlAIEAkACfAMEA5QD4AQsBNQFhAZABwQH1AisCZAKfAtwD' , String crlf ,
'  HANfA+oEfwTNBR0FxAZ0Bs8G/gctB4wIUgi4CSAJign2CmQK1QtHC7wMqw0mDaIOIQ8kD6kQLxC4' , String crlf ,
'  EUMRzxLuFBUUqxVDFd0XFxe2GPwZoRrxG5wcSR2oHlsfxSE3IfIjbyQwJPMltyZ+KBApqSp5LBws' , String crlf ,
'  8S3HL3kwVTEzMhIz1TS5NaA3cThcOUk6ODwaPQ4+Az77P/RAcUDuQepC6EPoROlF7EbxR/dI/0oJ' , String crlf ,
'  SxRMIU0wTkBPUlBmUXtSklOrVMVV4VgeWT9aYVuFXKtd0l77YVJif2OvZhJnR2h8abRsKG1kbqJx' , String crlf ,
'  InHDc6l073Y2eMl6FXtjfLJ/VYCpgf+DVoSvh2WIwoohi4GOR4+skRKSe5PklVCYK5mbmwycf530' , String crlf ,
'  oOGiWqMXo9Wmz6hOqc6rUazUrlqv4LFpsvK0frYLt5m5Kbq6vE294b93wQ7Cp8RBxd3He8kZyrrM' , String crlf ,
'  W83/ztHPo9FK0h3S8dZF1/HZn9tO3P/d2N6x4GTiGePQ5YjnQej86drquex27VbuNu8W7/fxufKa' , String crlf ,
'  83z0X/VC9iX3CPfs+ND5tfqa+zP7zPxl/P79l/4x/o3+6v9G/6P//wAAZGVzYwAAAAAAAAAKQ29s' , String crlf ,
'  b3IgTENEAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA' , String crlf ,
'  AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAG1sdWMAAAAAAAAADwAAAAxpdElUAAAAFAAAAMRm' , String crlf ,
'  ckZSAAAAQgAAANhuYk5PAAAAEgAAARplc0VTAAAAEgAAASxmaUZJAAAAEAAAAT5wdFBUAAAAGAAA' , String crlf ,
'  AU56aFRXAAAADgAAAWZqYUpQAAAADgAAAXRubE5MAAAAFgAAAYJkZURFAAAAEAAAAZhrb0tSAAAA' , String crlf ,
'  DAAAAahlblVTAAAAEgAAAbRzdlNFAAAAEAAAAcZkYURLAAAAHAAAAdZ6aENOAAAADAAAAfIATABD' , String crlf ,
'  AEQAIABjAG8AbABvAHIAaQDJAGMAcgBhAG4AIADgACAAYwByAGkAcwB0AGEAdQB4ACAAbABpAHEA' , String crlf ,
'  dQBpAGQAZQBzACAAYwBvAHUAbABlAHUAcgBGAGEAcgBnAGUALQBMAEMARABMAEMARAAgAGMAbwBs' , String crlf ,
'  AG8AcgBWAOQAcgBpAC0ATABDAEQATABDAEQAIABjAG8AbABvAHIAaQBkAG9faYJybbJmdphveTpW' , String crlf ,
'  aDCrMOkw/AAgAEwAQwBEAEsAbABlAHUAcgBlAG4ALQBMAEMARABGAGEAcgBiAC0ATABDAETO7Lfs' , String crlf ,
'  ACAATABDAEQAQwBvAGwAbwByACAATABDAEQARgDkAHIAZwAtAEwAQwBEAEwAQwBEAC0AZgBhAHIA' , String crlf ,
'  dgBlAHMAawDmAHIAbV9pgnIAIABMAEMARAAAbW1vZAAAAAAAAAYQAACcNQAAAAC6N+AAAAAAAAAA' , String crlf ,
'  AAAAAAAAAAAAAHRleHQAAAAAQ29weXJpZ2h0IEFwcGxlIENvbXB1dGVyLCBJbmMuLCAyMDA1AAAA' , String crlf ,
'  AA==' , String crlf ,
'X-ABUID:F0A8286E-0B5C-11D8-8904-000A95DB7844\:ABPerson' , String crlf ,
'END:VCARD' , String crlf! !

!ICVCardTest methodsFor: 'accessing-exporting' stamp: 'pmm 12/11/2005 13:55'!
aviCardStringExport
^
'BEGIN:VCARD' , String crlf ,
'VERSION:3.0' , String crlf ,
'N:Bryant;Avi;;;' , String crlf ,
'FN:Avi Bryant' , String crlf ,
'ADR;TYPE=home;TYPE=pref:;;xxx E. xx Ave;Vancouver;BC;V5V 1E3;Canada' , String crlf ,
'TEL;TYPE=home;TYPE=pref:(778) xxx-xxxx' , String crlf ,
'EMAIL;TYPE=pref;TYPE=internet;TYPE=work:avi@smallthought.com' , String crlf ,
'EMAIL;TYPE=internet;TYPE=home:avi.bryant@gmail.com' , String crlf ,
'X-AIM;TYPE=pref:avbry' , String crlf ,
'X-MSN;TYPE=pref:avi666@hotmail.com' , String crlf ,
'END:VCARD' , String crlf! !

!ICVCardTest methodsFor: 'accessing-parsing' stamp: 'pmm 11/14/2005 18:28'!
donaldCardString
^'begin:vcard
fn:Donald Major
n:Major;Donald
org:SAS Institute Inc.;ERV
adr:100 SAS Campus Drive;;R2424;Cary;NC;27513;United States of America
email;internet:Donald.Major@sas.com
title:Systems Developer
tel;work:677-8000 x16937
url:http://www.sas.com
version:2.1
end:vcard' , String crlf! !

!ICVCardTest methodsFor: 'accessing-parsing' stamp: 'pmm 11/14/2005 00:27'!
ericCardString
^
'BEGIN:VCARD' , String crlf ,
'VERSION:3.0' , String crlf ,
'N:Wahlforss;Eric;;;' , String crlf ,
'FN:Eric Wahlforss' , String crlf ,
'TITLE:Entrepreneur / Musician' , String crlf ,
'EMAIL;type=INTERNET;type=WORK;type=pref:eric at wahlforss.com' , String crlf ,
'item1.EMAIL;type=INTERNET:eric at forss.to' , String crlf ,
'item1.X-ABLabel:_$!!<Other>!!$_' , String crlf ,
'TEL;type=CELL;type=pref:+46703639900' , String crlf ,
'item2.TEL:+491793126620' , String crlf ,
'item2.X-ABLabel:_$!!<Other>!!$_' , String crlf ,
'item3.ADR;type=HOME;type=pref:;;Tavastgatan 6;Stockholm;;11820;Sweden' , String crlf ,
'item3.X-ABADR:se' , String crlf ,
'URL:http://eric.wahlforss.com/' , String crlf ,
'X-AIM;type=HOME;type=pref:ericwahlforss' , String crlf ,
'X-MSN;type=HOME:ericwahlforss@hotmail.com' , String crlf ,
'X-ICQ;type=WORK;type=pref:5399905' , String crlf ,
'CATEGORY:24HDC' , String crlf ,
'END:VCARD' , String crlf! !

!ICVCardTest methodsFor: 'accessing-parsing' stamp: 'pmm 1/2/2006 12:54'!
goofyCardString
^'BEGIN:VCARD' , String crlf ,
'VERSION:2.1' , String crlf ,
'FN;CHARSET=ISO-8859-1:Markus Tschannen' , String crlf ,
'N;CHARSET=ISO-8859-1:Tschannen;Markus;;;'  , String crlf ,
'ADR;TYPE=HOME;CHARSET=ISO-8859-1:;;Neufeldstrasse 11;Bern;;3012;Schweiz' , String crlf ,
'TEL;TYPE=VOICE,HOME;CHARSET=ISO-8859-1:+41 31 302 08 56' , String crlf ,
'TEL;TYPE=CELL,HOME;CHARSET=ISO-8859-1:+41 78 845 24 12' , String crlf ,
'BDAY:1980-10-30' , String crlf ,
'END:VCARD' , String crlf! !

!ICVCardTest methodsFor: 'accessing-exporting' stamp: 'pmm 1/2/2006 12:59'!
goofyCardStringExport
^'BEGIN:VCARD' , String crlf ,
'VERSION:2.1' , String crlf ,
'N:Tschannen;Markus;;;'  , String crlf ,
'FN:Markus Tschannen' , String crlf ,
'BDAY:1980-10-30' , String crlf ,
'ADR;TYPE=home:;;Neufeldstrasse 11;Bern;;3012;Schweiz' , String crlf ,
'TEL;TYPE=home;TYPE=voice:+41 31 302 08 56' , String crlf ,
'TEL;TYPE=cell;TYPE=home:+41 78 845 24 12' , String crlf ,
'END:VCARD' , String crlf! !

!ICVCardTest methodsFor: 'accessing-parsing' stamp: 'pmm 11/4/2005 23:24'!
josephCardString
^
'begin:vcard' , String crlf ,
'n:THOMAS;JOSEPH' , String crlf ,
'tel;home:3790977' , String crlf ,
'tel;work:2349961,2349972,2349986 EXT:7089' , String crlf ,
'x-mozilla-html:FALSE' , String crlf ,
'url:www.alcatel.com' , String crlf ,
'org:ADCC;VI-32' , String crlf ,
'version:2.1' , String crlf ,
'email;internet:Thomas.Joseph@adcc.alcatel.be' , String crlf ,
'title:SOFTWARE ENGINEER' , String crlf ,
'adr;quoted-printable:;;94/95,Thiru-Vi-Ka Industrial Estate,=0D=0AGuindy,=0D=0A;Chennai;Tamil Nadu;600032;India' , String crlf ,
'note;quoted-printable:=0D=0A=0D=0A=0D=0A=0D=0A=0D=0AMake Life a Meaningful Journey.......=0D=0A=0D=0A' , String crlf ,
'fn:JOSEPH' , String crlf ,
'end:vcard' , String crlf! !

!ICVCardTest methodsFor: 'accessing-parsing' stamp: 'pmm 12/2/2005 20:18'!
maeveCardString
^
'BEGIN:VCARD' , String crlf ,
'VERSION:3.0' , String crlf ,
'N:Price;Maeve;;;' , String crlf ,
'FN:Maeve Price' , String crlf ,
'TITLE:Digital Editor' , String crlf ,
'EMAIL;type=INTERNET;type=WORK;type=pref:maeve@zenediting.com' , String crlf ,
'EMAIL;type=INTERNET;type=WORK:maeve.price@myoasis.colum.edu' , String crlf ,
'EMAIL;type=INTERNET;type=HOME:mahaevey@aol.com' , String crlf ,
'TEL;type=CELL;type=pref:312-505-9563' , String crlf ,
'item1.ADR;type=HOME;type=pref:;;1636 W. Pierce Ave #1;Chicago;IL;60622;USA' , String crlf ,
'item1.X-ABADR:us' , String crlf ,
'item2.URL;type=pref:http\://www.zenediting.com' , String crlf ,
'item2.X-ABLabel:_$!!<HomePage>!!$_' , String crlf ,
'item3.URL:http\://www.myspace.com/maeveprice' , String crlf ,
'item3.X-ABLabel:my space' , String crlf ,
'BDAY;value=date:2005-06-14' , String crlf ,
'X-AIM;type=HOME;type=pref:Mahaevey' , String crlf ,
'X-MSN;type=HOME;type=pref:dgu186@hotmail.com' , String crlf ,
'CATEGORIES:Friends,Columbia College Chicago,Family' , String crlf ,
'X-ABUID:032C4F53-35BA-490E-8C25-5DBA59230358\:ABPerson' , String crlf ,
'END:VCARD' , String crlf! !

!ICVCardTest methodsFor: 'accessing-parsing' stamp: 'pmm 10/29/2005 21:53'!
oscarCardString
^'BEGIN:VCARD' , String crlf ,
'VERSION:3.0' , String crlf ,
'N:Nierstrasz;Oscar;;;' , String crlf ,
'FN:Oscar2 Nierstrasz' , String crlf ,
'ORG:University of Bern;' , String crlf ,
'TITLE:Professor' , String crlf ,
'EMAIL;type=INTERNET;type=WORK;type=pref:oscar.nierstrasz@acm.org' , String crlf ,
'TEL;type=WORK;type=pref:+41 31 631.4618' , String crlf ,
'TEL;type=HOME:+41 31 961.7065' , String crlf ,
'TEL;type=WORK;type=FAX:+41 31 631.3355' , String crlf ,
'item1.ADR;type=WORK;type=pref:;;Software Composition Group\nIAM\, University of Bern\nNeubrueckstrasse 10;Bern;;CH-3012;SWITZERLAND' , String crlf ,
'item1.X-ABADR:us' , String crlf ,
'item2.ADR;type=HOME:;;Fluhmattweg 41;Kehrsatz;;3122;SWITZERLAND' , String crlf ,
'item2.X-ABADR:us' , String crlf ,
'item3.ADR;type=HOME:;;Schuetzenmattstrasse 14\, room 103;;;;' , String crlf ,
'item3.X-ABLabel:express' , String crlf ,
'item3.X-ABADR:us' , String crlf ,
'URL:http://www.iam.unibe.ch/~oscar/' , String crlf ,
'END:VCARD' , String crlf! !

!ICVCardTest methodsFor: 'accessing-parsing' stamp: 'pmm 10/31/2005 22:19'!
seanCardString
^
'BEGIN:VCARD' , String crlf ,
'VERSION:2.1' , String crlf ,
'X-PLAXO-VERSION:1.0' , String crlf ,
'N:Glazier;Sean;;;' , String crlf ,
'FN:Sean Glazier' , String crlf ,
'ORG:Cincom Systems' , String crlf ,
'TITLE:Lead Software Engineer' , String crlf ,
'ADR;WORK;ENCODING=QUOTED-PRINTABLE:;;6 Christie Lane;Stratham;NH;03885;USA' , String crlf ,
'TEL;WORK;VOICE:603 772 4480' , String crlf ,
'TEL;CELL;VOICE:603 770 8260' , String crlf ,
'EMAIL;PREF;INTERNET;WORK:sglazier@comcast.net' , String crlf ,
'X-AIM;WORK:Visualwave' , String crlf ,
'ADR;HOME;ENCODING=QUOTED-PRINTABLE:;;6 Christie Lane;Stratham;NH;03885;USA' , String crlf ,
'TEL;HOME;VOICE:603 772 2852' , String crlf ,
'TEL;CELL;VOICE:603 770 8260' , String crlf ,
'EMAIL;INTERNET;HOME:sglazier@comcast.net' , String crlf ,
'X-AIM;HOME:Visualwave' , String crlf ,
'BDAY:2005-10-01' , String crlf ,
'END:VCARD' , String crlf! !

!ICVCardTest methodsFor: 'accessing-parsing' stamp: 'pmm 11/14/2005 00:22'!
surendarCardString
^
'BEGIN:VCARD' , String crlf ,
'VERSION:3.0' , String crlf,
'N:Chandra;Surendar;;;' , String crlf,
'FN:Surendar Chandra' , String crlf,
'ORG:Univ. of Notre Dame;Computer Science and Engg' , String crlf,
'TITLE:Asst. Professor' , String crlf,
'EMAIL;type=INTERNET;type=WORK:surendar@nd.edu' , String crlf,
'item1.EMAIL;type=INTERNET;type=pref:surendar@acm.org' , String crlf,
'item1.X-ABLabel:_$!!<Other>!!$_' , String crlf,
'item2.EMAIL;type=INTERNET:surendar@cs.duke.edu' , String crlf,
'item2.X-ABLabel:_$!!<Other>!!$_' , String crlf,
'TEL;type=WORK:5746318975' , String crlf,
'TEL;type=HOME;type=pref:5742773801' , String crlf,
'TEL;type=CELL:5743869632' , String crlf,
'TEL;type=WORK;type=FAX:5746319260' , String crlf,
'item3.TEL:(574) 631-5772' , String crlf,
'item3.X-ABLabel:lab' , String crlf,
'item4.TEL:(574) 386-1404' , String crlf,
'item4.X-ABLabel:norma''s cell' , String crlf,
'item5.ADR;type=WORK:;;384 Fitzpatrick Hall;Notre Dame;IN;46556;USA' , String crlf,
'item5.X-ABADR:us' , String crlf,
'item6.ADR;type=HOME;type=pref:;;14840 Cranford Ct;Granger;IN;46530;USA' , String crlf,
'item6.X-ABADR:us' , String crlf,
'NOTE:SMS message\n12/22/2003 18:12\nwassup\n\nSMS message\n12/23/2003 13:12\nHello' , String crlf,
'URL:http://www.cse.nd.edu/~surendar/' , String crlf,
'BDAY;value=date:1967-02-24' , String crlf,
'X-AIM;type=HOME;type=pref:surendar' , String crlf,
'X-MSN;type=HOME;type=pref:surendar' , String crlf,
'X-YAHOO;type=WORK;type=pref:surendarcsdukeedu' , String crlf,
'PHOTO;BASE64:' , String crlf,
'  /9j/4AAQSkZJRgABAQAAAQABAAD/2wBDAAEBAQEBAQEBAQEBAQEBAQEBAQEBAQEBAQEBAQEBAQEB' , String crlf,
'  AQEBAQEBAQEBAQEBAQEBAQEBAQEBAQEBAQEBAQEBAQH/2wBDAQEBAQEBAQEBAQEBAQEBAQEBAQEB' , String crlf,
'  AQEBAQEBAQEBAQEBAQEBAQEBAQEBAQEBAQEBAQEBAQEBAQEBAQEBAQEBAQH/wAARCAA8ADwDASIA' , String crlf,
'  AhEBAxEB/8QAHwAAAQUBAQEBAQEAAAAAAAAAAAECAwQFBgcICQoL/8QAtRAAAgEDAwIEAwUFBAQA' , String crlf,
'  AAF9AQIDAAQRBRIhMUEGE1FhByJxFDKBkaEII0KxwRVS0fAkM2JyggkKFhcYGRolJicoKSo0NTY3' , String crlf,
'  ODk6Q0RFRkdISUpTVFVWV1hZWmNkZWZnaGlqc3R1dnd4eXqDhIWGh4iJipKTlJWWl5iZmqKjpKWm' , String crlf,
'  p6ipqrKztLW2t7i5usLDxMXGx8jJytLT1NXW19jZ2uHi4+Tl5ufo6erx8vP09fb3+Pn6/8QAHwEA' , String crlf,
'  AwEBAQEBAQEBAQAAAAAAAAECAwQFBgcICQoL/8QAtREAAgECBAQDBAcFBAQAAQJ3AAECAxEEBSEx' , String crlf,
'  BhJBUQdhcRMiMoEIFEKRobHBCSMzUvAVYnLRChYkNOEl8RcYGRomJygpKjU2Nzg5OkNERUZHSElK' , String crlf,
'  U1RVVldYWVpjZGVmZ2hpanN0dXZ3eHl6goOEhYaHiImKkpOUlZaXmJmaoqOkpaanqKmqsrO0tba3' , String crlf,
'  uLm6wsPExcbHyMnK0tPU1dbX2Nna4uPk5ebn6Onq8vP09fb3+Pn6/9oADAMBAAIRAxEAPwD+/ivN' , String crlf,
'  Pij8QfAPwd+H3jn4s/FDxJpvhH4efDzw5rvjPxn4l1YyyWOj6BoWnXF/ql9LDFDc3V20NjaOIdNs' , String crlf,
'  YJ72+uFhtbG3ubyS1hr0uv5CP+Dxj9oL4p/Cj9gz4MfCrwJqM+jeEPj98cJdI+Kd7Z3rW1zq3h/w' , String crlf,
'  LoSeKNH8J3USNGbnRtW8QNZavqAeRES48M6cs2+DcspeUbuLs7aC5VJpNX1/U/Lr/goz/wAHXXxs' , String crlf,
'  8Z6/4h8DfsJ6Fp/wc+FqzXVtZfGHxLptv4g+MXiSxhR7c3mn6bqUmoaB4Gn1GVnFtZ22n6trtlCP' , String crlf,
'  Mm8R6bNG8I/mr+K/7fH7ZfxpkPibxz8f/jD4wv5vPuLW+8TfFjxnql3DLtLzSQwNqTQWAdy8kFvb' , String crlf,
'  G2giG1LeOONVUch8FfgtZ/EqLwDDrFs8SeMPFugeGWnUmNUsdQsrnU4jcMu7Mt+sTKdnzsQ4XJUk' , String crlf,
'  frZ8Zf2N/BXwp1eS30v4fXFpbWnh7wzdWVhb2G+xnu4L6HTZAXmUzeXPJqcIuLiUAbVR5NpcZ+Ix' , String crlf,
'  /FeCw+Nhh4zdeu3V5qlStGlh4ug1zQUZN803rFaaNN6H32VcC5ljsBUxnIqNCP1aMadOnKpiJPEx' , String crlf,
'  b51FLWEUk32Tet3Y+XP2I/8AguD/AMFEv2MZ9Qs9P+MepfGX4aXsLxSfDv42X2t+NtC0K7gJmD6F' , String crlf,
'  Nc6pa67ocMiRuzw6NrVpbXLo095HMFdT/ZR/wRr/AOC0Mf8AwU11P4g/DX4heFPCvgT4seCdBj8Y' , String crlf,
'  WGm6Df3MUPiLQRf2umavLY6fql3JOZrC6urG5uJNKW7CWsjzXBSNtx/hS/ah+BqfCfQdX8UX2jYX' , String crlf,
'  VhY3FvbaXIsaaTeXSCIWm4DypJI5Gt4Lt87JpXuNgIbFfP8A+yB+0b4r/Zh/a5/Zu/aD+Gt7Pa6r' , String crlf,
'  8N/iT4c1HULK2ubq2j1bSbjVLTRvE/hjVTZvBLcaN4o0K5vdH1WyIWObT5rpZWkeOCevqeHs+/tO' , String crlf,
'  lTxuGrT+qxrKlVp83ucyhSlJK927ObTezaWivr8pn2R1MlxLwWKio1nTVRaWbjKc4xeu14wUnu05' , String crlf,
'  O6P9t3wr/wAiv4b5Lf8AEh0fkkEn/iX2/JI4JPXI4Pat6ue8I3dtf+FPDF9ZiVbO98PaLd2qzDEw' , String crlf,
'  trnTbaaASgAASiJ0EgAHz54HSuhr0aj5qk5fzTk/vk2eZFWjFdkl9yCv5j/+Dr79mzWfj3/wSr8R' , String crlf,
'  +M/DltBcap+zT8W/BXxl1WRgrXsPge4j1vwB4qmsyAzhdNk8Y6Vrt9kCKLTdGubq5aOC0kkX+nCv' , String crlf,
'  mX9pbwxofxN+D3xM+Eniiwi1Lwv8VfCviz4beJbOZDIk2h+MdIvvDt+I45CiLOlvqMkls+dy3qQX' , String crlf,
'  EB3xoRjVqKlSqVZJtU4Sk0t3ZNqK83ay6X3aRpTjzThFfamo3v8ADe75mkm5JW1S1P8AKV/Zl+Mn' , String crlf,
'  jXwT4e8F6fpPwd8Ia7ovhQ+Hr3UbrUtIv5NWl1zS7C41rQNWk167v4AkMEFiWS70m0m0yP7Ra6fc' , String crlf,
'  yL9riR/13+M37Vv7YWqaf4VHwt8E+F9Fu/EXgDT/AB/4gl1/wvB4juNGstZsZ9QXw/LHqekappcR' , String crlf,
'  v7qzsrS3RYIoop9Q0+G4vrS1ikurH418RfGDwH8F/BWtfDHTfAq+I/Hnw68UzeDNP07VJr62u9bb' , String crlf,
'  w1qU2nDw1oxghnubRLyTT4P9ImilQ2JkEjiPcw92uf25fit8Q9e8B+K/EPwI0j4GaB4W0nSbZdfu' , String crlf,
'  tVutWitrfw9pKxamk2iQolnrGk63O6Q3EkJeJEGy3CyRED+dak8TiswnmGH4fwFClSxWNnX9vjL1' , String crlf,
'  sVNzj7KrLDykqrmry5pqFmrQ5+WyP6fwEcNg8peXYjizG1Z4nB5esP8AVMBU5MFCMLzgswjRqKhG' , String crlf,
'  UUm/rE1GnbmTalY+Bf2jNY+M3xctfFOofEP4a6rYWP8Awi+rJdSR6Boul2elaqmn28tsthJpV9Jp' , String crlf,
'  WrWv9puZIxaPd3dqkYjmZpFYn47/AOCWX7KOuftZ/ttfsufCzVNCurbwR4n+N3gO7+IOqXytpelL' , String crlf,
'  4W03W01/W40vryPyJ9U1WHRdQ0/TNPt/tEs97dw2kEMcsixH9fv2ov2iF+K+h3mnaB4E0vSY9UtU' , String crlf,
'  e2v9AZTosbXKLDPc6bC2biBWuJQXE5YIV2N8ykD7W/4I0fC+z1v4w/BSytYdSez8FeMtT+IutXlo' , String crlf,
'  4nsLaXw9m8sEnEIR9Le7vbS1g3XMscd79phhtEeSKda+u4X4ixuEVWlDLMPQlmGYYOjChRk40Kbm' , String crlf,
'  uXFVuSTlZyUU21onZq3T43inhrLsfWlVq57iMXHLslx2MqY2pTUq1edOCrYbD86S9o3Ncqt8TahH' , String crlf,
'  4kf6HGibRoukBIxEn9l2GyIDAjX7JFtjAwMBBhQMDAHStOsnQHMmhaLISSX0nTXJOcktZwsSc5Oe' , String crlf,
'  e5J9a1q/YJNNtrZttddL9z8P/r+rBXz/APFO0uLrR9WRNzyQ3VxcRgHLIpd2/djYdqgpEzxiKUTH' , String crlf,
'  ducEkn6Ar4r/AGg/2hPgl+z/AKXrniv48fFr4ffCPwpFc6io1T4ieK9G8MQXYj852i0y21WeC91u' , String crlf,
'  4dR+5sdEtL+9lyqxRuxXOdRRlTqQlblnCUXd6Wdr9bv5XBSlGUHHdO9/Nar73ofws/8ABZL9k/wp' , String crlf,
'  8HP2v7Px3P8AC7w7L8FP2lLGG+0A2dnLpOmeG/itpVjDp3jPRvM077HBp11q0Yi8XrEY1t9Ujvb9' , String crlf,
'  RJO9nORzeoRtdfCeLSfGvhf4Tz+DbG1t2srPSvD+iabqGqWix20Al1Y2djDNqNrHDbORb3LQ2ztI' , String crlf,
'  JZJPOODqf8Fyv+CiXwS/bn8E+Cvgb+yN431vxd4W8F/Ee9+IvirxzZ+H9Z8N6BqPiCx0W50jwbbe' , String crlf,
'  GP8AhIbXTvEGpx6Yup67eajPNpVtbT/bbGK1ea18x4/5uBrvx78UeH/sWufFrXRYaTJ9ij0S+nml' , String crlf,
'  vYpg5tzaW8KOJZlBBk3sHURESklGBr8mx+VwqZhXWFzdYWnSnGjXwM6uKUYVq8aFRVqNOjGUacZq' , String crlf,
'  UozfKnzJK9z9zyCvmeDyLLMVXyOpmH9r0Kn1DF0KOHlUqxwVaphfYYqdWMnNwupQTduT3o3SZ9we' , String crlf,
'  NfjJ4b0eTxbY6R/Zlhp0ksWg+GoLNY4Us7SF5Zr06am4lYFuGWKOUjbIsOEJKmv6ev8Ag27+KHwL' , String crlf,
'  8Y/CLx98P/DV/YWPxwsPiJqvxD+J3h+8luI9e1nwlNB4e8N+A/FNo89rsPhu0FgPD09vbtcPpWtS' , String crlf,
'  Ne36W665ZeZ/G74S+Fy6Jpa654ruZtU1KWNfIW6Ms0cB3Z2QxgbWnBdVeQZUtzyCKwvgJ+1v8Zv2' , String crlf,
'  QP2nvDH7SHwA10aJ4v8AA2qS29vZXayXHhzxb4blUW+u+DPFunRSRjVPDXiO3jkt7uOMi4tW+z6l' , String crlf,
'  pt3Z6hb6fMnucM4DCRzGs8PUdf2K9rUxDi40rpxtThzJuTnLVuyk931vycfZLjso4bwmKzp0sLmO' , String crlf,
'  Y140cFlcJRlVo0oQlVrTxMuX2dlFQpunS5o03VotzvNKP+094dIbw/oTKMKdG0wqMFcA2UBA2lnK' , String crlf,
'  4HGCzEdNx6nYr51/ZA+L9z+0J+yX+y78fL3QbbwtefHD9nX4J/F+78MWd3NqFp4cufiX8NPDPjSf' , String crlf,
'  QbW/uI4p7220iXWn0+C7niimuYrdZpI0d2UfRVfoMt36v8z8WVrK21lb0Cv8b/8A4KseLPEGu/8A' , String crlf,
'  BS7/AIKB/wDCQ67rOtR6L+2t+1VpGlDWNVvdRTTNJ0X44+O9P0nSNPF3PI1jp2n2kENpYWFii21t' , String crlf,
'  bRRQRxCNAo/2QK/mV+Pv/Bqb/wAE8/2i/jl8Z/j/AONvjN+2fpXjH45/Fj4jfGLxbpfhX4ifA+x8' , String crlf,
'  Mad4n+J3jHWPG2v2Ph2y1f8AZ11zVbTQrTVdbu7fSLXU9a1fUINPjt4r3U9QuUku5cqkFPluk0n8' , String crlf,
'  9WloO7Wzsf51HhDxPrWj+CtOs/CCQHxL4lk1W6n1G6i+02+l2sV41g99JAuxpJ0ihtLKwAe3KMty' , String crlf,
'  8MeYiB+gnhj9mzwXZfs4eH/2n4bxdDXxP8YJ/hHceE/FPiW+1rV9Y8ZaV4Zsta1rXvCN5qeiafb3' , String crlf,
'  WnXEt2txPpNnqWq3OkRXdtb3V1KxSaX+z/wp/wAGmn/BOPwfZy2ml/F/9s6YzBFe5v8A4h/A6e52' , String crlf,
'  pcPchVaP9nSCJFaSRg4SEBlx/F8x9c8bf8Gzv7CHjj4cfDP4W3PxZ/a60Lwx8KrybVPD/wDwj/xE' , String crlf,
'  +E8F9faxca3deIrnV9ck1P4G6raXd/Pq1yk7PZ2WnwxRWdlaW8ENnE8En5vj8pxWKxWZYXD1qWHj' , String crlf,
'  Vrzr4qunN160PrHPTppqn7kaMfY0acIySUIzblzNNf0fl/FGFyXLeA8Zy47EYnARwdCngZOKymlh' , String crlf,
'  Z4Wnh8xdOi8Q1PF4+8q88TUoKqqtRQc5UaNKB/nZftBeNIdHtbnw5pUgh1OeK3ilaDEbaaLuIGG1' , String crlf,
'  UliqXsltJLfGUsRBbyWvmH54yfiRkRlD4JUAHZL/AAjZjnoQFPBJ59eRX+lbr3/Bor/wTh8SXP2z' , String crlf,
'  Vfjp+3LNcvLfXFxKvxK+Aam6u9RuPPvbq4Vv2Z3QyzBYbYrGscEdpbW9vFCiKwfBb/gzz/4JnsCD' , String crlf,
'  8c/26hnncPiZ8ANwPcgn9mM8k/McgjPbHFfYcPZXTyrLqdFNTrVHKeIqq756ibg+Vys1C8XaL2Vr' , String crlf,
'  u9z8v8T+LcRxhxPXxcoyo4PDwhRwGEcYxWHoTUKnvRhOVN1pudq1SCiqns6dlGnCnSpfuf8A8EuB' , String crlf,
'  j/gmX/wTpHAx+wn+yKMDoMfs/wDw+6e3pX3ZXk3wE+Dnhr9nb4F/Bf8AZ+8F6hr+reDvgX8Jvhz8' , String crlf,
'  HPCeq+K7rTr3xRqfhr4Y+D9G8FaFqHiS90fStC0m71+90vRLW51i60vRNH0641GW5lstK0+2eK0h' , String crlf,
'  9Zr3D8/WiS7JH//Z' , String crlf,
'item7.X-ABRELATEDNAMES;type=pref:Virginia Johns' , String crlf,
'item7.X-ABLabel:_$!!<Assistant>!!$_' , String crlf,
'item8.X-ABRELATEDNAMES:Norma Brown' , String crlf,
'item8.X-ABLabel:_$!!<Spouse>!!$_' , String crlf,
'END:VCARD' , String crlf! !

!ICVCardTest methodsFor: 'testing-exporting' stamp: 'pmm 12/11/2005 13:38'!
testExportAvi
	| cards exporter str |
	cards := ICCardHandParser parseVCardString: self aviCardString.
	cards anyOne photo: nil.
	
	exporter := ICVCardExporter cards: cards.
	exporter export.
	str := self aviCardStringExport.

	exporter dataStream contents 
		keysAndValuesDo: [:index :value |
			self assert: value = (str at: index) ].
	self assert: exporter dataStream contents = str.
	! !

!ICVCardTest methodsFor: 'testing-exporting' stamp: 'pmm 12/13/2005 22:22'!
testExportGoofy
	| cards exporter str |
	cards := ICCardHandParser parseVCardString: self goofyCardString.
	cards anyOne photo: nil.
	
	exporter := ICVCardExporter cards: cards.
	exporter export.
	str := self goofyCardStringExport.

	exporter dataStream contents 
		keysAndValuesDo: [:index :value |
			self assert: value = (str at: index) ].
	self assert: exporter dataStream contents = str.
	! !

!ICVCardTest methodsFor: 'testing-parsing' stamp: 'pmm 10/30/2005 08:30'!
testName
	| name |
	name := ICName fromICalString: 'Public;John;Quinlan;Mr.;Esq'.
	self assert: name familyName = 	'Public'.
	self assert: name givenName = 	'John'.
	self assert: name additionalNames size = 1.
	self assert: name additionalNames first = 'Quinlan'.
	self assert: name honorificPrefixes size = 1.
	self assert: name honorificPrefixes first = 'Mr.'.
	self assert: name honorificSuffixes size = 1.
	self assert: name honorificSuffixes first = 'Esq'.

	name := ICName fromICalString: 'Stevenson;John;Philip,Paul;Dr.;Jr.,M.D.,A.C.P.'.
	self assert: name familyName = 	'Stevenson'.
	self assert: name givenName = 	'John'.
		
	self assert: name additionalNames size = 2.
	self assert: name additionalNames first = 'Philip'.
	self assert: name additionalNames second = 'Paul'.
	
	self assert: name honorificPrefixes size = 1.
	self assert: name honorificPrefixes first = 'Dr.'.
	
	self assert: name honorificSuffixes size = 3.
	self assert: name honorificSuffixes first = 'Jr.'.
	self assert: name honorificSuffixes second = 'M.D.'.
	self assert: name honorificSuffixes third = 'A.C.P.'.! !

!ICVCardTest methodsFor: 'testing-parsing' stamp: 'pmm 3/24/2006 15:34'!
testParseAvi
	| cards card address name phoneNumber emailAddress imid |
	cards := ICCardHandParser parseVCardString: self aviCardString.
	self assert: cards size = 1.
	card := cards anyOne.
	
	self assert: card fullname = 'Avi Bryant'.
	self assert: card version = 3.0.
	name := card name.
	self assert: name notNil.
	self assert: name familyName = 'Bryant'.
	self assert: name givenName = 'Avi'.
	self assert: name additionalNames isEmptyOrNil.
	self assert: name honorificPrefixes isEmptyOrNil.
	self assert: name honorificSuffixes isEmptyOrNil.
	
	self assert: card addresses size = 1.
	address := card addresses anyOne.
	
	self assert: address isHome.
	self deny: address isDomestic.
	self deny: address isInternational.
	self deny: address isParcel.
	self deny: address isPostal.
	self assert: address isPreferred.
	self deny: address isWork.
	
	self assert: address poBox isEmptyOrNil.
	self assert: address extended isEmptyOrNil.
	
	self assert: address street = 'xxx E. xx Ave'.
	self assert: address locality = 'Vancouver'.
	self assert: address region = 'BC'.
	self assert: address postalcode = 'V5V 1E3'.
	self assert: address country = 'Canada'.
	
	self assert: card phoneNumbers size = 1.
	phoneNumber := card phoneNumbers first.
	self assert: phoneNumber number = '(778) xxx-xxxx'.
	self assert: phoneNumber isHome.
	self assert: phoneNumber isPreferred.
	self deny: phoneNumber isWork.
	self deny: phoneNumber isBulletinBoard.
	self deny: phoneNumber isCar.
	self deny: phoneNumber isCellular.
	self deny: phoneNumber isFax.
	self deny: phoneNumber isISDN.
	self deny: phoneNumber isModem.
	self deny: phoneNumber isPager.
	self deny: phoneNumber isVoice.
	self deny: phoneNumber isVoiceMessage.
	
	self assert: card emailAddresses size = 2.
	emailAddress := card emailAddresses first.
	self assert: emailAddress address = 'avi@smallthought.com'.
	self assert: emailAddress isWork.
	self assert: emailAddress isPreferred.
	self deny: emailAddress isHome.
	self assert: emailAddress isInternet.
	self deny: emailAddress isX400.
	
	emailAddress := card emailAddresses second.
	self assert: emailAddress address = 'avi.bryant@gmail.com'.
	self deny: emailAddress isWork.
	self deny: emailAddress isPreferred.
	self assert: emailAddress isHome.
	self assert: emailAddress isInternet.
	self deny: emailAddress isX400.
	
	self assert: card photo iCalType = 'BINARY'.
	
	self assert: card aimids size = 1.
	imid := card aimids anyOne.
	self assert: (imid isKindOf: ICAIMId).
	self assert: imid isPreferred.
	self deny: imid isWork.
	self deny: imid isHome.
	self assert: imid id = 'avbry'.
	
	self assert: card icqids isEmpty.
	
	self assert: card msnids size = 1.
	imid := card msnids anyOne.
	self assert: (imid isKindOf: ICMSNId).
	self assert: imid isPreferred.
	self deny: imid isWork.
	self deny: imid isHome.
	self assert: imid id = 'avi666@hotmail.com'.
	
	self assert: card yahooids isEmpty.
	! !

!ICVCardTest methodsFor: 'testing-parsing' stamp: 'pmm 3/24/2006 15:35'!
testParseEric
	| cards card name imid |
	cards := ICCardHandParser parseVCardString: self ericCardString.
	self assert: cards size = 1.
	card := cards anyOne.
	
	self assert: card fullname = 'Eric Wahlforss'.
	self assert: card title = 'Entrepreneur / Musician'.
	self assert: card url asVCardString = 'http://eric.wahlforss.com/'.
	self assert: card version = 3.0.
	name := card name.
	self assert: name notNil.
	self assert: name familyName = 'Wahlforss'.
	self assert: name givenName = 'Eric'.
	self assert: name additionalNames isEmptyOrNil.
	self assert: name honorificPrefixes isEmptyOrNil.
	self assert: name honorificSuffixes isEmptyOrNil.
	
	self assert: card aimids size = 1.	
	imid := card aimids anyOne.
	self assert: (imid isKindOf: ICAIMId).
	self assert: imid isPreferred.
	self deny: imid isWork.
	self assert: imid isHome.
	self assert: imid id = 'ericwahlforss'.
	
	self assert: card icqids size = 1.	
	imid := card icqids anyOne.
	self assert: (imid isKindOf: ICICQId).
	self assert: imid isPreferred.
	self assert: imid isWork.
	self deny: imid isHome.
	self assert: imid id = '5399905'.
	
	self assert: card msnids size = 1.
	imid := card msnids anyOne.
	self assert: (imid isKindOf: ICMSNId).
	self deny: imid isPreferred.
	self deny: imid isWork.
	self assert: imid isHome.
	self assert: imid id = 'ericwahlforss@hotmail.com'.
	
	self assert: card yahooids isEmpty.
	
	self assert: card categories size = 1.
	self assert: card categories anyOne summary = '24HDC'
	! !

!ICVCardTest methodsFor: 'testing-parsing' stamp: 'pmm 1/2/2006 12:55'!
testParseGoofy
	| cards card address name phoneNumber |
	cards := ICCardHandParser parseVCardString: self goofyCardString.
	self assert: cards size = 1.
	card := cards anyOne.
	
	self assert: card fullname = 'Markus Tschannen'.
	self assert: card version = 2.1.
	self assert: card birthday = (Date year: 1980 month: 10 day: 30).
	name := card name.
	self assert: name notNil.
	self assert: name familyName = 'Tschannen'.
	self assert: name givenName = 'Markus'.
	self assert: name additionalNames isEmptyOrNil.
	self assert: name honorificPrefixes isEmptyOrNil.
	self assert: name honorificSuffixes isEmptyOrNil.
	
	self assert: card addresses size = 1.
	address := card addresses anyOne.
	
	self assert: address isHome.
	self deny: address isDomestic.
	self deny: address isInternational.
	self deny: address isParcel.
	self deny: address isPostal.
	self deny: address isPreferred.
	self deny: address isWork.
	
	self assert: address poBox isEmptyOrNil.
	self assert: address extended isEmptyOrNil.
	
	self assert: address street = 'Neufeldstrasse 11'.
	self assert: address locality = 'Bern'.
	self assert: address region isEmptyOrNil.
	self assert: address postalcode = '3012'.
	self assert: address country = 'Schweiz'.
	
	self assert: card phoneNumbers size = 2.
	phoneNumber := card phoneNumbers first.
	self assert: phoneNumber number = '+41 31 302 08 56'.
	self assert: phoneNumber isHome.
	self deny: phoneNumber isPreferred.
	self deny: phoneNumber isWork.
	self deny: phoneNumber isBulletinBoard.
	self deny: phoneNumber isCar.
	self deny: phoneNumber isCellular.
	self deny: phoneNumber isFax.
	self deny: phoneNumber isISDN.
	self deny: phoneNumber isModem.
	self deny: phoneNumber isPager.
	self assert: phoneNumber isVoice.
	self deny: phoneNumber isVoiceMessage.
	
	phoneNumber := card phoneNumbers second.
	self assert: phoneNumber number = '+41 78 845 24 12'.
	self assert: phoneNumber isHome.
	self deny: phoneNumber isPreferred.
	self deny: phoneNumber isWork.
	self deny: phoneNumber isBulletinBoard.
	self deny: phoneNumber isCar.
	self assert: phoneNumber isCellular.
	self deny: phoneNumber isFax.
	self deny: phoneNumber isISDN.
	self deny: phoneNumber isModem.
	self deny: phoneNumber isPager.
	self deny: phoneNumber isVoice.
	self deny: phoneNumber isVoiceMessage.
	
	self assert: card emailAddresses isEmpty! !

!ICVCardTest methodsFor: 'testing-parsing' stamp: 'pmm 3/24/2006 15:39'!
testParseMaeve
	| cards card name imid |
	cards := ICCardHandParser parseVCardString: self maeveCardString.
	self assert: cards size = 1.
	card := cards anyOne.
	
	self assert: card fullname = 'Maeve Price'.
	self assert: card title = 'Digital Editor'.
	self assert: card version = 3.0.
	name := card name.
	self assert: name notNil.
	self assert: name familyName = 'Price'.
	self assert: name givenName = 'Maeve'.
	self assert: name additionalNames isEmptyOrNil.
	self assert: name honorificPrefixes isEmptyOrNil.
	self assert: name honorificSuffixes isEmptyOrNil.
	
	self assert: card aimids size = 1.
	imid := card aimids anyOne.
	self assert: imid isPreferred.
	self deny: imid isWork.
	self assert: imid isHome.
	self assert: imid id = 'Mahaevey'.
	
	self assert: card icqids isEmpty.
	
	self assert: card msnids size = 1.
	imid := card msnids anyOne.
	self assert: (imid isKindOf: ICMSNId).
	self assert: imid isPreferred.
	self deny: imid isWork.
	self assert: imid isHome.
	self assert: imid id = 'dgu186@hotmail.com'.
	
	self assert: card yahooids isEmpty.
	
	self assert: card categories size = 3.
	#('Friends' 'Columbia College Chicago' 'Family') do: [ :each |
		self assert: (card categories anySatisfy: [ :cat | cat summary = each  ]) ].
	
	self assert: card notes isEmpty	! !

!ICVCardTest methodsFor: 'testing-parsing' stamp: 'pmm 12/8/2005 14:37'!
testParseMaeveUrl
	| cards card |
	cards := ICCardHandParser parseVCardString: self maeveCardString.
	self assert: cards size = 1.
	card := cards anyOne.
	
	self assert: card url asVCardString = 'http://http\:0/www.myspace.com/maeveprice'.	! !

!ICVCardTest methodsFor: 'testing-parsing' stamp: 'pmm 12/6/2005 18:48'!
testParseOscar
	| cards card address name phoneNumber emailAddress organization |
	cards := ICCardHandParser parseVCardString: self oscarCardString.
	self assert: cards size = 1.
	card := cards anyOne.
	
	self assert: card fullname = 'Oscar2 Nierstrasz'.
	self assert: card version = 3.0.
	self assert: card title = 'Professor'.
	
	name := card name.
	self assert: name notNil.
	self assert: name familyName = 'Nierstrasz'.
	self assert: name givenName = 'Oscar'.
	self assert: name additionalNames isEmptyOrNil.
	self assert: name honorificPrefixes isEmptyOrNil.
	self assert: name honorificSuffixes isEmptyOrNil.
	
	self assert: card addresses size = 3.
	address := card addresses first.
	
	self deny: address isHome.
	self deny: address isDomestic.
	self deny: address isInternational.
	self deny: address isParcel.
	self deny: address isPostal.
	self assert: address isPreferred.
	self assert: address isWork.
	
	self assert: address poBox isEmptyOrNil.
	self assert: address extended isEmptyOrNil.
	
	self assert: address street = 'Software Composition Group
IAM, University of Bern
Neubrueckstrasse 10'.
	self assert: address locality = 'Bern'.
	self assert: address region isEmptyOrNil.
	self assert: address postalcode = 'CH-3012'.
	self assert: address country = 'SWITZERLAND'.
	
	address := card addresses second.
	
	self assert: address isHome.
	self deny: address isDomestic.
	self deny: address isInternational.
	self deny: address isParcel.
	self deny: address isPostal.
	self deny: address isPreferred.
	self deny: address isWork.
	
	self assert: address poBox isEmptyOrNil.
	self assert: address extended isEmptyOrNil.
	
	self assert: address street = 'Fluhmattweg 41'.
	self assert: address locality = 'Kehrsatz'.
	self assert: address region isEmptyOrNil.
	self assert: address postalcode = '3122'.
	self assert: address country = 'SWITZERLAND'.
	
	address := card addresses third.
	
	self assert: address isHome.
	self deny: address isDomestic.
	self deny: address isInternational.
	self deny: address isParcel.
	self deny: address isPostal.
	self deny: address isPreferred.
	self deny: address isWork.
	
	self assert: address poBox isEmptyOrNil.
	self assert: address extended isEmptyOrNil.
	
	self assert: address street = 'Schuetzenmattstrasse 14, room 103'.
	self assert: address locality isEmptyOrNil.
	self assert: address region isEmptyOrNil.
	self assert: address postalcode isEmptyOrNil.
	self assert: address country isEmptyOrNil.
	
	self assert: card phoneNumbers size = 3.
	phoneNumber := card phoneNumbers first.
	self assert: phoneNumber number = '+41 31 631.4618'.
	self deny: phoneNumber isHome.
	self assert: phoneNumber isPreferred.
	self assert: phoneNumber isWork.
	self deny: phoneNumber isBulletinBoard.
	self deny: phoneNumber isCar.
	self deny: phoneNumber isCellular.
	self deny: phoneNumber isFax.
	self deny: phoneNumber isISDN.
	self deny: phoneNumber isModem.
	self deny: phoneNumber isPager.
	self deny: phoneNumber isVoice.
	self deny: phoneNumber isVoiceMessage.
	
	phoneNumber := card phoneNumbers second.
	self assert: phoneNumber number = '+41 31 961.7065'.
	self assert: phoneNumber isHome.
	self deny: phoneNumber isPreferred.
	self deny: phoneNumber isWork.
	self deny: phoneNumber isBulletinBoard.
	self deny: phoneNumber isCar.
	self deny: phoneNumber isCellular.
	self deny: phoneNumber isFax.
	self deny: phoneNumber isISDN.
	self deny: phoneNumber isModem.
	self deny: phoneNumber isPager.
	self deny: phoneNumber isVoice.
	self deny: phoneNumber isVoiceMessage.
	
	phoneNumber := card phoneNumbers third.
	self assert: phoneNumber number = '+41 31 631.3355'.
	self deny: phoneNumber isHome.
	self deny: phoneNumber isPreferred.
	self assert: phoneNumber isWork.
	self deny: phoneNumber isBulletinBoard.
	self deny: phoneNumber isCar.
	self deny: phoneNumber isCellular.
	self assert: phoneNumber isFax.
	self deny: phoneNumber isISDN.
	self deny: phoneNumber isModem.
	self deny: phoneNumber isPager.
	self deny: phoneNumber isVoice.
	self deny: phoneNumber isVoiceMessage.
	
	self assert: card emailAddresses size = 1.
	emailAddress := card emailAddresses first.
	self assert: emailAddress address = 'oscar.nierstrasz@acm.org'.
	self assert: emailAddress isWork.
	self assert: emailAddress isPreferred.
	self deny: emailAddress isHome.
	self assert: emailAddress isInternet.
	self deny: emailAddress isX400.
	
	organization := card organization.
	self assert: organization name = 'University of Bern'.
	self assert: organization unitNames isEmpty.! !

!ICVCardTest methodsFor: 'testing-parsing' stamp: 'pmm 12/8/2005 14:36'!
testParseOscarUrl
	| cards card |
	cards := ICCardHandParser parseVCardString: self oscarCardString.
	self assert: cards size = 1.
	card := cards anyOne.

	self assert: card url asVCardString = 'http://www.iam.unibe.ch/~oscar/'.
	! !

!ICVCardTest methodsFor: 'testing-parsing' stamp: 'pmm 1/2/2006 12:57'!
testParseSean
	| cards card address name phoneNumber emailAddress organization |
	cards := ICCardHandParser parseVCardString: self seanCardString.
	self assert: cards size = 1.
	card := cards anyOne.
	
	self assert: card fullname = 'Sean Glazier'.
	self assert: card version = 2.1.
	self assert: card title = 'Lead Software Engineer'.
	self assert: card birthday = (Date year: 2005 month: 10 day: 01).
	name := card name.
	self assert: name notNil.
	self assert: name familyName = 'Glazier'.
	self assert: name givenName = 'Sean'.
	self assert: name additionalNames isEmptyOrNil.
	self assert: name honorificPrefixes isEmptyOrNil.
	self assert: name honorificSuffixes isEmptyOrNil.
	
	self assert: card addresses size = 2.
	address := card addresses first.
	
	self deny: address isHome.
	self deny: address isDomestic.
	self deny: address isInternational.
	self deny: address isParcel.
	self deny: address isPostal.
	self deny: address isPreferred.
	self assert: address isWork.
	
	self assert: address poBox isEmptyOrNil.
	self assert: address extended isEmptyOrNil.
	
	self assert: address street = '6 Christie Lane'.
	self assert: address locality = 'Stratham'.
	self assert: address region = 'NH'.
	self assert: address postalcode = '03885'.
	self assert: address country = 'USA'.
	
	address := card addresses second.
	
	self assert: address isHome.
	self deny: address isDomestic.
	self deny: address isInternational.
	self deny: address isParcel.
	self deny: address isPostal.
	self deny: address isPreferred.
	self deny: address isWork.
	
	self assert: address poBox isEmptyOrNil.
	self assert: address extended isEmptyOrNil.
	
	self assert: address street = '6 Christie Lane'.
	self assert: address locality = 'Stratham'.
	self assert: address region = 'NH'.
	self assert: address postalcode = '03885'.
	self assert: address country = 'USA'.
	
	self assert: card phoneNumbers size = 4.
	phoneNumber := card phoneNumbers first.
	self assert: phoneNumber number = '603 772 4480'.
	self deny: phoneNumber isHome.
	self deny: phoneNumber isPreferred.
	self assert: phoneNumber isWork.
	self deny: phoneNumber isBulletinBoard.
	self deny: phoneNumber isCar.
	self deny: phoneNumber isCellular.
	self deny: phoneNumber isFax.
	self deny: phoneNumber isISDN.
	self deny: phoneNumber isModem.
	self deny: phoneNumber isPager.
	self assert: phoneNumber isVoice.
	self deny: phoneNumber isVoiceMessage.
	
	phoneNumber := card phoneNumbers second.
	self assert: phoneNumber number = '603 770 8260'.
	self deny: phoneNumber isHome.
	self deny: phoneNumber isPreferred.
	self deny: phoneNumber isWork.
	self deny: phoneNumber isBulletinBoard.
	self deny: phoneNumber isCar.
	self assert: phoneNumber isCellular.
	self deny: phoneNumber isFax.
	self deny: phoneNumber isISDN.
	self deny: phoneNumber isModem.
	self deny: phoneNumber isPager.
	self assert: phoneNumber isVoice.
	self deny: phoneNumber isVoiceMessage.
	
	phoneNumber := card phoneNumbers third.
	self assert: phoneNumber number = '603 772 2852'.
	self assert: phoneNumber isHome.
	self deny: phoneNumber isPreferred.
	self deny: phoneNumber isWork.
	self deny: phoneNumber isBulletinBoard.
	self deny: phoneNumber isCar.
	self deny: phoneNumber isCellular.
	self deny: phoneNumber isFax.
	self deny: phoneNumber isISDN.
	self deny: phoneNumber isModem.
	self deny: phoneNumber isPager.
	self assert: phoneNumber isVoice.
	self deny: phoneNumber isVoiceMessage.
	
	phoneNumber := card phoneNumbers fourth.
	self assert: phoneNumber number = '603 770 8260'.
	self deny: phoneNumber isHome.
	self deny: phoneNumber isPreferred.
	self deny: phoneNumber isWork.
	self deny: phoneNumber isBulletinBoard.
	self deny: phoneNumber isCar.
	self assert: phoneNumber isCellular.
	self deny: phoneNumber isFax.
	self deny: phoneNumber isISDN.
	self deny: phoneNumber isModem.
	self deny: phoneNumber isPager.
	self assert: phoneNumber isVoice.
	self deny: phoneNumber isVoiceMessage.
	
	self assert: card emailAddresses size = 2.
	emailAddress := card emailAddresses first.
	self assert: emailAddress address = 'sglazier@comcast.net'.
	self assert: emailAddress isWork.
	self assert: emailAddress isPreferred.
	self deny: emailAddress isHome.
	self assert: emailAddress isInternet.
	self deny: emailAddress isX400.
	
	emailAddress := card emailAddresses second.
	self assert: emailAddress address = 'sglazier@comcast.net'.
	self deny: emailAddress isWork.
	self deny: emailAddress isPreferred.
	self assert: emailAddress isHome.
	self assert: emailAddress isInternet.
	self deny: emailAddress isX400.
	
	organization := card organization.
	self assert: organization name = 'Cincom Systems'.
	self assert: organization unitNames isEmpty.
	! !

!ICVCardTest methodsFor: 'testing-parsing' stamp: 'pmm 3/24/2006 15:37'!
testParseSurendar
	| cards card name imid organization |
	cards := ICCardHandParser parseVCardString: self surendarCardString.
	self assert: cards size = 1.
	card := cards anyOne.
	
	self assert: card fullname = 'Surendar Chandra'.
	self assert: card title = 'Asst. Professor'.
	self assert: card version = 3.0.
	name := card name.
	self assert: name notNil.
	self assert: name familyName = 'Chandra'.
	self assert: name givenName = 'Surendar'.
	self assert: name additionalNames isEmptyOrNil.
	self assert: name honorificPrefixes isEmptyOrNil.
	self assert: name honorificSuffixes isEmptyOrNil.
	
	self assert: card aimids size = 1.
	imid := card aimids anyOne.
	self assert: (imid isKindOf: ICAIMId).
	self assert: imid isPreferred.
	self deny: imid isWork.
	self assert: imid isHome.
	self assert: imid id = 'surendar'.
	
	self assert: card icqids isEmpty.
	
	self assert: card msnids size = 1.
	imid := card msnids anyOne.
	self assert: (imid isKindOf: ICMSNId).
	self assert: imid isPreferred.
	self deny: imid isWork.
	self assert: imid isHome.
	self assert: imid id = 'surendar'.
	
	self assert: card yahooids size = 1.
	imid := card yahooids anyOne.
	self assert: (imid isKindOf: ICYahooId).
	self assert: imid isPreferred.
	self assert: imid isWork.
	self deny: imid isHome.
	self assert: imid id = 'surendarcsdukeedu'.
	
	organization := card organization.
	self assert: organization name = 'Univ. of Notre Dame'.
	self assert: organization unitNames size = 1.
	self assert: organization unitNames anyOne = 'Computer Science and Engg'.
	
	self shouldnt: [ self assert: card notes size = 1 ] raise: Error.
	self assert: card notes anyOne =
'SMS message
12/22/2003 18:12
wassup

SMS message
12/23/2003 13:12
Hello'
	! !

!ICVCardTest methodsFor: 'testing-parsing' stamp: 'pmm 12/8/2005 14:36'!
testParseSurendarUrl
	| cards card |
	cards := ICCardHandParser parseVCardString: self surendarCardString.
	self assert: cards size = 1.
	card := cards anyOne.

	self assert: card url asVCardString = 'http://www.cse.nd.edu/~surendar/'.! !

!ICVCardTest methodsFor: 'testing-parsing' stamp: 'pmm 12/2/2005 22:59'!
testParseWikipedia
	| cards card address name phoneNumber emailAddress |
	cards := ICCardHandParser parseVCardString: self wikipediaCardString.
	self assert: cards size = 1.
	card := cards anyOne.
	
	self assert: card fullname = 'Firstname Lastname'.
	self assert: card version = 2.1.
	name := card name.
	self assert: name notNil.
	self assert: name familyName = 'Lastname'.
	self assert: name givenName = 'Firstname'.
	self assert: name additionalNames isEmptyOrNil.
	self assert: name honorificPrefixes isEmptyOrNil.
	self assert: name honorificSuffixes isEmptyOrNil.
	
	self assert: card addresses size = 1.
	address := card addresses anyOne.
	
	self deny: address isHome.
	self deny: address isDomestic.
	self deny: address isInternational.
	self deny: address isParcel.
	self deny: address isPostal.
	self assert: address isPreferred.
	self assert: address isWork.
	
	self assert: address poBox isEmptyOrNil.
	self assert: address locality isEmptyOrNil.
	
	self assert: address street = 'Bar Street 99'.
	self assert: address extended = 'Footown 12345
Fooland'.
	self assert: address region isEmptyOrNil.
	self assert: address postalcode isEmptyOrNil.
	self assert: address country isEmptyOrNil.
	
	self assert: card phoneNumbers size = 1.
	phoneNumber := card phoneNumbers first.
	self assert: phoneNumber number = '+358-40-123456'.
	self deny: phoneNumber isHome.
	self deny: phoneNumber isPreferred.
	self deny: phoneNumber isWork.
	self deny: phoneNumber isBulletinBoard.
	self deny: phoneNumber isCar.
	self assert: phoneNumber isCellular.
	self deny: phoneNumber isFax.
	self deny: phoneNumber isISDN.
	self deny: phoneNumber isModem.
	self deny: phoneNumber isPager.
	self deny: phoneNumber isVoice.
	self deny: phoneNumber isVoiceMessage.

	
	self assert: card emailAddresses size = 1.
	emailAddress := card emailAddresses first.
	self assert: emailAddress address = 'nobody@example.invalid'.
	self deny: emailAddress isWork.
	self deny: emailAddress isPreferred.
	self deny: emailAddress isHome.
	self assert: emailAddress isInternet.
	self deny: emailAddress isX400.! !

!ICVCardTest methodsFor: 'accessing-parsing' stamp: 'pmm 11/4/2005 23:04'!
wikipediaCardString
^
'BEGIN:VCARD' , String crlf ,
'VERSION:2.1' , String crlf ,
'FN:Firstname Lastname' , String crlf ,
'N:Lastname;Firstname' , String crlf ,
'ADR;WORK;PREF;QUOTED-PRINTABLE:;Footown 12345=0AFooland;Bar Street 99' , String crlf ,
'LABEL;QUOTED-PRINTABLE;WORK;PREF:Bar Street 99=0AFootown 12345=0AFooland' , String crlf ,
'TEL;CELL:+358-40-123456' , String crlf ,
'EMAIL;INTERNET:nobody@example.invalid' , String crlf ,
'UID:' , String crlf ,
'END:VCARD' , String crlf! !

!ScaledDecimal class methodsFor: '*ICal' stamp: 'pmm 11/9/2005 07:21'!
fromICalString: aString
	| beforeComma afterComma number beforeCommaScale beforeCommaNumber afterCommaNumber |
	beforeComma := aString upTo: $. .
	afterComma := aString copyAfter: $. .
	beforeCommaScale := 10 raisedTo: afterComma size.
	beforeCommaNumber := beforeComma asNumber * beforeCommaScale
			/ beforeCommaScale.
	afterCommaNumber := ((afterComma isEmpty ifFalse: [ afterComma asNumber ] ifTrue: [ 0 ])
			/  beforeCommaScale).
	number := beforeCommaNumber negative
		ifFalse: [ beforeCommaNumber + afterCommaNumber ]
		ifTrue: [ beforeCommaNumber - afterCommaNumber ].
	^self newFromNumber: number scale: afterComma size! !

!ScaledDecimal class methodsFor: '*ICal' stamp: 'pmm 11/9/2005 07:10'!
iCalType
	^'FLOAT'! !

!ScaledDecimal methodsFor: '*ICal' stamp: 'pmm 11/9/2005 07:22'!
asICalString
	"copy pasted from #printOn:"
	| aFraction tmpFractionPart |
	^String streamContents: [ :stream |
		self negative ifTrue: [ stream nextPut: $-].
		aFraction := fraction abs.
		stream nextPutAll: aFraction truncated printString.
		scale isZero ifFalse: [ 
			stream nextPut: $..
			tmpFractionPart := aFraction fractionPart.
			scale timesRepeat: [
				tmpFractionPart := tmpFractionPart * 10.
				stream nextPut: (Character digitValue: tmpFractionPart truncated).
				tmpFractionPart := tmpFractionPart fractionPart ] ] ]! !

!UndefinedObject methodsFor: '*ICal' stamp: 'pmm 11/10/2005 23:23'!
asICalString
	^self! !

!UndefinedObject methodsFor: '*ICal' stamp: 'pmm 10/7/2005 14:19'!
isDateOrNil
	^true! !

!Dictionary methodsFor: '*ICal' stamp: 'pmm 10/14/2005 11:31'!
includesKey: aKey withValue: aValue
	^(self includesKey: aKey)
		and: [ (self at: aKey) = aValue ]! !

!DateAndTime class methodsFor: '*ICal' stamp: 'pmm 10/4/2005 20:11'!
fromICalString: aString
	| date time |
	date := Date fromICalString: (aString first: 8).
	^aString size >= 15
		ifTrue: [
			time := Time fromICalString: (aString allButFirst: 9).
			self date: date time: time ]
		ifFalse: [ date ]! !

!DateAndTime class methodsFor: '*ICal' stamp: 'pmm 1/2/2006 12:06'!
fromVCardString: aString
	| date time |
	date := Date fromVCardString: (aString copyUpTo: $T).
	^(aString includes: $T)
		ifTrue: [
			time := Time fromVCardString: (aString copyAfter: $T).
			self date: date time: time ]
		ifFalse: [ date ]! !

!DateAndTime class methodsFor: '*ICal' stamp: 'pmm 10/3/2005 17:08'!
iCalType
	^'DATE-TIME'! !

!DateAndTime methodsFor: '*ICal' stamp: 'pmm 10/2/2005 14:36'!
asICalDateAndTimeString
	^String streamContents: [ :stream |
		stream 
			nextPutAll: self asDate asICalString;
			nextPut: $T;
			nextPutAll: self asTime asICalString ]! !

!DateAndTime methodsFor: '*ICal' stamp: 'pmm 10/2/2005 14:32'!
asICalString
	^self asICalDateAndTimeString! !

!DateAndTime methodsFor: '*ICal' stamp: 'pmm 10/10/2005 16:20'!
asICalUtcString
	^self asICalDateAndTimeString , 'Z'! !

!DateAndTime methodsFor: '*ICal' stamp: 'pmm 1/2/2006 12:03'!
asVCardString
	^String streamContents: [ :stream |
		stream 
			nextPutAll: self asDate asVCardString;
			nextPut: $T;
			nextPutAll: self asTime asVCardString ]! !

!Point methodsFor: '*ICal' stamp: 'pmm 10/9/2005 11:42'!
asArray
	^Array with: self x with: self y! !

Notification subclass: #ICCalendarVersion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Parser'!

!ICCalendarVersion class methodsFor: 'as yet unclassified' stamp: 'pmm 11/19/2005 14:56'!
defaultValue
	^ 2.0! !

!ICCalendarVersion class methodsFor: 'as yet unclassified' stamp: 'pmm 11/19/2005 14:56'!
use: anObject during: aBlock
	^ aBlock
		on: self
		do: [ :notification | notification resume: anObject]! !

!ICCalendarVersion class methodsFor: 'as yet unclassified' stamp: 'pmm 11/19/2005 14:56'!
value
	^ self raiseSignal! !

!ICCalendarVersion methodsFor: 'as yet unclassified' stamp: 'pmm 11/19/2005 14:56'!
defaultAction
	self resume: self class defaultValue! !

Notification subclass: #ICCardVersion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-VCard-Parser'!

!ICCardVersion class methodsFor: 'as yet unclassified' stamp: 'pmm 11/4/2005 22:59'!
defaultValue
	^ 3.0! !

!ICCardVersion class methodsFor: 'as yet unclassified' stamp: 'pmm 11/4/2005 22:59'!
use: anObject during: aBlock
	^ aBlock
		on: self
		do: [ :notification | notification resume: anObject]! !

!ICCardVersion class methodsFor: 'as yet unclassified' stamp: 'pmm 11/4/2005 23:00'!
value
	^ self raiseSignal! !

!ICCardVersion methodsFor: 'as yet unclassified' stamp: 'pmm 11/4/2005 22:58'!
defaultAction
	self resume: self class defaultValue! !

!Boolean class methodsFor: '*ICal' stamp: 'pmm 10/14/2005 12:01'!
fromICalString: aString
	(aString sameAs: true asICalString)
		ifTrue: [ ^true ].
	(aString sameAs: false asICalString)
		ifTrue: [ ^false ].
	self error: 'invalid argument'! !

!Boolean class methodsFor: '*ICal' stamp: 'pmm 10/14/2005 11:58'!
iCalType
	^'BOOLEAN'! !

!Boolean methodsFor: '*ICal' stamp: 'pmm 10/14/2005 11:57'!
asICalBooleanString
	self subclassResponsibility ! !

!Boolean methodsFor: '*ICal' stamp: 'pmm 10/14/2005 12:07'!
asICalString
	^self asICalBooleanString ! !

!PositionableStream methodsFor: '*ICal' stamp: 'pmm 10/15/2005 15:43'!
upToAny: aCollection 
	"Answer a subcollection from the current access position to the 
	occurrence (if any, but not inclusive) of anObject in the receiver. If 
	anObject is not in the collection, answer the entire rest of the receiver."
	| newStream element |
	newStream := WriteStream on: (collection species new: 100).
	[self atEnd or: [aCollection includes: (element := self next) ] ]
		whileFalse: [newStream nextPut: element].
	^newStream contents! !

!True methodsFor: '*ICal' stamp: 'pmm 10/14/2005 12:01'!
asICalBooleanString
	^'TRUE'! !

!Duration class methodsFor: '*ICal' stamp: 'pmm 10/4/2005 21:34'!
fromICalString: aString
	| positive value weeks days hours minutes seconds |
	positive := aString first ~= $-.
	value := aString copyAfter: $P.
	^(value includes: $W)
		ifTrue: [
			weeks := (value copyUpTo: $W) asInteger.
			self weeks: (positive ifTrue: [ weeks ] ifFalse: [ weeks negated ] )]
		ifFalse: [
			days := hours := minutes := seconds := 0.
			self flag: #XXX. "copy pasted code"
			(value includes: $D) ifTrue: [
				days := (value copyUpTo: $D) asInteger.
				value := value copyAfter: $D ].
			(value includes: $H) ifTrue: [
				hours := (value copyUpTo: $H) asInteger.
				value := value copyAfter: $H ].
			(value includes: $M) ifTrue: [
				minutes := (value copyUpTo: $M) asInteger.
				value := value copyAfter: $M ].
			(value includes: $S) ifTrue: [
				seconds := (value copyUpTo: $S) asInteger.
				value := value copyAfter: $S ].
			positive
				ifTrue: [
					self days: days hours: hours minutes: minutes seconds: seconds ]
				ifFalse: [
					self negatedDays: days hours: hours minutes: minutes seconds: seconds] ]
		! !

!Duration class methodsFor: '*ICal' stamp: 'pmm 10/3/2005 17:04'!
iCalType
	^'DURATION'! !

!Duration class methodsFor: '*ICal' stamp: 'pmm 10/4/2005 21:30'!
negatedDays: days hours: hours minutes: minutes seconds: seconds
 	^ self negatedDays: days hours: hours minutes: minutes seconds: seconds nanoSeconds: 0! !

!Duration class methodsFor: '*ICal' stamp: 'pmm 10/4/2005 21:26'!
negatedDays: days hours: hours minutes: minutes seconds: seconds nanoSeconds: nanos

 	^ self nanoSeconds: 
			( ( ( (days * SecondsInDay) 
				+ (hours * SecondsInHour)
					+ (minutes * SecondsInMinute) 
						+ seconds ) * NanosInSecond )
							+ nanos) negated.
! !

!Duration methodsFor: '*ICal' stamp: 'pmm 11/11/2005 09:38'!
asICalDurationString
	^String streamContents: [ :stream |
		self isNegative ifTrue: [ stream nextPut: $-. ].
		stream nextPut: $P.
		self justWeeks
			ifTrue: [
				stream
					nextPutAll: self weeks abs asString;
					nextPut: $W ]
			ifFalse: [
				self days isZero ifFalse: [ 
					stream
						nextPutAll: self days abs asString;
						nextPut: $D ].
				self hasTime ifTrue: [
					stream
						nextPut: $T;
						"we could leave out those who are 0 but that's just cosmetic"
						nextPutAll: self hours abs asString;
						nextPut: $H;
						nextPutAll: self minutes abs asString;
						nextPut: $M;
						nextPutAll: self seconds abs asString;
						nextPut: $S  ] ] ]! !

!Duration methodsFor: '*ICal' stamp: 'pmm 10/2/2005 21:13'!
asICalString
	^self asICalDurationString! !

!Duration methodsFor: '*ICal' stamp: 'pmm 10/2/2005 22:14'!
daysWithoutWeeks
	^self days - (7 * self weeks)! !

!Duration methodsFor: '*ICal' stamp: 'pmm 10/2/2005 21:05'!
hasTime
	^self hours isZero not
		or: [ self minutes isZero not ]
		or: [ self seconds isZero not ]! !

!Duration methodsFor: '*ICal' stamp: 'pmm 10/2/2005 21:07'!
isNegative
	^self isPositive not! !

!Duration methodsFor: '*ICal' stamp: 'pmm 10/2/2005 21:06'!
isPositive
	^seconds > 0
	 	or: [ seconds = 0
			and: [ nanos > 0 ] ]! !

!Duration methodsFor: '*ICal' stamp: 'pmm 10/2/2005 22:15'!
justWeeks
	^self weeks isZero not
		and: [ self daysWithoutWeeks isZero ]
		and: [ self hours isZero ]
		and: [ self minutes isZero ]
		and: [ self seconds isZero ]! !

!Duration methodsFor: '*ICal' stamp: 'pmm 10/2/2005 20:16'!
weeks
	^self days quo: 7! !

!False methodsFor: '*ICal' stamp: 'pmm 10/14/2005 12:01'!
asICalBooleanString
	^'FALSE'! !

!Url class methodsFor: '*ICal' stamp: 'pmm 10/3/2005 22:31'!
fromICalString: aString
	^self absoluteFromText: aString! !

!Url class methodsFor: '*ICal' stamp: 'pmm 10/3/2005 22:32'!
iCalType
	^'URI'! !

!Url methodsFor: '*ICal' stamp: 'pmm 12/8/2005 14:32'!
asICalString
	^self asString
		replaceStrings: (Array
			with: '%2D' -> '-'
			with: '%2E' -> '.'
			with: '%5F' -> '_'
			with: '%7E' -> '~')! !

SmaCCParser subclass: #ICCalendarParser2
	instanceVariableNames: 'generator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICal-Parser'!

!ICCalendarParser2 commentStamp: '<historical>' prior: 0!
I'm the new Parser. I'm more flexible and use dynmic dispatch rather than lots of production rules (my author was lazy).!

!ICCalendarParser2 class methodsFor: 'instance creation' stamp: 'pmm 10/14/2005 14:54'!
parseCalendarStream: aStream
	| parser |
	parser := self on: aStream.
	parser generator: ICCalendarGenerator new.
	parser parse.
	^parser product! !

!ICCalendarParser2 class methodsFor: 'instance creation' stamp: 'pmm 10/14/2005 10:52'!
parseCalendarString: aString
	^self parseCalendarStream: (ReadStream on: aString).! !

!ICCalendarParser2 class methodsFor: 'generated-comments' stamp: 'pmm 10/15/2005 20:31'!
parserDefinitionComment

	"%start calendar;

calendar:
	contentline*;

contentline:
	name 'name' parameterlist 'parameterlist' "":"" value 'value' <CRLF>
		{self contentline: name parameters: parameterlist value: value};
	
parameterlist:
	("";"" param )*					{#parameterlist};
	
name:
	xname							{#name:}
|	ianatoken						{#name:};
	
param:
	paramname ""="" paramvalue		{#parameter:};
	
value:
	<value>							{#value};
	
xname:
	<xname>							{#first:};
	
ianatoken:
	<ianatoken>						{#first:};

paramname:
	ianatoken						{#parameterName:}
|	xtoken							{#parameterName:};

paramvalue:
	paramtext						{#parameterValue:}
|	quotedstring						{#parameterValue.};

quotedstring:
	<quotedstring> 					{#unquote:};


paramtext:
	<paramtext>						{#first:};

xtoken:
	<xtoken>							{#first:};
"! !

!ICCalendarParser2 class methodsFor: 'generated-accessing' stamp: 'pmm 10/15/2005 20:31'!
scannerClass
	^ICCalendarScanner2! !

!ICCalendarParser2 class methodsFor: 'generated-starting states' stamp: 'pmm 10/15/2005 20:31'!
startingStateForcalendar
	^1! !

!ICCalendarParser2 methodsFor: 'utilities' stamp: 'pmm 10/14/2005 15:06'!
asSelector: aString
	| parts |
	parts := aString subStrings: #($-).
	^String streamContents: [ :stream |
		parts allButFirst do: [ :each |
			stream nextPutAll: each asLowercase ].
		stream nextPut: $: ]! !

!ICCalendarParser2 methodsFor: 'productions' stamp: 'pmm 10/14/2005 10:49'!
contentline: aName parameters: aCollection value: aString
	^self generator contentline: aName parameters: aCollection value: aString! !

!ICCalendarParser2 methodsFor: 'productions' stamp: 'pmm 10/15/2005 11:36'!
contentline: aName value: aString
	^self contentline: aName parameters: Dictionary new value: aString! !

!ICCalendarParser2 methodsFor: 'utilities' stamp: 'pmm 10/13/2005 08:41'!
firstAsUppercase: nodes
	| string |
	string := nodes first.
	^string asUppercase! !

!ICCalendarParser2 methodsFor: 'utilities' stamp: 'pmm 10/13/2005 08:49'!
first: nodes
	^nodes first! !

!ICCalendarParser2 methodsFor: 'accessing' stamp: 'pmm 10/14/2005 10:49'!
generator
	^generator! !

!ICCalendarParser2 methodsFor: 'accessing' stamp: 'pmm 10/14/2005 10:49'!
generator: anObject
	generator := anObject! !

!ICCalendarParser2 methodsFor: 'productions' stamp: 'pmm 10/15/2005 09:56'!
ianatoken: nodes
	^self tokensAsString: nodes first! !

!ICCalendarParser2 methodsFor: 'productions' stamp: 'pmm 10/13/2005 08:54'!
name: nodes
	"property names are case insensitive"
	^self firstAsUppercase: nodes! !

!ICCalendarParser2 methodsFor: 'productions' stamp: 'pmm 10/13/2005 09:45'!
parameterlist: nodes
	| parameters |
	parameters := Dictionary new: nodes size / 2.
	nodes withIndexDo: [ :each :index |
		index even ifTrue: [ parameters add: each ] ].
	^parameters! !

!ICCalendarParser2 methodsFor: 'productions' stamp: 'pmm 10/13/2005 08:43'!
parameterName: nodes
	"parameter names are case insensitive"
	^self firstAsUppercase: nodes! !

!ICCalendarParser2 methodsFor: 'productions' stamp: 'pmm 10/13/2005 08:42'!
parameterValue: nodes
	"parameter values are case insensitive"
	^self firstAsUppercase: nodes! !

!ICCalendarParser2 methodsFor: 'productions' stamp: 'pmm 10/13/2005 09:01'!
parameter: nodes
	| name value |
	name := nodes first.
	"the second node is '='"
	value := nodes third.
	^name -> value! !

!ICCalendarParser2 methodsFor: 'productions' stamp: 'pmm 10/15/2005 09:57'!
paramtext: nodes
	^self tokensAsString: nodes first! !

!ICCalendarParser2 methodsFor: 'accessing' stamp: 'pmm 10/14/2005 14:53'!
product
	^self generator product! !

!ICCalendarParser2 methodsFor: 'productions' stamp: 'pmm 10/15/2005 09:56'!
quotedstring: nodes
	| tokens |
	tokens := nodes first.
	^String streamContents: [ :stream |
		1 to: tokens size - 1 do:  [ :each | "leave out first and last, they are double quotes"
			stream nextPutAll: (tokens at: each) value ] ]! !

!ICCalendarParser2 methodsFor: 'generated-reduction actions' stamp: 'pmm 10/15/2005 20:31'!
reduceActionForcontentline1: nodes 
	^self 
		contentline: (nodes at: 1)
		parameters: (nodes at: 2)
		value: (nodes at: 4)! !

!ICCalendarParser2 methodsFor: 'generated-reduction actions' stamp: 'pmm 10/15/2005 20:31'!
reduceActionForparameterlist1: nodes 
	^#parameterlist! !

!ICCalendarParser2 methodsFor: 'generated-reduction actions' stamp: 'pmm 10/15/2005 20:31'!
reduceActionForparamvalue2: nodes 
	^#parameterValue! !

!ICCalendarParser2 methodsFor: 'generated-reduction actions' stamp: 'pmm 10/15/2005 20:31'!
reduceActionForRepeatXXcontentline1: nodes 
	^OrderedCollection new! !

!ICCalendarParser2 methodsFor: 'generated-reduction actions' stamp: 'pmm 10/15/2005 20:31'!
reduceActionForRepeatXXcontentline2: nodes 
	^(nodes at: 1)
		add: (nodes at: 2);
		yourself! !

!ICCalendarParser2 methodsFor: 'generated-reduction actions' stamp: 'pmm 10/15/2005 20:31'!
reduceActionForRepeatXXGroupXXXXXXXXXparam1: nodes 
	^OrderedCollection new! !

!ICCalendarParser2 methodsFor: 'generated-reduction actions' stamp: 'pmm 10/15/2005 20:31'!
reduceActionForRepeatXXGroupXXXXXXXXXparam2: nodes 
	^(nodes at: 1)
		add: (nodes at: 2);
		yourself! !

!ICCalendarParser2 methodsFor: 'generated-tables' stamp: 'pmm 10/15/2005 20:31'!
reduceTable
	^#(
#(11 1 #value)
#(12 3 #parameter:)
#(13 2 #reduceFor:)
#(14 1 #reduceActionForparameterlist1:)
#(15 1 #first:)
#(16 1 #first:)
#(17 1 #parameterName:)
#(17 1 #parameterName:)
#(18 1 #parameterValue:)
#(18 1 #reduceActionForparamvalue2:)
#(19 1 #name:)
#(19 1 #name:)
#(20 1 #reduceFor:)
#(21 0 #reduceActionForRepeatXXcontentline1:)
#(21 2 #reduceActionForRepeatXXcontentline2:)
#(22 1 #first:)
#(23 1 #first:)
#(24 1 #unquote:)
#(25 5 #reduceActionForcontentline1:)
#(26 1 #reduceFor:)
#(27 0 #reduceActionForRepeatXXGroupXXXXXXXXXparam1:)
#(27 2 #reduceActionForRepeatXXGroupXXXXXXXXXparam2:)
)! !

!ICCalendarParser2 methodsFor: 'utilities' stamp: 'pmm 10/15/2005 09:52'!
tokensAsString: tokens
	^String streamContents: [ :stream |
		tokens do: [ :each | stream nextPutAll: each value] ]! !

!ICCalendarParser2 methodsFor: 'generated-tables' stamp: 'pmm 10/15/2005 20:31'!
transitionTable
	^#(
#(3 58 5 58 6 13 21 17 26 58 28)
#(3 58 5 58 6 13 21 21 26 58 28)
#(3 25 5 29 6 33 15 37 16 41 19 45 25 82 28)
#(2 0 28)
#(2 0 28)
#(2 26 1 2 3)
#(2 22 1 2)
#(2 46 1 2)
#(2 50 1 2)
#(3 86 1 86 2 49 14 53 27)
#(2 62 5 6 28)
#(2 57 1)
#(3 18 1 61 2 65 13)
#(3 69 9 73 11)
#(3 25 5 77 10 81 12 85 16 89 17 93 22)
#(2 90 1 2)
#(2 6 4)
#(2 97 4)
#(2 66 3)
#(2 14 1 2)
#(2 30 3)
#(2 101 3)
#(2 34 3)
#(2 78 5 6 28)
#(3 105 7 109 8 113 18 117 23 121 24)
#(2 70 1 2)
#(2 74 1 2)
#(2 10 1 2)
#(2 38 1 2)
#(2 42 1 2)
)! !

!ICCalendarParser2 methodsFor: 'utilities' stamp: 'pmm 10/14/2005 11:26'!
unfold: aString
	"remove any sequence of CR LF WSP"
	| pattern whiteSpaces |
	whiteSpaces := Array
		with: Character space
		with: Character tab
		with: (Character value: 9)
		with: (Character value: 32).
	pattern := Array new: 3.
	pattern at: 1 put: Character cr.
	pattern at: 2 put: Character lf.
	^whiteSpaces inject: aString into: [ :each :string |
		pattern at: 3 put: each.
		(string includesSubString: pattern)
			ifFalse: [ aString ]
			ifTrue: [ aString copyReplaceAll: pattern with: ''  ] ]! !

!ICCalendarParser2 methodsFor: 'utilities' stamp: 'pmm 10/13/2005 08:39'!
unquote: nodes
	| string |
	string := nodes first.
	^string copyFrom: 2 to: string size! !

!ICCalendarParser2 methodsFor: 'productions' stamp: 'pmm 10/15/2005 09:57'!
value: nodes
	^self unfold: (self tokensAsString: nodes first)! !

!String class methodsFor: '*ICal' stamp: 'pmm 11/19/2005 14:58'!
fromICalString: aString
	^ICCalendarVersion value >= 2.0
		ifTrue: [ self fromNewString: aString ]
		ifFalse: [ self fromOldString: aString ]! !

!String class methodsFor: '*ICal' stamp: 'pmm 10/12/2005 06:27'!
fromIParameterString: aString
	^((aString first = $"
		and: [ aString last = $" ]
		and: [ aString size > 1 ])
			ifTrue: [ aString copyFrom: 2 to: aString size - 1 ]
			ifFalse: [ aString ]) asUppercase! !

!String class methodsFor: '*ICal' stamp: 'pmm 12/3/2005 12:47'!
fromNewString: aString
	^aString replaceStrings: (Array
		with: '\n' -> (String with: Character cr)
		with: '\N' -> (String with: Character cr)
		with: '\,' -> ','
		with: '\;' -> ';'
		with: '\\' -> '\')! !

!String class methodsFor: '*ICal' stamp: 'pmm 12/3/2005 12:46'!
fromOldString: aString
	^aString replaceStrings: (Array
				with: '=0D=0A' -> (String with: Character cr)
				with: '\\' -> '\'
				with: '=0D' -> (String with: Character cr)
				with: '=0A' -> (String with: Character cr)
				with: '\,' -> ','
				with: '\;' -> ';')! !

!String class methodsFor: '*ICal' stamp: 'pmm 11/19/2005 14:57'!
fromVCardString: aString
	^ICCardVersion value >= 3.0
		ifTrue: [ self fromNewString: aString ]
		ifFalse: [ self fromOldString: aString ]! !

!String class methodsFor: '*ICal' stamp: 'pmm 10/3/2005 17:11'!
iCalType
	^'TEXT'! !

!String methodsFor: '*ICal' stamp: 'pmm 10/12/2005 06:30'!
asICalParameterString
	^(self includesAnyOf: #($, $; $\ $:))
		ifTrue: [ 
			'"' , self asString , '"' ]
		ifFalse: [ self asString ]! !

!String methodsFor: '*ICal' stamp: 'pmm 12/3/2005 12:27'!
asICalString
	^ICCalendarVersion value >= 2.0
		ifTrue: [ self asNewICalString ]
		ifFalse: [ self asOldICalString ]! !

!String methodsFor: '*ICal' stamp: 'pmm 12/3/2005 12:47'!
asNewICalString
	^self replaceStrings: (Array
		with: '\' -> '\\'
		with: ',' -> '\,'
		with: ';' -> '\;'
		with: (String with: Character cr) -> '\n')! !

!String methodsFor: '*ICal' stamp: 'pmm 12/3/2005 12:47'!
asOldICalString
	^self replaceStrings: (Array
		with: ',' -> '\,'
		with: ';' -> '\;'
		with: '\' -> '\\'
		with: (String with: Character cr) -> '=0D=0A')! !

!String methodsFor: '*ICal' stamp: 'pmm 12/3/2005 12:28'!
asVCardString
	^ICCardVersion value >= 3.0
		ifTrue: [ self asNewICalString ]
		ifFalse: [ self asOldICalString ]! !

!String methodsFor: '*ICal' stamp: 'pmm 12/3/2005 12:44'!
replaceStrings: aCollection
	| result |
	result := self.
	aCollection do: [ :each |
		(result includesSubString: each key) ifTrue: [
				result := result copyReplaceAll: each key with: each value ] ].
	^result! !

!String methodsFor: '*ICal' stamp: 'pmm 10/30/2005 08:23'!
splitAtCommas
	| indices start parts |
	indices := OrderedCollection new.
	self withIndexDo: [ :each :index |
		(each = $,
			and: [ index > 1 ]
			and: [ (self at: index - 1) ~= $\ ])
			ifTrue: [ indices add: index ] ].
	start := 1.
	parts := OrderedCollection new: indices size + 1.
	indices do: [ :each |
		parts add: (self copyFrom: start to: each - 1).
		start := each + 1 ].
	parts add: (self copyFrom: start to: self size).
	^parts! !

!String methodsFor: '*ICal' stamp: 'pmm 10/29/2005 23:18'!
subStringsFull: separators 
	"Answer an array containing the substrings in the receiver separated 
	by the elements of separators."
	| char result sourceStream subString |
	sourceStream := ReadStream on: self.
	result := OrderedCollection new.
	subString := String new.
	[sourceStream atEnd]
		whileFalse: 
			[char := sourceStream next.
			(separators includes: char)
				ifTrue: [
					result add: subString.
					subString := String new ]
				ifFalse: [subString := subString , (String with: char)]].
	result add: subString.
	^ result! !

!Integer class methodsFor: '*ICal' stamp: 'pmm 10/4/2005 20:10'!
fromICalString: aString
	^aString asNumber! !

!Integer class methodsFor: '*ICal' stamp: 'pmm 10/3/2005 17:03'!
iCalType
	^'INTEGER'! !

!Integer methodsFor: '*ICal' stamp: 'pmm 10/3/2005 17:12'!
asICalString
	^self asString! !

!Behavior methodsFor: '*ICal' stamp: 'pmm 10/29/2005 21:32'!
fromICalString: aString parameters: aDictionary
	^self fromICalString: aString! !

!Behavior methodsFor: '*ICal' stamp: 'pmm 12/2/2005 20:31'!
fromVCardString: aString
	^self fromICalString: aString! !

!Behavior methodsFor: '*ICal' stamp: 'pmm 1/2/2006 12:58'!
fromVCardString: aString parameters: aDictionary
	^self fromVCardString: aString! !
ICCalendarEntry initialize!
